searchData={"items":[{"type":"task","title":"mix pipeline.generate","doc":"Generates a new pipeline using the Genesis Pipeline.","ref":"Mix.Tasks.Pipeline.Generate.html"},{"type":"task","title":"Usage - mix pipeline.generate","doc":"mix pipeline.generate \"Create a pipeline that analyzes code quality\"      # Mock mode (safe, no API costs)\n    mix pipeline.generate.live \"Create a pipeline that analyzes code quality\" # Live mode (real AI calls)","ref":"Mix.Tasks.Pipeline.Generate.html#module-usage"},{"type":"task","title":"Options - mix pipeline.generate","doc":"* `--output` - Output file path (defaults to generated_pipeline.yaml)\n  * `--profile` - Performance profile: speed_optimized, accuracy_optimized, balanced\n  * `--complexity` - Target complexity: simple, moderate, complex\n  * `--dry-run` - Show what would be generated without creating files","ref":"Mix.Tasks.Pipeline.Generate.html#module-options"},{"type":"task","title":"Examples - mix pipeline.generate","doc":"# Generate a simple data processing pipeline (mock mode)\n    mix pipeline.generate \"Process CSV data and extract insights\"\n    \n    # Generate with real AI providers (requires API keys)\n    mix pipeline.generate.live \"Analyze customer feedback\" --profile accuracy_optimized\n    \n    # Preview pipeline without creating files\n    mix pipeline.generate \"Generate API documentation\" --dry-run","ref":"Mix.Tasks.Pipeline.Generate.html#module-examples"},{"type":"task","title":"Environment Variables - mix pipeline.generate","doc":"- `TEST_MODE`: \"mock\" (default), \"live\", or \"mixed\"\n- `PIPELINE_DEBUG`: \"true\" to enable detailed logging\n- `CLAUDE_API_KEY`: Required for live mode with Claude\n- `GEMINI_API_KEY`: Required for live mode with Gemini","ref":"Mix.Tasks.Pipeline.Generate.html#module-environment-variables"},{"type":"task","title":"mix pipeline.generate.live","doc":"Generates a new pipeline using the Genesis Pipeline in LIVE mode.","ref":"Mix.Tasks.Pipeline.Generate.Live.html"},{"type":"task","title":"Usage - mix pipeline.generate.live","doc":"mix pipeline.generate.live \"Create a pipeline that analyzes code quality\"","ref":"Mix.Tasks.Pipeline.Generate.Live.html#module-usage"},{"type":"task","title":"Options - mix pipeline.generate.live","doc":"* `--output` - Output file path (defaults to generated_pipeline.yaml)\n  * `--profile` - Performance profile: speed_optimized, accuracy_optimized, balanced\n  * `--complexity` - Target complexity: simple, moderate, complex\n  * `--dry-run` - Show what would be generated without creating files","ref":"Mix.Tasks.Pipeline.Generate.Live.html#module-options"},{"type":"task","title":"Examples - mix pipeline.generate.live","doc":"# Generate a simple data processing pipeline with real AI\n    mix pipeline.generate.live \"Process CSV data and extract insights\"\n    \n    # Generate an optimized pipeline with specific profile\n    mix pipeline.generate.live \"Analyze customer feedback\" --profile accuracy_optimized\n    \n    # Preview pipeline without creating files\n    mix pipeline.generate.live \"Generate API documentation\" --dry-run","ref":"Mix.Tasks.Pipeline.Generate.Live.html#module-examples"},{"type":"task","title":"Environment Variables - mix pipeline.generate.live","doc":"- `PIPELINE_DEBUG`: \"true\" to enable detailed logging\n- `CLAUDE_API_KEY`: Required for Claude API calls\n- `GEMINI_API_KEY`: Required for Gemini API calls","ref":"Mix.Tasks.Pipeline.Generate.Live.html#module-environment-variables"},{"type":"task","title":"mix pipeline.run","doc":"Runs a Pipeline workflow from a YAML configuration file.","ref":"Mix.Tasks.Pipeline.Run.html"},{"type":"task","title":"Usage - mix pipeline.run","doc":"mix pipeline.run            # Run in mock mode (safe, no API costs)\n    TEST_MODE=live mix pipeline.run    # Run with real API calls","ref":"Mix.Tasks.Pipeline.Run.html#module-usage"},{"type":"task","title":"Examples - mix pipeline.run","doc":"# Run the comprehensive example in mock mode\n    mix pipeline.run examples/comprehensive_config_example.yaml\n\n    # Run with real AI providers (requires API keys)\n    TEST_MODE=live mix pipeline.run examples/comprehensive_config_example.yaml\n\n    # Run with debug output\n    PIPELINE_DEBUG=true mix pipeline.run examples/comprehensive_config_example.yaml","ref":"Mix.Tasks.Pipeline.Run.html#module-examples"},{"type":"task","title":"Environment Variables - mix pipeline.run","doc":"- `TEST_MODE`: \"mock\" (default), \"live\", or \"mixed\"\n- `PIPELINE_DEBUG`: \"true\" to enable detailed logging\n- `PIPELINE_LOG_LEVEL`: \"debug\", \"info\" (default), \"warn\", \"error\"\n- `GEMINI_API_KEY`: Required for live mode with Gemini","ref":"Mix.Tasks.Pipeline.Run.html#module-environment-variables"},{"type":"function","title":"Mix.Tasks.Pipeline.Run.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Pipeline.Run.html#run/1"},{"type":"task","title":"mix pipeline.run.live","doc":"Runs a Pipeline workflow from a YAML configuration file in LIVE mode.","ref":"Mix.Tasks.Pipeline.Run.Live.html"},{"type":"task","title":"Usage - mix pipeline.run.live","doc":"mix pipeline.run.live    # Run with real API calls","ref":"Mix.Tasks.Pipeline.Run.Live.html#module-usage"},{"type":"task","title":"Examples - mix pipeline.run.live","doc":"# Run the comprehensive example with real AI providers (requires API keys)\n    mix pipeline.run.live examples/comprehensive_config_example.yaml\n\n    # Run with debug output\n    PIPELINE_DEBUG=true mix pipeline.run.live examples/comprehensive_config_example.yaml","ref":"Mix.Tasks.Pipeline.Run.Live.html#module-examples"},{"type":"task","title":"Environment Variables - mix pipeline.run.live","doc":"- `PIPELINE_DEBUG`: \"true\" to enable detailed logging\n- `PIPELINE_LOG_LEVEL`: \"debug\", \"info\" (default), \"warn\", \"error\"\n- `GEMINI_API_KEY`: Required for Gemini API calls","ref":"Mix.Tasks.Pipeline.Run.Live.html#module-environment-variables"},{"type":"function","title":"Mix.Tasks.Pipeline.Run.Live.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Pipeline.Run.Live.html#run/1"},{"type":"task","title":"mix pipeline.showcase","doc":"Demonstrates the Pipeline with both mock and live modes.","ref":"Mix.Tasks.Pipeline.Showcase.html"},{"type":"task","title":"Usage - mix pipeline.showcase","doc":"mix pipeline.showcase          # Mock mode (safe, no API costs)\n    mix pipeline.showcase --live   # Live mode (real API calls, costs money)","ref":"Mix.Tasks.Pipeline.Showcase.html#module-usage"},{"type":"function","title":"Mix.Tasks.Pipeline.Showcase.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Pipeline.Showcase.html#run/1"},{"type":"task","title":"mix pipeline.test.live","doc":"Runs Pipeline tests in live mode with real API calls.","ref":"Mix.Tasks.Pipeline.Test.Live.html"},{"type":"task","title":"Usage - mix pipeline.test.live","doc":"mix pipeline.test.live            # Run all tests with live APIs\n    mix pipeline.test.live integration # Run only integration tests with live APIs\n\n⚠️ This will make real API calls and incur costs!","ref":"Mix.Tasks.Pipeline.Test.Live.html#module-usage"},{"type":"function","title":"Mix.Tasks.Pipeline.Test.Live.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Pipeline.Test.Live.html#run/1"},{"type":"module","title":"Pipeline.CheckpointManager","doc":"Manages checkpoint creation and restoration for pipeline execution.\n\nProvides state persistence to allow pipeline resumption after failures\nor interruptions.","ref":"Pipeline.CheckpointManager.html"},{"type":"type","title":"Pipeline.CheckpointManager.checkpoint_data/0","doc":"","ref":"Pipeline.CheckpointManager.html#t:checkpoint_data/0"},{"type":"function","title":"Pipeline.CheckpointManager.cleanup_old_checkpoints/3","doc":"Delete old checkpoints, keeping only the most recent N.","ref":"Pipeline.CheckpointManager.html#cleanup_old_checkpoints/3"},{"type":"function","title":"Pipeline.CheckpointManager.get_checkpoint_info/2","doc":"Get checkpoint metadata without loading the full data.","ref":"Pipeline.CheckpointManager.html#get_checkpoint_info/2"},{"type":"function","title":"Pipeline.CheckpointManager.list_checkpoints/2","doc":"List all checkpoints for a workflow.","ref":"Pipeline.CheckpointManager.html#list_checkpoints/2"},{"type":"function","title":"Pipeline.CheckpointManager.load_checkpoint/2","doc":"Load a specific checkpoint by filename.","ref":"Pipeline.CheckpointManager.html#load_checkpoint/2"},{"type":"function","title":"Pipeline.CheckpointManager.load_latest/2","doc":"Load the latest checkpoint for a workflow.","ref":"Pipeline.CheckpointManager.html#load_latest/2"},{"type":"function","title":"Pipeline.CheckpointManager.save/3","doc":"Save a checkpoint for the current pipeline state.","ref":"Pipeline.CheckpointManager.html#save/3"},{"type":"module","title":"Pipeline.Codebase.ASTParser","doc":"Unified AST parsing utilities for different programming languages.\n\nProvides a consistent interface for parsing and analyzing code across\nmultiple languages, extracting functions, classes, imports, and other\ncode constructs.","ref":"Pipeline.Codebase.ASTParser.html"},{"type":"module","title":"⚠️  IMPORTANT WARNING ⚠️ - Pipeline.Codebase.ASTParser","doc":"This is a PROTOTYPE implementation using simplified regex-based parsing.\n\nFor production use, this module should be replaced with proper language parsers:\n- JavaScript/TypeScript: Babylon, Acorn, or ESTree-based parsers\n- Python: Built-in `ast` module or `parso` library\n- Rust: `syn` crate or `rustc_parse`\n- Go: `go/parser` and `go/ast` from Go standard library\n- Elixir: Enhanced AST traversal using `Code.string_to_quoted/2`\n\nThe current regex patterns are fragile and will fail on complex code patterns.","ref":"Pipeline.Codebase.ASTParser.html#module-important-warning"},{"type":"function","title":"Pipeline.Codebase.ASTParser.calculate_complexity/1","doc":"Calculate cyclomatic complexity for a file.","ref":"Pipeline.Codebase.ASTParser.html#calculate_complexity/1"},{"type":"type","title":"Pipeline.Codebase.ASTParser.class_info/0","doc":"","ref":"Pipeline.Codebase.ASTParser.html#t:class_info/0"},{"type":"type","title":"Pipeline.Codebase.ASTParser.comment_info/0","doc":"","ref":"Pipeline.Codebase.ASTParser.html#t:comment_info/0"},{"type":"function","title":"Pipeline.Codebase.ASTParser.find_classes/2","doc":"Find class definitions in a file.","ref":"Pipeline.Codebase.ASTParser.html#find_classes/2"},{"type":"function","title":"Pipeline.Codebase.ASTParser.find_functions/2","doc":"Find function definitions in a file.","ref":"Pipeline.Codebase.ASTParser.html#find_functions/2"},{"type":"function","title":"Pipeline.Codebase.ASTParser.find_imports/1","doc":"Find import/require statements in a file.","ref":"Pipeline.Codebase.ASTParser.html#find_imports/1"},{"type":"type","title":"Pipeline.Codebase.ASTParser.function_info/0","doc":"","ref":"Pipeline.Codebase.ASTParser.html#t:function_info/0"},{"type":"function","title":"Pipeline.Codebase.ASTParser.parse_file/1","doc":"Parse a file and extract code information.\n\nReturns structured information about functions, classes, imports,\nand other code constructs based on the file's language.","ref":"Pipeline.Codebase.ASTParser.html#parse_file/1"},{"type":"type","title":"Pipeline.Codebase.ASTParser.parse_result/0","doc":"","ref":"Pipeline.Codebase.ASTParser.html#t:parse_result/0"},{"type":"module","title":"Pipeline.Codebase.Analyzers.ElixirAnalyzer","doc":"Specialized analyzer for Elixir projects.\n\nProvides deep analysis of Elixir codebases including:\n- Module and function discovery\n- Dependency analysis\n- Test file relationships\n- Documentation extraction","ref":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.html"},{"type":"function","title":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.analyze_file/1","doc":"Analyze an Elixir file and extract module information.","ref":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.html#analyze_file/1"},{"type":"function","title":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.extract_documentation/1","doc":"Extract documentation from module.","ref":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.html#extract_documentation/1"},{"type":"function","title":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.find_module_dependencies/2","doc":"Find module dependencies within the project.","ref":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.html#find_module_dependencies/2"},{"type":"function","title":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.find_test_file/2","doc":"Find the corresponding test file for a source file.","ref":"Pipeline.Codebase.Analyzers.ElixirAnalyzer.html#find_test_file/2"},{"type":"module","title":"Pipeline.Codebase.Analyzers.GoAnalyzer","doc":"Specialized analyzer for Go projects.","ref":"Pipeline.Codebase.Analyzers.GoAnalyzer.html"},{"type":"function","title":"Pipeline.Codebase.Analyzers.GoAnalyzer.analyze_file/1","doc":"","ref":"Pipeline.Codebase.Analyzers.GoAnalyzer.html#analyze_file/1"},{"type":"function","title":"Pipeline.Codebase.Analyzers.GoAnalyzer.find_module_dependencies/2","doc":"","ref":"Pipeline.Codebase.Analyzers.GoAnalyzer.html#find_module_dependencies/2"},{"type":"module","title":"Pipeline.Codebase.Analyzers.JavaScriptAnalyzer","doc":"Specialized analyzer for JavaScript/TypeScript projects.\n\nProvides analysis of JavaScript codebases including:\n- Module and function discovery\n- Import/export analysis\n- Package.json dependency extraction","ref":"Pipeline.Codebase.Analyzers.JavaScriptAnalyzer.html"},{"type":"function","title":"Pipeline.Codebase.Analyzers.JavaScriptAnalyzer.analyze_file/1","doc":"Analyze a JavaScript/TypeScript file.","ref":"Pipeline.Codebase.Analyzers.JavaScriptAnalyzer.html#analyze_file/1"},{"type":"function","title":"Pipeline.Codebase.Analyzers.JavaScriptAnalyzer.find_module_dependencies/2","doc":"Find module dependencies within the project.","ref":"Pipeline.Codebase.Analyzers.JavaScriptAnalyzer.html#find_module_dependencies/2"},{"type":"module","title":"Pipeline.Codebase.Analyzers.PythonAnalyzer","doc":"Specialized analyzer for Python projects.","ref":"Pipeline.Codebase.Analyzers.PythonAnalyzer.html"},{"type":"function","title":"Pipeline.Codebase.Analyzers.PythonAnalyzer.analyze_file/1","doc":"","ref":"Pipeline.Codebase.Analyzers.PythonAnalyzer.html#analyze_file/1"},{"type":"function","title":"Pipeline.Codebase.Analyzers.PythonAnalyzer.find_module_dependencies/2","doc":"","ref":"Pipeline.Codebase.Analyzers.PythonAnalyzer.html#find_module_dependencies/2"},{"type":"module","title":"Pipeline.Codebase.Analyzers.RustAnalyzer","doc":"Specialized analyzer for Rust projects.","ref":"Pipeline.Codebase.Analyzers.RustAnalyzer.html"},{"type":"function","title":"Pipeline.Codebase.Analyzers.RustAnalyzer.analyze_file/1","doc":"","ref":"Pipeline.Codebase.Analyzers.RustAnalyzer.html#analyze_file/1"},{"type":"function","title":"Pipeline.Codebase.Analyzers.RustAnalyzer.find_module_dependencies/2","doc":"","ref":"Pipeline.Codebase.Analyzers.RustAnalyzer.html#find_module_dependencies/2"},{"type":"module","title":"Pipeline.Codebase.Context","doc":"Codebase discovery and context analysis system.\n\nAutomatically analyzes project structure and provides intelligent context\nto pipeline steps including project type detection, file structure analysis,\ndependency parsing, and git information integration.","ref":"Pipeline.Codebase.Context.html"},{"type":"function","title":"Pipeline.Codebase.Context.discover/1","doc":"Discover and analyze codebase context for a given workspace directory.","ref":"Pipeline.Codebase.Context.html#discover/1"},{"type":"function","title":"Examples - Pipeline.Codebase.Context.discover/1","doc":"iex> context = Pipeline.Codebase.Context.discover(\"/path/to/project\")\n    %Pipeline.Codebase.Context{\n      project_type: :elixir,\n      root_path: \"/path/to/project\",\n      ...\n    }","ref":"Pipeline.Codebase.Context.html#discover/1-examples"},{"type":"type","title":"Pipeline.Codebase.Context.file_info/0","doc":"","ref":"Pipeline.Codebase.Context.html#t:file_info/0"},{"type":"function","title":"Pipeline.Codebase.Context.find_related_files/2","doc":"Find files related to a given file path using various heuristics.","ref":"Pipeline.Codebase.Context.html#find_related_files/2"},{"type":"function","title":"Pipeline.Codebase.Context.get_summary/1","doc":"Get a summary of the codebase for use in prompts.","ref":"Pipeline.Codebase.Context.html#get_summary/1"},{"type":"type","title":"Pipeline.Codebase.Context.git_info/0","doc":"","ref":"Pipeline.Codebase.Context.html#t:git_info/0"},{"type":"type","title":"Pipeline.Codebase.Context.project_type/0","doc":"","ref":"Pipeline.Codebase.Context.html#t:project_type/0"},{"type":"function","title":"Pipeline.Codebase.Context.query_files/2","doc":"Query files by various criteria.","ref":"Pipeline.Codebase.Context.html#query_files/2"},{"type":"type","title":"Pipeline.Codebase.Context.structure_info/0","doc":"","ref":"Pipeline.Codebase.Context.html#t:structure_info/0"},{"type":"type","title":"Pipeline.Codebase.Context.t/0","doc":"","ref":"Pipeline.Codebase.Context.html#t:t/0"},{"type":"function","title":"Pipeline.Codebase.Context.to_template_vars/1","doc":"Convert context to template variables for use in pipeline steps.","ref":"Pipeline.Codebase.Context.html#to_template_vars/1"},{"type":"function","title":"Examples - Pipeline.Codebase.Context.to_template_vars/1","doc":"iex> context |> Pipeline.Codebase.Context.to_template_vars()\n    %{\n      \"codebase.project_type\" => \"elixir\",\n      \"codebase.structure.main_files\" => [\"lib/my_app.ex\"],\n      ...\n    }","ref":"Pipeline.Codebase.Context.html#to_template_vars/1-examples"},{"type":"module","title":"Pipeline.Codebase.Discovery","doc":"Core discovery engine for codebase analysis.\n\nHandles project type detection, file scanning, dependency parsing,\ngit integration, and structure analysis.","ref":"Pipeline.Codebase.Discovery.html"},{"type":"function","title":"Pipeline.Codebase.Discovery.analyze_structure/1","doc":"Analyze project structure and categorize files.","ref":"Pipeline.Codebase.Discovery.html#analyze_structure/1"},{"type":"function","title":"Pipeline.Codebase.Discovery.detect_project_type/1","doc":"Detect project type based on file indicators.","ref":"Pipeline.Codebase.Discovery.html#detect_project_type/1"},{"type":"function","title":"Pipeline.Codebase.Discovery.extract_metadata/1","doc":"Extract project metadata.","ref":"Pipeline.Codebase.Discovery.html#extract_metadata/1"},{"type":"function","title":"Pipeline.Codebase.Discovery.find_related_files/2","doc":"Find files related to a given file path.","ref":"Pipeline.Codebase.Discovery.html#find_related_files/2"},{"type":"function","title":"Pipeline.Codebase.Discovery.get_git_info/1","doc":"Get git information for the workspace.","ref":"Pipeline.Codebase.Discovery.html#get_git_info/1"},{"type":"function","title":"Pipeline.Codebase.Discovery.parse_dependencies/1","doc":"Parse project dependencies from configuration files.","ref":"Pipeline.Codebase.Discovery.html#parse_dependencies/1"},{"type":"function","title":"Pipeline.Codebase.Discovery.query_files/2","doc":"Query files by various criteria.","ref":"Pipeline.Codebase.Discovery.html#query_files/2"},{"type":"function","title":"Pipeline.Codebase.Discovery.scan_files/1","doc":"Scan all files in the workspace directory.","ref":"Pipeline.Codebase.Discovery.html#scan_files/1"},{"type":"module","title":"Pipeline.Codebase.QueryEngine","doc":"Core query engine for intelligent codebase analysis.\n\nProvides high-level query operations that combine discovery, analysis,\nand relationship mapping to answer complex questions about code structure\nand dependencies.","ref":"Pipeline.Codebase.QueryEngine.html"},{"type":"function","title":"Pipeline.Codebase.QueryEngine.analyze_impact/2","doc":"Analyze the impact of changes to a file.","ref":"Pipeline.Codebase.QueryEngine.html#analyze_impact/2"},{"type":"function","title":"Config Options - Pipeline.Codebase.QueryEngine.analyze_impact/2","doc":"- `file`: File to analyze impact for\n- `include_tests`: Include test files in impact analysis\n- `max_depth`: Maximum depth for dependency traversal","ref":"Pipeline.Codebase.QueryEngine.html#analyze_impact/2-config-options"},{"type":"function","title":"Pipeline.Codebase.QueryEngine.find_dependencies/2","doc":"Find dependencies for a given file or the entire project.","ref":"Pipeline.Codebase.QueryEngine.html#find_dependencies/2"},{"type":"function","title":"Config Options - Pipeline.Codebase.QueryEngine.find_dependencies/2","doc":"- `for_file`: Specific file to analyze dependencies for\n- `include_transitive`: Include transitive dependencies\n- `type`: \"direct\", \"transitive\", \"all\"\n- `language`: Filter by programming language","ref":"Pipeline.Codebase.QueryEngine.html#find_dependencies/2-config-options"},{"type":"function","title":"Pipeline.Codebase.QueryEngine.find_files/2","doc":"Find files based on various criteria.","ref":"Pipeline.Codebase.QueryEngine.html#find_files/2"},{"type":"function","title":"Criteria Options - Pipeline.Codebase.QueryEngine.find_files/2","doc":"- `type`: \"main\", \"test\", \"config\", \"source\"\n- `pattern`: Glob pattern to match\n- `language`: Programming language\n- `extension`: File extension\n- `contains`: String that must be in file path\n- `exclude_tests`: Boolean to exclude test files\n- `related_to`: Find files related to given file\n- `modified_since`: Date string (ISO format)\n- `size_min`: Minimum file size in bytes\n- `size_max`: Maximum file size in bytes","ref":"Pipeline.Codebase.QueryEngine.html#find_files/2-criteria-options"},{"type":"function","title":"Pipeline.Codebase.QueryEngine.find_functions/2","doc":"Find functions, classes, and other code constructs.","ref":"Pipeline.Codebase.QueryEngine.html#find_functions/2"},{"type":"function","title":"Config Options - Pipeline.Codebase.QueryEngine.find_functions/2","doc":"- `name`: Function/class name to search for\n- `pattern`: Regex pattern to match\n- `type`: \"function\", \"class\", \"module\", \"constant\"\n- `in_file`: Specific file to search in\n- `in_files`: List of files to search in\n- `language`: Programming language filter","ref":"Pipeline.Codebase.QueryEngine.html#find_functions/2-config-options"},{"type":"function","title":"Pipeline.Codebase.QueryEngine.find_related_files/2","doc":"Find files related to a given file.","ref":"Pipeline.Codebase.QueryEngine.html#find_related_files/2"},{"type":"function","title":"Config Options - Pipeline.Codebase.QueryEngine.find_related_files/2","doc":"- `file`: File to find relations for\n- `types`: List of relation types [\"test\", \"source\", \"similar\", \"directory\"]\n- `max_results`: Maximum number of results","ref":"Pipeline.Codebase.QueryEngine.html#find_related_files/2-config-options"},{"type":"module","title":"Pipeline.Condition.Engine","doc":"Enhanced conditional execution engine supporting complex boolean expressions and mathematical operations.\n\nSupports:\n- Boolean operators: and, or, not\n- Comparison operators: >, <, ==, !=, >=, <=, contains, matches\n- Mathematical expressions: +, -, *, /, % with proper precedence\n- Function calls: any(), all(), count(), sum(), length(), startsWith(), etc.\n- Date/time operations: now(), days(), hours(), minutes()\n- Pattern matching: regex matching and validation\n- Dot notation for nested field access: step_name.field.subfield\n- Backward compatibility with simple truthy conditions\n\nExample condition YAML:\n```yaml\ncondition:\n  and:\n    - \"analysis.score * analysis.confidence > 0.8\"\n    - \"any(analysis.issues, 'severity == \"high\"') == false\"\n    - \"length(analysis.recommendations) between 3 and 10\"\n    - \"analysis.timestamp > now() - days(7)\"\n    - \"analysis.file_path matches '.*\\.ex'\"\n```","ref":"Pipeline.Condition.Engine.html"},{"type":"type","title":"Pipeline.Condition.Engine.condition/0","doc":"","ref":"Pipeline.Condition.Engine.html#t:condition/0"},{"type":"type","title":"Pipeline.Condition.Engine.context/0","doc":"","ref":"Pipeline.Condition.Engine.html#t:context/0"},{"type":"function","title":"Pipeline.Condition.Engine.evaluate/2","doc":"Evaluates a condition expression against the execution context.\n\nSupports both simple conditions (strings) and complex boolean expressions (maps/lists).","ref":"Pipeline.Condition.Engine.html#evaluate/2"},{"type":"type","title":"Pipeline.Condition.Engine.evaluation_result/0","doc":"","ref":"Pipeline.Condition.Engine.html#t:evaluation_result/0"},{"type":"function","title":"Pipeline.Condition.Engine.resolve_value/2","doc":"Resolves a value expression in the given context.\n\nPublic function for use by the Functions module.","ref":"Pipeline.Condition.Engine.html#resolve_value/2"},{"type":"module","title":"Pipeline.Condition.Functions","doc":"Function library for advanced condition expressions.\n\nProvides built-in functions for:\n- String operations: contains(), matches(), length(), startsWith(), endsWith()\n- Array operations: any(), all(), count(), sum(), average(), min(), max()\n- Date/time operations: now(), days(), hours(), minutes()\n- Mathematical operations: abs(), round(), floor(), ceil()\n- Pattern matching: regex matching and validation","ref":"Pipeline.Condition.Functions.html"},{"type":"function","title":"Pipeline.Condition.Functions.call_function/3","doc":"Evaluates a function call with given arguments.\n\nReturns the result of the function or raises an error if function not found.","ref":"Pipeline.Condition.Functions.html#call_function/3"},{"type":"module","title":"Pipeline.Context.Nested","doc":"Context management for nested pipeline execution.\n\nHandles context creation, variable mapping, and output extraction\nfor nested pipeline execution with support for context inheritance.","ref":"Pipeline.Context.Nested.html"},{"type":"function","title":"Pipeline.Context.Nested.create_nested_context/2","doc":"Create a nested context from parent context based on configuration.","ref":"Pipeline.Context.Nested.html#create_nested_context/2"},{"type":"function","title":"Parameters - Pipeline.Context.Nested.create_nested_context/2","doc":"- `parent_context`: The parent pipeline's execution context\n- `step_config`: The nested pipeline step configuration","ref":"Pipeline.Context.Nested.html#create_nested_context/2-parameters"},{"type":"function","title":"Returns - Pipeline.Context.Nested.create_nested_context/2","doc":"- `{:ok, nested_context}` on success\n- `{:error, reason}` on failure","ref":"Pipeline.Context.Nested.html#create_nested_context/2-returns"},{"type":"function","title":"Pipeline.Context.Nested.extract_outputs/2","doc":"Extract outputs from nested pipeline results based on configuration.","ref":"Pipeline.Context.Nested.html#extract_outputs/2"},{"type":"function","title":"Parameters - Pipeline.Context.Nested.extract_outputs/2","doc":"- `results`: The nested pipeline execution results\n- `output_config`: Output extraction configuration","ref":"Pipeline.Context.Nested.html#extract_outputs/2-parameters"},{"type":"function","title":"Returns - Pipeline.Context.Nested.extract_outputs/2","doc":"- `{:ok, extracted_outputs}` on success\n- `{:error, reason}` on failure","ref":"Pipeline.Context.Nested.html#extract_outputs/2-returns"},{"type":"function","title":"Pipeline.Context.Nested.resolve_template/2","doc":"Resolve templates in a string using the provided context.\nThis is made public so it can be used by other modules.","ref":"Pipeline.Context.Nested.html#resolve_template/2"},{"type":"module","title":"Pipeline.Data.Transformer","doc":"Data transformation engine for manipulating structured data between pipeline steps.\n\nSupports operations:\n- filter: Filter items based on conditions\n- map: Transform each item\n- aggregate: Aggregate values (sum, average, count, etc.)\n- join: Join with data from another source\n- group_by: Group items by field values\n- sort: Sort items by field values\n- transform: Apply custom transformations\n\nUses JSONPath-like syntax for field access and supports chaining operations.","ref":"Pipeline.Data.Transformer.html"},{"type":"function","title":"Pipeline.Data.Transformer.apply_operation/3","doc":"Apply a single transformation operation.","ref":"Pipeline.Data.Transformer.html#apply_operation/3"},{"type":"type","title":"Pipeline.Data.Transformer.operation/0","doc":"","ref":"Pipeline.Data.Transformer.html#t:operation/0"},{"type":"function","title":"Pipeline.Data.Transformer.transform/3","doc":"Apply a series of transformation operations to data.","ref":"Pipeline.Data.Transformer.html#transform/3"},{"type":"module","title":"Pipeline.Debug","doc":"Debug logging utilities for the pipeline.","ref":"Pipeline.Debug.html"},{"type":"function","title":"Pipeline.Debug.find_latest_debug_log/1","doc":"Find the latest debug log in the output directory.","ref":"Pipeline.Debug.html#find_latest_debug_log/1"},{"type":"function","title":"Pipeline.Debug.find_output_files/1","doc":"Find all output files (excluding debug logs) in the output directory.","ref":"Pipeline.Debug.html#find_output_files/1"},{"type":"function","title":"Pipeline.Debug.find_workspace_files/1","doc":"Find all files created in the workspace directory.","ref":"Pipeline.Debug.html#find_workspace_files/1"},{"type":"function","title":"Pipeline.Debug.format_size/1","doc":"Format file size in human readable format.","ref":"Pipeline.Debug.html#format_size/1"},{"type":"function","title":"Pipeline.Debug.format_timestamp/1","doc":"Format timestamp in human readable format.","ref":"Pipeline.Debug.html#format_timestamp/1"},{"type":"function","title":"Pipeline.Debug.log/2","doc":"Log a message to the debug file.","ref":"Pipeline.Debug.html#log/2"},{"type":"module","title":"Pipeline.Debug.NestedExecution","doc":"Debugging tools and utilities for nested pipeline execution.\n\nProvides interactive debugging capabilities, execution analysis,\nand troubleshooting tools for complex nested pipeline workflows.","ref":"Pipeline.Debug.NestedExecution.html"},{"type":"type","title":"Pipeline.Debug.NestedExecution.analysis_result/0","doc":"","ref":"Pipeline.Debug.NestedExecution.html#t:analysis_result/0"},{"type":"function","title":"Pipeline.Debug.NestedExecution.analyze_execution/2","doc":"Analyze execution for performance issues and optimization opportunities.","ref":"Pipeline.Debug.NestedExecution.html#analyze_execution/2"},{"type":"function","title":"Parameters - Pipeline.Debug.NestedExecution.analyze_execution/2","doc":"- `execution_tree`: The execution tree to analyze\n- `options`: Analysis options","ref":"Pipeline.Debug.NestedExecution.html#analyze_execution/2-parameters"},{"type":"function","title":"Returns - Pipeline.Debug.NestedExecution.analyze_execution/2","doc":"- Analysis results with issues and recommendations","ref":"Pipeline.Debug.NestedExecution.html#analyze_execution/2-returns"},{"type":"function","title":"Pipeline.Debug.NestedExecution.compare_executions/2","doc":"Compare execution performance between different traces.","ref":"Pipeline.Debug.NestedExecution.html#compare_executions/2"},{"type":"function","title":"Parameters - Pipeline.Debug.NestedExecution.compare_executions/2","doc":"- `trace_contexts`: List of trace contexts to compare\n- `options`: Comparison options","ref":"Pipeline.Debug.NestedExecution.html#compare_executions/2-parameters"},{"type":"function","title":"Returns - Pipeline.Debug.NestedExecution.compare_executions/2","doc":"- Formatted comparison report","ref":"Pipeline.Debug.NestedExecution.html#compare_executions/2-returns"},{"type":"function","title":"Pipeline.Debug.NestedExecution.debug_execution_tree/2","doc":"Print comprehensive execution tree with debugging information.","ref":"Pipeline.Debug.NestedExecution.html#debug_execution_tree/2"},{"type":"function","title":"Parameters - Pipeline.Debug.NestedExecution.debug_execution_tree/2","doc":"- `context`: Execution context or debug session\n- `options`: Display options","ref":"Pipeline.Debug.NestedExecution.html#debug_execution_tree/2-parameters"},{"type":"function","title":"Returns - Pipeline.Debug.NestedExecution.debug_execution_tree/2","doc":"- Formatted debug output","ref":"Pipeline.Debug.NestedExecution.html#debug_execution_tree/2-returns"},{"type":"type","title":"Pipeline.Debug.NestedExecution.debug_session/0","doc":"","ref":"Pipeline.Debug.NestedExecution.html#t:debug_session/0"},{"type":"function","title":"Pipeline.Debug.NestedExecution.generate_debug_report/1","doc":"Generate a debugging report for troubleshooting.","ref":"Pipeline.Debug.NestedExecution.html#generate_debug_report/1"},{"type":"function","title":"Parameters - Pipeline.Debug.NestedExecution.generate_debug_report/1","doc":"- `trace_context`: The trace context to analyze\n- `error`: Optional error that occurred\n- `options`: Report generation options","ref":"Pipeline.Debug.NestedExecution.html#generate_debug_report/1-parameters"},{"type":"function","title":"Returns - Pipeline.Debug.NestedExecution.generate_debug_report/1","doc":"- Comprehensive debugging report","ref":"Pipeline.Debug.NestedExecution.html#generate_debug_report/1-returns"},{"type":"function","title":"Pipeline.Debug.NestedExecution.generate_debug_report/2","doc":"","ref":"Pipeline.Debug.NestedExecution.html#generate_debug_report/2"},{"type":"function","title":"Pipeline.Debug.NestedExecution.generate_debug_report/3","doc":"","ref":"Pipeline.Debug.NestedExecution.html#generate_debug_report/3"},{"type":"function","title":"Pipeline.Debug.NestedExecution.inspect_context/1","doc":"Show context information at a specific point in execution.","ref":"Pipeline.Debug.NestedExecution.html#inspect_context/1"},{"type":"function","title":"Parameters - Pipeline.Debug.NestedExecution.inspect_context/1","doc":"- `context`: Execution context to inspect\n- `step`: Optional step information","ref":"Pipeline.Debug.NestedExecution.html#inspect_context/1-parameters"},{"type":"function","title":"Returns - Pipeline.Debug.NestedExecution.inspect_context/1","doc":"- Formatted context information","ref":"Pipeline.Debug.NestedExecution.html#inspect_context/1-returns"},{"type":"function","title":"Pipeline.Debug.NestedExecution.inspect_context/2","doc":"","ref":"Pipeline.Debug.NestedExecution.html#inspect_context/2"},{"type":"function","title":"Pipeline.Debug.NestedExecution.search_execution/3","doc":"Search for specific patterns in execution traces.","ref":"Pipeline.Debug.NestedExecution.html#search_execution/3"},{"type":"function","title":"Parameters - Pipeline.Debug.NestedExecution.search_execution/3","doc":"- `trace_context`: Trace context to search\n- `pattern`: Search pattern (string or regex)\n- `search_in`: What to search in (:pipeline_ids, :step_names, :errors, :all)","ref":"Pipeline.Debug.NestedExecution.html#search_execution/3-parameters"},{"type":"function","title":"Returns - Pipeline.Debug.NestedExecution.search_execution/3","doc":"- List of matching spans with context","ref":"Pipeline.Debug.NestedExecution.html#search_execution/3-returns"},{"type":"function","title":"Pipeline.Debug.NestedExecution.start_debug_session/1","doc":"Start an interactive debugging session for a trace context.","ref":"Pipeline.Debug.NestedExecution.html#start_debug_session/1"},{"type":"function","title":"Parameters - Pipeline.Debug.NestedExecution.start_debug_session/1","doc":"- `trace_context`: The trace context to debug\n- `options`: Debug session options","ref":"Pipeline.Debug.NestedExecution.html#start_debug_session/1-parameters"},{"type":"function","title":"Returns - Pipeline.Debug.NestedExecution.start_debug_session/1","doc":"- Debug session context","ref":"Pipeline.Debug.NestedExecution.html#start_debug_session/1-returns"},{"type":"function","title":"Pipeline.Debug.NestedExecution.start_debug_session/2","doc":"","ref":"Pipeline.Debug.NestedExecution.html#start_debug_session/2"},{"type":"type","title":"Pipeline.Debug.NestedExecution.trace_context/0","doc":"","ref":"Pipeline.Debug.NestedExecution.html#t:trace_context/0"},{"type":"module","title":"Pipeline.EnhancedConfig","doc":"Enhanced configuration management for Claude Code SDK integration.\n\nExtends the base Pipeline.Config with support for:\n- Enhanced Claude options schema\n- New step types (claude_smart, claude_session, etc.)\n- Workflow-level authentication and environment configuration\n- Advanced prompt template types","ref":"Pipeline.EnhancedConfig.html"},{"type":"function","title":"Pipeline.EnhancedConfig.load_from_map/1","doc":"Load and validate an enhanced workflow configuration from map.\nThis function replaces the base Config.load_workflow for enhanced features.","ref":"Pipeline.EnhancedConfig.html#load_from_map/1"},{"type":"function","title":"Pipeline.EnhancedConfig.load_workflow/1","doc":"Load and validate an enhanced workflow configuration from file.","ref":"Pipeline.EnhancedConfig.html#load_workflow/1"},{"type":"module","title":"Pipeline.Error.NestedPipeline","doc":"Enhanced error formatting and context tracking for nested pipeline execution.\n\nProvides comprehensive error messages with full execution stack traces,\npipeline hierarchy, and relevant context information for debugging\nnested pipeline failures.","ref":"Pipeline.Error.NestedPipeline.html"},{"type":"function","title":"Pipeline.Error.NestedPipeline.create_debug_log_entry/2","doc":"Create a structured error log entry for debugging.","ref":"Pipeline.Error.NestedPipeline.html#create_debug_log_entry/2"},{"type":"function","title":"Parameters - Pipeline.Error.NestedPipeline.create_debug_log_entry/2","doc":"- `error`: The error that occurred\n- `context`: Current execution context\n- `step`: Current step configuration (optional)","ref":"Pipeline.Error.NestedPipeline.html#create_debug_log_entry/2-parameters"},{"type":"function","title":"Returns - Pipeline.Error.NestedPipeline.create_debug_log_entry/2","doc":"- Structured log entry map","ref":"Pipeline.Error.NestedPipeline.html#create_debug_log_entry/2-returns"},{"type":"function","title":"Pipeline.Error.NestedPipeline.create_debug_log_entry/3","doc":"","ref":"Pipeline.Error.NestedPipeline.html#create_debug_log_entry/3"},{"type":"type","title":"Pipeline.Error.NestedPipeline.debug_log_entry/0","doc":"","ref":"Pipeline.Error.NestedPipeline.html#t:debug_log_entry/0"},{"type":"type","title":"Pipeline.Error.NestedPipeline.error_context/0","doc":"","ref":"Pipeline.Error.NestedPipeline.html#t:error_context/0"},{"type":"type","title":"Pipeline.Error.NestedPipeline.error_type/0","doc":"","ref":"Pipeline.Error.NestedPipeline.html#t:error_type/0"},{"type":"function","title":"Pipeline.Error.NestedPipeline.extract_base_error_message/1","doc":"","ref":"Pipeline.Error.NestedPipeline.html#extract_base_error_message/1"},{"type":"function","title":"Pipeline.Error.NestedPipeline.format_circular_dependency_error/2","doc":"Format a circular dependency error with the detected cycle.","ref":"Pipeline.Error.NestedPipeline.html#format_circular_dependency_error/2"},{"type":"function","title":"Parameters - Pipeline.Error.NestedPipeline.format_circular_dependency_error/2","doc":"- `circular_chain`: List of pipeline IDs forming the circular dependency\n- `context`: Current execution context","ref":"Pipeline.Error.NestedPipeline.html#format_circular_dependency_error/2-parameters"},{"type":"function","title":"Returns - Pipeline.Error.NestedPipeline.format_circular_dependency_error/2","doc":"- Formatted circular dependency error message","ref":"Pipeline.Error.NestedPipeline.html#format_circular_dependency_error/2-returns"},{"type":"function","title":"Pipeline.Error.NestedPipeline.format_nested_error/3","doc":"Format a nested pipeline error with comprehensive context information.","ref":"Pipeline.Error.NestedPipeline.html#format_nested_error/3"},{"type":"function","title":"Parameters - Pipeline.Error.NestedPipeline.format_nested_error/3","doc":"- `error`: The original error (string, exception, or error tuple)\n- `context`: Current execution context\n- `step`: Current step configuration (optional)","ref":"Pipeline.Error.NestedPipeline.html#format_nested_error/3-parameters"},{"type":"function","title":"Returns - Pipeline.Error.NestedPipeline.format_nested_error/3","doc":"- Formatted error with full context information","ref":"Pipeline.Error.NestedPipeline.html#format_nested_error/3-returns"},{"type":"function","title":"Examples - Pipeline.Error.NestedPipeline.format_nested_error/3","doc":"iex> context = %{nesting_depth: 1, pipeline_id: \"child\", parent_context: %{pipeline_id: \"parent\", nesting_depth: 0}}\n    iex> formatted = Pipeline.Error.NestedPipeline.format_nested_error(\"API timeout\", context)\n    iex> String.contains?(formatted.message, \"parent → child\")\n    true","ref":"Pipeline.Error.NestedPipeline.html#format_nested_error/3-examples"},{"type":"function","title":"Pipeline.Error.NestedPipeline.format_resource_limit_error/4","doc":"Format a resource limit error with current usage information.","ref":"Pipeline.Error.NestedPipeline.html#format_resource_limit_error/4"},{"type":"function","title":"Parameters - Pipeline.Error.NestedPipeline.format_resource_limit_error/4","doc":"- `limit_type`: Type of limit exceeded (:memory, :depth, :steps)\n- `current_value`: Current resource usage\n- `limit_value`: The limit that was exceeded\n- `context`: Current execution context","ref":"Pipeline.Error.NestedPipeline.html#format_resource_limit_error/4-parameters"},{"type":"function","title":"Returns - Pipeline.Error.NestedPipeline.format_resource_limit_error/4","doc":"- Formatted resource limit error message","ref":"Pipeline.Error.NestedPipeline.html#format_resource_limit_error/4-returns"},{"type":"function","title":"Pipeline.Error.NestedPipeline.format_timeout_error/3","doc":"Format a timeout error with execution context.","ref":"Pipeline.Error.NestedPipeline.html#format_timeout_error/3"},{"type":"function","title":"Parameters - Pipeline.Error.NestedPipeline.format_timeout_error/3","doc":"- `timeout_seconds`: The timeout that was exceeded\n- `context`: Current execution context\n- `elapsed_ms`: Actual elapsed time in milliseconds","ref":"Pipeline.Error.NestedPipeline.html#format_timeout_error/3-parameters"},{"type":"function","title":"Returns - Pipeline.Error.NestedPipeline.format_timeout_error/3","doc":"- Formatted timeout error message","ref":"Pipeline.Error.NestedPipeline.html#format_timeout_error/3-returns"},{"type":"type","title":"Pipeline.Error.NestedPipeline.formatted_error/0","doc":"","ref":"Pipeline.Error.NestedPipeline.html#t:formatted_error/0"},{"type":"module","title":"Pipeline.Meta.DNA.AdaptationChromosome","doc":"Manages environmental adaptation capabilities","ref":"Pipeline.Meta.DNA.AdaptationChromosome.html"},{"type":"function","title":"Pipeline.Meta.DNA.AdaptationChromosome.new/0","doc":"","ref":"Pipeline.Meta.DNA.AdaptationChromosome.html#new/0"},{"type":"type","title":"Pipeline.Meta.DNA.AdaptationChromosome.t/0","doc":"","ref":"Pipeline.Meta.DNA.AdaptationChromosome.html#t:t/0"},{"type":"module","title":"Pipeline.Meta.DNA.BehavioralChromosome","doc":"Determines execution patterns and runtime behavior","ref":"Pipeline.Meta.DNA.BehavioralChromosome.html"},{"type":"function","title":"Pipeline.Meta.DNA.BehavioralChromosome.from_traits/1","doc":"","ref":"Pipeline.Meta.DNA.BehavioralChromosome.html#from_traits/1"},{"type":"type","title":"Pipeline.Meta.DNA.BehavioralChromosome.t/0","doc":"","ref":"Pipeline.Meta.DNA.BehavioralChromosome.html#t:t/0"},{"type":"module","title":"Pipeline.Meta.DNA.OptimizationChromosome","doc":"Controls performance optimization characteristics","ref":"Pipeline.Meta.DNA.OptimizationChromosome.html"},{"type":"function","title":"Pipeline.Meta.DNA.OptimizationChromosome.from_traits/1","doc":"","ref":"Pipeline.Meta.DNA.OptimizationChromosome.html#from_traits/1"},{"type":"type","title":"Pipeline.Meta.DNA.OptimizationChromosome.t/0","doc":"","ref":"Pipeline.Meta.DNA.OptimizationChromosome.html#t:t/0"},{"type":"module","title":"Pipeline.Meta.DNA.StructuralChromosome","doc":"Controls the fundamental architecture of the pipeline","ref":"Pipeline.Meta.DNA.StructuralChromosome.html"},{"type":"function","title":"Pipeline.Meta.DNA.StructuralChromosome.from_genome/1","doc":"","ref":"Pipeline.Meta.DNA.StructuralChromosome.html#from_genome/1"},{"type":"type","title":"Pipeline.Meta.DNA.StructuralChromosome.t/0","doc":"","ref":"Pipeline.Meta.DNA.StructuralChromosome.html#t:t/0"},{"type":"module","title":"Pipeline.Metrics.NestedPerformance","doc":"Performance metrics collection and analysis for nested pipeline execution.\n\nProvides detailed performance tracking, metrics aggregation, and\nperformance analysis capabilities for nested pipeline workflows.","ref":"Pipeline.Metrics.NestedPerformance.html"},{"type":"function","title":"Pipeline.Metrics.NestedPerformance.analyze_performance/1","doc":"Analyze performance metrics and identify issues.","ref":"Pipeline.Metrics.NestedPerformance.html#analyze_performance/1"},{"type":"function","title":"Parameters - Pipeline.Metrics.NestedPerformance.analyze_performance/1","doc":"- `performance_metrics`: Completed performance metrics","ref":"Pipeline.Metrics.NestedPerformance.html#analyze_performance/1-parameters"},{"type":"function","title":"Returns - Pipeline.Metrics.NestedPerformance.analyze_performance/1","doc":"- Performance analysis with insights and recommendations","ref":"Pipeline.Metrics.NestedPerformance.html#analyze_performance/1-returns"},{"type":"function","title":"Pipeline.Metrics.NestedPerformance.compare_performance/2","doc":"Compare performance between multiple executions.","ref":"Pipeline.Metrics.NestedPerformance.html#compare_performance/2"},{"type":"function","title":"Parameters - Pipeline.Metrics.NestedPerformance.compare_performance/2","doc":"- `performance_metrics_list`: List of performance metrics to compare\n- `options`: Comparison options","ref":"Pipeline.Metrics.NestedPerformance.html#compare_performance/2-parameters"},{"type":"function","title":"Returns - Pipeline.Metrics.NestedPerformance.compare_performance/2","doc":"- Performance comparison report","ref":"Pipeline.Metrics.NestedPerformance.html#compare_performance/2-returns"},{"type":"function","title":"Pipeline.Metrics.NestedPerformance.complete_performance_tracking/1","doc":"Complete performance tracking and generate final metrics.","ref":"Pipeline.Metrics.NestedPerformance.html#complete_performance_tracking/1"},{"type":"function","title":"Parameters - Pipeline.Metrics.NestedPerformance.complete_performance_tracking/1","doc":"- `performance_context`: Current performance tracking context","ref":"Pipeline.Metrics.NestedPerformance.html#complete_performance_tracking/1-parameters"},{"type":"function","title":"Returns - Pipeline.Metrics.NestedPerformance.complete_performance_tracking/1","doc":"- Completed performance metrics with analysis","ref":"Pipeline.Metrics.NestedPerformance.html#complete_performance_tracking/1-returns"},{"type":"type","title":"Pipeline.Metrics.NestedPerformance.depth_metric/0","doc":"","ref":"Pipeline.Metrics.NestedPerformance.html#t:depth_metric/0"},{"type":"function","title":"Pipeline.Metrics.NestedPerformance.emit_performance_telemetry/2","doc":"Emit telemetry events for performance metrics.","ref":"Pipeline.Metrics.NestedPerformance.html#emit_performance_telemetry/2"},{"type":"function","title":"Parameters - Pipeline.Metrics.NestedPerformance.emit_performance_telemetry/2","doc":"- `performance_metrics`: Performance metrics to emit\n- `event_type`: Type of telemetry event","ref":"Pipeline.Metrics.NestedPerformance.html#emit_performance_telemetry/2-parameters"},{"type":"function","title":"Pipeline.Metrics.NestedPerformance.generate_performance_report/2","doc":"Generate a performance report.","ref":"Pipeline.Metrics.NestedPerformance.html#generate_performance_report/2"},{"type":"function","title":"Parameters - Pipeline.Metrics.NestedPerformance.generate_performance_report/2","doc":"- `performance_metrics`: Performance metrics to report on\n- `options`: Report generation options","ref":"Pipeline.Metrics.NestedPerformance.html#generate_performance_report/2-parameters"},{"type":"function","title":"Returns - Pipeline.Metrics.NestedPerformance.generate_performance_report/2","doc":"- Formatted performance report","ref":"Pipeline.Metrics.NestedPerformance.html#generate_performance_report/2-returns"},{"type":"type","title":"Pipeline.Metrics.NestedPerformance.performance_metrics/0","doc":"","ref":"Pipeline.Metrics.NestedPerformance.html#t:performance_metrics/0"},{"type":"type","title":"Pipeline.Metrics.NestedPerformance.performance_summary/0","doc":"","ref":"Pipeline.Metrics.NestedPerformance.html#t:performance_summary/0"},{"type":"type","title":"Pipeline.Metrics.NestedPerformance.pipeline_metric/0","doc":"","ref":"Pipeline.Metrics.NestedPerformance.html#t:pipeline_metric/0"},{"type":"function","title":"Pipeline.Metrics.NestedPerformance.record_pipeline_metric/8","doc":"Record metrics for a single pipeline execution.","ref":"Pipeline.Metrics.NestedPerformance.html#record_pipeline_metric/8"},{"type":"function","title":"Parameters - Pipeline.Metrics.NestedPerformance.record_pipeline_metric/8","doc":"- `performance_context`: Current performance tracking context\n- `pipeline_id`: Pipeline that was executed\n- `depth`: Nesting depth of the pipeline\n- `duration_ms`: Execution duration in milliseconds\n- `step_count`: Number of steps in the pipeline\n- `success`: Whether execution was successful\n- `error`: Error message if execution failed\n- `metadata`: Additional metadata","ref":"Pipeline.Metrics.NestedPerformance.html#record_pipeline_metric/8-parameters"},{"type":"function","title":"Returns - Pipeline.Metrics.NestedPerformance.record_pipeline_metric/8","doc":"- Updated performance context","ref":"Pipeline.Metrics.NestedPerformance.html#record_pipeline_metric/8-returns"},{"type":"type","title":"Pipeline.Metrics.NestedPerformance.resource_metric/0","doc":"","ref":"Pipeline.Metrics.NestedPerformance.html#t:resource_metric/0"},{"type":"function","title":"Pipeline.Metrics.NestedPerformance.start_performance_tracking/2","doc":"Start performance tracking for a nested pipeline execution.","ref":"Pipeline.Metrics.NestedPerformance.html#start_performance_tracking/2"},{"type":"function","title":"Parameters - Pipeline.Metrics.NestedPerformance.start_performance_tracking/2","doc":"- `trace_id`: The trace ID for this execution\n- `pipeline_id`: The root pipeline ID","ref":"Pipeline.Metrics.NestedPerformance.html#start_performance_tracking/2-parameters"},{"type":"function","title":"Returns - Pipeline.Metrics.NestedPerformance.start_performance_tracking/2","doc":"- Performance tracking context","ref":"Pipeline.Metrics.NestedPerformance.html#start_performance_tracking/2-returns"},{"type":"module","title":"Pipeline.Monitoring.Performance","doc":"Performance monitoring and metrics collection for pipeline execution.\n\nProvides real-time performance tracking, memory usage monitoring,\nbottleneck identification, and performance optimization recommendations.","ref":"Pipeline.Monitoring.Performance.html"},{"type":"function","title":"Pipeline.Monitoring.Performance.check_thresholds/1","doc":"Check if performance thresholds are being exceeded.","ref":"Pipeline.Monitoring.Performance.html#check_thresholds/1"},{"type":"function","title":"Pipeline.Monitoring.Performance.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Pipeline.Monitoring.Performance.html#child_spec/1"},{"type":"function","title":"Pipeline.Monitoring.Performance.get_metrics/1","doc":"Get current performance metrics.","ref":"Pipeline.Monitoring.Performance.html#get_metrics/1"},{"type":"type","title":"Pipeline.Monitoring.Performance.metric_value/0","doc":"","ref":"Pipeline.Monitoring.Performance.html#t:metric_value/0"},{"type":"type","title":"Pipeline.Monitoring.Performance.metrics/0","doc":"","ref":"Pipeline.Monitoring.Performance.html#t:metrics/0"},{"type":"function","title":"Pipeline.Monitoring.Performance.start_monitoring/2","doc":"Start performance monitoring for a pipeline.","ref":"Pipeline.Monitoring.Performance.html#start_monitoring/2"},{"type":"function","title":"Pipeline.Monitoring.Performance.step_completed/3","doc":"Record step completion event.","ref":"Pipeline.Monitoring.Performance.html#step_completed/3"},{"type":"function","title":"Pipeline.Monitoring.Performance.step_failed/3","doc":"Record step failure event.","ref":"Pipeline.Monitoring.Performance.html#step_failed/3"},{"type":"function","title":"Pipeline.Monitoring.Performance.step_started/3","doc":"Record step start event.","ref":"Pipeline.Monitoring.Performance.html#step_started/3"},{"type":"function","title":"Pipeline.Monitoring.Performance.stop_monitoring/1","doc":"Stop performance monitoring and return final metrics.","ref":"Pipeline.Monitoring.Performance.html#stop_monitoring/1"},{"type":"type","title":"Pipeline.Monitoring.Performance.t/0","doc":"","ref":"Pipeline.Monitoring.Performance.html#t:t/0"},{"type":"module","title":"Pipeline.Monitoring.Registry","doc":"Registry for pipeline monitoring processes.","ref":"Pipeline.Monitoring.Registry.html"},{"type":"function","title":"Pipeline.Monitoring.Registry.child_spec/1","doc":"","ref":"Pipeline.Monitoring.Registry.html#child_spec/1"},{"type":"module","title":"Pipeline.OptionBuilder","doc":"Pipeline wrapper for ClaudeCodeSDK.OptionBuilder with additional pipeline-specific functionality.\n\nProvides preset configurations optimized for different environments and use cases:\n- Development: Permissive settings, verbose logging, full tool access\n- Production: Restricted settings, minimal tools, safe defaults\n- Analysis: Read-only tools, optimized for code analysis\n- Chat: Simple conversation settings, basic tools\n- Test: Optimized for testing with mock-friendly settings","ref":"Pipeline.OptionBuilder.html"},{"type":"function","title":"Pipeline.OptionBuilder.apply_preset_optimizations/2","doc":"Apply preset-specific optimizations to a configuration.","ref":"Pipeline.OptionBuilder.html#apply_preset_optimizations/2"},{"type":"function","title":"Pipeline.OptionBuilder.build_analysis_options/0","doc":"Build analysis preset options.\nOptimized for code analysis with read-only tools and detailed reporting.","ref":"Pipeline.OptionBuilder.html#build_analysis_options/0"},{"type":"function","title":"Pipeline.OptionBuilder.build_chat_options/0","doc":"Build chat preset options.\nOptimized for simple conversations with minimal tools.","ref":"Pipeline.OptionBuilder.html#build_chat_options/0"},{"type":"function","title":"Pipeline.OptionBuilder.build_development_options/0","doc":"Build development preset options.\nOptimized for development work with permissive settings and verbose output.","ref":"Pipeline.OptionBuilder.html#build_development_options/0"},{"type":"function","title":"Pipeline.OptionBuilder.build_production_options/0","doc":"Build production preset options.\nOptimized for production use with restricted settings and minimal tools.","ref":"Pipeline.OptionBuilder.html#build_production_options/0"},{"type":"function","title":"Pipeline.OptionBuilder.build_test_options/0","doc":"Build test preset options.\nOptimized for testing with mock-friendly settings.","ref":"Pipeline.OptionBuilder.html#build_test_options/0"},{"type":"type","title":"Pipeline.OptionBuilder.claude_options/0","doc":"","ref":"Pipeline.OptionBuilder.html#t:claude_options/0"},{"type":"function","title":"Pipeline.OptionBuilder.for_environment/0","doc":"Build options based on the current environment.\nAuto-detects the environment and applies appropriate presets.","ref":"Pipeline.OptionBuilder.html#for_environment/0"},{"type":"function","title":"Pipeline.OptionBuilder.get_preset_config/1","doc":"Get preset configuration for a specific use case.","ref":"Pipeline.OptionBuilder.html#get_preset_config/1"},{"type":"function","title":"Pipeline.OptionBuilder.list_presets/0","doc":"List all available presets with their descriptions.","ref":"Pipeline.OptionBuilder.html#list_presets/0"},{"type":"function","title":"Pipeline.OptionBuilder.merge/2","doc":"Merge a preset with custom options.\nCustom options override preset values.","ref":"Pipeline.OptionBuilder.html#merge/2"},{"type":"type","title":"Pipeline.OptionBuilder.preset_name/0","doc":"","ref":"Pipeline.OptionBuilder.html#t:preset_name/0"},{"type":"function","title":"Pipeline.OptionBuilder.valid_preset?/1","doc":"Validate that a preset name is valid.","ref":"Pipeline.OptionBuilder.html#valid_preset?/1"},{"type":"module","title":"Pipeline.PromptBuilder","doc":"Builds prompts from template configurations.\nIncludes file caching for improved performance.","ref":"Pipeline.PromptBuilder.html"},{"type":"function","title":"Pipeline.PromptBuilder.build/2","doc":"Build a prompt from prompt parts and previous results.","ref":"Pipeline.PromptBuilder.html#build/2"},{"type":"function","title":"Pipeline.PromptBuilder.clear_cache/0","doc":"Clear the file cache (useful for testing and memory management).","ref":"Pipeline.PromptBuilder.html#clear_cache/0"},{"type":"behaviour","title":"Pipeline.Providers.AIProvider","doc":"Behavior for AI service providers (Claude, Gemini, etc.)\n\nThis interface allows swapping between live and mock implementations\nfor testing and development.","ref":"Pipeline.Providers.AIProvider.html"},{"type":"type","title":"Pipeline.Providers.AIProvider.error_reason/0","doc":"","ref":"Pipeline.Providers.AIProvider.html#t:error_reason/0"},{"type":"function","title":"Pipeline.Providers.AIProvider.get_provider/0","doc":"Get the provider implementation based on configuration.","ref":"Pipeline.Providers.AIProvider.html#get_provider/0"},{"type":"type","title":"Pipeline.Providers.AIProvider.options/0","doc":"","ref":"Pipeline.Providers.AIProvider.html#t:options/0"},{"type":"type","title":"Pipeline.Providers.AIProvider.prompt/0","doc":"","ref":"Pipeline.Providers.AIProvider.html#t:prompt/0"},{"type":"callback","title":"Pipeline.Providers.AIProvider.query/2","doc":"Query the AI service with a prompt and options.\n\nReturns either a successful response with text, success status and cost,\nor an error with a reason string.","ref":"Pipeline.Providers.AIProvider.html#c:query/2"},{"type":"type","title":"Pipeline.Providers.AIProvider.response/0","doc":"","ref":"Pipeline.Providers.AIProvider.html#t:response/0"},{"type":"module","title":"Pipeline.Providers.EnhancedClaudeProvider","doc":"Enhanced Claude provider with full Claude Code SDK integration.\n\nSupports all enhanced features:\n- Complete ClaudeCodeSDK.Options mapping\n- OptionBuilder preset integration\n- Advanced error handling with retries\n- Session management support\n- Content extraction integration\n- Performance monitoring and cost tracking","ref":"Pipeline.Providers.EnhancedClaudeProvider.html"},{"type":"function","title":"Pipeline.Providers.EnhancedClaudeProvider.query/2","doc":"Query Claude using the enhanced Claude Code SDK integration.","ref":"Pipeline.Providers.EnhancedClaudeProvider.html#query/2"},{"type":"module","title":"Pipeline.Providers.GeminiProvider.TextResponse","doc":"Simple response schema for Gemini text responses.","ref":"Pipeline.Providers.GeminiProvider.TextResponse.html"},{"type":"function","title":"Pipeline.Providers.GeminiProvider.TextResponse.fetch/2","doc":"Callback implementation for  Access.fetch/2 .","ref":"Pipeline.Providers.GeminiProvider.TextResponse.html#fetch/2"},{"type":"function","title":"Pipeline.Providers.GeminiProvider.TextResponse.get_and_update/3","doc":"Callback implementation for  Access.get_and_update/3 .","ref":"Pipeline.Providers.GeminiProvider.TextResponse.html#get_and_update/3"},{"type":"function","title":"Pipeline.Providers.GeminiProvider.TextResponse.pop/2","doc":"Callback implementation for  Access.pop/2 .","ref":"Pipeline.Providers.GeminiProvider.TextResponse.html#pop/2"},{"type":"module","title":"Pipeline.ResultManager","doc":"Manages step results throughout pipeline execution.\n\nProvides structured storage, retrieval, and transformation of results\nbetween pipeline steps with support for serialization and validation.\n\nFeatures include:\n- JSON Schema validation for step outputs\n- Structured result storage and retrieval\n- Result transformation for prompt consumption\n- Serialization and persistence","ref":"Pipeline.ResultManager.html"},{"type":"function","title":"Pipeline.ResultManager.extract_field/3","doc":"Extract a specific field from a step result.","ref":"Pipeline.ResultManager.html#extract_field/3"},{"type":"function","title":"Pipeline.ResultManager.from_json/1","doc":"Deserialize results from JSON.","ref":"Pipeline.ResultManager.html#from_json/1"},{"type":"function","title":"Pipeline.ResultManager.get_all_results/1","doc":"Get all results.","ref":"Pipeline.ResultManager.html#get_all_results/1"},{"type":"function","title":"Pipeline.ResultManager.get_result/2","doc":"Retrieve a result by step name.","ref":"Pipeline.ResultManager.html#get_result/2"},{"type":"function","title":"Pipeline.ResultManager.get_summary/1","doc":"Get summary statistics about stored results.","ref":"Pipeline.ResultManager.html#get_summary/1"},{"type":"function","title":"Pipeline.ResultManager.has_result?/2","doc":"Check if a result exists for a step.","ref":"Pipeline.ResultManager.html#has_result?/2"},{"type":"function","title":"Pipeline.ResultManager.load_from_file/1","doc":"Load results from file.","ref":"Pipeline.ResultManager.html#load_from_file/1"},{"type":"function","title":"Pipeline.ResultManager.new/0","doc":"Create a new result manager.","ref":"Pipeline.ResultManager.html#new/0"},{"type":"type","title":"Pipeline.ResultManager.result/0","doc":"","ref":"Pipeline.ResultManager.html#t:result/0"},{"type":"type","title":"Pipeline.ResultManager.result_key/0","doc":"","ref":"Pipeline.ResultManager.html#t:result_key/0"},{"type":"type","title":"Pipeline.ResultManager.result_store/0","doc":"","ref":"Pipeline.ResultManager.html#t:result_store/0"},{"type":"function","title":"Pipeline.ResultManager.save_to_file/2","doc":"Save results to file.","ref":"Pipeline.ResultManager.html#save_to_file/2"},{"type":"type","title":"Pipeline.ResultManager.schema/0","doc":"","ref":"Pipeline.ResultManager.html#t:schema/0"},{"type":"function","title":"Pipeline.ResultManager.store_result/3","doc":"Store a result for a step.","ref":"Pipeline.ResultManager.html#store_result/3"},{"type":"function","title":"Pipeline.ResultManager.store_result_with_schema/4","doc":"Store a result for a step with optional schema validation.","ref":"Pipeline.ResultManager.html#store_result_with_schema/4"},{"type":"function","title":"Pipeline.ResultManager.to_json/1","doc":"Serialize results to JSON for storage.","ref":"Pipeline.ResultManager.html#to_json/1"},{"type":"function","title":"Pipeline.ResultManager.transform_for_prompt/3","doc":"Transform results for consumption by next step.","ref":"Pipeline.ResultManager.html#transform_for_prompt/3"},{"type":"module","title":"Pipeline.Safety.RecursionGuard","doc":"Recursion protection and circular dependency detection for nested pipelines.\n\nProvides safety mechanisms to prevent infinite recursion and detect circular \ndependencies in nested pipeline execution chains.","ref":"Pipeline.Safety.RecursionGuard.html"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.build_execution_chain/1","doc":"Build the execution chain from the current context up to the root.","ref":"Pipeline.Safety.RecursionGuard.html#build_execution_chain/1"},{"type":"function","title":"Parameters - Pipeline.Safety.RecursionGuard.build_execution_chain/1","doc":"- `context`: The current execution context","ref":"Pipeline.Safety.RecursionGuard.html#build_execution_chain/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.RecursionGuard.build_execution_chain/1","doc":"- List of pipeline IDs in the execution chain","ref":"Pipeline.Safety.RecursionGuard.html#build_execution_chain/1-returns"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.check_all_safety/2","doc":"Perform all safety checks for nested pipeline execution.","ref":"Pipeline.Safety.RecursionGuard.html#check_all_safety/2"},{"type":"function","title":"Parameters - Pipeline.Safety.RecursionGuard.check_all_safety/2","doc":"- `pipeline_id`: The ID of the pipeline about to be executed\n- `context`: The current execution context\n- `limits`: Safety limits configuration (optional)","ref":"Pipeline.Safety.RecursionGuard.html#check_all_safety/2-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.RecursionGuard.check_all_safety/2","doc":"- `:ok` if all checks pass\n- `{:error, message}` if any check fails","ref":"Pipeline.Safety.RecursionGuard.html#check_all_safety/2-returns"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.check_all_safety/3","doc":"","ref":"Pipeline.Safety.RecursionGuard.html#check_all_safety/3"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.check_circular_dependency/2","doc":"Check for circular dependencies in the execution chain.","ref":"Pipeline.Safety.RecursionGuard.html#check_circular_dependency/2"},{"type":"function","title":"Parameters - Pipeline.Safety.RecursionGuard.check_circular_dependency/2","doc":"- `pipeline_id`: The ID of the pipeline about to be executed\n- `context`: The current execution context","ref":"Pipeline.Safety.RecursionGuard.html#check_circular_dependency/2-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.RecursionGuard.check_circular_dependency/2","doc":"- `:ok` if no circular dependency detected\n- `{:error, message}` if circular dependency found","ref":"Pipeline.Safety.RecursionGuard.html#check_circular_dependency/2-returns"},{"type":"function","title":"Examples - Pipeline.Safety.RecursionGuard.check_circular_dependency/2","doc":"iex> context = %{pipeline_id: \"parent\", parent_context: nil}\n    iex> Pipeline.Safety.RecursionGuard.check_circular_dependency(\"child\", context)\n    :ok\n    \n    iex> parent = %{pipeline_id: \"parent\", parent_context: nil}\n    iex> child = %{pipeline_id: \"child\", parent_context: parent}\n    iex> Pipeline.Safety.RecursionGuard.check_circular_dependency(\"parent\", child)\n    {:error, \"Circular dependency detected: parent → child → parent\"}","ref":"Pipeline.Safety.RecursionGuard.html#check_circular_dependency/2-examples"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.check_limits/1","doc":"Check if the current execution context violates recursion limits.","ref":"Pipeline.Safety.RecursionGuard.html#check_limits/1"},{"type":"function","title":"Parameters - Pipeline.Safety.RecursionGuard.check_limits/1","doc":"- `context`: The current execution context\n- `limits`: Safety limits configuration (optional)","ref":"Pipeline.Safety.RecursionGuard.html#check_limits/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.RecursionGuard.check_limits/1","doc":"- `:ok` if all checks pass\n- `{:error, message}` if limits are exceeded","ref":"Pipeline.Safety.RecursionGuard.html#check_limits/1-returns"},{"type":"function","title":"Examples - Pipeline.Safety.RecursionGuard.check_limits/1","doc":"iex> context = %{nesting_depth: 2, pipeline_id: \"test\", parent_context: nil, step_count: 5}\n    iex> Pipeline.Safety.RecursionGuard.check_limits(context)\n    :ok\n    \n    iex> context = %{nesting_depth: 15, pipeline_id: \"test\", parent_context: nil, step_count: 5}\n    iex> Pipeline.Safety.RecursionGuard.check_limits(context)\n    {:error, \"Maximum nesting depth (10) exceeded: current depth is 15\"}","ref":"Pipeline.Safety.RecursionGuard.html#check_limits/1-examples"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.check_limits/2","doc":"","ref":"Pipeline.Safety.RecursionGuard.html#check_limits/2"},{"type":"type","title":"Pipeline.Safety.RecursionGuard.check_result/0","doc":"","ref":"Pipeline.Safety.RecursionGuard.html#t:check_result/0"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.count_total_steps/1","doc":"Count the total number of steps across all nested pipelines.","ref":"Pipeline.Safety.RecursionGuard.html#count_total_steps/1"},{"type":"function","title":"Parameters - Pipeline.Safety.RecursionGuard.count_total_steps/1","doc":"- `context`: The current execution context","ref":"Pipeline.Safety.RecursionGuard.html#count_total_steps/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.RecursionGuard.count_total_steps/1","doc":"- Total number of steps","ref":"Pipeline.Safety.RecursionGuard.html#count_total_steps/1-returns"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.create_execution_context/3","doc":"Create a new execution context for a nested pipeline.","ref":"Pipeline.Safety.RecursionGuard.html#create_execution_context/3"},{"type":"function","title":"Parameters - Pipeline.Safety.RecursionGuard.create_execution_context/3","doc":"- `pipeline_id`: The ID of the pipeline\n- `parent_context`: The parent execution context (optional)\n- `step_count`: The number of steps in this pipeline (default: 0)","ref":"Pipeline.Safety.RecursionGuard.html#create_execution_context/3-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.RecursionGuard.create_execution_context/3","doc":"- New execution context","ref":"Pipeline.Safety.RecursionGuard.html#create_execution_context/3-returns"},{"type":"type","title":"Pipeline.Safety.RecursionGuard.execution_context/0","doc":"","ref":"Pipeline.Safety.RecursionGuard.html#t:execution_context/0"},{"type":"function","title":"Pipeline.Safety.RecursionGuard.log_safety_check/3","doc":"Log safety check results with appropriate log level.","ref":"Pipeline.Safety.RecursionGuard.html#log_safety_check/3"},{"type":"function","title":"Parameters - Pipeline.Safety.RecursionGuard.log_safety_check/3","doc":"- `check_result`: The result of safety checks\n- `pipeline_id`: The ID of the pipeline being checked\n- `context`: The current execution context","ref":"Pipeline.Safety.RecursionGuard.html#log_safety_check/3-parameters"},{"type":"type","title":"Pipeline.Safety.RecursionGuard.safety_limits/0","doc":"","ref":"Pipeline.Safety.RecursionGuard.html#t:safety_limits/0"},{"type":"module","title":"Pipeline.Safety.ResourceMonitor","doc":"Resource monitoring and management for nested pipeline execution.\n\nProvides memory usage tracking, resource cleanup, and resource limit enforcement\nto prevent resource exhaustion during nested pipeline execution.","ref":"Pipeline.Safety.ResourceMonitor.html"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.check_limits/1","doc":"Check if current resource usage exceeds configured limits.","ref":"Pipeline.Safety.ResourceMonitor.html#check_limits/1"},{"type":"function","title":"Parameters - Pipeline.Safety.ResourceMonitor.check_limits/1","doc":"- `usage`: Current resource usage metrics\n- `limits`: Resource limits configuration (optional)","ref":"Pipeline.Safety.ResourceMonitor.html#check_limits/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.ResourceMonitor.check_limits/1","doc":"- `:ok` if within limits\n- `{:error, message}` if limits exceeded","ref":"Pipeline.Safety.ResourceMonitor.html#check_limits/1-returns"},{"type":"function","title":"Examples - Pipeline.Safety.ResourceMonitor.check_limits/1","doc":"iex> usage = %{memory_bytes: 100_000_000, start_time: DateTime.utc_now(), elapsed_ms: 1000}\n    iex> Pipeline.Safety.ResourceMonitor.check_limits(usage)\n    :ok\n    \n    iex> usage = %{memory_bytes: 2_000_000_000, start_time: DateTime.utc_now(), elapsed_ms: 1000}\n    iex> limits = %{memory_limit_mb: 1024}\n    iex> Pipeline.Safety.ResourceMonitor.check_limits(usage, limits)\n    {:error, \"Memory limit exceeded: 1907.3 MB > 1024 MB\"}","ref":"Pipeline.Safety.ResourceMonitor.html#check_limits/1-examples"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.check_limits/2","doc":"","ref":"Pipeline.Safety.ResourceMonitor.html#check_limits/2"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.check_memory_pressure/1","doc":"Check if memory usage is approaching limits and log warnings.","ref":"Pipeline.Safety.ResourceMonitor.html#check_memory_pressure/1"},{"type":"function","title":"Parameters - Pipeline.Safety.ResourceMonitor.check_memory_pressure/1","doc":"- `usage`: Current resource usage metrics\n- `limits`: Resource limits configuration (optional)","ref":"Pipeline.Safety.ResourceMonitor.html#check_memory_pressure/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.ResourceMonitor.check_memory_pressure/1","doc":"- `:ok` always (warnings are logged, not returned as errors)","ref":"Pipeline.Safety.ResourceMonitor.html#check_memory_pressure/1-returns"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.check_memory_pressure/2","doc":"","ref":"Pipeline.Safety.ResourceMonitor.html#check_memory_pressure/2"},{"type":"type","title":"Pipeline.Safety.ResourceMonitor.check_result/0","doc":"","ref":"Pipeline.Safety.ResourceMonitor.html#t:check_result/0"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.cleanup_context/1","doc":"Perform resource cleanup on execution context.\n\nThis function cleans up resources associated with nested pipeline execution,\nincluding workspace directories and large data structures.","ref":"Pipeline.Safety.ResourceMonitor.html#cleanup_context/1"},{"type":"function","title":"Parameters - Pipeline.Safety.ResourceMonitor.cleanup_context/1","doc":"- `context`: Execution context containing resource references","ref":"Pipeline.Safety.ResourceMonitor.html#cleanup_context/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.ResourceMonitor.cleanup_context/1","doc":"- Updated context with resources cleaned","ref":"Pipeline.Safety.ResourceMonitor.html#cleanup_context/1-returns"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.cleanup_workspace/1","doc":"Clean up workspace directory and its contents.","ref":"Pipeline.Safety.ResourceMonitor.html#cleanup_workspace/1"},{"type":"function","title":"Parameters - Pipeline.Safety.ResourceMonitor.cleanup_workspace/1","doc":"- `workspace_path`: Path to workspace directory to clean up","ref":"Pipeline.Safety.ResourceMonitor.html#cleanup_workspace/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.ResourceMonitor.cleanup_workspace/1","doc":"- `:ok` if cleanup successful\n- `{:error, reason}` if cleanup failed","ref":"Pipeline.Safety.ResourceMonitor.html#cleanup_workspace/1-returns"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.collect_usage/1","doc":"Collect current resource usage metrics.","ref":"Pipeline.Safety.ResourceMonitor.html#collect_usage/1"},{"type":"function","title":"Parameters - Pipeline.Safety.ResourceMonitor.collect_usage/1","doc":"- `start_time`: When execution started (optional, defaults to now)","ref":"Pipeline.Safety.ResourceMonitor.html#collect_usage/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.ResourceMonitor.collect_usage/1","doc":"- Resource usage metrics","ref":"Pipeline.Safety.ResourceMonitor.html#collect_usage/1-returns"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.create_workspace/2","doc":"Create workspace directory for nested pipeline execution.","ref":"Pipeline.Safety.ResourceMonitor.html#create_workspace/2"},{"type":"function","title":"Parameters - Pipeline.Safety.ResourceMonitor.create_workspace/2","doc":"- `workspace_path`: Path to workspace directory\n- `step_name`: Name of the step (for unique directory naming)","ref":"Pipeline.Safety.ResourceMonitor.html#create_workspace/2-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.ResourceMonitor.create_workspace/2","doc":"- `{:ok, full_path}` if directory created successfully\n- `{:error, reason}` if creation failed","ref":"Pipeline.Safety.ResourceMonitor.html#create_workspace/2-returns"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.log_resource_usage/2","doc":"Log resource usage with appropriate detail level.","ref":"Pipeline.Safety.ResourceMonitor.html#log_resource_usage/2"},{"type":"function","title":"Parameters - Pipeline.Safety.ResourceMonitor.log_resource_usage/2","doc":"- `usage`: Current resource usage metrics\n- `level`: Log level (:debug, :info, :warning, :error)","ref":"Pipeline.Safety.ResourceMonitor.html#log_resource_usage/2-parameters"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.monitor_execution/1","doc":"Monitor resource usage during execution and check limits.","ref":"Pipeline.Safety.ResourceMonitor.html#monitor_execution/1"},{"type":"function","title":"Parameters - Pipeline.Safety.ResourceMonitor.monitor_execution/1","doc":"- `start_time`: When execution started\n- `limits`: Resource limits configuration (optional)","ref":"Pipeline.Safety.ResourceMonitor.html#monitor_execution/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.ResourceMonitor.monitor_execution/1","doc":"- `:ok` if within limits\n- `{:error, message}` if limits exceeded","ref":"Pipeline.Safety.ResourceMonitor.html#monitor_execution/1-returns"},{"type":"function","title":"Pipeline.Safety.ResourceMonitor.monitor_execution/2","doc":"","ref":"Pipeline.Safety.ResourceMonitor.html#monitor_execution/2"},{"type":"type","title":"Pipeline.Safety.ResourceMonitor.resource_limits/0","doc":"","ref":"Pipeline.Safety.ResourceMonitor.html#t:resource_limits/0"},{"type":"type","title":"Pipeline.Safety.ResourceMonitor.resource_usage/0","doc":"","ref":"Pipeline.Safety.ResourceMonitor.html#t:resource_usage/0"},{"type":"module","title":"Pipeline.Safety.SafetyManager","doc":"Unified safety management for nested pipeline execution.\n\nProvides a single interface for all safety checks including recursion limits,\nresource monitoring, and error handling for nested pipeline execution.","ref":"Pipeline.Safety.SafetyManager.html"},{"type":"function","title":"Pipeline.Safety.SafetyManager.check_safety/2","doc":"Perform comprehensive safety checks before executing a nested pipeline.","ref":"Pipeline.Safety.SafetyManager.html#check_safety/2"},{"type":"function","title":"Parameters - Pipeline.Safety.SafetyManager.check_safety/2","doc":"- `pipeline_id`: The ID of the pipeline about to be executed\n- `context`: The current execution context\n- `config`: Safety configuration (optional)","ref":"Pipeline.Safety.SafetyManager.html#check_safety/2-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.SafetyManager.check_safety/2","doc":"- `:ok` if all safety checks pass\n- `{:error, message}` if any safety check fails","ref":"Pipeline.Safety.SafetyManager.html#check_safety/2-returns"},{"type":"function","title":"Examples - Pipeline.Safety.SafetyManager.check_safety/2","doc":"iex> context = %{nesting_depth: 2, pipeline_id: \"test\", parent_context: nil, step_count: 5, start_time: DateTime.utc_now(), workspace_dir: nil}\n    iex> Pipeline.Safety.SafetyManager.check_safety(\"child\", context)\n    :ok","ref":"Pipeline.Safety.SafetyManager.html#check_safety/2-examples"},{"type":"function","title":"Pipeline.Safety.SafetyManager.check_safety/3","doc":"","ref":"Pipeline.Safety.SafetyManager.html#check_safety/3"},{"type":"function","title":"Pipeline.Safety.SafetyManager.cleanup_execution/1","doc":"Clean up resources and perform safety cleanup after execution.","ref":"Pipeline.Safety.SafetyManager.html#cleanup_execution/1"},{"type":"function","title":"Parameters - Pipeline.Safety.SafetyManager.cleanup_execution/1","doc":"- `context`: Execution context to clean up\n- `config`: Safety configuration (optional)","ref":"Pipeline.Safety.SafetyManager.html#cleanup_execution/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.SafetyManager.cleanup_execution/1","doc":"- Cleaned execution context","ref":"Pipeline.Safety.SafetyManager.html#cleanup_execution/1-returns"},{"type":"function","title":"Pipeline.Safety.SafetyManager.cleanup_execution/2","doc":"","ref":"Pipeline.Safety.SafetyManager.html#cleanup_execution/2"},{"type":"function","title":"Pipeline.Safety.SafetyManager.create_safe_context/1","doc":"Create execution context for a nested pipeline with safety tracking.","ref":"Pipeline.Safety.SafetyManager.html#create_safe_context/1"},{"type":"function","title":"Parameters - Pipeline.Safety.SafetyManager.create_safe_context/1","doc":"- `pipeline_id`: The ID of the pipeline\n- `parent_context`: The parent execution context (optional)\n- `step_count`: Number of steps in the pipeline (default: 0)\n- `config`: Safety configuration (optional)","ref":"Pipeline.Safety.SafetyManager.html#create_safe_context/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.SafetyManager.create_safe_context/1","doc":"- New execution context with safety tracking","ref":"Pipeline.Safety.SafetyManager.html#create_safe_context/1-returns"},{"type":"function","title":"Pipeline.Safety.SafetyManager.create_safe_context/2","doc":"","ref":"Pipeline.Safety.SafetyManager.html#create_safe_context/2"},{"type":"function","title":"Pipeline.Safety.SafetyManager.create_safe_context/3","doc":"","ref":"Pipeline.Safety.SafetyManager.html#create_safe_context/3"},{"type":"function","title":"Pipeline.Safety.SafetyManager.create_safe_context/4","doc":"","ref":"Pipeline.Safety.SafetyManager.html#create_safe_context/4"},{"type":"function","title":"Pipeline.Safety.SafetyManager.default_config/0","doc":"Get default safety configuration.","ref":"Pipeline.Safety.SafetyManager.html#default_config/0"},{"type":"function","title":"Returns - Pipeline.Safety.SafetyManager.default_config/0","doc":"- Default safety configuration map","ref":"Pipeline.Safety.SafetyManager.html#default_config/0-returns"},{"type":"type","title":"Pipeline.Safety.SafetyManager.execution_context/0","doc":"","ref":"Pipeline.Safety.SafetyManager.html#t:execution_context/0"},{"type":"function","title":"Pipeline.Safety.SafetyManager.handle_safety_violation/2","doc":"Handle safety violations and perform appropriate cleanup.","ref":"Pipeline.Safety.SafetyManager.html#handle_safety_violation/2"},{"type":"function","title":"Parameters - Pipeline.Safety.SafetyManager.handle_safety_violation/2","doc":"- `error`: The safety error that occurred\n- `context`: Current execution context\n- `config`: Safety configuration (optional)","ref":"Pipeline.Safety.SafetyManager.html#handle_safety_violation/2-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.SafetyManager.handle_safety_violation/2","doc":"- Formatted error with context information","ref":"Pipeline.Safety.SafetyManager.html#handle_safety_violation/2-returns"},{"type":"function","title":"Pipeline.Safety.SafetyManager.handle_safety_violation/3","doc":"","ref":"Pipeline.Safety.SafetyManager.html#handle_safety_violation/3"},{"type":"function","title":"Pipeline.Safety.SafetyManager.merge_config/1","doc":"Merge user configuration with defaults.","ref":"Pipeline.Safety.SafetyManager.html#merge_config/1"},{"type":"function","title":"Parameters - Pipeline.Safety.SafetyManager.merge_config/1","doc":"- `user_config`: User-provided configuration (optional)","ref":"Pipeline.Safety.SafetyManager.html#merge_config/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.SafetyManager.merge_config/1","doc":"- Complete safety configuration","ref":"Pipeline.Safety.SafetyManager.html#merge_config/1-returns"},{"type":"function","title":"Pipeline.Safety.SafetyManager.monitor_execution/1","doc":"Monitor ongoing execution and check for safety violations.","ref":"Pipeline.Safety.SafetyManager.html#monitor_execution/1"},{"type":"function","title":"Parameters - Pipeline.Safety.SafetyManager.monitor_execution/1","doc":"- `context`: Current execution context\n- `config`: Safety configuration (optional)","ref":"Pipeline.Safety.SafetyManager.html#monitor_execution/1-parameters"},{"type":"function","title":"Returns - Pipeline.Safety.SafetyManager.monitor_execution/1","doc":"- `:ok` if execution is within safety limits\n- `{:error, message}` if safety limits exceeded","ref":"Pipeline.Safety.SafetyManager.html#monitor_execution/1-returns"},{"type":"function","title":"Pipeline.Safety.SafetyManager.monitor_execution/2","doc":"","ref":"Pipeline.Safety.SafetyManager.html#monitor_execution/2"},{"type":"type","title":"Pipeline.Safety.SafetyManager.safety_config/0","doc":"","ref":"Pipeline.Safety.SafetyManager.html#t:safety_config/0"},{"type":"type","title":"Pipeline.Safety.SafetyManager.safety_result/0","doc":"","ref":"Pipeline.Safety.SafetyManager.html#t:safety_result/0"},{"type":"module","title":"Pipeline.Schemas.AnalysisResponse","doc":"Schema for basic analysis responses from Gemini.","ref":"Pipeline.Schemas.AnalysisResponse.html"},{"type":"module","title":"Pipeline.Schemas.CommonSchemas","doc":"Common JSON Schema definitions for pipeline step outputs.\n\nProvides reusable schema definitions for common data structures\nused across different pipeline steps.","ref":"Pipeline.Schemas.CommonSchemas.html"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.all_schemas/0","doc":"Get all available schema definitions as a map.","ref":"Pipeline.Schemas.CommonSchemas.html#all_schemas/0"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.analysis_result_schema/0","doc":"Schema for basic analysis results.","ref":"Pipeline.Schemas.CommonSchemas.html#analysis_result_schema/0"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.api_response_schema/0","doc":"Schema for API response data.","ref":"Pipeline.Schemas.CommonSchemas.html#api_response_schema/0"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.code_analysis_schema/0","doc":"Schema for code analysis results.","ref":"Pipeline.Schemas.CommonSchemas.html#code_analysis_schema/0"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.documentation_schema/0","doc":"Schema for documentation generation results.","ref":"Pipeline.Schemas.CommonSchemas.html#documentation_schema/0"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.file_operation_schema/0","doc":"Schema for file operation results.","ref":"Pipeline.Schemas.CommonSchemas.html#file_operation_schema/0"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.get_schema/1","doc":"Get a schema by name.","ref":"Pipeline.Schemas.CommonSchemas.html#get_schema/1"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.schema_names/0","doc":"List all available schema names.","ref":"Pipeline.Schemas.CommonSchemas.html#schema_names/0"},{"type":"function","title":"Pipeline.Schemas.CommonSchemas.test_results_schema/0","doc":"Schema for test results.","ref":"Pipeline.Schemas.CommonSchemas.html#test_results_schema/0"},{"type":"module","title":"Pipeline.SessionManager","doc":"Session management for persistent Claude conversations.\n\nProvides session creation, retrieval, checkpointing, and lifecycle management\nfor claude_session step types. Sessions can persist across pipeline runs\nand maintain conversation context.","ref":"Pipeline.SessionManager.html"},{"type":"function","title":"Pipeline.SessionManager.checkpoint_session/2","doc":"Checkpoint session data for persistence.","ref":"Pipeline.SessionManager.html#checkpoint_session/2"},{"type":"function","title":"Pipeline.SessionManager.continue_session/2","doc":"Continue an existing session with a new prompt.\nReturns {:ok, response} or {:error, reason}.","ref":"Pipeline.SessionManager.html#continue_session/2"},{"type":"function","title":"Pipeline.SessionManager.create_session/2","doc":"Create a new session with the given name and options.","ref":"Pipeline.SessionManager.html#create_session/2"},{"type":"function","title":"Options - Pipeline.SessionManager.create_session/2","doc":"- `persist`: Whether to persist the session across restarts (default: false)\n- `max_turns`: Maximum turns allowed in the session (default: 50)\n- `checkpoint_interval`: How often to checkpoint (default: 5 interactions)","ref":"Pipeline.SessionManager.html#create_session/2-options"},{"type":"function","title":"Pipeline.SessionManager.get_session/1","doc":"Get an existing session by session_id.\nReturns nil if session not found.","ref":"Pipeline.SessionManager.html#get_session/1"},{"type":"function","title":"Pipeline.SessionManager.list_sessions/0","doc":"List all available sessions.","ref":"Pipeline.SessionManager.html#list_sessions/0"},{"type":"module","title":"Pipeline.State.VariableEngine","doc":"Manages pipeline variables and state interpolation.\n\nProvides variable assignment, retrieval, and interpolation capabilities\nfor pipeline execution with support for different scoping levels.","ref":"Pipeline.State.VariableEngine.html"},{"type":"function","title":"Pipeline.State.VariableEngine.clear_scope/2","doc":"Clear variables in a specific scope.","ref":"Pipeline.State.VariableEngine.html#clear_scope/2"},{"type":"function","title":"Pipeline.State.VariableEngine.deserialize_state/1","doc":"Deserialize state from checkpoint data.","ref":"Pipeline.State.VariableEngine.html#deserialize_state/1"},{"type":"function","title":"Pipeline.State.VariableEngine.get_all_variables/1","doc":"Get all variables as a flattened map with scope precedence.","ref":"Pipeline.State.VariableEngine.html#get_all_variables/1"},{"type":"function","title":"Pipeline.State.VariableEngine.get_variable/2","doc":"Get a variable value from the state with scope precedence.\n\nLookup order: loop -> session -> global","ref":"Pipeline.State.VariableEngine.html#get_variable/2"},{"type":"function","title":"Parameters - Pipeline.State.VariableEngine.get_variable/2","doc":"- `state`: Current variable state\n- `var_name`: Variable name to retrieve","ref":"Pipeline.State.VariableEngine.html#get_variable/2-parameters"},{"type":"function","title":"Returns - Pipeline.State.VariableEngine.get_variable/2","doc":"Variable value or nil if not found","ref":"Pipeline.State.VariableEngine.html#get_variable/2-returns"},{"type":"function","title":"Pipeline.State.VariableEngine.interpolate_data/2","doc":"Interpolate variables in any data structure recursively.","ref":"Pipeline.State.VariableEngine.html#interpolate_data/2"},{"type":"function","title":"Pipeline.State.VariableEngine.interpolate_data_with_context/3","doc":"Interpolate variables in any data structure with execution context access.\nThis allows resolving step results and other execution-time data.","ref":"Pipeline.State.VariableEngine.html#interpolate_data_with_context/3"},{"type":"function","title":"Pipeline.State.VariableEngine.interpolate_data_with_type_preservation/3","doc":"Interpolate variables in any data structure with type preservation for single templates.","ref":"Pipeline.State.VariableEngine.html#interpolate_data_with_type_preservation/3"},{"type":"function","title":"Pipeline.State.VariableEngine.interpolate_string/2","doc":"Interpolate variables in a string using {{variable_name}} syntax.\n\nSupports:\n- Simple variables: {{variable_name}}\n- State references: {{state.variable_name}}\n- Nested access: {{state.nested.value}}\n- Arithmetic expressions: {{state.count + 1}}","ref":"Pipeline.State.VariableEngine.html#interpolate_string/2"},{"type":"function","title":"Examples - Pipeline.State.VariableEngine.interpolate_string/2","doc":"iex> state = %{global: %{\"name\" => \"test\", \"count\" => 5}}\n    iex> Pipeline.State.VariableEngine.interpolate_string(\"Hello {{name}}, count: {{count}}\", state)\n    \"Hello test, count: 5\"","ref":"Pipeline.State.VariableEngine.html#interpolate_string/2-examples"},{"type":"function","title":"Pipeline.State.VariableEngine.interpolate_string_with_context/3","doc":"Interpolate variables in a string with execution context access.\nThis handles both variable state and step result patterns.","ref":"Pipeline.State.VariableEngine.html#interpolate_string_with_context/3"},{"type":"function","title":"Pipeline.State.VariableEngine.interpolate_with_type_preservation/3","doc":"Interpolate variables with type preservation for single templates.\nThis is used for nested pipeline execution where types should be preserved.","ref":"Pipeline.State.VariableEngine.html#interpolate_with_type_preservation/3"},{"type":"function","title":"Pipeline.State.VariableEngine.new_state/0","doc":"Initialize a new variable state.","ref":"Pipeline.State.VariableEngine.html#new_state/0"},{"type":"function","title":"Pipeline.State.VariableEngine.serialize_state/1","doc":"Serialize state for checkpoint persistence.","ref":"Pipeline.State.VariableEngine.html#serialize_state/1"},{"type":"function","title":"Pipeline.State.VariableEngine.set_variables/3","doc":"Set variables in the specified scope.","ref":"Pipeline.State.VariableEngine.html#set_variables/3"},{"type":"function","title":"Parameters - Pipeline.State.VariableEngine.set_variables/3","doc":"- `state`: Current variable state\n- `variables`: Map of variable names to values\n- `scope`: Variable scope (:global, :session, :loop)","ref":"Pipeline.State.VariableEngine.html#set_variables/3-parameters"},{"type":"function","title":"Examples - Pipeline.State.VariableEngine.set_variables/3","doc":"iex> state = Pipeline.State.VariableEngine.new_state()\n    iex> Pipeline.State.VariableEngine.set_variables(state, %{\"count\" => 1}, :global)\n    %{global: %{\"count\" => 1}, session: %{}, loop: %{}, current_step: nil, step_index: 0}","ref":"Pipeline.State.VariableEngine.html#set_variables/3-examples"},{"type":"function","title":"Pipeline.State.VariableEngine.update_step_info/3","doc":"Update the current step information in state.","ref":"Pipeline.State.VariableEngine.html#update_step_info/3"},{"type":"module","title":"Pipeline.Step","doc":"Step execution coordination module.","ref":"Pipeline.Step.html"},{"type":"module","title":"Pipeline.Step.ClaudeBatch","doc":"Claude Batch step executor - handles claude_batch step type with parallel processing capabilities.\n\nClaude Batch steps provide parallel processing for multiple tasks:\n- Process multiple files or prompts concurrently\n- Configurable parallelism limits to control resource usage\n- Task-specific timeouts for reliable processing\n- Result consolidation and aggregation\n- Error handling per task with graceful degradation","ref":"Pipeline.Step.ClaudeBatch.html"},{"type":"function","title":"Pipeline.Step.ClaudeBatch.execute/2","doc":"Execute a claude_batch step with parallel processing.","ref":"Pipeline.Step.ClaudeBatch.html#execute/2"},{"type":"module","title":"Pipeline.Step.ClaudeExtract","doc":"Claude Extract step executor - handles claude_extract step type with content extraction and processing.\n\nClaude Extract steps provide advanced content extraction capabilities:\n- Extract structured data from Claude responses\n- Apply post-processing operations (code blocks, recommendations, etc.)\n- Format content in various output formats (text, json, structured, summary, markdown)\n- Include extraction metadata and statistics","ref":"Pipeline.Step.ClaudeExtract.html"},{"type":"function","title":"Pipeline.Step.ClaudeExtract.execute/2","doc":"Execute a claude_extract step with content extraction.","ref":"Pipeline.Step.ClaudeExtract.html#execute/2"},{"type":"module","title":"Pipeline.Step.ClaudeRobust","doc":"Enhanced Claude step type for robust execution with advanced error recovery patterns.\n\nThis step provides:\n- Configurable retry mechanisms with backoff strategies\n- Multiple fallback execution paths\n- Circuit breaker pattern for preventing cascade failures\n- Graceful degradation options\n- Comprehensive error tracking and recovery statistics","ref":"Pipeline.Step.ClaudeRobust.html"},{"type":"function","title":"Pipeline.Step.ClaudeRobust.execute/2","doc":"","ref":"Pipeline.Step.ClaudeRobust.html#execute/2"},{"type":"module","title":"Pipeline.Step.ClaudeSession","doc":"Claude Session step executor - handles claude_session step type with session management integration.\n\nClaude Session steps provide persistent conversational sessions that can:\n- Maintain conversation context across multiple interactions\n- Persist sessions for later continuation\n- Checkpoint session state at regular intervals\n- Resume sessions after restarts","ref":"Pipeline.Step.ClaudeSession.html"},{"type":"function","title":"Pipeline.Step.ClaudeSession.execute/2","doc":"Execute a claude_session step with session management.","ref":"Pipeline.Step.ClaudeSession.html#execute/2"},{"type":"module","title":"Pipeline.Step.CodebaseQuery","doc":"Codebase query step executor for intelligent code analysis and querying.\n\nEnables sophisticated querying of project structure and code relationships:\n- File finding by patterns, types, and relationships\n- Code analysis queries (find functions, classes, imports)\n- Test relationship discovery\n- Dependency analysis\n- Change impact analysis","ref":"Pipeline.Step.CodebaseQuery.html"},{"type":"module","title":"Example YAML Usage - Pipeline.Step.CodebaseQuery","doc":"- name: \"find_related_files\"\n      type: \"codebase_query\"\n      queries:\n        main_modules:\n          find_files:\n            - type: \"main\"\n            - pattern: \"lib/**/*.ex\"\n            - exclude_tests: true\n        test_files:\n          find_files:\n            - related_to: \"{{previous_response:target_file}}\"\n            - type: \"test\"\n        dependencies:\n          find_dependencies:\n            - for_file: \"lib/user.ex\"\n            - include_transitive: false","ref":"Pipeline.Step.CodebaseQuery.html#module-example-yaml-usage"},{"type":"function","title":"Pipeline.Step.CodebaseQuery.execute/2","doc":"Execute a codebase query step.","ref":"Pipeline.Step.CodebaseQuery.html#execute/2"},{"type":"module","title":"Pipeline.Step.DataTransform","doc":"Data transformation step executor for manipulating structured data between pipeline steps.\n\nThis step type provides powerful data transformation capabilities including:\n- Filtering data based on conditions\n- Mapping and transforming fields\n- Aggregating values with functions like sum, average, count\n- Joining data from multiple sources\n- Grouping data by field values\n- Sorting data by field values\n\nUses JSONPath-like syntax for field access and supports chaining multiple operations.","ref":"Pipeline.Step.DataTransform.html"},{"type":"module","title":"Configuration - Pipeline.Step.DataTransform","doc":"- `input_source` (required): Source of input data (e.g., \"previous_response:step_name\")\n- `operations` (required): List of transformation operations to apply\n- `output_field` (optional): Field name to store result in context (defaults to step name)","ref":"Pipeline.Step.DataTransform.html#module-configuration"},{"type":"module","title":"Example YAML Configuration - Pipeline.Step.DataTransform","doc":"```yaml\n- name: \"process_results\"\n  type: \"data_transform\"\n  input_source: \"previous_response:analysis\"\n  operations:\n    - operation: \"filter\"\n      field: \"recommendations\"\n      condition: \"priority == 'high'\"\n    - operation: \"aggregate\"\n      field: \"scores\"\n      function: \"average\"\n    - operation: \"join\"\n      left_field: \"files\"\n      right_source: \"previous_response:file_metadata\"\n      join_key: \"filename\"\n  output_field: \"processed_data\"\n```","ref":"Pipeline.Step.DataTransform.html#module-example-yaml-configuration"},{"type":"module","title":"Supported Operations - Pipeline.Step.DataTransform","doc":"","ref":"Pipeline.Step.DataTransform.html#module-supported-operations"},{"type":"module","title":"Filter - Pipeline.Step.DataTransform","doc":"Filter items based on conditions.\n```yaml\n- operation: \"filter\"\n  field: \"status\"\n  condition: \"status == 'active'\"\n```","ref":"Pipeline.Step.DataTransform.html#module-filter"},{"type":"module","title":"Map - Pipeline.Step.DataTransform","doc":"Transform fields with mappings or expressions.\n```yaml\n- operation: \"map\"\n  field: \"priority\"\n  mapping:\n    \"1\": \"high\"\n    \"2\": \"medium\"\n    \"3\": \"low\"\n```","ref":"Pipeline.Step.DataTransform.html#module-map"},{"type":"module","title":"Aggregate - Pipeline.Step.DataTransform","doc":"Aggregate values using functions.\n```yaml\n- operation: \"aggregate\"\n  field: \"scores\"\n  function: \"average\"  # sum, average, count, max, min, first, last, unique\n```","ref":"Pipeline.Step.DataTransform.html#module-aggregate"},{"type":"module","title":"Join - Pipeline.Step.DataTransform","doc":"Join data from another source.\n```yaml\n- operation: \"join\"\n  left_field: \"user_id\"\n  right_source: \"previous_response:users\"\n  join_key: \"id\"\n```","ref":"Pipeline.Step.DataTransform.html#module-join"},{"type":"module","title":"Group By - Pipeline.Step.DataTransform","doc":"Group items by field values.\n```yaml\n- operation: \"group_by\"\n  field: \"category\"\n```","ref":"Pipeline.Step.DataTransform.html#module-group-by"},{"type":"module","title":"Sort - Pipeline.Step.DataTransform","doc":"Sort items by field values.\n```yaml\n- operation: \"sort\"\n  field: \"created_at\"\n  order: \"desc\"  # asc or desc\n```","ref":"Pipeline.Step.DataTransform.html#module-sort"},{"type":"function","title":"Pipeline.Step.DataTransform.execute/2","doc":"Execute a data transformation step.","ref":"Pipeline.Step.DataTransform.html#execute/2"},{"type":"module","title":"Pipeline.Step.FileOps","doc":"File operations step executor for comprehensive file management.\n\nSupports operations:\n- copy: Copy files/directories\n- move: Move/rename files/directories\n- delete: Delete files/directories\n- validate: Validate file properties\n- list: List directory contents\n- convert: Convert between file formats","ref":"Pipeline.Step.FileOps.html"},{"type":"function","title":"Pipeline.Step.FileOps.execute/2","doc":"Execute a file operations step.","ref":"Pipeline.Step.FileOps.html#execute/2"},{"type":"module","title":"Pipeline.Step.GeminiInstructor","doc":"Executes Gemini (Brain) steps using InstructorLite for structured output and function calling.","ref":"Pipeline.Step.GeminiInstructor.html"},{"type":"function","title":"Pipeline.Step.GeminiInstructor.execute/2","doc":"","ref":"Pipeline.Step.GeminiInstructor.html#execute/2"},{"type":"module","title":"Pipeline.Step.Loop","doc":"Advanced loop step executor - handles for_loop and while_loop operations.\n\nProvides iteration capabilities with:\n- Nested loop support with proper variable scoping\n- Parallel execution for independent iterations\n- Loop control flow (break, continue, early termination)\n- Performance optimization for large datasets\n- Memory management for long-running loops","ref":"Pipeline.Step.Loop.html"},{"type":"function","title":"Pipeline.Step.Loop.create_nested_loop_context/5","doc":"","ref":"Pipeline.Step.Loop.html#create_nested_loop_context/5"},{"type":"function","title":"Pipeline.Step.Loop.execute/2","doc":"Execute a loop step (for_loop or while_loop).","ref":"Pipeline.Step.Loop.html#execute/2"},{"type":"module","title":"Pipeline.Step.NestedPipeline","doc":"Executes another pipeline as a step within the current pipeline.\n\nThis enables pipeline composition where complex workflows can be built\nfrom smaller, reusable pipeline components.","ref":"Pipeline.Step.NestedPipeline.html"},{"type":"function","title":"Pipeline.Step.NestedPipeline.execute/2","doc":"Execute a nested pipeline step.\n\nSupports three ways to specify the pipeline:\n- pipeline_file: Path to external YAML file\n- pipeline_ref: Reference to registered pipeline (future feature)\n- pipeline: Inline pipeline definition","ref":"Pipeline.Step.NestedPipeline.html#execute/2"},{"type":"module","title":"Pipeline.Step.ParallelClaude","doc":"Executes multiple Claude tasks in parallel.","ref":"Pipeline.Step.ParallelClaude.html"},{"type":"function","title":"Pipeline.Step.ParallelClaude.execute/2","doc":"","ref":"Pipeline.Step.ParallelClaude.html#execute/2"},{"type":"module","title":"Pipeline.Step.SetVariable","doc":"Set variable step executor - handles variable assignment and state management.\n\nSupports:\n- Setting variables in different scopes (global, session, loop)\n- Variable interpolation and expressions\n- Type validation and coercion","ref":"Pipeline.Step.SetVariable.html"},{"type":"function","title":"Pipeline.Step.SetVariable.execute/2","doc":"Execute a set_variable step.","ref":"Pipeline.Step.SetVariable.html#execute/2"},{"type":"function","title":"Step Configuration - Pipeline.Step.SetVariable.execute/2","doc":"```yaml\n- name: \"set_counter\"\n  type: \"set_variable\"\n  variables:\n    counter: 0\n    name: \"test_pipeline\"\n    items: []\n  scope: \"global\"  # Optional: global (default), session, loop\n  \n- name: \"increment_counter\"  \n  type: \"set_variable\"\n  variables:\n    counter: \"{{state.counter + 1}}\"\n    last_updated: \"{{current_timestamp}}\"\n```","ref":"Pipeline.Step.SetVariable.html#execute/2-step-configuration"},{"type":"function","title":"Pipeline.Step.SetVariable.validate_config/1","doc":"Validate step configuration for set_variable type.","ref":"Pipeline.Step.SetVariable.html#validate_config/1"},{"type":"module","title":"Pipeline.Step.TestEcho","doc":"Simple test step that echoes its value for testing purposes.\nOnly available in test environment.","ref":"Pipeline.Step.TestEcho.html"},{"type":"function","title":"Pipeline.Step.TestEcho.execute/2","doc":"","ref":"Pipeline.Step.TestEcho.html#execute/2"},{"type":"module","title":"Pipeline.Streaming.ResultStream","doc":"Result streaming capabilities for pipeline execution.\n\nProvides memory-efficient result passing between steps by streaming\nlarge results instead of keeping them in memory.","ref":"Pipeline.Streaming.ResultStream.html"},{"type":"function","title":"Pipeline.Streaming.ResultStream.cleanup_stream/1","doc":"Clean up a result stream and free resources.","ref":"Pipeline.Streaming.ResultStream.html#cleanup_stream/1"},{"type":"function","title":"Pipeline.Streaming.ResultStream.create_stream/4","doc":"Create a result stream from a large result.","ref":"Pipeline.Streaming.ResultStream.html#create_stream/4"},{"type":"function","title":"Pipeline.Streaming.ResultStream.get_stream_info/1","doc":"Get metadata about a stream.","ref":"Pipeline.Streaming.ResultStream.html#get_stream_info/1"},{"type":"function","title":"Pipeline.Streaming.ResultStream.read_stream/1","doc":"Read data from a result stream.","ref":"Pipeline.Streaming.ResultStream.html#read_stream/1"},{"type":"function","title":"Pipeline.Streaming.ResultStream.should_stream_result?/1","doc":"Check if a result should be streamed based on size.","ref":"Pipeline.Streaming.ResultStream.html#should_stream_result?/1"},{"type":"function","title":"Pipeline.Streaming.ResultStream.stream_chunks/1","doc":"Stream data from a result stream in chunks.","ref":"Pipeline.Streaming.ResultStream.html#stream_chunks/1"},{"type":"type","title":"Pipeline.Streaming.ResultStream.t/0","doc":"","ref":"Pipeline.Streaming.ResultStream.html#t:t/0"},{"type":"function","title":"Pipeline.Streaming.ResultStream.transform_stream/2","doc":"Transform a stream with a function.","ref":"Pipeline.Streaming.ResultStream.html#transform_stream/2"},{"type":"behaviour","title":"Pipeline.Test.AIProvider","doc":"Behaviour for mocking AI providers (Gemini) in tests.","ref":"Pipeline.Test.AIProvider.html"},{"type":"callback","title":"Pipeline.Test.AIProvider.generate/2","doc":"Generate a response from the AI provider.","ref":"Pipeline.Test.AIProvider.html#c:generate/2"},{"type":"callback","title":"Parameters - Pipeline.Test.AIProvider.generate/2","doc":"- prompt: The input prompt string\n  - opts: Keyword list of options (model, token_budget, etc.)","ref":"Pipeline.Test.AIProvider.html#c:generate/2-parameters"},{"type":"callback","title":"Returns - Pipeline.Test.AIProvider.generate/2","doc":"- `{:ok, response_map}` on success\n- `{:error, reason}` on failure","ref":"Pipeline.Test.AIProvider.html#c:generate/2-returns"},{"type":"behaviour","title":"Pipeline.Test.ClaudeProvider","doc":"Behaviour for mocking Claude SDK in tests.","ref":"Pipeline.Test.ClaudeProvider.html"},{"type":"callback","title":"Pipeline.Test.ClaudeProvider.query/2","doc":"Query Claude with a prompt and options.","ref":"Pipeline.Test.ClaudeProvider.html#c:query/2"},{"type":"callback","title":"Parameters - Pipeline.Test.ClaudeProvider.query/2","doc":"- prompt: The input prompt string\n  - options: ClaudeCodeSDK.Options struct","ref":"Pipeline.Test.ClaudeProvider.html#c:query/2-parameters"},{"type":"callback","title":"Returns - Pipeline.Test.ClaudeProvider.query/2","doc":"An Enumerable that yields message structs","ref":"Pipeline.Test.ClaudeProvider.html#c:query/2-returns"},{"type":"behaviour","title":"Pipeline.Test.FileSystem","doc":"Behaviour for mocking file system operations in tests.","ref":"Pipeline.Test.FileSystem.html"},{"type":"callback","title":"Pipeline.Test.FileSystem.exists?/1","doc":"Check if file exists","ref":"Pipeline.Test.FileSystem.html#c:exists?/1"},{"type":"callback","title":"Pipeline.Test.FileSystem.ls/1","doc":"List files in directory","ref":"Pipeline.Test.FileSystem.html#c:ls/1"},{"type":"callback","title":"Pipeline.Test.FileSystem.mkdir_p/1","doc":"Create directory path recursively","ref":"Pipeline.Test.FileSystem.html#c:mkdir_p/1"},{"type":"callback","title":"Pipeline.Test.FileSystem.read/1","doc":"Read a file from the file system","ref":"Pipeline.Test.FileSystem.html#c:read/1"},{"type":"callback","title":"Pipeline.Test.FileSystem.write/2","doc":"Write content to a file","ref":"Pipeline.Test.FileSystem.html#c:write/2"},{"type":"module","title":"Pipeline.Test.Helpers","doc":"Common test utilities for pipeline testing.","ref":"Pipeline.Test.Helpers.html"},{"type":"function","title":"Pipeline.Test.Helpers.assert_file_created/2","doc":"Assert that a file was created with optional content check.","ref":"Pipeline.Test.Helpers.html#assert_file_created/2"},{"type":"function","title":"Examples - Pipeline.Test.Helpers.assert_file_created/2","doc":"Pipeline.Test.Helpers.assert_file_created(\"/tmp/test.txt\")\n    Pipeline.Test.Helpers.assert_file_created(\"/tmp/test.txt\", \"expected content\")","ref":"Pipeline.Test.Helpers.html#assert_file_created/2-examples"},{"type":"function","title":"Pipeline.Test.Helpers.assert_logged/2","doc":"Assert that a log message was captured.","ref":"Pipeline.Test.Helpers.html#assert_logged/2"},{"type":"function","title":"Examples - Pipeline.Test.Helpers.assert_logged/2","doc":"Pipeline.Test.Helpers.assert_logged(:info, \"Starting pipeline\")\n    Pipeline.Test.Helpers.assert_logged(:error, ~r/Error: .+/)","ref":"Pipeline.Test.Helpers.html#assert_logged/2-examples"},{"type":"function","title":"Pipeline.Test.Helpers.assert_mock_file_created/2","doc":"Assert that a file was created in the mock file system.\n\nUses Pipeline.Test.Mocks.FileMock to check file existence.","ref":"Pipeline.Test.Helpers.html#assert_mock_file_created/2"},{"type":"function","title":"Pipeline.Test.Helpers.assert_step_executed/2","doc":"Assert that a step was executed and has results.","ref":"Pipeline.Test.Helpers.html#assert_step_executed/2"},{"type":"function","title":"Examples - Pipeline.Test.Helpers.assert_step_executed/2","doc":"orchestrator = %Pipeline.Orchestrator{results: %{\"test_step\" => %{status: \"completed\"}}}\n    Pipeline.Test.Helpers.assert_step_executed(orchestrator, \"test_step\")","ref":"Pipeline.Test.Helpers.html#assert_step_executed/2-examples"},{"type":"function","title":"Pipeline.Test.Helpers.capture_logs/1","doc":"Capture Logger output during test execution.","ref":"Pipeline.Test.Helpers.html#capture_logs/1"},{"type":"function","title":"Examples - Pipeline.Test.Helpers.capture_logs/1","doc":"{result, logs} = Pipeline.Test.Helpers.capture_logs(fn ->\n      Logger.info(\"Test message\")\n      :some_result\n    end)\n\n    assert result == :some_result\n    assert Enum.any?(logs, &String.contains?(&1, \"Test message\"))","ref":"Pipeline.Test.Helpers.html#capture_logs/1-examples"},{"type":"function","title":"Pipeline.Test.Helpers.create_claude_step/1","doc":"Create a simple Claude step configuration.","ref":"Pipeline.Test.Helpers.html#create_claude_step/1"},{"type":"function","title":"Options - Pipeline.Test.Helpers.create_claude_step/1","doc":"* `:name` - Step name (required)\n  * `:prompt` - Prompt content or configuration\n  * `:claude_options` - Claude CLI options\n  * `:output_to_file` - Output file name","ref":"Pipeline.Test.Helpers.html#create_claude_step/1-options"},{"type":"function","title":"Pipeline.Test.Helpers.create_gemini_step/1","doc":"Create a simple Gemini step configuration.","ref":"Pipeline.Test.Helpers.html#create_gemini_step/1"},{"type":"function","title":"Options - Pipeline.Test.Helpers.create_gemini_step/1","doc":"* `:name` - Step name (required)\n  * `:prompt` - Prompt content or configuration\n  * `:model` - Gemini model to use\n  * `:token_budget` - Token budget configuration\n  * `:output_to_file` - Output file name","ref":"Pipeline.Test.Helpers.html#create_gemini_step/1-options"},{"type":"function","title":"Pipeline.Test.Helpers.create_temp_config_file/1","doc":"Create a temporary YAML config file for testing.","ref":"Pipeline.Test.Helpers.html#create_temp_config_file/1"},{"type":"function","title":"Examples - Pipeline.Test.Helpers.create_temp_config_file/1","doc":"config_path = Pipeline.Test.Helpers.create_temp_config_file(%{\n      workflow: %{\n        name: \"test\",\n        steps: [%{name: \"step1\", type: \"gemini\", prompt: [{type: \"static\", content: \"test\"}]}]\n      }\n    })","ref":"Pipeline.Test.Helpers.html#create_temp_config_file/1-examples"},{"type":"function","title":"Pipeline.Test.Helpers.create_test_config/1","doc":"Create a test configuration from options.","ref":"Pipeline.Test.Helpers.html#create_test_config/1"},{"type":"function","title":"Options - Pipeline.Test.Helpers.create_test_config/1","doc":"* `:name` - Workflow name (default: \"test_workflow\")\n  * `:steps` - List of step configurations\n  * `:workspace_dir` - Workspace directory\n  * `:checkpoint_enabled` - Enable checkpoints\n  * `:defaults` - Default configuration values","ref":"Pipeline.Test.Helpers.html#create_test_config/1-options"},{"type":"function","title":"Examples - Pipeline.Test.Helpers.create_test_config/1","doc":"config = Pipeline.Test.Helpers.create_test_config(\n      name: \"test_pipeline\",\n      steps: [\n        %{name: \"test_step\", type: \"gemini\", prompt: [{type: \"static\", content: \"test\"}]}\n      ]\n    )","ref":"Pipeline.Test.Helpers.html#create_test_config/1-examples"},{"type":"function","title":"Pipeline.Test.Helpers.reset_mocks/0","doc":"Reset all mock state (useful to run between tests).","ref":"Pipeline.Test.Helpers.html#reset_mocks/0"},{"type":"function","title":"Pipeline.Test.Helpers.with_temp_dir/1","doc":"Execute a function with a temporary directory that gets cleaned up afterwards.","ref":"Pipeline.Test.Helpers.html#with_temp_dir/1"},{"type":"function","title":"Examples - Pipeline.Test.Helpers.with_temp_dir/1","doc":"Pipeline.Test.Helpers.with_temp_dir(fn temp_dir ->\n      #Use temp_dir for test operations\n      assert File.exists?(temp_dir)\n    end)","ref":"Pipeline.Test.Helpers.html#with_temp_dir/1-examples"},{"type":"behaviour","title":"Pipeline.Test.Logger","doc":"Behaviour for mocking Logger operations in tests.","ref":"Pipeline.Test.Logger.html"},{"type":"callback","title":"Pipeline.Test.Logger.debug/1","doc":"Log a debug message","ref":"Pipeline.Test.Logger.html#c:debug/1"},{"type":"callback","title":"Pipeline.Test.Logger.error/1","doc":"Log an error message","ref":"Pipeline.Test.Logger.html#c:error/1"},{"type":"callback","title":"Pipeline.Test.Logger.info/1","doc":"Log an info message","ref":"Pipeline.Test.Logger.html#c:info/1"},{"type":"callback","title":"Pipeline.Test.Logger.warn/1","doc":"Log a warning message","ref":"Pipeline.Test.Logger.html#c:warn/1"},{"type":"module","title":"Pipeline.Test.Mocks.ClaudeProvider","doc":"Mock implementation of Claude provider for testing.","ref":"Pipeline.Test.Mocks.ClaudeProvider.html"},{"type":"function","title":"Pipeline.Test.Mocks.ClaudeProvider.query/2","doc":"","ref":"Pipeline.Test.Mocks.ClaudeProvider.html#query/2"},{"type":"function","title":"Pipeline.Test.Mocks.ClaudeProvider.reset/0","doc":"","ref":"Pipeline.Test.Mocks.ClaudeProvider.html#reset/0"},{"type":"function","title":"Pipeline.Test.Mocks.ClaudeProvider.set_response_pattern/2","doc":"","ref":"Pipeline.Test.Mocks.ClaudeProvider.html#set_response_pattern/2"},{"type":"module","title":"Pipeline.Test.Mocks.ClaudeSDKMock","doc":"Mock implementation of Claude Code SDK for testing.","ref":"Pipeline.Test.Mocks.ClaudeSDKMock.html"},{"type":"module","title":"Pipeline.Test.Mocks.FileMock","doc":"Mock implementation of file system operations for testing.","ref":"Pipeline.Test.Mocks.FileMock.html"},{"type":"function","title":"Pipeline.Test.Mocks.FileMock.get_state/0","doc":"Get current mock file system state","ref":"Pipeline.Test.Mocks.FileMock.html#get_state/0"},{"type":"function","title":"Pipeline.Test.Mocks.FileMock.reset/0","doc":"Reset the mock file system state (useful for tests)","ref":"Pipeline.Test.Mocks.FileMock.html#reset/0"},{"type":"function","title":"Pipeline.Test.Mocks.FileMock.set_file/2","doc":"Set a file in the mock file system","ref":"Pipeline.Test.Mocks.FileMock.html#set_file/2"},{"type":"module","title":"Pipeline.Test.Mocks.GeminiMock","doc":"Mock implementation of Gemini AI provider for testing.","ref":"Pipeline.Test.Mocks.GeminiMock.html"},{"type":"module","title":"Pipeline.Test.Mocks.GeminiProvider","doc":"Mock implementation of Gemini provider for testing.","ref":"Pipeline.Test.Mocks.GeminiProvider.html"},{"type":"function","title":"Pipeline.Test.Mocks.GeminiProvider.generate_function_calls/3","doc":"","ref":"Pipeline.Test.Mocks.GeminiProvider.html#generate_function_calls/3"},{"type":"function","title":"Pipeline.Test.Mocks.GeminiProvider.query/2","doc":"","ref":"Pipeline.Test.Mocks.GeminiProvider.html#query/2"},{"type":"function","title":"Pipeline.Test.Mocks.GeminiProvider.reset/0","doc":"","ref":"Pipeline.Test.Mocks.GeminiProvider.html#reset/0"},{"type":"function","title":"Pipeline.Test.Mocks.GeminiProvider.set_function_response/2","doc":"","ref":"Pipeline.Test.Mocks.GeminiProvider.html#set_function_response/2"},{"type":"function","title":"Pipeline.Test.Mocks.GeminiProvider.set_response_pattern/2","doc":"","ref":"Pipeline.Test.Mocks.GeminiProvider.html#set_response_pattern/2"},{"type":"module","title":"Pipeline.Test.Mocks.LoggerMock","doc":"Mock implementation of Logger for testing.","ref":"Pipeline.Test.Mocks.LoggerMock.html"},{"type":"function","title":"Pipeline.Test.Mocks.LoggerMock.get_all_logs/0","doc":"Get all logged messages","ref":"Pipeline.Test.Mocks.LoggerMock.html#get_all_logs/0"},{"type":"function","title":"Pipeline.Test.Mocks.LoggerMock.get_logs_by_level/1","doc":"Get logs by level","ref":"Pipeline.Test.Mocks.LoggerMock.html#get_logs_by_level/1"},{"type":"function","title":"Pipeline.Test.Mocks.LoggerMock.reset/0","doc":"Reset logged messages","ref":"Pipeline.Test.Mocks.LoggerMock.html#reset/0"},{"type":"module","title":"Pipeline.Test.Mocks.SessionManager","doc":"Mock implementation of Session Manager for testing claude_session steps.","ref":"Pipeline.Test.Mocks.SessionManager.html"},{"type":"function","title":"Pipeline.Test.Mocks.SessionManager.checkpoint_session/2","doc":"Checkpoint session data for persistence.","ref":"Pipeline.Test.Mocks.SessionManager.html#checkpoint_session/2"},{"type":"function","title":"Pipeline.Test.Mocks.SessionManager.close_session/1","doc":"Close and cleanup a session.","ref":"Pipeline.Test.Mocks.SessionManager.html#close_session/1"},{"type":"function","title":"Pipeline.Test.Mocks.SessionManager.continue_session/2","doc":"Continue an existing session with a new prompt.","ref":"Pipeline.Test.Mocks.SessionManager.html#continue_session/2"},{"type":"function","title":"Pipeline.Test.Mocks.SessionManager.create_session/2","doc":"Create a new session with the given name and options.","ref":"Pipeline.Test.Mocks.SessionManager.html#create_session/2"},{"type":"function","title":"Pipeline.Test.Mocks.SessionManager.get_session/1","doc":"Get an existing session by name.","ref":"Pipeline.Test.Mocks.SessionManager.html#get_session/1"},{"type":"function","title":"Pipeline.Test.Mocks.SessionManager.list_sessions/0","doc":"List all active sessions.","ref":"Pipeline.Test.Mocks.SessionManager.html#list_sessions/0"},{"type":"function","title":"Pipeline.Test.Mocks.SessionManager.reset_all_sessions/0","doc":"Reset all mock sessions (for testing cleanup).","ref":"Pipeline.Test.Mocks.SessionManager.html#reset_all_sessions/0"},{"type":"module","title":"Pipeline.Tools.Adapters.InstructorLiteAdapter","doc":"Adapter for using Pipeline tools with InstructorLite.\n\nConverts tool definitions to InstructorLite-compatible schemas\nand handles function call execution.","ref":"Pipeline.Tools.Adapters.InstructorLiteAdapter.html"},{"type":"function","title":"Pipeline.Tools.Adapters.InstructorLiteAdapter.create_function_response_schema/0","doc":"Create an Ecto schema for function calling responses.","ref":"Pipeline.Tools.Adapters.InstructorLiteAdapter.html#create_function_response_schema/0"},{"type":"function","title":"Pipeline.Tools.Adapters.InstructorLiteAdapter.create_function_schema/1","doc":"Create function calling schema for InstructorLite from registered tools.","ref":"Pipeline.Tools.Adapters.InstructorLiteAdapter.html#create_function_schema/1"},{"type":"function","title":"Pipeline.Tools.Adapters.InstructorLiteAdapter.execute_function_calls/1","doc":"Execute function calls from InstructorLite response.","ref":"Pipeline.Tools.Adapters.InstructorLiteAdapter.html#execute_function_calls/1"},{"type":"module","title":"Pipeline.Tools.Implementations.GetWanIp.Ubuntu2404","doc":"Tool to get the WAN (external) IP address using Ubuntu 24.04 CLI tools.\n\nThis implementation uses curl to query external services for the public IP.","ref":"Pipeline.Tools.Implementations.GetWanIp.Ubuntu2404.html"},{"type":"behaviour","title":"Pipeline.Tools.Tool","doc":"Base behavior for pipeline tools that can be called by LLMs.\n\nTools define functions that can be executed by AI models during conversations.\nEach tool should implement this behavior to provide consistent interface.","ref":"Pipeline.Tools.Tool.html"},{"type":"callback","title":"Pipeline.Tools.Tool.execute/1","doc":"Executes the tool with the given arguments.\nReturns {:ok, result} on success or {:error, reason} on failure.","ref":"Pipeline.Tools.Tool.html#c:execute/1"},{"type":"callback","title":"Pipeline.Tools.Tool.get_definition/0","doc":"Returns the tool definition including name, description, and parameters schema.\nThis is used by LLM adapters to register the tool with the AI service.","ref":"Pipeline.Tools.Tool.html#c:get_definition/0"},{"type":"callback","title":"Pipeline.Tools.Tool.supported_platforms/0","doc":"Returns the platforms/configurations this tool supports.\nUsed for tool discovery and validation.","ref":"Pipeline.Tools.Tool.html#c:supported_platforms/0"},{"type":"callback","title":"Pipeline.Tools.Tool.validate_environment/0","doc":"Validates that the tool can run in the current environment.\nReturns :ok if valid, {:error, reason} if not.","ref":"Pipeline.Tools.Tool.html#c:validate_environment/0"},{"type":"module","title":"Pipeline.Tools.ToolRegistry","doc":"Registry for managing and executing pipeline tools.\n\nProvides a central place to register, discover, and execute tools\nthat can be called by LLM adapters.","ref":"Pipeline.Tools.ToolRegistry.html"},{"type":"function","title":"Pipeline.Tools.ToolRegistry.auto_register_tools/1","doc":"Auto-discover and register tools from a given module path.","ref":"Pipeline.Tools.ToolRegistry.html#auto_register_tools/1"},{"type":"function","title":"Pipeline.Tools.ToolRegistry.execute_tool/2","doc":"Execute a tool by name with the given arguments.","ref":"Pipeline.Tools.ToolRegistry.html#execute_tool/2"},{"type":"function","title":"Pipeline.Tools.ToolRegistry.get_tool/1","doc":"Get a specific tool module by name.","ref":"Pipeline.Tools.ToolRegistry.html#get_tool/1"},{"type":"function","title":"Pipeline.Tools.ToolRegistry.get_tool_definitions/0","doc":"Get all registered tool definitions for LLM adapters.","ref":"Pipeline.Tools.ToolRegistry.html#get_tool_definitions/0"},{"type":"function","title":"Pipeline.Tools.ToolRegistry.list_tools/0","doc":"List all registered tool names.","ref":"Pipeline.Tools.ToolRegistry.html#list_tools/0"},{"type":"function","title":"Pipeline.Tools.ToolRegistry.register_tool/1","doc":"Register a tool module in the registry.","ref":"Pipeline.Tools.ToolRegistry.html#register_tool/1"},{"type":"function","title":"Pipeline.Tools.ToolRegistry.start_link/0","doc":"Start the tool registry.","ref":"Pipeline.Tools.ToolRegistry.html#start_link/0"},{"type":"module","title":"Pipeline.Tracing.NestedExecution","doc":"Execution tracing and monitoring for nested pipeline execution.\n\nProvides comprehensive tracing capabilities including span tracking,\nexecution trees, performance metrics, and debugging information\nfor nested pipeline workflows.","ref":"Pipeline.Tracing.NestedExecution.html"},{"type":"function","title":"Pipeline.Tracing.NestedExecution.build_execution_tree/1","doc":"Generate an execution tree from trace spans.","ref":"Pipeline.Tracing.NestedExecution.html#build_execution_tree/1"},{"type":"function","title":"Parameters - Pipeline.Tracing.NestedExecution.build_execution_tree/1","doc":"- `trace_context`: Trace context containing all spans","ref":"Pipeline.Tracing.NestedExecution.html#build_execution_tree/1-parameters"},{"type":"function","title":"Returns - Pipeline.Tracing.NestedExecution.build_execution_tree/1","doc":"- Hierarchical execution tree","ref":"Pipeline.Tracing.NestedExecution.html#build_execution_tree/1-returns"},{"type":"function","title":"Pipeline.Tracing.NestedExecution.complete_span/2","doc":"Complete a span in the trace.","ref":"Pipeline.Tracing.NestedExecution.html#complete_span/2"},{"type":"function","title":"Parameters - Pipeline.Tracing.NestedExecution.complete_span/2","doc":"- `trace_context`: Current trace context\n- `result`: Execution result (:ok, {:ok, value}, or {:error, reason})","ref":"Pipeline.Tracing.NestedExecution.html#complete_span/2-parameters"},{"type":"function","title":"Returns - Pipeline.Tracing.NestedExecution.complete_span/2","doc":"- Updated trace context","ref":"Pipeline.Tracing.NestedExecution.html#complete_span/2-returns"},{"type":"function","title":"Pipeline.Tracing.NestedExecution.create_debug_info/2","doc":"Create debug information for troubleshooting.","ref":"Pipeline.Tracing.NestedExecution.html#create_debug_info/2"},{"type":"function","title":"Parameters - Pipeline.Tracing.NestedExecution.create_debug_info/2","doc":"- `trace_context`: Current trace context\n- `error`: Error that occurred (optional)","ref":"Pipeline.Tracing.NestedExecution.html#create_debug_info/2-parameters"},{"type":"function","title":"Returns - Pipeline.Tracing.NestedExecution.create_debug_info/2","doc":"- Debug information map","ref":"Pipeline.Tracing.NestedExecution.html#create_debug_info/2-returns"},{"type":"type","title":"Pipeline.Tracing.NestedExecution.execution_span/0","doc":"","ref":"Pipeline.Tracing.NestedExecution.html#t:execution_span/0"},{"type":"type","title":"Pipeline.Tracing.NestedExecution.execution_tree/0","doc":"","ref":"Pipeline.Tracing.NestedExecution.html#t:execution_tree/0"},{"type":"function","title":"Pipeline.Tracing.NestedExecution.generate_performance_summary/1","doc":"Generate performance summary from execution tree.","ref":"Pipeline.Tracing.NestedExecution.html#generate_performance_summary/1"},{"type":"function","title":"Parameters - Pipeline.Tracing.NestedExecution.generate_performance_summary/1","doc":"- `execution_tree`: The execution tree to analyze","ref":"Pipeline.Tracing.NestedExecution.html#generate_performance_summary/1-parameters"},{"type":"function","title":"Returns - Pipeline.Tracing.NestedExecution.generate_performance_summary/1","doc":"- Performance summary with metrics by depth","ref":"Pipeline.Tracing.NestedExecution.html#generate_performance_summary/1-returns"},{"type":"type","title":"Pipeline.Tracing.NestedExecution.span_id/0","doc":"","ref":"Pipeline.Tracing.NestedExecution.html#t:span_id/0"},{"type":"function","title":"Pipeline.Tracing.NestedExecution.start_nested_trace/4","doc":"Start tracing a nested pipeline execution.","ref":"Pipeline.Tracing.NestedExecution.html#start_nested_trace/4"},{"type":"function","title":"Parameters - Pipeline.Tracing.NestedExecution.start_nested_trace/4","doc":"- `pipeline_id`: The ID of the pipeline being executed\n- `context`: Current execution context\n- `step`: Current step configuration (optional)\n- `parent_trace`: Parent trace context (optional)","ref":"Pipeline.Tracing.NestedExecution.html#start_nested_trace/4-parameters"},{"type":"function","title":"Returns - Pipeline.Tracing.NestedExecution.start_nested_trace/4","doc":"- New trace context with initial span","ref":"Pipeline.Tracing.NestedExecution.html#start_nested_trace/4-returns"},{"type":"type","title":"Pipeline.Tracing.NestedExecution.trace_context/0","doc":"","ref":"Pipeline.Tracing.NestedExecution.html#t:trace_context/0"},{"type":"type","title":"Pipeline.Tracing.NestedExecution.trace_id/0","doc":"","ref":"Pipeline.Tracing.NestedExecution.html#t:trace_id/0"},{"type":"function","title":"Pipeline.Tracing.NestedExecution.visualize_execution_tree/2","doc":"Generate a visual representation of the execution tree.","ref":"Pipeline.Tracing.NestedExecution.html#visualize_execution_tree/2"},{"type":"function","title":"Parameters - Pipeline.Tracing.NestedExecution.visualize_execution_tree/2","doc":"- `execution_tree`: The execution tree to visualize\n- `options`: Visualization options (optional)","ref":"Pipeline.Tracing.NestedExecution.html#visualize_execution_tree/2-parameters"},{"type":"function","title":"Returns - Pipeline.Tracing.NestedExecution.visualize_execution_tree/2","doc":"- String representation of the execution tree","ref":"Pipeline.Tracing.NestedExecution.html#visualize_execution_tree/2-returns"},{"type":"module","title":"Pipeline.Utils.FileUtils","doc":"File utility functions for pipeline file operations.\n\nProvides comprehensive file manipulation capabilities including:\n- File operations (copy, move, delete)\n- File validation (existence, size, permissions)\n- Format conversion (CSV, JSON, YAML, XML)\n- Path resolution and workspace management\n- Streaming operations for large files (>100MB)\n- Memory-efficient file processing","ref":"Pipeline.Utils.FileUtils.html"},{"type":"function","title":"Pipeline.Utils.FileUtils.convert_format/3","doc":"Convert file format from source to destination.","ref":"Pipeline.Utils.FileUtils.html#convert_format/3"},{"type":"function","title":"Pipeline.Utils.FileUtils.copy_file/2","doc":"Copy a file from source to destination with error handling.","ref":"Pipeline.Utils.FileUtils.html#copy_file/2"},{"type":"function","title":"Pipeline.Utils.FileUtils.delete_file/1","doc":"Delete a file or directory with error handling.","ref":"Pipeline.Utils.FileUtils.html#delete_file/1"},{"type":"function","title":"Pipeline.Utils.FileUtils.get_file_size/1","doc":"Get file size efficiently.","ref":"Pipeline.Utils.FileUtils.html#get_file_size/1"},{"type":"function","title":"Pipeline.Utils.FileUtils.list_files/2","doc":"List files in a directory with optional pattern matching.","ref":"Pipeline.Utils.FileUtils.html#list_files/2"},{"type":"function","title":"Pipeline.Utils.FileUtils.move_file/2","doc":"Move a file from source to destination with error handling.","ref":"Pipeline.Utils.FileUtils.html#move_file/2"},{"type":"function","title":"Pipeline.Utils.FileUtils.resolve_path/2","doc":"Resolve a path relative to the workspace directory.","ref":"Pipeline.Utils.FileUtils.html#resolve_path/2"},{"type":"function","title":"Pipeline.Utils.FileUtils.should_use_streaming?/1","doc":"Check if a file should be processed using streaming based on size.","ref":"Pipeline.Utils.FileUtils.html#should_use_streaming?/1"},{"type":"function","title":"Pipeline.Utils.FileUtils.smart_process_file/2","doc":"Process a file with automatic streaming decision.","ref":"Pipeline.Utils.FileUtils.html#smart_process_file/2"},{"type":"function","title":"Pipeline.Utils.FileUtils.stream_copy_file/2","doc":"Copy a large file using streaming to avoid memory issues.","ref":"Pipeline.Utils.FileUtils.html#stream_copy_file/2"},{"type":"function","title":"Pipeline.Utils.FileUtils.stream_process_lines/2","doc":"Process a large file line by line with a given function.\nMemory-efficient for large text files.","ref":"Pipeline.Utils.FileUtils.html#stream_process_lines/2"},{"type":"function","title":"Pipeline.Utils.FileUtils.stream_read_file/1","doc":"Read a file in chunks using streaming.\nReturns a stream that yields binary chunks.","ref":"Pipeline.Utils.FileUtils.html#stream_read_file/1"},{"type":"function","title":"Pipeline.Utils.FileUtils.stream_write_file/2","doc":"Write data to a file using streaming.","ref":"Pipeline.Utils.FileUtils.html#stream_write_file/2"},{"type":"function","title":"Pipeline.Utils.FileUtils.validate_file/2","doc":"Validate file properties according to given criteria.","ref":"Pipeline.Utils.FileUtils.html#validate_file/2"},{"type":"module","title":"Pipeline.Validation.SchemaValidator","doc":"JSON Schema-based validation for pipeline step outputs.\n\nProvides comprehensive validation of step outputs against JSON schemas,\nensuring structured data exchange between pipeline steps.","ref":"Pipeline.Validation.SchemaValidator.html"},{"type":"type","title":"Pipeline.Validation.SchemaValidator.schema/0","doc":"","ref":"Pipeline.Validation.SchemaValidator.html#t:schema/0"},{"type":"function","title":"Pipeline.Validation.SchemaValidator.supported_types/0","doc":"Get supported JSON Schema types.","ref":"Pipeline.Validation.SchemaValidator.html#supported_types/0"},{"type":"function","title":"Pipeline.Validation.SchemaValidator.valid_schema?/1","doc":"Check if a schema is valid JSON Schema format.","ref":"Pipeline.Validation.SchemaValidator.html#valid_schema?/1"},{"type":"function","title":"Pipeline.Validation.SchemaValidator.validate/2","doc":"Validate data against a JSON schema.","ref":"Pipeline.Validation.SchemaValidator.html#validate/2"},{"type":"function","title":"Examples - Pipeline.Validation.SchemaValidator.validate/2","doc":"iex> schema = %{\"type\" => \"object\", \"required\" => [\"name\"], \"properties\" => %{\"name\" => %{\"type\" => \"string\"}}}\n    iex> data = %{\"name\" => \"test\"}\n    iex> Pipeline.Validation.SchemaValidator.validate(data, schema)\n    {:ok, %{\"name\" => \"test\"}}\n    \n    iex> data = %{\"age\" => 25}\n    iex> Pipeline.Validation.SchemaValidator.validate(data, schema)\n    {:error, [%{path: \"\", message: \"Required property 'name' is missing\", value: %{\"age\" => 25}, schema: schema}]}","ref":"Pipeline.Validation.SchemaValidator.html#validate/2-examples"},{"type":"function","title":"Pipeline.Validation.SchemaValidator.validate_step_output/3","doc":"Validate step output with detailed error reporting.\n\nReturns a structured result with validation status and detailed error information.","ref":"Pipeline.Validation.SchemaValidator.html#validate_step_output/3"},{"type":"type","title":"Pipeline.Validation.SchemaValidator.validation_error/0","doc":"","ref":"Pipeline.Validation.SchemaValidator.html#t:validation_error/0"},{"type":"type","title":"Pipeline.Validation.SchemaValidator.validation_errors/0","doc":"","ref":"Pipeline.Validation.SchemaValidator.html#t:validation_errors/0"},{"type":"type","title":"Pipeline.Validation.SchemaValidator.validation_result/0","doc":"","ref":"Pipeline.Validation.SchemaValidator.html#t:validation_result/0"},{"type":"module","title":"Pipeline","doc":"AI pipeline orchestration library for Elixir.\n\nPipeline provides a robust framework for chaining AI provider calls (Claude, Gemini)\nwith advanced features like fault tolerance, session management, and self-improving\nGenesis pipelines.","ref":"Pipeline.html"},{"type":"module","title":"Quick Start - Pipeline","doc":"# Load and execute a pipeline\n    {:ok, config} = Pipeline.load_workflow(\"my_pipeline.yaml\")\n    {:ok, results} = Pipeline.execute(config)\n\n    # Execute with custom options\n    {:ok, results} = Pipeline.execute(config,\n      workspace_dir: \"/tmp/pipeline_workspace\",\n      debug: true\n    )","ref":"Pipeline.html#module-quick-start"},{"type":"module","title":"Configuration - Pipeline","doc":"Pipelines can be configured via:\n\n- Function options: `Pipeline.execute(config, workspace_dir: \"/custom/path\")`\n- Environment variables: `PIPELINE_WORKSPACE_DIR`, `PIPELINE_OUTPUT_DIR`, etc.\n- YAML configuration: workspace_dir, output_dir settings in the pipeline file\n\nSee `Pipeline.Executor` and `Pipeline.Config` for detailed documentation.","ref":"Pipeline.html#module-configuration"},{"type":"function","title":"Pipeline.execute/2","doc":"Execute a pipeline workflow.","ref":"Pipeline.html#execute/2"},{"type":"function","title":"Parameters - Pipeline.execute/2","doc":"- `workflow` - Pipeline configuration map (from `load_workflow/1`)\n- `opts` - Execution options (optional)","ref":"Pipeline.html#execute/2-parameters"},{"type":"function","title":"Options - Pipeline.execute/2","doc":"- `:workspace_dir` - Directory for AI workspace operations (default: \"./workspace\")\n- `:output_dir` - Directory for saving pipeline outputs (default: \"./outputs\") \n- `:checkpoint_dir` - Directory for saving execution checkpoints (default: \"./checkpoints\")\n- `:debug` - Enable debug logging (default: false)","ref":"Pipeline.html#execute/2-options"},{"type":"function","title":"Examples - Pipeline.execute/2","doc":"# Basic execution\n    {:ok, results} = Pipeline.execute(config)\n\n    # With custom directories\n    {:ok, results} = Pipeline.execute(config,\n      workspace_dir: \"/tmp/ai_workspace\",\n      output_dir: \"/app/pipeline_outputs\"\n    )\n\n    # With debug logging\n    {:ok, results} = Pipeline.execute(config, debug: true)","ref":"Pipeline.html#execute/2-examples"},{"type":"function","title":"Returns - Pipeline.execute/2","doc":"- `{:ok, results}` - Map of step results keyed by step name\n- `{:error, reason}` - Execution failure with error details","ref":"Pipeline.html#execute/2-returns"},{"type":"function","title":"Pipeline.execute_step/2","doc":"Execute a single pipeline step for testing or debugging.","ref":"Pipeline.html#execute_step/2"},{"type":"function","title":"Examples - Pipeline.execute_step/2","doc":"step = %{\"name\" => \"analyze\", \"type\" => \"claude\", \"prompt\" => \"Analyze this code\"}\n    context = %{workspace_dir: \"/tmp\", results: %{}}\n    {:ok, result} = Pipeline.execute_step(step, context)","ref":"Pipeline.html#execute_step/2-examples"},{"type":"function","title":"Pipeline.get_config/0","doc":"Get the current pipeline configuration.\n\nReturns application-level configuration including default directories,\ntest mode, and debug settings.","ref":"Pipeline.html#get_config/0"},{"type":"function","title":"Examples - Pipeline.get_config/0","doc":"config = Pipeline.get_config()\n    IO.inspect(config.workspace_dir)","ref":"Pipeline.html#get_config/0-examples"},{"type":"function","title":"Pipeline.health_check/0","doc":"Check if the pipeline system is properly configured.\n\nValidates that required dependencies and configurations are available.","ref":"Pipeline.html#health_check/0"},{"type":"function","title":"Examples - Pipeline.health_check/0","doc":"case Pipeline.health_check() do\n      :ok -> IO.puts(\"Pipeline system ready\")\n      {:error, _problems} -> IO.puts(\"Configuration issues found\")\n    end","ref":"Pipeline.html#health_check/0-examples"},{"type":"function","title":"Pipeline.load_workflow/1","doc":"Load a workflow configuration from a YAML file.","ref":"Pipeline.html#load_workflow/1"},{"type":"function","title":"Examples - Pipeline.load_workflow/1","doc":"{:ok, config} = Pipeline.load_workflow(\"examples/simple_workflow.yaml\")\n    {:ok, config} = Pipeline.load_workflow(\"/path/to/my_pipeline.yaml\")","ref":"Pipeline.html#load_workflow/1-examples"},{"type":"function","title":"Pipeline.run/2","doc":"Load and execute a workflow in one call.\n\nConvenience function that combines `load_workflow/1` and `execute/2`.","ref":"Pipeline.html#run/2"},{"type":"function","title":"Examples - Pipeline.run/2","doc":"{:ok, results} = Pipeline.run(\"my_pipeline.yaml\")\n    {:ok, results} = Pipeline.run(\"my_pipeline.yaml\", debug: true)","ref":"Pipeline.html#run/2-examples"},{"type":"module","title":"Pipeline.Config","doc":"Configuration management system for the pipeline.\n\nHandles loading and validation of workflow configurations,\nenvironment variables, and runtime settings.","ref":"Pipeline.Config.html"},{"type":"function","title":"Pipeline.Config.apply_defaults/1","doc":"Merge default values into workflow configuration.","ref":"Pipeline.Config.html#apply_defaults/1"},{"type":"type","title":"Pipeline.Config.config/0","doc":"","ref":"Pipeline.Config.html#t:config/0"},{"type":"function","title":"Pipeline.Config.get_app_config/0","doc":"Get application configuration with environment variable overrides.","ref":"Pipeline.Config.html#get_app_config/0"},{"type":"function","title":"Pipeline.Config.get_provider_config/1","doc":"Get provider configuration for external services.","ref":"Pipeline.Config.html#get_provider_config/1"},{"type":"function","title":"Pipeline.Config.load_workflow/1","doc":"Load and validate a workflow configuration from file.","ref":"Pipeline.Config.html#load_workflow/1"},{"type":"function","title":"Pipeline.Config.validate_workflow/1","doc":"Validate a workflow configuration.","ref":"Pipeline.Config.html#validate_workflow/1"},{"type":"type","title":"Pipeline.Config.validation_result/0","doc":"","ref":"Pipeline.Config.html#t:validation_result/0"},{"type":"module","title":"Pipeline.Executor","doc":"Main pipeline execution engine.\n\nOrchestrates the execution of workflow steps, manages state,\nand coordinates between Brain (Gemini) and Muscle (Claude) operations.","ref":"Pipeline.Executor.html"},{"type":"function","title":"Pipeline.Executor.execute/2","doc":"Execute a complete workflow.\n\nTakes a workflow configuration and executes all steps in sequence,\nmanaging state and checkpoints along the way.","ref":"Pipeline.Executor.html#execute/2"},{"type":"function","title":"Pipeline.Executor.execute_step/2","doc":"Execute a single step for testing.","ref":"Pipeline.Executor.html#execute_step/2"},{"type":"type","title":"Pipeline.Executor.execution_result/0","doc":"","ref":"Pipeline.Executor.html#t:execution_result/0"},{"type":"type","title":"Pipeline.Executor.workflow/0","doc":"","ref":"Pipeline.Executor.html#t:workflow/0"},{"type":"module","title":"Pipeline.Providers.ClaudeProvider","doc":"Live Claude provider using the existing Claude SDK integration.","ref":"Pipeline.Providers.ClaudeProvider.html"},{"type":"function","title":"Pipeline.Providers.ClaudeProvider.query/2","doc":"Query Claude using the existing Claude SDK integration.","ref":"Pipeline.Providers.ClaudeProvider.html#query/2"},{"type":"module","title":"Pipeline.Providers.GeminiProvider","doc":"Live Gemini provider using InstructorLite for structured generation.","ref":"Pipeline.Providers.GeminiProvider.html"},{"type":"function","title":"Pipeline.Providers.GeminiProvider.generate_function_calls/3","doc":"Generate function calls using Gemini and InstructorLite.","ref":"Pipeline.Providers.GeminiProvider.html#generate_function_calls/3"},{"type":"function","title":"Pipeline.Providers.GeminiProvider.query/2","doc":"Query Gemini using InstructorLite for structured responses.","ref":"Pipeline.Providers.GeminiProvider.html#query/2"},{"type":"module","title":"Pipeline.Step.Claude","doc":"Claude step executor - handles all Claude (Muscle) operations.","ref":"Pipeline.Step.Claude.html"},{"type":"function","title":"Pipeline.Step.Claude.execute/2","doc":"Execute a Claude step.","ref":"Pipeline.Step.Claude.html#execute/2"},{"type":"module","title":"Pipeline.Step.ClaudeSmart","doc":"Claude Smart step executor - handles claude_smart step type with OptionBuilder preset integration.\n\nClaude Smart steps automatically apply OptionBuilder presets and environment-aware configuration\nto provide optimized settings for different use cases.","ref":"Pipeline.Step.ClaudeSmart.html"},{"type":"function","title":"Pipeline.Step.ClaudeSmart.execute/2","doc":"Execute a claude_smart step with preset integration.","ref":"Pipeline.Step.ClaudeSmart.html#execute/2"},{"type":"module","title":"Pipeline.Step.Gemini","doc":"Gemini step executor - handles all Gemini (Brain) operations using InstructorLite.","ref":"Pipeline.Step.Gemini.html"},{"type":"function","title":"Pipeline.Step.Gemini.execute/2","doc":"Execute a Gemini step.","ref":"Pipeline.Step.Gemini.html#execute/2"},{"type":"module","title":"Pipeline.Meta.DNA","doc":"The genetic blueprint structure for pipeline organisms.\nDefines the DNA schema used by the Genesis Pipeline and evolution system.","ref":"Pipeline.Meta.DNA.html"},{"type":"function","title":"Pipeline.Meta.DNA.from_genome/1","doc":"Creates a new pipeline DNA from a genome specification","ref":"Pipeline.Meta.DNA.html#from_genome/1"},{"type":"type","title":"Pipeline.Meta.DNA.t/0","doc":"","ref":"Pipeline.Meta.DNA.html#t:t/0"},{"type":"function","title":"Pipeline.Meta.DNA.to_genome/1","doc":"Converts DNA back to a genome specification for pipeline generation","ref":"Pipeline.Meta.DNA.html#to_genome/1"},{"type":"module","title":"Pipeline.Meta.Generator","doc":"Pipeline generator that transforms DNA into executable pipeline configurations.\nThis is the core engine that brings pipeline organisms to life.","ref":"Pipeline.Meta.Generator.html"},{"type":"function","title":"Pipeline.Meta.Generator.generate_from_dna/1","doc":"Generates a pipeline YAML configuration from DNA","ref":"Pipeline.Meta.Generator.html#generate_from_dna/1"},{"type":"function","title":"Pipeline.Meta.Generator.generate_from_request/1","doc":"Generates a pipeline from a request using the Genesis Pipeline","ref":"Pipeline.Meta.Generator.html#generate_from_request/1"},{"type":"module","title":"Pipeline.Test.Mocks","doc":"Mock implementations for testing pipeline components without external dependencies.","ref":"Pipeline.Test.Mocks.html"},{"type":"module","title":"Pipeline.TestMode","doc":"Manages test mode configuration for switching between mock and live providers.","ref":"Pipeline.TestMode.html"},{"type":"function","title":"Pipeline.TestMode.clear_test_context/0","doc":"","ref":"Pipeline.TestMode.html#clear_test_context/0"},{"type":"function","title":"Pipeline.TestMode.get_mode/0","doc":"","ref":"Pipeline.TestMode.html#get_mode/0"},{"type":"function","title":"Pipeline.TestMode.live_mode?/0","doc":"","ref":"Pipeline.TestMode.html#live_mode?/0"},{"type":"function","title":"Pipeline.TestMode.mixed_mode?/0","doc":"","ref":"Pipeline.TestMode.html#mixed_mode?/0"},{"type":"function","title":"Pipeline.TestMode.mock_mode?/0","doc":"","ref":"Pipeline.TestMode.html#mock_mode?/0"},{"type":"function","title":"Pipeline.TestMode.provider_for/1","doc":"","ref":"Pipeline.TestMode.html#provider_for/1"},{"type":"function","title":"Pipeline.TestMode.set_test_context/1","doc":"","ref":"Pipeline.TestMode.html#set_test_context/1"},{"type":"extras","title":"Pipeline","doc":"# Pipeline\n\n[![CI](https://github.com/nshkrdotcom/pipeline_ex/actions/workflows/elixir.yaml/badge.svg)](https://github.com/nshkrdotcom/pipeline_ex/actions/workflows/elixir.yaml)\n[![Hex.pm](https://img.shields.io/hexpm/v/pipeline_ex.svg)](https://hex.pm/packages/pipeline_ex)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-purple.svg)](https://hexdocs.pm/pipeline_ex)\n\n**AI Pipeline Orchestration Library for Elixir** \n\nA robust, production-ready library for chaining AI providers (Claude and Gemini) with advanced features like fault tolerance, session management, and self-improving Genesis pipelines. \n\n**🎯 Library Readiness: 8.5/10** - Ready for immediate use as a Git dependency with comprehensive testing, clean API, and flexible configuration.\n\n \n  📋 Remaining 1.5/10 for Full Production Readiness  \n\n**Missing Features (1.5/10):**\n\n1. **Hex Package Publication (0.5/10)** - Currently Git-only, needs `mix hex.publish` workflow\n2. **Enhanced Documentation (0.3/10)** - ExDoc polish, API reference examples, getting started guide  \n3. **Backward Compatibility (0.2/10)** - Semantic versioning strategy, deprecation warnings, migration guides\n4. **Performance Benchmarks (0.2/10)** - Baseline metrics, memory profiling, concurrency benchmarks\n5. **Production Hardening (0.3/10)** - Rate limiting, circuit breakers, structured logging with correlation IDs\n\n**Current Status:** 8.5/10 = Excellent for Git dependency | 10/10 = Enterprise-ready Hex package","ref":"readme.html"},{"type":"extras","title":"🧬 Genesis Pipeline: Self-Improving AI System - Pipeline","doc":"**NEW**: Our flagship feature - a pipeline that generates pipelines! The Genesis Pipeline is an AI system that creates other AI pipelines, enabling true self-improvement and evolution.","ref":"readme.html#genesis-pipeline-self-improving-ai-system"},{"type":"extras","title":"Quick Start with Genesis - Pipeline","doc":"```bash\n# Generate a new AI pipeline with one command\nmix pipeline.generate.live \"Create a sentiment analysis pipeline\"\n\n# The system will create a complete, executable pipeline in evolved_pipelines/\n# Run your generated pipeline immediately:\nmix pipeline.run evolved_pipelines/sentiment_analyzer_*.yaml\n```\n\n**What just happened?** The Genesis Pipeline used Claude to analyze your request, design the optimal pipeline structure, and generate a complete YAML configuration that's immediately ready to execute.","ref":"readme.html#quick-start-with-genesis"},{"type":"extras","title":"📦 Library Usage - Pipeline","doc":"**Use pipeline_ex as a dependency in your Elixir applications:**","ref":"readme.html#library-usage"},{"type":"extras","title":"Add to Your Project - Pipeline","doc":"```elixir\n# mix.exs\ndefp deps do\n  [\n    # From Hex.pm (recommended)\n    {:pipeline_ex, \"~> 0.0.1\"}\n    \n    # Or from GitHub\n    # {:pipeline_ex, git: \"https://github.com/nshkrdotcom/pipeline_ex.git\", tag: \"v0.0.1\"}\n  ]\nend\n```","ref":"readme.html#add-to-your-project"},{"type":"extras","title":"Simple API - Pipeline","doc":"```elixir\n# Load and execute a pipeline\n{:ok, config} = Pipeline.load_workflow(\"my_analysis.yaml\")\n{:ok, results} = Pipeline.execute(config)\n\n# Execute with custom configuration\n{:ok, results} = Pipeline.execute(config,\n  workspace_dir: \"/app/ai_workspace\",\n  output_dir: \"/app/pipeline_outputs\"\n)\n\n# Convenience function\n{:ok, results} = Pipeline.run(\"my_analysis.yaml\", debug: true)\n\n# Health check\ncase Pipeline.health_check() do\n  :ok -> IO.puts(\"Pipeline system ready\")\n  {:error, issues} -> IO.puts(\"Issues: #{inspect(issues)}\")\nend\n```","ref":"readme.html#simple-api"},{"type":"extras","title":"Configuration Options - Pipeline","doc":"The library supports flexible configuration through multiple sources:\n\n1. **Function options** (highest priority):\n   ```elixir\n   Pipeline.execute(config, workspace_dir: \"/custom/workspace\")\n   ```\n\n2. **Environment variables**:\n   ```bash\n   export PIPELINE_WORKSPACE_DIR=\"/app/workspace\"\n   export PIPELINE_OUTPUT_DIR=\"/app/outputs\"\n   export PIPELINE_CHECKPOINT_DIR=\"/app/checkpoints\"\n   ```\n\n3. **YAML configuration** and **defaults**","ref":"readme.html#configuration-options"},{"type":"extras","title":"Integration Examples - Pipeline","doc":"```elixir\n# Phoenix controller\ndefmodule MyAppWeb.AIController do\n  def analyze(conn, %{\"code\" => code}) do\n    case Pipeline.run(\"pipelines/code_analysis.yaml\",\n      workspace_dir: \"/tmp/ai_workspace\") do\n      {:ok, %{\"analysis\" => result}} -> \n        json(conn, %{analysis: result})\n      {:error, reason} -> \n        put_status(conn, 500) |> json(%{error: reason})\n    end\n  end\nend\n\n# Background job with Oban\ndefmodule MyApp.AnalysisWorker do\n  use Oban.Worker, queue: :ai_analysis\n  \n  def perform(%Oban.Job{args: %{\"project_id\" => project_id}}) do\n    case Pipeline.execute(get_analysis_config(), \n      workspace_dir: \"/tmp/analysis_#{project_id}\",\n      output_dir: \"/app/results/#{project_id}\") do\n      {:ok, results} -> \n        MyApp.Projects.update_analysis(project, results)\n        :ok\n      {:error, reason} -> \n        {:error, reason}\n    end\n  end\nend\n```","ref":"readme.html#integration-examples"},{"type":"extras","title":"Testing Integration - Pipeline","doc":"```elixir\n# Enable mock mode for development/testing\nApplication.put_env(:pipeline, :test_mode, true)\n\n# All AI calls will be mocked\n{:ok, results} = Pipeline.execute(config)\n```\n\n📖 **Complete Library Guide**: See the documentation sections below for detailed usage instructions, configuration options, and integration patterns.\n\n🚀 **Advanced Features**: See [ADVANCED_FEATURES.md](ADVANCED_FEATURES.md) for comprehensive documentation on loops, complex conditions, file operations, data transformation, codebase intelligence, and state management.\n\n📋 **YAML Format v2 Documentation**: See [docs/20250704_yaml_format_v2/index.md](docs/20250704_yaml_format_v2/index.md) for complete reference documentation on the Pipeline YAML format, including all step types, prompt systems, control flow, and best practices.","ref":"readme.html#testing-integration"},{"type":"extras","title":"Features - Pipeline","doc":"","ref":"readme.html#features"},{"type":"extras","title":"📦 Library-Ready - Pipeline","doc":"- 🏗️ **Elixir Library**: Use as a dependency in any Elixir application\n- 🔧 **Clean API**: Simple `Pipeline.execute/2` and `Pipeline.load_workflow/1` functions\n- ⚙️ **Configurable**: All paths and settings customizable via options/environment variables\n- 🧪 **Mock Mode**: Complete testing support without API costs\n- 🏥 **Health Checks**: Built-in system validation and monitoring","ref":"readme.html#library-ready"},{"type":"extras","title":"🤖 AI Integration - Pipeline","doc":"- 🤖 **Multi-AI Integration**: Chain Claude and Gemini APIs together\n- 🔄 **Flexible Execution Modes**: Mock, Live, and Mixed modes for testing\n- 📋 **YAML Workflow Configuration**: Define complex multi-step workflows\n- 🎯 **Structured Output**: JSON-based responses with proper error handling\n- 🔧 **InstructorLite Integration**: Structured generation with Gemini\n- 📊 **Result Management**: Organized output storage and display","ref":"readme.html#ai-integration"},{"type":"extras","title":"⚡ Advanced Features - Pipeline","doc":"- **Enhanced Claude Steps**: Smart presets, sessions, extraction, batch processing, robust error handling\n- **Genesis Pipeline**: Self-improving AI system that generates other pipelines\n- **Session Management**: Persistent conversations with automatic checkpointing\n- **Fault Tolerance**: Retry mechanisms, circuit breakers, graceful degradation\n- **Loop Constructs**: For/while loops with parallel execution and nested support\n- **Complex Conditions**: Boolean logic, comparisons, mathematical expressions\n- **File Operations**: Copy, move, validate, convert with format transformations\n- **Data Transformation**: Filter, aggregate, join with schema validation\n- **Codebase Intelligence**: Project discovery, code analysis, dependency mapping\n- **State Management**: Variables, interpolation, checkpoints with persistence\n\n📚 **See [ADVANCED_FEATURES.md](ADVANCED_FEATURES.md) for detailed documentation and examples of all advanced capabilities.**","ref":"readme.html#advanced-features"},{"type":"extras","title":"Quick Start - Pipeline","doc":"","ref":"readme.html#quick-start"},{"type":"extras","title":"1. Installation - Pipeline","doc":"#### As a Library Dependency (Recommended)\n\n```elixir\n# mix.exs\ndefp deps do\n  [\n    # From Hex.pm (recommended)\n    {:pipeline_ex, \"~> 0.0.1\"}\n    \n    # Or from GitHub\n    # {:pipeline_ex, git: \"https://github.com/nshkrdotcom/pipeline_ex.git\", tag: \"v0.0.1\"}\n  ]\nend\n```\n\n#### Standalone Development\n\n```bash\ngit clone  \ncd pipeline_ex\nmix deps.get\n```","ref":"readme.html#1-installation"},{"type":"extras","title":"2. Try the Showcase (Recommended) - Pipeline","doc":"**🌟 Start with one of these commands:**\n\n```bash\n# Mock mode (safe, free, fast)\nmix showcase               # Complete demo with mocks\n\n# Live mode (real API calls, costs money)\nmix showcase --live        # Complete demo with live APIs\n```","ref":"readme.html#2-try-the-showcase-recommended"},{"type":"extras","title":"🎭 Mock vs Live Mode - Pipeline","doc":"**All examples and tests can run in two modes:**\n\n| **Mode** | **Command Format** | **API Calls** | **Costs** | **Authentication Required** |\n|----------|-------------------|---------------|-----------|---------------------------|\n| **Mock** | `mix showcase` | None (mocked) | $0.00 | No |\n| **Live** | `mix showcase --live` | Real API calls | Real costs | Yes (`claude login`) |","ref":"readme.html#mock-vs-live-mode"},{"type":"extras","title":"Running Tests - Pipeline","doc":"","ref":"readme.html#running-tests"},{"type":"extras","title":"Mock Mode (Recommended) - Pipeline","doc":"```bash\nmix test                       # All tests with mocked APIs (fast, free)\n```","ref":"readme.html#mock-mode-recommended"},{"type":"extras","title":"Live Mode (Real API Calls) - Pipeline","doc":"```bash\n# Setup authentication first:\nexport GEMINI_API_KEY=\"your_api_key\"\nclaude login\n\n# Run tests with real APIs:\nmix pipeline.test.live         # Only integration tests with live APIs (costs money)\n```","ref":"readme.html#live-mode-real-api-calls"},{"type":"extras","title":"Execution Modes - Pipeline","doc":"The pipeline supports three execution modes controlled by the `TEST_MODE` environment variable:\n\n| Mode | Description | Use Case |\n|------|-------------|----------|\n| `mock` | Uses fake responses | Development, unit testing, CI/CD |\n| `live` | Uses real API calls | Production, integration testing |\n| `mixed` | Mocks for unit tests, live for integration | Hybrid testing approach |","ref":"readme.html#execution-modes"},{"type":"extras","title":"Mode Examples - Pipeline","doc":"```bash\n# Mock mode - fast, no API costs\nmix pipeline.run examples/comprehensive_config_example.yaml\n\n# Live mode - real AI responses  \nmix pipeline.run.live examples/comprehensive_config_example.yaml\n\n# Mixed mode - context-dependent\nTEST_MODE=mixed mix test\n```","ref":"readme.html#mode-examples"},{"type":"extras","title":"Configuration - Pipeline","doc":"","ref":"readme.html#configuration"},{"type":"extras","title":"API Keys - Pipeline","doc":"#### Claude\nClaude uses the authenticated CLI. Run once:\n```bash\nclaude login\n```\n\n#### Gemini\nSet your API key:\n```bash\nexport GEMINI_API_KEY=\"your_gemini_api_key_here\"\n```\n\nOr in your application config:\n```elixir\nconfig :pipeline, gemini_api_key: \"your_api_key\"\n```","ref":"readme.html#api-keys"},{"type":"extras","title":"Workflow Configuration - Pipeline","doc":"Create YAML workflow files like `test_simple_workflow.yaml`:\n\n```yaml\nworkflow:\n  name: \"simple_test_workflow\"\n  description: \"Test basic claude functionality\"\n  \n  steps:\n    - name: \"analyze_code\"\n      type: \"claude\"\n      prompt: \n        - type: \"static\"\n          content: |\n            Analyze this simple Python function and provide feedback:\n            \n            def add(a, b):\n                return a + b\n            \n            Please provide your analysis in JSON format.\n      \n    - name: \"plan_improvements\"\n      type: \"gemini\"  \n      prompt:\n        - type: \"static\"\n          content: |\n            Based on the previous analysis, create a plan to improve the function.\n            Consider error handling, type hints, and documentation.\n```","ref":"readme.html#workflow-configuration"},{"type":"extras","title":"Example Usage - Pipeline","doc":"","ref":"readme.html#example-usage"},{"type":"extras","title":"Library Usage in Your Application - Pipeline","doc":"```elixir\ndefmodule MyApp.AIProcessor do\n  @doc \"Analyze code using the pipeline library\"\n  def analyze_code(code_content) do\n    # Load your pipeline configuration\n    case Pipeline.load_workflow(\"pipelines/code_analysis.yaml\") do\n      {:ok, config} ->\n        # Execute with custom workspace\n        Pipeline.execute(config,\n          workspace_dir: \"/tmp/ai_workspace\",\n          debug: true\n        )\n      {:error, reason} ->\n        {:error, \"Failed to load workflow: #{reason}\"}\n    end\n  end\n  \n  @doc \"Health check for the AI system\"\n  def system_ready? do\n    case Pipeline.health_check() do\n      :ok -> true\n      {:error, _issues} -> false\n    end\n  end\nend\n\n# Usage in your application\n{:ok, analysis} = MyApp.AIProcessor.analyze_code(user_code)\nIO.inspect(analysis[\"analysis_step\"])\n```","ref":"readme.html#library-usage-in-your-application"},{"type":"extras","title":"Simple Script Example - Pipeline","doc":"```elixir\n#!/usr/bin/env elixir\n\nMix.install([\n  {:pipeline_ex, git: \"https://github.com/nshkrdotcom/pipeline_ex.git\"}\n])\n\n# Load and execute pipeline\ncase Pipeline.run(\"test_simple_workflow.yaml\", output_dir: \"outputs\") do\n  {:ok, results} ->\n    IO.puts(\"✅ Pipeline completed!\")\n    IO.inspect(results)\n    \n  {:error, reason} ->\n    IO.puts(\"❌ Pipeline failed: #{reason}\")\nend\n```","ref":"readme.html#simple-script-example"},{"type":"extras","title":"Testing Different Scenarios - Pipeline","doc":"```bash\n# Test with mock responses (fast)\nTEST_MODE=mock elixir run_example.exs\n\n# Test with real Claude + mock Gemini\n# (useful when you have Claude access but no Gemini API key)\nTEST_MODE=mixed elixir -e \"\nSystem.put_env(\\\"FORCE_MOCK_GEMINI\\\", \\\"true\\\")\nCode.compile_file(\\\"run_example.exs\\\")\n\"\n\n# Full live test (requires both API keys)\nelixir run_example.exs\n```","ref":"readme.html#testing-different-scenarios"},{"type":"extras","title":"Running the Comprehensive Example - Pipeline","doc":"The project includes a comprehensive configuration example that demonstrates **all available features** with minimal steps. This example showcases every configuration option, step type, and feature available in the pipeline system.","ref":"readme.html#running-the-comprehensive-example"},{"type":"extras","title":"Mock Mode (Safe, No API Keys Required) - Pipeline","doc":"```bash\n# Run the comprehensive example with mocked AI responses\nmix pipeline.run examples/comprehensive_config_example.yaml\n\n# Run with debug output to see detailed execution\nPIPELINE_DEBUG=true mix pipeline.run examples/comprehensive_config_example.yaml\n```","ref":"readme.html#mock-mode-safe-no-api-keys-required"},{"type":"extras","title":"Live Mode (Real AI Providers) - Pipeline","doc":"To run the comprehensive example with actual AI providers:\n\n#### 1. Set Up API Keys\n\n```bash\n# Set your Gemini API key (get from https://aistudio.google.com/)\nexport GEMINI_API_KEY=\"your_gemini_api_key_here\"\n\n# Authenticate Claude CLI (pre-authenticated, no API key needed)\nclaude auth\n```\n\n#### 2. Run in Live Mode\n\n```bash\n# Run with real AI providers\nmix pipeline.run.live examples/comprehensive_config_example.yaml\n\n# Run with full debug logging\nPIPELINE_DEBUG=true PIPELINE_LOG_LEVEL=debug mix pipeline.run.live examples/comprehensive_config_example.yaml\n```","ref":"readme.html#live-mode-real-ai-providers"},{"type":"extras","title":"What the Comprehensive Example Demonstrates - Pipeline","doc":"The `examples/comprehensive_config_example.yaml` shows:\n\n- ✅ **Basic step types**: `gemini`, `claude`, `parallel_claude`, `gemini_instructor`\n- ✅ **Enhanced Claude steps**: `claude_smart`, `claude_session`, `claude_extract`, `claude_batch`, `claude_robust`\n- ✅ **Function calling**: Gemini with structured function definitions\n- ✅ **All Claude tools**: Write, Edit, Read, Bash, Search, Glob, Grep\n- ✅ **Parallel execution**: Multiple Claude instances running simultaneously\n- ✅ **Conditional steps**: Steps that run based on previous results\n- ✅ **All prompt types**: Static content, file content, previous responses\n- ✅ **Workspace management**: Sandboxed file operations\n- ✅ **Token budgets**: Fine-tuned AI response configurations\n- ✅ **Model selection**: Different AI models for different tasks\n- ✅ **Output management**: Structured result saving and organization","ref":"readme.html#what-the-comprehensive-example-demonstrates"},{"type":"extras","title":"Enhanced Claude Step Types - Pipeline","doc":"The pipeline includes five advanced Claude step types that extend the basic `claude` step with specialized capabilities:","ref":"readme.html#enhanced-claude-step-types"},{"type":"extras","title":"🎯 Claude Smart (claude_smart) - Pipeline","doc":"Intelligent preset-based configuration with environment awareness.\n- **Presets**: `development`, `production`, `analysis`, `chat`, `test`\n- **Auto-optimization**: Preset-specific tool restrictions and performance tuning\n- **Environment detection**: Automatic preset selection based on Mix environment\n\n```yaml\n- name: \"smart_analysis\" \n  type: \"claude_smart\"\n  preset: \"analysis\"  # Uses analysis-optimized settings\n  prompt: [...]\n```","ref":"readme.html#claude-smart-claude_smart"},{"type":"extras","title":"🗣️ Claude Session (claude_session) - Pipeline","doc":"Persistent conversation management with session state.\n- **Session persistence**: Continue conversations across multiple steps\n- **Automatic checkpointing**: Save session state for recovery\n- **Turn management**: Configurable conversation length limits\n\n```yaml\n- name: \"session_start\"\n  type: \"claude_session\" \n  session_name: \"math_tutor\"\n  session_config:\n    persist: true\n    max_turns: 50\n```","ref":"readme.html#claude-session-claude_session"},{"type":"extras","title":"📄 Claude Extract (claude_extract) - Pipeline","doc":"Advanced content extraction and post-processing.\n- **Output formats**: `json`, `markdown`, `structured`, `summary`\n- **Post-processing**: Extract code blocks, recommendations, links, key points\n- **Content filtering**: Apply extraction rules and transformations\n\n```yaml\n- name: \"extract_json\"\n  type: \"claude_extract\"\n  preset: \"analysis\"\n  extraction_config:\n    format: \"json\"\n    post_processing: [\"extract_code_blocks\", \"extract_recommendations\"]\n    include_metadata: true\n```","ref":"readme.html#claude-extract-claude_extract"},{"type":"extras","title":"⚡ Claude Batch (claude_batch) - Pipeline","doc":"Parallel task execution with load balancing.\n- **Concurrent processing**: Run multiple Claude queries simultaneously\n- **Task management**: Queue and execute independent tasks\n- **Performance scaling**: Configurable parallelism limits\n\n```yaml\n- name: \"batch_analysis\"\n  type: \"claude_batch\"\n  batch_config:\n    max_parallel: 3\n    tasks:\n      - id: \"task1\"\n        prompt: \"Analyze JavaScript code...\"\n      - id: \"task2\" \n        prompt: \"Analyze Python code...\"\n```","ref":"readme.html#claude-batch-claude_batch"},{"type":"extras","title":"🛡️ Claude Robust (claude_robust) - Pipeline","doc":"Enterprise-grade error recovery and fault tolerance.\n- **Retry mechanisms**: Configurable backoff strategies\n- **Fallback actions**: Graceful degradation options\n- **Circuit breaker**: Prevent cascade failures\n\n```yaml\n- name: \"robust_analysis\"\n  type: \"claude_robust\"\n  retry_config:\n    max_retries: 3\n    backoff_strategy: \"exponential\"\n    fallback_action: \"simplified_prompt\"\n```","ref":"readme.html#claude-robust-claude_robust"},{"type":"extras","title":"Testing Enhanced Step Types - Pipeline","doc":"Each enhanced step type has dedicated example files for testing:\n\n```bash\n# Test individual enhanced step types\nmix pipeline.run.live examples/claude_smart_example.yaml\nmix pipeline.run.live examples/claude_session_example.yaml  \nmix pipeline.run.live examples/claude_extract_example.yaml\nmix pipeline.run.live examples/claude_batch_example.yaml\nmix pipeline.run.live examples/claude_robust_example.yaml\n\n# Or run all enhanced examples in mock mode (free)\nmix pipeline.run examples/claude_smart_example.yaml\nmix pipeline.run examples/claude_session_example.yaml\n# ... etc\n```","ref":"readme.html#testing-enhanced-step-types"},{"type":"extras","title":"Environment Configuration - Pipeline","doc":"For advanced configuration, you can set these environment variables:\n\n```bash\n# API Configuration\nexport GEMINI_API_KEY=\"your_gemini_api_key\"\n# Note: Claude uses CLI authentication (claude auth), no API key needed\n\n# Pipeline Directories\nexport PIPELINE_WORKSPACE_DIR=\"./workspace\"     # Claude's sandbox\nexport PIPELINE_OUTPUT_DIR=\"./outputs\"          # Result storage\nexport PIPELINE_CHECKPOINT_DIR=\"./checkpoints\"  # State management\n\n# Logging and Debug\nexport PIPELINE_LOG_LEVEL=\"debug\"               # debug, info, warn, error\nexport PIPELINE_DEBUG=\"true\"                    # Detailed execution logs\n\n# Execution Mode\nexport TEST_MODE=\"live\"                          # live, mock, mixed\n```","ref":"readme.html#environment-configuration"},{"type":"extras","title":"Creating Your Own Workflows - Pipeline","doc":"1. **Start with the example**: Copy `examples/comprehensive_config_example.yaml`\n2. **Read the guides**: \n   - [Pipeline Configuration Guide](PIPELINE_CONFIG_GUIDE.md) for basic configuration\n   - [Prompt System Guide](PROMPT_SYSTEM_GUIDE.md) for advanced prompt management, templates, and reusable components\n   - [Recursive Pipelines Guide](RECURSIVE_PIPELINES_GUIDE.md) for pipeline composition and modular workflows\n   - [ADVANCED_FEATURES.md](ADVANCED_FEATURES.md) for loops, conditions, file operations, and more\n   - [TESTING_ARCHITECTURE.md](TESTING_ARCHITECTURE.md) for comprehensive testing approaches\n3. **Test in mock mode**: Validate your workflow logic without API costs\n4. **Run live**: Execute with real AI providers when ready","ref":"readme.html#creating-your-own-workflows"},{"type":"extras","title":"Development - Pipeline","doc":"","ref":"readme.html#development"},{"type":"extras","title":"Running the Example - Pipeline","doc":"The `run_example.exs` script demonstrates the pipeline:\n\n```bash\n# Quick test with mocks\nTEST_MODE=mock elixir run_example.exs\n\n# Full test with APIs\nelixir run_example.exs\n```","ref":"readme.html#running-the-example"},{"type":"extras","title":"Test Structure - Pipeline","doc":"```\ntest/\n├── unit/           # Fast unit tests (mocked)\n├── integration/    # Integration tests (live APIs) \n├── fixtures/       # Test data and workflows\n└── support/        # Test helpers\n```","ref":"readme.html#test-structure"},{"type":"extras","title":"Adding New Tests - Pipeline","doc":"```elixir\ndefmodule MyTest do\n  use ExUnit.Case\n  use Pipeline.TestCase  # Provides test mode helpers\n  \n  test \"my feature works in mock mode\" do\n    # Test automatically uses mocks\n    assert Pipeline.execute_something() == expected_result\n  end\nend\n```","ref":"readme.html#adding-new-tests"},{"type":"extras","title":"Debugging - Pipeline","doc":"Enable debug output:\n\n```bash\n# See detailed execution logs\nDEBUG=true elixir run_example.exs\n\n# See API request/response details\nVERBOSE=true elixir run_example.exs\n```\n\nDebug output includes:\n- Step execution flow\n- API request/response details\n- Provider selection (mock vs live)\n- Result processing","ref":"readme.html#debugging"},{"type":"extras","title":"Common Issues - Pipeline","doc":"","ref":"readme.html#common-issues"},{"type":"extras","title":"Claude CLI Not Authenticated - Pipeline","doc":"```bash\n# Error: Claude CLI not found or not authenticated\nclaude login\n```","ref":"readme.html#claude-cli-not-authenticated"},{"type":"extras","title":"Missing Gemini API Key - Pipeline","doc":"```bash\n# Error: GEMINI_API_KEY environment variable not set\nexport GEMINI_API_KEY=\"your_key_here\"\n```","ref":"readme.html#missing-gemini-api-key"},{"type":"extras","title":"Mixed Results (Some Success, Some Failure) - Pipeline","doc":"```bash\n# Check which providers are mocked vs live\nTEST_MODE=mock elixir run_example.exs  # All mocked\nTEST_MODE=live elixir run_example.exs  # All live\n```","ref":"readme.html#mixed-results-some-success-some-failure"},{"type":"extras","title":"License - Pipeline","doc":"TODO: Add license information","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [0.0.1] - 2025-01-05\n\n**Maintainer**: NSHkr","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release of Pipeline.ex - AI pipeline orchestration library for Elixir\n- Core pipeline execution engine with robust error handling and retries\n- Support for Claude (Anthropic) and Gemini (Google) AI providers\n- YAML v2 pipeline format with comprehensive features:\n  - Multi-step pipelines with conditional execution\n  - Advanced prompt templating with variables and transformations\n  - Control flow (conditionals, loops, parallel execution)\n  - Pipeline composition and inheritance\n  - Function calling support for both providers\n- Genesis/Meta pipeline system for self-improving pipelines:\n  - Pipeline DNA evolution and mutation\n  - Fitness evaluation framework\n  - Recursive pipeline generation\n- Comprehensive testing framework with mocking support\n- Extensive documentation including:\n  - Complete YAML format v2 reference\n  - Architecture documentation\n  - Usage guides and patterns\n  - Pipeline specifications for various use cases\n- Visual pipeline editor specifications (implementation planned)\n- Safety features and context management\n- Performance optimization with caching and parallel execution","ref":"changelog.html#added"},{"type":"extras","title":"Features - Changelog","doc":"- **Pipeline Execution**: Robust execution engine with retry logic and error handling\n- **Provider Support**: Claude (via Anthropic API) and Gemini (via Google API) integration\n- **YAML Configuration**: Declarative pipeline definitions with v2 format\n- **Prompt System**: Advanced templating with variables, transformations, and inheritance\n- **Control Flow**: Conditionals, loops, parallel execution, and error handling\n- **Genesis System**: Self-improving pipelines with evolution capabilities\n- **Testing Support**: Built-in test mode with comprehensive mocking\n- **Documentation**: Extensive guides, references, and examples","ref":"changelog.html#features"},{"type":"extras","title":"Known Limitations - Changelog","doc":"- Visual editor GUI not yet implemented (specifications only)\n- Limited to Claude and Gemini providers in this release\n- Some advanced meta-pipeline features are experimental\n\n[0.0.1]: https://github.com/nshkrdotcom/pipeline_ex/releases/tag/v0.0.1","ref":"changelog.html#known-limitations"},{"type":"extras","title":"Advanced Features","doc":"# Advanced Pipeline Features Guide\n\n**🎯 Library Status: Complete Implementation Ready** - This guide covers the 5 critical advanced features that transform pipeline_ex from an 8.5/10 library into a complete 10/10 AI engineering platform.","ref":"advanced_features.html"},{"type":"extras","title":"Overview - Advanced Features","doc":"This document covers the advanced features implemented to address the critical gaps identified in the missing pieces analysis. These features enable intelligent, self-correcting workflows with enterprise-grade capabilities.","ref":"advanced_features.html#overview"},{"type":"extras","title":"🔄 1. Enhanced Loop Constructs - Advanced Features","doc":"","ref":"advanced_features.html#1-enhanced-loop-constructs"},{"type":"extras","title":"For Loops - Advanced Features","doc":"Execute steps iteratively over data collections with full variable scoping and error handling.\n\n```yaml\n- name: \"process_files\"\n  type: \"for_loop\"\n  iterator: \"file\"\n  data_source: \"previous_response:file_list\"\n  steps:\n    - name: \"analyze_file\"\n      type: \"claude\"\n      prompt: \"Analyze file: {{loop.file.name}}\"\n      \n- name: \"nested_processing\"\n  type: \"for_loop\"\n  iterator: \"category\"\n  data_source: \"categories\"\n  parallel: true\n  max_parallel: 3\n  steps:\n    - name: \"process_category_files\"\n      type: \"for_loop\"\n      iterator: \"file\"\n      data_source: \"{{loop.category.files}}\"\n      steps:\n        - name: \"analyze_file\"\n          type: \"claude\"\n          prompt: \"Analyze {{loop.file.path}} in {{loop.parent.category.name}}\"\n```","ref":"advanced_features.html#for-loops"},{"type":"extras","title":"While Loops - Advanced Features","doc":"Continue execution until conditions are met with safety limits and early termination.\n\n```yaml\n- name: \"fix_until_passing\"\n  type: \"while_loop\"\n  condition: \"test_results.status != 'passed'\"\n  max_iterations: 5\n  steps:\n    - name: \"run_tests\"\n      type: \"claude\"\n      prompt: \"Run tests and analyze failures\"\n    - name: \"fix_issues\"\n      type: \"claude\"\n      prompt: \"Fix the failing tests based on: {{previous_response}}\"\n```","ref":"advanced_features.html#while-loops"},{"type":"extras","title":"Loop Features - Advanced Features","doc":"- **Variable Scoping**: `{{loop.variable}}` access with nested loop support (`{{loop.parent.variable}}`)\n- **Parallel Execution**: Configure `parallel: true` with `max_parallel` limits\n- **Safety Limits**: `max_iterations` prevents infinite loops\n- **Error Handling**: `break_on_error` and graceful degradation\n- **Performance**: Memory-efficient streaming for large datasets","ref":"advanced_features.html#loop-features"},{"type":"extras","title":"🧠 2. Complex Conditional Logic - Advanced Features","doc":"","ref":"advanced_features.html#2-complex-conditional-logic"},{"type":"extras","title":"Boolean Expressions - Advanced Features","doc":"Advanced condition evaluation with AND/OR/NOT logic and comparison operators.\n\n```yaml\n- name: \"conditional_step\"\n  type: \"claude\"\n  condition:\n    and:\n      - \"analysis.score > 7\"\n      - or:\n        - \"analysis.status == 'passed'\"\n        - \"analysis.warnings.length < 3\"\n      - not: \"analysis.errors.length > 0\"\n  prompt: \"Proceed with implementation...\"\n```","ref":"advanced_features.html#boolean-expressions"},{"type":"extras","title":"Comparison Operations - Advanced Features","doc":"Support for mathematical and string comparison operations.\n\n```yaml\n- name: \"complex_decision\"\n  type: \"claude\"\n  condition:\n    and:\n      - \"analysis.score * analysis.confidence > 0.8\"\n      - \"any(analysis.issues, 'severity == \\\"high\\\"') == false\"\n      - \"length(analysis.recommendations) between 3 and 10\"\n      - \"analysis.timestamp > now() - days(7)\"\n      - \"analysis.file_path matches '.*\\\\.ex$'\"\n```","ref":"advanced_features.html#comparison-operations"},{"type":"extras","title":"Switch/Case Branching - Advanced Features","doc":"Route execution based on values with default fallbacks.\n\n```yaml\n- name: \"route_by_status\"\n  type: \"switch\"\n  expression: \"analysis.status\"\n  cases:\n    \"passed\": \n      - name: \"deploy_step\"\n        type: \"claude\"\n        prompt: \"Deploy the application...\"\n    \"failed\":\n      - name: \"fix_step\"\n        type: \"claude\"\n        prompt: \"Fix the identified issues...\"\n    \"warning\":\n      - name: \"review_step\"\n        type: \"claude\"\n        prompt: \"Review warnings and decide...\"\n  default:\n    - name: \"unknown_status\"\n      type: \"claude\"\n      prompt: \"Handle unknown status...\"\n```","ref":"advanced_features.html#switch-case-branching"},{"type":"extras","title":"Condition Features - Advanced Features","doc":"- **Operators**: `>`, `<`, `==`, `!=`, `contains`, `matches`, `between`\n- **Functions**: `length()`, `any()`, `all()`, `count()`, `sum()`, `average()`\n- **Pattern Matching**: Regular expressions and string patterns\n- **Date/Time**: Relative time comparisons and arithmetic\n- **Mathematical**: Complex expressions with variables","ref":"advanced_features.html#condition-features"},{"type":"extras","title":"📁 3. Advanced File Operations - Advanced Features","doc":"","ref":"advanced_features.html#3-advanced-file-operations"},{"type":"extras","title":"Core File Operations - Advanced Features","doc":"Comprehensive file manipulation within pipeline workspaces.\n\n```yaml\n- name: \"copy_config\"\n  type: \"file_ops\"\n  operation: \"copy\"\n  source: \"templates/config.yaml\"\n  destination: \"config/app.yaml\"\n\n- name: \"validate_files\"\n  type: \"file_ops\"\n  operation: \"validate\"\n  files:\n    - path: \"lib/my_app.ex\"\n      must_exist: true\n      min_size: 100\n    - path: \"test/\"\n      must_be_dir: true\n\n- name: \"convert_data\"\n  type: \"file_ops\"\n  operation: \"convert\"\n  source: \"data.csv\"\n  destination: \"data.json\"\n  format: \"csv_to_json\"\n```","ref":"advanced_features.html#core-file-operations"},{"type":"extras","title":"Supported Operations - Advanced Features","doc":"- **copy**: Duplicate files with path resolution\n- **move**: Relocate files atomically\n- **delete**: Remove files and directories safely\n- **validate**: Check existence, size, permissions\n- **list**: Directory scanning with filters\n- **convert**: Format transformations (CSV↔JSON↔YAML↔XML)","ref":"advanced_features.html#supported-operations"},{"type":"extras","title":"File Operation Features - Advanced Features","doc":"- **Atomic Operations**: Rollback on failure\n- **Permission Checking**: Validate access before operations\n- **Large File Streaming**: Memory-efficient processing\n- **Workspace Relative**: Safe path resolution within workspaces\n- **Binary Support**: Handle images, PDFs, and other binary formats","ref":"advanced_features.html#file-operation-features"},{"type":"extras","title":"🔄 4. Structured Data Transformation - Advanced Features","doc":"","ref":"advanced_features.html#4-structured-data-transformation"},{"type":"extras","title":"Schema Validation - Advanced Features","doc":"Enforce structured output formats with comprehensive validation.\n\n```yaml\n- name: \"analyze_code\"\n  type: \"claude\"\n  output_schema:\n    type: \"object\"\n    required: [\"analysis\", \"recommendations\", \"score\"]\n    properties:\n      analysis:\n        type: \"string\"\n        min_length: 50\n      score:\n        type: \"number\"\n        minimum: 0\n        maximum: 10\n      recommendations:\n        type: \"array\"\n        items:\n          type: \"object\"\n          properties:\n            priority: {type: \"string\", enum: [\"high\", \"medium\", \"low\"]}\n            action: {type: \"string\"}\n```","ref":"advanced_features.html#schema-validation"},{"type":"extras","title":"Data Transformation - Advanced Features","doc":"Manipulate structured data between pipeline steps.\n\n```yaml\n- name: \"process_results\"\n  type: \"data_transform\"\n  input_source: \"previous_response:analysis\"\n  operations:\n    - operation: \"filter\"\n      field: \"recommendations\"\n      condition: \"priority == 'high'\"\n    - operation: \"aggregate\"\n      field: \"scores\"\n      function: \"average\"\n    - operation: \"join\"\n      left_field: \"files\"\n      right_source: \"previous_response:file_metadata\"\n      join_key: \"filename\"\n  output_field: \"processed_data\"\n```","ref":"advanced_features.html#data-transformation"},{"type":"extras","title":"Query Language - Advanced Features","doc":"JSONPath-like syntax for complex data extraction.\n\n```yaml\n- name: \"extract_high_priority\"\n  type: \"data_transform\"\n  operations:\n    - operation: \"query\"\n      expression: \"$.analysis[?(@.score > 7)].recommendations\"\n    - operation: \"transform\"\n      expression: \"$.files[*].{name: filename, size: filesize}\"\n```","ref":"advanced_features.html#query-language"},{"type":"extras","title":"Data Features - Advanced Features","doc":"- **JSON Schema**: Complete validation with clear error messages\n- **Transformations**: filter, map, aggregate, join, group_by, sort\n- **Query Engine**: JSONPath expressions with functions\n- **Type Safety**: Automatic type conversion and validation\n- **Chaining**: Multiple operations in sequence","ref":"advanced_features.html#data-features"},{"type":"extras","title":"🗂️ 5. Codebase Intelligence System - Advanced Features","doc":"","ref":"advanced_features.html#5-codebase-intelligence-system"},{"type":"extras","title":"Automatic Discovery - Advanced Features","doc":"Intelligent project structure analysis and context awareness.\n\n```yaml\n- name: \"analyze_project\"\n  type: \"claude\"\n  codebase_context: true\n  prompt: |\n    Analyze this {{codebase.project_type}} project.\n    Main files: {{codebase.structure.main_files}}\n    Dependencies: {{codebase.dependencies}}\n    Recent changes: {{codebase.git_info.recent_commits}}\n```","ref":"advanced_features.html#automatic-discovery"},{"type":"extras","title":"Codebase Queries - Advanced Features","doc":"Search and analyze code relationships intelligently.\n\n```yaml\n- name: \"find_related_files\"\n  type: \"codebase_query\"\n  queries:\n    main_modules:\n      find_files:\n        - type: \"main\"\n        - pattern: \"lib/**/*.ex\"\n        - exclude_tests: true\n    test_files:\n      find_files:\n        - related_to: \"{{previous_response:target_file}}\"\n        - type: \"test\"\n    dependencies:\n      find_dependencies:\n        - for_file: \"lib/user.ex\"\n        - include_transitive: false\n```","ref":"advanced_features.html#codebase-queries"},{"type":"extras","title":"Code Analysis - Advanced Features","doc":"AST parsing and semantic understanding for multiple languages.\n\n```yaml\n- name: \"analyze_code_structure\"\n  type: \"codebase_query\"\n  queries:\n    functions:\n      find_functions:\n        - in_file: \"lib/user.ex\"\n        - public_only: true\n    dependencies:\n      find_dependents:\n        - of_file: \"lib/user.ex\"\n        - include_tests: true\n```","ref":"advanced_features.html#code-analysis"},{"type":"extras","title":"Codebase Features - Advanced Features","doc":"- **Project Detection**: Elixir, Node.js, Python, Go, Rust support\n- **File Relationships**: Dependency mapping and impact analysis\n- **Git Integration**: Commit history, branch status, change detection\n- **Semantic Search**: Find functions, classes, imports across codebases\n- **Test Mapping**: Automatic test-to-code relationship discovery","ref":"advanced_features.html#codebase-features"},{"type":"extras","title":"💾 6. State Management & Variables - Advanced Features","doc":"","ref":"advanced_features.html#6-state-management-variables"},{"type":"extras","title":"Variable Assignment - Advanced Features","doc":"Persistent state management across pipeline execution.\n\n```yaml\n- name: \"initialize_state\"\n  type: \"set_variable\"\n  variables:\n    attempt_count: 0\n    error_threshold: 3\n    processed_files: []\n\n- name: \"increment_counter\"\n  type: \"set_variable\"\n  variables:\n    attempt_count: \"{{state.attempt_count + 1}}\"\n```","ref":"advanced_features.html#variable-assignment"},{"type":"extras","title":"Variable Interpolation - Advanced Features","doc":"Use variables throughout pipeline configurations.\n\n```yaml\n- name: \"conditional_step\"\n  type: \"claude\"\n  condition: \"state.attempt_count < state.error_threshold\"\n  prompt: \"Attempt #{{state.attempt_count}}: Process data\"\n```","ref":"advanced_features.html#variable-interpolation"},{"type":"extras","title":"State Persistence - Advanced Features","doc":"Maintain state across pipeline runs and checkpoint recovery.\n\n```yaml\n- name: \"save_progress\"\n  type: \"checkpoint\"\n  state:\n    completed_files: \"{{state.processed_files}}\"\n    last_successful_step: \"{{current_step}}\"\n```","ref":"advanced_features.html#state-persistence"},{"type":"extras","title":"State Features - Advanced Features","doc":"- **Scoping**: Global, loop, and session variable scopes\n- **Persistence**: Automatic checkpoint integration\n- **Type Safety**: Variable validation and type checking\n- **Interpolation**: Template variables in any configuration field\n- **Mutation**: Safe state updates with rollback support","ref":"advanced_features.html#state-features"},{"type":"extras","title":"🚀 Performance & Streaming - Advanced Features","doc":"","ref":"advanced_features.html#performance-streaming"},{"type":"extras","title":"Large Dataset Processing - Advanced Features","doc":"Memory-efficient handling of large files and data collections.\n\n```yaml\n- name: \"process_large_dataset\"\n  type: \"file_ops\"\n  operation: \"stream_process\"\n  source: \"large_data.csv\"\n  chunk_size: 1000\n  processor:\n    type: \"claude\"\n    prompt: \"Process data chunk: {{chunk}}\"\n```","ref":"advanced_features.html#large-dataset-processing"},{"type":"extras","title":"Parallel Execution - Advanced Features","doc":"Concurrent processing with resource management.\n\n```yaml\n- name: \"parallel_analysis\"\n  type: \"for_loop\"\n  iterator: \"file\"\n  data_source: \"file_list\"\n  parallel: true\n  max_parallel: 5\n  memory_limit: \"500MB\"\n  steps:\n    - name: \"analyze_file\"\n      type: \"claude\"\n      prompt: \"Analyze {{loop.file}}\"\n```","ref":"advanced_features.html#parallel-execution"},{"type":"extras","title":"Performance Features - Advanced Features","doc":"- **Streaming I/O**: Process files without loading into memory\n- **Lazy Evaluation**: Compute results only when needed\n- **Resource Limits**: Memory and execution time constraints\n- **Performance Monitoring**: Built-in metrics and bottleneck detection\n- **Optimization**: Automatic query optimization and caching","ref":"advanced_features.html#performance-features"},{"type":"extras","title":"🛠️ Integration Examples - Advanced Features","doc":"","ref":"advanced_features.html#integration-examples"},{"type":"extras","title":"Complete Workflow Example - Advanced Features","doc":"A real-world example combining all advanced features:\n\n```yaml\nworkflow:\n  name: \"advanced_code_analysis\"\n  description: \"Complete codebase analysis with intelligent processing\"\n  \n  steps:\n    - name: \"discover_project\"\n      type: \"codebase_query\"\n      codebase_context: true\n      queries:\n        project_info:\n          get_project_type: true\n          get_dependencies: true\n          get_git_status: true\n    \n    - name: \"initialize_analysis_state\"\n      type: \"set_variable\"\n      variables:\n        total_files: 0\n        processed_files: []\n        issues_found: []\n        analysis_score: 0\n    \n    - name: \"find_source_files\"\n      type: \"codebase_query\"\n      queries:\n        source_files:\n          find_files:\n            - type: \"source\"\n            - exclude_tests: true\n            - modified_since: \"{{state.last_analysis_date}}\"\n    \n    - name: \"analyze_files\"\n      type: \"for_loop\"\n      iterator: \"file\"\n      data_source: \"previous_response:source_files\"\n      parallel: true\n      max_parallel: 3\n      steps:\n        - name: \"analyze_single_file\"\n          type: \"claude\"\n          output_schema:\n            type: \"object\"\n            required: [\"file_path\", \"issues\", \"score\"]\n            properties:\n              file_path: {type: \"string\"}\n              issues:\n                type: \"array\"\n                items:\n                  type: \"object\"\n                  properties:\n                    severity: {type: \"string\", enum: [\"low\", \"medium\", \"high\"]}\n                    message: {type: \"string\"}\n              score: {type: \"number\", minimum: 0, maximum: 10}\n          prompt: |\n            Analyze this {{codebase.project_type}} file: {{loop.file.path}}\n            \n            File content:\n            ```\n            {{file:{{loop.file.path}}}}\n            ```\n            \n            Consider:\n            - Code quality and style\n            - Potential bugs or issues\n            - Performance concerns\n            - Security vulnerabilities\n        \n        - name: \"update_analysis_state\"\n          type: \"set_variable\"\n          variables:\n            processed_files: \"{{state.processed_files + [loop.file.path]}}\"\n            issues_found: \"{{state.issues_found + previous_response.issues}}\"\n    \n    - name: \"filter_high_priority_issues\"\n      type: \"data_transform\"\n      input_source: \"state.issues_found\"\n      operations:\n        - operation: \"filter\"\n          condition: \"severity == 'high'\"\n        - operation: \"group_by\"\n          field: \"file_path\"\n        - operation: \"sort\"\n          field: \"severity\"\n          order: \"desc\"\n    \n    - name: \"generate_fixes\"\n      type: \"while_loop\"\n      condition: \"length(filtered_issues) > 0 and state.fix_attempts < 3\"\n      max_iterations: 3\n      steps:\n        - name: \"attempt_fix\"\n          type: \"claude\"\n          condition: \n            and:\n              - \"length(previous_response:filtered_issues) > 0\"\n              - \"state.fix_attempts < 3\"\n          prompt: |\n            Fix these high-priority issues:\n            {{previous_response:filtered_issues}}\n            \n            Generate specific fix recommendations for each issue.\n        \n        - name: \"increment_fix_attempts\"\n          type: \"set_variable\"\n          variables:\n            fix_attempts: \"{{state.fix_attempts + 1}}\"\n    \n    - name: \"save_analysis_report\"\n      type: \"data_transform\"\n      operations:\n        - operation: \"aggregate\"\n          input_source: \"state\"\n          output_format: \"analysis_report\"\n      \n    - name: \"export_results\"\n      type: \"file_ops\"\n      operation: \"convert\"\n      source: \"analysis_report\"\n      destination: \"analysis_report.json\"\n      format: \"object_to_json\"\n\n    - name: \"checkpoint_final_state\"\n      type: \"checkpoint\"\n      state:\n        analysis_complete: true\n        total_issues: \"{{length(state.issues_found)}}\"\n        high_priority_issues: \"{{length(filtered_issues)}}\"\n        completion_time: \"{{now()}}\"\n```","ref":"advanced_features.html#complete-workflow-example"},{"type":"extras","title":"🧪 Testing & Validation - Advanced Features","doc":"All advanced features support comprehensive testing:","ref":"advanced_features.html#testing-validation"},{"type":"extras","title":"Mock Mode Testing - Advanced Features","doc":"```bash\n# Test all advanced features with mocks\nmix pipeline.run examples/advanced_features_example.yaml\n\n# Test specific feature sets\nmix pipeline.run examples/loops_example.yaml\nmix pipeline.run examples/conditions_example.yaml\nmix pipeline.run examples/file_ops_example.yaml\nmix pipeline.run examples/data_transform_example.yaml\nmix pipeline.run examples/codebase_query_example.yaml\n```","ref":"advanced_features.html#mock-mode-testing"},{"type":"extras","title":"Live Mode Testing - Advanced Features","doc":"```bash\n# Test with real AI providers\nmix pipeline.run.live examples/advanced_features_example.yaml\n\n# Performance testing\nmix pipeline.benchmark examples/large_dataset_example.yaml\n```","ref":"advanced_features.html#live-mode-testing"},{"type":"extras","title":"Integration Testing - Advanced Features","doc":"```bash\n# Full integration test suite\nmix test test/integration/advanced_features_test.exs\n\n# Performance benchmarks\nmix test test/performance/advanced_features_performance_test.exs\n```","ref":"advanced_features.html#integration-testing"},{"type":"extras","title":"📚 Migration Guide - Advanced Features","doc":"","ref":"advanced_features.html#migration-guide"},{"type":"extras","title":"From Basic to Advanced - Advanced Features","doc":"Existing pipelines remain fully compatible. To use advanced features:\n\n1. **Add Loop Processing**:\n   ```yaml\n   # Before: Single step\n   - name: \"analyze\"\n     type: \"claude\"\n     prompt: \"Analyze file1.ex\"\n   \n   # After: Loop over multiple files\n   - name: \"analyze_all\"\n     type: \"for_loop\"\n     iterator: \"file\"\n     data_source: \"file_list\"\n     steps:\n       - name: \"analyze\"\n         type: \"claude\"\n         prompt: \"Analyze {{loop.file}}\"\n   ```\n\n2. **Add Conditional Logic**:\n   ```yaml\n   # Before: Always runs\n   - name: \"deploy\"\n     type: \"claude\"\n     prompt: \"Deploy application\"\n   \n   # After: Conditional execution\n   - name: \"deploy\"\n     type: \"claude\"\n     condition: \"tests.status == 'passed' and analysis.score > 8\"\n     prompt: \"Deploy application\"\n   ```\n\n3. **Add Schema Validation**:\n   ```yaml\n   # Before: Unstructured output\n   - name: \"analyze\"\n     type: \"claude\"\n     prompt: \"Analyze code\"\n   \n   # After: Structured output\n   - name: \"analyze\"\n     type: \"claude\"\n     output_schema:\n       type: \"object\"\n       required: [\"score\", \"issues\"]\n     prompt: \"Analyze code and return JSON\"\n   ```","ref":"advanced_features.html#from-basic-to-advanced"},{"type":"extras","title":"🎯 Best Practices - Advanced Features","doc":"","ref":"advanced_features.html#best-practices"},{"type":"extras","title":"Performance - Advanced Features","doc":"- Use `parallel: true` for independent loop iterations\n- Set appropriate `max_parallel` limits (typically 3-5)\n- Use streaming for files >100MB\n- Set memory limits for long-running processes","ref":"advanced_features.html#performance"},{"type":"extras","title":"Error Handling - Advanced Features","doc":"- Always set `max_iterations` on while loops\n- Use `break_on_error: false` for non-critical operations\n- Implement fallback strategies with conditions\n- Add checkpoints for long-running workflows","ref":"advanced_features.html#error-handling"},{"type":"extras","title":"Data Management - Advanced Features","doc":"- Validate schemas early in pipelines\n- Use data transformations to normalize between steps\n- Keep state variables minimal and focused\n- Clean up large temporary data regularly","ref":"advanced_features.html#data-management"},{"type":"extras","title":"Codebase Intelligence - Advanced Features","doc":"- Enable `codebase_context: true` for code analysis steps\n- Cache codebase discovery results for multiple runs\n- Use specific queries rather than broad scans\n- Combine with file operations for intelligent refactoring","ref":"advanced_features.html#codebase-intelligence"},{"type":"extras","title":"🔗 Related Documentation - Advanced Features","doc":"- [README.md](README.md) - Complete library usage guide\n- [PIPELINE_CONFIG_GUIDE.md](PIPELINE_CONFIG_GUIDE.md) - Configuration reference\n- [USE_CASES.md](USE_CASES.md) - Working examples for various features\n- [TESTING_ARCHITECTURE.md](TESTING_ARCHITECTURE.md) - Testing approaches\n\n---\n\n**Next Steps**: See [TESTING_ARCHITECTURE.md](TESTING_ARCHITECTURE.md) for comprehensive examples and testing approaches for each advanced feature.","ref":"advanced_features.html#related-documentation"},{"type":"extras","title":"Pipeline Configuration","doc":"# Pipeline Configuration Technical Guide","ref":"pipeline_config_guide.html"},{"type":"extras","title":"Table of Contents - Pipeline Configuration","doc":"1. [Overview](#overview)\n2. [Configuration File Structure](#configuration-file-structure)\n3. [Workflow Section](#workflow-section)\n4. [Defaults Section](#defaults-section)\n5. [Steps Section](#steps-section)\n6. [Step Types](#step-types)\n7. [Prompt Templates](#prompt-templates)\n8. [Token Budget Management](#token-budget-management)\n9. [Claude Options](#claude-options)\n10. [Advanced Features](#advanced-features)\n11. [Complete Examples](#complete-examples)\n12. [Best Practices](#best-practices)\n13. [Troubleshooting](#troubleshooting)","ref":"pipeline_config_guide.html#table-of-contents"},{"type":"extras","title":"Overview - Pipeline Configuration","doc":"Pipeline configuration files are written in YAML format and define the complete workflow for orchestrating Gemini (planning/decision-making) and Claude (code execution) to accomplish complex tasks.","ref":"pipeline_config_guide.html#overview"},{"type":"extras","title":"Basic Structure - Pipeline Configuration","doc":"```yaml\nworkflow:\n  name: \"string\"                    # Required: Workflow identifier\n  checkpoint_enabled: boolean       # Optional: Enable state saving\n  workspace_dir: \"string\"          # Optional: Claude's sandbox directory\n  checkpoint_dir: \"string\"         # Optional: Checkpoint storage location\n  \n  defaults:                        # Optional: Default settings\n    gemini_model: \"string\"         # Gemini model to use\n    gemini_token_budget: {}        # Token limits for Gemini\n    claude_output_format: \"string\" # Output format for Claude\n    output_dir: \"string\"          # Where to save outputs\n    \n  gemini_functions: {}            # Optional: Function definitions\n  \n  steps: []                       # Required: List of workflow steps\n```","ref":"pipeline_config_guide.html#basic-structure"},{"type":"extras","title":"Configuration File Structure - Pipeline Configuration","doc":"","ref":"pipeline_config_guide.html#configuration-file-structure"},{"type":"extras","title":"Root Level - Pipeline Configuration","doc":"The configuration file must have a single root key `workflow`:\n\n```yaml\nworkflow:\n  # All configuration goes here\n```","ref":"pipeline_config_guide.html#root-level"},{"type":"extras","title":"Required Fields - Pipeline Configuration","doc":"- `workflow.name`: Unique identifier for the workflow\n- `workflow.steps`: Array of step definitions","ref":"pipeline_config_guide.html#required-fields"},{"type":"extras","title":"Optional Fields - Pipeline Configuration","doc":"- `workflow.checkpoint_enabled`: Enable workflow state saving (default: false)\n- `workflow.workspace_dir`: Directory for Claude's file operations (default: \"./workspace\")\n- `workflow.checkpoint_dir`: Where to save checkpoints (default: \"./checkpoints\")\n- `workflow.defaults`: Default settings for all steps","ref":"pipeline_config_guide.html#optional-fields"},{"type":"extras","title":"Workflow Section - Pipeline Configuration","doc":"The workflow section contains global settings:\n\n```yaml\nworkflow:\n  name: \"data_processor\"\n  checkpoint_enabled: true\n  workspace_dir: \"./workspace\"\n  checkpoint_dir: \"./checkpoints\"\n```","ref":"pipeline_config_guide.html#workflow-section"},{"type":"extras","title":"Field Details - Pipeline Configuration","doc":"#### `name` (string, required)\n- Identifies the workflow in logs and outputs\n- Used in output directory naming\n- Should be descriptive and unique\n\n#### `checkpoint_enabled` (boolean, optional)\n- When `true`, saves state after each step\n- Allows resuming interrupted workflows\n- Checkpoints include step results and timestamps\n\n#### `workspace_dir` (string, optional)\n- Directory where Claude performs file operations\n- Created automatically if it doesn't exist\n- Provides sandboxing for Claude's file access\n- Default: \"./workspace\"\n\n#### `checkpoint_dir` (string, optional)\n- Directory for storing checkpoint files\n- Created automatically if needed\n- Default: \"./checkpoints\"","ref":"pipeline_config_guide.html#field-details"},{"type":"extras","title":"Defaults Section - Pipeline Configuration","doc":"Sets default values for all steps:\n\n```yaml\ndefaults:\n  gemini_model: \"gemini-2.5-flash-lite-preview-06-17\"\n  gemini_token_budget:\n    max_output_tokens: 2048\n    temperature: 0.7\n    top_p: 0.95\n    top_k: 40\n  claude_output_format: \"json\"\n  output_dir: \"./outputs/my_workflow\"\n```","ref":"pipeline_config_guide.html#defaults-section"},{"type":"extras","title":"Available Defaults - Pipeline Configuration","doc":"#### `gemini_model` (string)\nAvailable models:\n- `\"gemini-2.5-flash\"` - Fast, efficient model\n- `\"gemini-2.5-flash-lite-preview-06-17\"` - Lightweight version\n- `\"gemini-2.5-pro\"` - Most capable model\n- `\"gemini-2.0-flash\"` - Previous generation\n\n#### `gemini_token_budget` (object)\nDefault token limits for Gemini:\n- `max_output_tokens`: Maximum response length (256-8192)\n- `temperature`: Randomness control (0.0-1.0)\n- `top_p`: Nucleus sampling (0.0-1.0)\n- `top_k`: Top-k sampling (1-40)\n\n#### `claude_output_format` (string)\nDefault output format for Claude:\n- `\"json\"` - Structured JSON output\n- `\"text\"` - Plain text output\n- `\"stream-json\"` - Streaming JSON\n\n#### `output_dir` (string)\nDefault directory for saving step outputs.","ref":"pipeline_config_guide.html#available-defaults"},{"type":"extras","title":"Steps Section - Pipeline Configuration","doc":"The heart of the configuration - defines the workflow sequence:\n\n```yaml\nsteps:\n  - name: \"analyze\"\n    type: \"gemini\"\n    role: \"brain\"\n    # ... step configuration\n    \n  - name: \"implement\"\n    type: \"claude\"\n    role: \"muscle\"\n    # ... step configuration\n```","ref":"pipeline_config_guide.html#steps-section"},{"type":"extras","title":"Step Fields - Pipeline Configuration","doc":"#### Common Fields (all step types)\n\n##### `name` (string, required)\n- Unique identifier for the step\n- Referenced by other steps via `previous_response`\n- Used in output filenames\n\n##### `type` (string, required)\nOptions:\n- `\"gemini\"` - Gemini AI step\n- `\"claude\"` - Claude AI step\n- `\"parallel_claude\"` - Multiple Claude instances\n\n##### `role` (string, optional)\n- `\"brain\"` - Decision-making role (typically Gemini)\n- `\"muscle\"` - Execution role (typically Claude)\n- Used for documentation/clarity\n\n##### `condition` (string, optional)\nSkip step based on previous results:\n```yaml\ncondition: \"previous_step.field_name\"\n```\n\n##### `output_to_file` (string, optional)\nSave step output to specified file:\n```yaml\noutput_to_file: \"analysis_result.json\"\n```","ref":"pipeline_config_guide.html#step-fields"},{"type":"extras","title":"Step Types - Pipeline Configuration","doc":"","ref":"pipeline_config_guide.html#step-types"},{"type":"extras","title":"1. Gemini Step - Pipeline Configuration","doc":"For planning, analysis, and decision-making:\n\n```yaml\n- name: \"plan_implementation\"\n  type: \"gemini\"\n  role: \"brain\"\n  model: \"gemini-2.5-flash\"  # Override default\n  token_budget:\n    max_output_tokens: 4096\n    temperature: 0.5\n  prompt:\n    - type: \"static\"\n      content: \"Create an implementation plan...\"\n  output_to_file: \"plan.json\"\n```\n\n#### Gemini-Specific Fields\n\n##### `model` (string, optional)\nOverride the default Gemini model for this step.\n\n##### `token_budget` (object, optional)\nOverride default token limits:\n```yaml\ntoken_budget:\n  max_output_tokens: 8192  # More tokens for detailed output\n  temperature: 0.3         # Lower for focused responses\n  top_p: 0.9              # Adjust nucleus sampling\n  top_k: 20               # Limit token choices\n```\n\n##### `functions` (array, optional)\nEnable function calling:\n```yaml\nfunctions:\n  - \"evaluate_code\"\n  - \"generate_tests\"\n```","ref":"pipeline_config_guide.html#1-gemini-step"},{"type":"extras","title":"2. Claude Step - Pipeline Configuration","doc":"For code execution and file manipulation:\n\n```yaml\n- name: \"implement_feature\"\n  type: \"claude\"\n  role: \"muscle\"\n  claude_options:\n    print: true\n    max_turns: 15\n    allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\"]\n    output_format: \"json\"\n    cwd: \"./workspace\"\n  prompt:\n    - type: \"static\"\n      content: \"Implement the following...\"\n  output_to_file: \"implementation.json\"\n```\n\n#### Claude-Specific Fields\n\n##### `claude_options` (object, optional)\nConfiguration for Claude CLI:\n\n```yaml\nclaude_options:\n  print: true                    # Non-interactive mode\n  output_format: \"json\"          # Response format\n  max_turns: 20                  # Conversation limit\n  allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\", \"Search\"]\n  verbose: true                  # Detailed logging\n  append_system_prompt: \"Focus on clean code\"\n  cwd: \"./workspace/project\"     # Working directory\n```","ref":"pipeline_config_guide.html#2-claude-step"},{"type":"extras","title":"3. Parallel Claude Step - Pipeline Configuration","doc":"Run multiple Claude instances simultaneously:\n\n```yaml\n- name: \"parallel_development\"\n  type: \"parallel_claude\"\n  parallel_tasks:\n    - id: \"backend\"\n      claude_options:\n        max_turns: 15\n        cwd: \"./workspace/backend\"\n      prompt:\n        - type: \"static\"\n          content: \"Implement REST API...\"\n      output_to_file: \"backend.json\"\n      \n    - id: \"frontend\"\n      claude_options:\n        max_turns: 15\n        cwd: \"./workspace/frontend\"\n      prompt:\n        - type: \"static\"\n          content: \"Implement React UI...\"\n      output_to_file: \"frontend.json\"\n```\n\n#### Parallel-Specific Fields\n\n##### `parallel_tasks` (array, required)\nList of task definitions, each with:\n- `id`: Unique task identifier\n- `claude_options`: Task-specific Claude settings\n- `prompt`: Task prompt configuration\n- `output_to_file`: Task output file","ref":"pipeline_config_guide.html#3-parallel-claude-step"},{"type":"extras","title":"Prompt Templates - Pipeline Configuration","doc":"Prompts are built from components that can reference files and previous outputs:","ref":"pipeline_config_guide.html#prompt-templates"},{"type":"extras","title":"1. Static Content - Pipeline Configuration","doc":"Fixed text content:\n\n```yaml\nprompt:\n  - type: \"static\"\n    content: |\n      Analyze this requirement:\n      - Feature A\n      - Feature B\n```","ref":"pipeline_config_guide.html#1-static-content"},{"type":"extras","title":"2. File Content - Pipeline Configuration","doc":"Load content from files:\n\n```yaml\nprompt:\n  - type: \"file\"\n    path: \"requirements.txt\"\n  - type: \"file\"\n    path: \"src/main.py\"\n```","ref":"pipeline_config_guide.html#2-file-content"},{"type":"extras","title":"3. Previous Response - Pipeline Configuration","doc":"Reference output from earlier steps:\n\n```yaml\nprompt:\n  - type: \"static\"\n    content: \"Based on the plan:\"\n  - type: \"previous_response\"\n    step: \"planning_step\"\n```\n\nWith field extraction:\n\n```yaml\nprompt:\n  - type: \"previous_response\"\n    step: \"analysis_step\"\n    extract: \"issues\"  # Extract specific field from JSON\n```","ref":"pipeline_config_guide.html#3-previous-response"},{"type":"extras","title":"4. Complex Example - Pipeline Configuration","doc":"Combining all prompt types:\n\n```yaml\nprompt:\n  - type: \"static\"\n    content: \"Project requirements:\"\n  - type: \"file\"\n    path: \"requirements.md\"\n  - type: \"static\"\n    content: \"\\n\\nPrevious analysis found these issues:\"\n  - type: \"previous_response\"\n    step: \"code_review\"\n    extract: \"critical_issues\"\n  - type: \"static\"\n    content: \"\\n\\nPlease fix all critical issues.\"\n```","ref":"pipeline_config_guide.html#4-complex-example"},{"type":"extras","title":"Token Budget Management - Pipeline Configuration","doc":"Fine-tune AI response lengths and quality:","ref":"pipeline_config_guide.html#token-budget-management"},{"type":"extras","title":"Understanding Token Budgets - Pipeline Configuration","doc":"```yaml\ntoken_budget:\n  max_output_tokens: 4096  # Response length limit\n  temperature: 0.7         # Randomness (0=deterministic, 1=creative)\n  top_p: 0.95             # Cumulative probability cutoff\n  top_k: 40               # Consider top K tokens\n```","ref":"pipeline_config_guide.html#understanding-token-budgets"},{"type":"extras","title":"Common Configurations - Pipeline Configuration","doc":"#### Concise Analysis\n```yaml\ntoken_budget:\n  max_output_tokens: 1024\n  temperature: 0.5\n```\n\n#### Detailed Planning\n```yaml\ntoken_budget:\n  max_output_tokens: 4096\n  temperature: 0.7\n```\n\n#### Code Generation\n```yaml\ntoken_budget:\n  max_output_tokens: 8192\n  temperature: 0.3  # Lower for consistency\n```\n\n#### Creative Writing\n```yaml\ntoken_budget:\n  max_output_tokens: 2048\n  temperature: 0.9  # Higher for variety\n```","ref":"pipeline_config_guide.html#common-configurations"},{"type":"extras","title":"Claude Options - Pipeline Configuration","doc":"","ref":"pipeline_config_guide.html#claude-options"},{"type":"extras","title":"Tool Configuration - Pipeline Configuration","doc":"Control which tools Claude can use:\n\n```yaml\nallowed_tools: [\"Write\", \"Edit\", \"Read\"]  # File operations only\nallowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\"]  # Include shell\nallowed_tools: [\"Write\", \"Edit\", \"Read\", \"Search\", \"Bash\"]  # Full access\n```","ref":"pipeline_config_guide.html#tool-configuration"},{"type":"extras","title":"Turn Limits - Pipeline Configuration","doc":"Set conversation length:\n\n```yaml\nmax_turns: 5   # Quick tasks\nmax_turns: 15  # Standard implementation\nmax_turns: 30  # Complex projects\n```","ref":"pipeline_config_guide.html#turn-limits"},{"type":"extras","title":"Working Directory - Pipeline Configuration","doc":"Sandbox file operations:\n\n```yaml\ncwd: \"./workspace\"          # Default sandbox\ncwd: \"./workspace/backend\"  # Project-specific\ncwd: \"/tmp/safe_dir\"       # Absolute path\n```","ref":"pipeline_config_guide.html#working-directory"},{"type":"extras","title":"Advanced Features - Pipeline Configuration","doc":"","ref":"pipeline_config_guide.html#advanced-features"},{"type":"extras","title":"1. Conditional Execution - Pipeline Configuration","doc":"Skip steps based on conditions:\n\n```yaml\nsteps:\n  - name: \"check_quality\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Review code quality. Set needs_fixes=true if issues found.\"\n    \n  - name: \"fix_issues\"\n    type: \"claude\"\n    condition: \"check_quality.needs_fixes\"  # Only runs if true\n    prompt:\n      - type: \"static\"\n        content: \"Fix the identified issues\"\n```","ref":"pipeline_config_guide.html#1-conditional-execution"},{"type":"extras","title":"2. Function Calling - Pipeline Configuration","doc":"Define functions for Gemini:\n\n```yaml\nworkflow:\n  gemini_functions:\n    evaluate_code:\n      description: \"Evaluate code quality and security\"\n      parameters:\n        type: object\n        properties:\n          quality_score:\n            type: integer\n            description: \"Score from 1-10\"\n          security_issues:\n            type: array\n            items:\n              type: string\n          needs_refactoring:\n            type: boolean\n        required: [\"quality_score\", \"security_issues\"]\n    \n  steps:\n    - name: \"code_review\"\n      type: \"gemini\"\n      functions:\n        - \"evaluate_code\"\n      prompt:\n        - type: \"static\"\n          content: \"Review this code and call evaluate_code function\"\n```","ref":"pipeline_config_guide.html#2-function-calling"},{"type":"extras","title":"3. Dynamic Workflows - Pipeline Configuration","doc":"Build prompts from multiple sources:\n\n```yaml\nsteps:\n  - name: \"gather_context\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"context/project.md\"\n      - type: \"file\" \n        path: \"context/architecture.md\"\n      - type: \"static\"\n        content: \"Summarize the project context\"\n    \n  - name: \"generate_tasks\"\n    type: \"gemini\"\n    prompt:\n      - type: \"previous_response\"\n        step: \"gather_context\"\n      - type: \"static\"\n        content: \"Based on this context, generate implementation tasks\"\n    \n  - name: \"implement\"\n    type: \"claude\"\n    prompt:\n      - type: \"previous_response\"\n        step: \"generate_tasks\"\n      - type: \"static\"\n        content: \"Implement these tasks\"\n```","ref":"pipeline_config_guide.html#3-dynamic-workflows"},{"type":"extras","title":"Complete Examples - Pipeline Configuration","doc":"","ref":"pipeline_config_guide.html#complete-examples"},{"type":"extras","title":"Example 1: Code Review and Fix - Pipeline Configuration","doc":"```yaml\nworkflow:\n  name: \"code_reviewer\"\n  workspace_dir: \"./workspace\"\n  \n  defaults:\n    gemini_model: \"gemini-2.5-flash\"\n    output_dir: \"./outputs/review\"\n    \n  steps:\n    - name: \"analyze_code\"\n      type: \"gemini\"\n      token_budget:\n        max_output_tokens: 2048\n        temperature: 0.3\n      prompt:\n        - type: \"static\"\n          content: \"Review this code for bugs, security issues, and style:\"\n        - type: \"file\"\n          path: \"src/main.py\"\n      output_to_file: \"analysis.json\"\n      \n    - name: \"fix_issues\"\n      type: \"claude\"\n      claude_options:\n        max_turns: 10\n        allowed_tools: [\"Read\", \"Edit\"]\n        cwd: \"./workspace\"\n      prompt:\n        - type: \"static\"\n          content: \"Fix all issues identified in the review:\"\n        - type: \"previous_response\"\n          step: \"analyze_code\"\n      output_to_file: \"fixes.json\"\n```","ref":"pipeline_config_guide.html#example-1-code-review-and-fix"},{"type":"extras","title":"Example 2: Full Application Development - Pipeline Configuration","doc":"```yaml\nworkflow:\n  name: \"app_builder\"\n  checkpoint_enabled: true\n  workspace_dir: \"./workspace\"\n  \n  defaults:\n    gemini_model: \"gemini-2.5-flash\"\n    gemini_token_budget:\n      max_output_tokens: 4096\n      temperature: 0.7\n    claude_output_format: \"json\"\n    output_dir: \"./outputs/app\"\n    \n  gemini_functions:\n    design_architecture:\n      description: \"Design application architecture\"\n      parameters:\n        type: object\n        properties:\n          components:\n            type: array\n            items:\n              type: object\n              properties:\n                name:\n                  type: string\n                type:\n                  type: string\n                  enum: [\"frontend\", \"backend\", \"database\", \"service\"]\n                dependencies:\n                  type: array\n                  items:\n                    type: string\n    \n  steps:\n    - name: \"design\"\n      type: \"gemini\"\n      role: \"brain\"\n      functions:\n        - \"design_architecture\"\n      prompt:\n        - type: \"file\"\n          path: \"requirements.md\"\n        - type: \"static\"\n          content: |\n            Design a microservices architecture for these requirements.\n            Call design_architecture with the component structure.\n      output_to_file: \"architecture.json\"\n      \n    - name: \"plan_implementation\"\n      type: \"gemini\"\n      role: \"brain\"\n      token_budget:\n        max_output_tokens: 8192\n      prompt:\n        - type: \"static\"\n          content: \"Create detailed implementation instructions for each component:\"\n        - type: \"previous_response\"\n          step: \"design\"\n      output_to_file: \"implementation_plan.json\"\n      \n    - name: \"implement_services\"\n      type: \"parallel_claude\"\n      parallel_tasks:\n        - id: \"auth_service\"\n          claude_options:\n            max_turns: 20\n            allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\"]\n            cwd: \"./workspace/services/auth\"\n          prompt:\n            - type: \"static\"\n              content: \"Implement the authentication service based on the plan:\"\n            - type: \"previous_response\"\n              step: \"plan_implementation\"\n              extract: \"auth_service\"\n          output_to_file: \"auth_implementation.json\"\n          \n        - id: \"api_gateway\"\n          claude_options:\n            max_turns: 20\n            allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\"]\n            cwd: \"./workspace/services/gateway\"\n          prompt:\n            - type: \"static\"\n              content: \"Implement the API gateway based on the plan:\"\n            - type: \"previous_response\"\n              step: \"plan_implementation\"\n              extract: \"api_gateway\"\n          output_to_file: \"gateway_implementation.json\"\n          \n        - id: \"frontend\"\n          claude_options:\n            max_turns: 25\n            allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\"]\n            cwd: \"./workspace/frontend\"\n          prompt:\n            - type: \"static\"\n              content: \"Implement the React frontend based on the plan:\"\n            - type: \"previous_response\"\n              step: \"plan_implementation\"\n              extract: \"frontend\"\n          output_to_file: \"frontend_implementation.json\"\n      \n    - name: \"integration_tests\"\n      type: \"gemini\"\n      role: \"brain\"\n      prompt:\n        - type: \"static\"\n          content: \"Design integration tests for the implemented services:\"\n        - type: \"previous_response\"\n          step: \"implement_services\"\n      output_to_file: \"test_plan.json\"\n      \n    - name: \"implement_tests\"\n      type: \"claude\"\n      role: \"muscle\"\n      claude_options:\n        max_turns: 15\n        allowed_tools: [\"Write\", \"Read\", \"Bash\"]\n        cwd: \"./workspace/tests\"\n      prompt:\n        - type: \"previous_response\"\n          step: \"integration_tests\"\n        - type: \"static\"\n          content: \"Implement these integration tests\"\n      output_to_file: \"tests_implementation.json\"\n      \n    - name: \"final_review\"\n      type: \"gemini\"\n      role: \"brain\"\n      token_budget:\n        max_output_tokens: 2048\n        temperature: 0.3\n      prompt:\n        - type: \"static\"\n          content: |\n            Review the complete implementation:\n            1. Check if all requirements are met\n            2. Identify any missing features\n            3. Suggest improvements\n            Set 'ready_for_deployment' to true if acceptable.\n        - type: \"previous_response\"\n          step: \"implement_services\"\n      output_to_file: \"final_review.json\"\n```","ref":"pipeline_config_guide.html#example-2-full-application-development"},{"type":"extras","title":"Best Practices - Pipeline Configuration","doc":"","ref":"pipeline_config_guide.html#best-practices"},{"type":"extras","title":"1. Token Budget Optimization - Pipeline Configuration","doc":"- Start with conservative limits and increase as needed\n- Use lower temperatures (0.1-0.3) for technical tasks\n- Use higher temperatures (0.7-0.9) for creative tasks\n- Monitor token usage in debug logs","ref":"pipeline_config_guide.html#1-token-budget-optimization"},{"type":"extras","title":"2. Step Design - Pipeline Configuration","doc":"- Keep prompts focused on single responsibilities\n- Use descriptive step names for easy reference\n- Save outputs for all important steps\n- Build complex prompts from simpler components","ref":"pipeline_config_guide.html#2-step-design"},{"type":"extras","title":"3. Error Handling - Pipeline Configuration","doc":"- Set appropriate `max_turns` for Claude tasks\n- Use conditions to handle failure cases\n- Include validation steps after implementation\n- Review debug logs when issues occur","ref":"pipeline_config_guide.html#3-error-handling"},{"type":"extras","title":"4. Workspace Management - Pipeline Configuration","doc":"- Use subdirectories for different components\n- Set appropriate `cwd` in claude_options\n- Keep workspace separate from project files\n- Clean workspace between runs if needed","ref":"pipeline_config_guide.html#4-workspace-management"},{"type":"extras","title":"5. Prompt Engineering - Pipeline Configuration","doc":"- Be specific in instructions\n- Provide examples when possible\n- Use previous responses to maintain context\n- Break complex tasks into smaller steps","ref":"pipeline_config_guide.html#5-prompt-engineering"},{"type":"extras","title":"Troubleshooting - Pipeline Configuration","doc":"","ref":"pipeline_config_guide.html#troubleshooting"},{"type":"extras","title":"Common Issues - Pipeline Configuration","doc":"#### 1. Claude Hits Turn Limit\n\n```yaml\n# Increase max_turns\nclaude_options:\n  max_turns: 30  # Increase from default\n```\n\n#### 2. Gemini Response Truncated\n\n```yaml\n# Increase token limit\ntoken_budget:\n  max_output_tokens: 8192  # Maximum allowed\n```\n\n#### 3. Files Created in Wrong Location\n\n```yaml\n# Check workspace configuration\nworkflow:\n  workspace_dir: \"./workspace\"\n  \nsteps:\n  - name: \"implement\"\n    claude_options:\n      cwd: \"./workspace/project\"  # Must be under workspace_dir\n```\n\n#### 4. Step References Not Found\n\n```yaml\n# Ensure step names match exactly\n- name: \"step_one\"  # This exact name\n  type: \"gemini\"\n  \n- name: \"step_two\"\n  prompt:\n    - type: \"previous_response\"\n      step: \"step_one\"  # Must match exactly\n```\n\n#### 5. JSON Parsing Errors\n\n```yaml\n# Use appropriate output format\nclaude_options:\n  output_format: \"json\"  # For structured data\n  # or\n  output_format: \"text\"  # For plain text\n```","ref":"pipeline_config_guide.html#common-issues"},{"type":"extras","title":"Debug Techniques - Pipeline Configuration","doc":"1. **Check Debug Logs**\n   ```bash\n   python view_debug.py -l\n   ```\n\n2. **Verify File Creation**\n   ```bash\n   python view_debug.py -w\n   ```\n\n3. **Test Individual Steps**\n   - Comment out later steps\n   - Run pipeline partially\n   - Check intermediate outputs\n\n4. **Validate YAML Syntax**\n   ```bash\n   python -c \"import yaml; yaml.safe_load(open('config.yaml'))\"\n   ```","ref":"pipeline_config_guide.html#debug-techniques"},{"type":"extras","title":"Schema Reference - Pipeline Configuration","doc":"","ref":"pipeline_config_guide.html#schema-reference"},{"type":"extras","title":"Complete Configuration Schema - Pipeline Configuration","doc":"```yaml\nworkflow:\n  name: string                    # Required\n  checkpoint_enabled: boolean     # Optional\n  workspace_dir: string          # Optional\n  checkpoint_dir: string         # Optional\n  \n  # NEW: Enhanced Claude authentication and environment configuration\n  claude_auth:                   # Optional\n    auto_check: boolean          # Verify auth before starting\n    provider: enum[\"anthropic\", \"aws_bedrock\", \"google_vertex\"]\n    fallback_mock: boolean       # Use mocks if auth fails in dev\n    diagnostics: boolean         # Run AuthChecker diagnostics\n  \n  environment:                   # Optional\n    mode: enum[\"development\", \"production\", \"test\"]\n    debug_level: enum[\"basic\", \"detailed\", \"performance\"]\n    cost_alerts:\n      enabled: boolean\n      threshold_usd: float\n      notify_on_exceed: boolean\n  \n  defaults:                      # Optional\n    gemini_model: string\n    gemini_token_budget:\n      max_output_tokens: integer\n      temperature: float\n      top_p: float\n      top_k: integer\n    claude_output_format: enum[\"json\", \"text\", \"stream-json\"]\n    claude_preset: enum[\"development\", \"production\", \"analysis\", \"chat\"]  # NEW\n    output_dir: string\n    \n  gemini_functions:              # Optional\n    function_name:\n      description: string\n      parameters: object         # JSON Schema\n      \n  steps:                         # Required\n    - name: string               # Required\n      type: enum[\"gemini\", \"claude\", \"parallel_claude\", \"claude_session\", \"claude_smart\", \"claude_extract\", \"claude_batch\", \"claude_robust\"]  # Enhanced\n      role: enum[\"brain\", \"muscle\"]  # Optional\n      condition: string          # Optional\n      output_to_file: string     # Optional\n      \n      # For type: \"gemini\"\n      model: string              # Optional\n      token_budget: object       # Optional\n      functions: array[string]   # Optional\n      \n      # For type: \"claude\" (Enhanced options)\n      claude_options:            # Optional\n        # Core Configuration\n        max_turns: integer\n        output_format: enum[\"text\", \"json\", \"stream_json\"]\n        verbose: boolean\n        \n        # Tool Management\n        allowed_tools: array[string]\n        disallowed_tools: array[string]\n        \n        # System Prompts\n        system_prompt: string\n        append_system_prompt: string\n        \n        # Working Environment\n        cwd: string\n        \n        # Permission Management (Future: MCP Support)\n        permission_mode: enum[\"default\", \"accept_edits\", \"bypass_permissions\", \"plan\"]\n        permission_prompt_tool: string\n        \n        # Advanced Features (Future)\n        mcp_config: string\n        \n        # Session Management\n        session_id: string\n        resume_session: boolean\n        \n        # Performance & Reliability\n        retry_config:\n          max_retries: integer\n          backoff_strategy: enum[\"linear\", \"exponential\"]\n          retry_on: array[string]\n        timeout_ms: integer\n        \n        # Debug & Monitoring\n        debug_mode: boolean\n        telemetry_enabled: boolean\n        cost_tracking: boolean\n      \n      # NEW: For type: \"claude_smart\" (Using OptionBuilder presets)\n      preset: enum[\"development\", \"production\", \"analysis\", \"chat\"]\n      environment_aware: boolean\n      \n      # NEW: For type: \"claude_extract\" (Enhanced content processing)\n      extraction_config:\n        use_content_extractor: boolean\n        format: enum[\"text\", \"json\", \"structured\", \"summary\", \"markdown\"]\n        post_processing: array[string]\n        max_summary_length: integer\n        include_metadata: boolean\n      \n      # NEW: For type: \"claude_session\" (Session management)\n      session_config:\n        persist: boolean\n        session_name: string\n        continue_on_restart: boolean\n        checkpoint_frequency: integer\n        description: string\n      \n      # NEW: For type: \"claude_batch\" (Batch processing)\n      batch_config:\n        max_parallel: integer\n        timeout_per_task: integer\n        consolidate_results: boolean\n      tasks: array\n        - file: string\n          prompt: string\n      \n      # NEW: For type: \"claude_robust\" (Error recovery)\n      retry_config:\n        max_retries: integer\n        backoff_strategy: enum[\"linear\", \"exponential\"]\n        retry_conditions: array[string]\n        fallback_action: string\n      \n      # For type: \"parallel_claude\"\n      parallel_tasks: array      # Required\n        - id: string\n          claude_options: object\n          prompt: array\n          output_to_file: string\n          \n      prompt: array              # Required (except parallel_claude)\n        - type: enum[\"static\", \"file\", \"previous_response\", \"session_context\", \"claude_continue\"]  # Enhanced\n          # For type: \"static\"\n          content: string\n          # For type: \"file\"\n          path: string\n          # For type: \"previous_response\"\n          step: string\n          extract: string        # Optional\n          extract_with: enum[\"content_extractor\"]  # NEW: Use ContentExtractor\n          summary: boolean       # NEW: Summarize content\n          max_length: integer    # NEW: Limit extracted content length\n          # NEW: For type: \"session_context\"\n          session_id: string\n          include_last_n: integer\n          # NEW: For type: \"claude_continue\"\n          new_prompt: string\n```","ref":"pipeline_config_guide.html#complete-configuration-schema"},{"type":"extras","title":"Enhanced Claude Options Reference - Pipeline Configuration","doc":"The enhanced `claude_options` section now supports the full feature set of the Claude Code SDK:\n\n#### Basic Configuration\n- `max_turns`: Maximum conversation turns (integer)\n- `output_format`: Response format - \"text\", \"json\", or \"stream_json\"\n- `verbose`: Enable detailed logging (boolean)\n\n#### Tool Management  \n- `allowed_tools`: List of permitted tool names (array of strings)\n- `disallowed_tools`: List of explicitly forbidden tools (array of strings)\n\n#### System Prompts\n- `system_prompt`: Custom system prompt override (string)\n- `append_system_prompt`: Additional system prompt to append (string)\n\n#### Working Environment\n- `cwd`: Working directory for Claude operations (string)\n\n#### Session Management\n- `session_id`: Explicit session identifier for continuation (string)\n- `resume_session`: Automatically resume existing session if available (boolean)\n\n#### Performance & Reliability\n- `retry_config`: Retry mechanism configuration (object)\n  - `max_retries`: Maximum number of retry attempts (integer)\n  - `backoff_strategy`: \"linear\" or \"exponential\" backoff (string)\n  - `retry_on`: List of conditions that trigger retries (array)\n- `timeout_ms`: Request timeout in milliseconds (integer)\n\n#### Monitoring & Debug\n- `debug_mode`: Enable debug output and diagnostics (boolean)\n- `telemetry_enabled`: Enable performance telemetry (boolean)\n- `cost_tracking`: Track and report API costs (boolean)","ref":"pipeline_config_guide.html#enhanced-claude-options-reference"},{"type":"extras","title":"Smart Configuration Presets - Pipeline Configuration","doc":"The new `claude_smart` step type supports OptionBuilder presets:\n\n- **`development`**: Permissive settings, verbose logging, full tool access\n- **`production`**: Restricted settings, minimal tools, safe defaults  \n- **`analysis`**: Read-only tools, optimized for code analysis\n- **`chat`**: Simple conversation settings, basic tools","ref":"pipeline_config_guide.html#smart-configuration-presets"},{"type":"extras","title":"Future-Ready Features - Pipeline Configuration","doc":"The schema includes placeholders for planned features:\n\n#### MCP Integration\n- `mcp_config`: Path to MCP server configuration file\n- `permission_prompt_tool`: Tool for handling permission prompts\n- `permission_mode`: Permission handling strategy\n\n#### Advanced Content Processing\n- Content extraction with multiple format options\n- Post-processing pipeline support\n- Metadata inclusion and summarization\n\nThis guide provides comprehensive documentation for creating and managing pipeline configuration files. Use it as a reference when building your own AI-orchestrated workflows.","ref":"pipeline_config_guide.html#future-ready-features"},{"type":"extras","title":"Prompt System","doc":"# Pipeline Prompt System Guide","ref":"prompt_system_guide.html"},{"type":"extras","title":"Table of Contents - Prompt System","doc":"1. [Overview](#overview)\n2. [Prompt Types Reference](#prompt-types-reference)\n3. [File-Based Prompt Management](#file-based-prompt-management)\n4. [Prompt Template Standards](#prompt-template-standards)\n5. [Component Library Standards](#component-library-standards)\n6. [Advanced Prompt Patterns](#advanced-prompt-patterns)\n7. [Content Processing Features](#content-processing-features)\n8. [Best Practices](#best-practices)\n9. [Complete Examples](#complete-examples)\n10. [Migration Guide](#migration-guide)","ref":"prompt_system_guide.html#table-of-contents"},{"type":"extras","title":"Overview - Prompt System","doc":"The Pipeline Prompt System provides a comprehensive framework for managing, reusing, and composing prompts across AI workflows. This system enables:\n\n- **External Prompt Files**: Store prompts in dedicated files for reusability\n- **Dynamic Composition**: Combine multiple prompt sources into complex instructions\n- **Template Libraries**: Standardized prompt components for common patterns\n- **Content Processing**: Advanced extraction and transformation of prompt content\n- **Version Control**: Track and manage prompt evolution over time","ref":"prompt_system_guide.html#overview"},{"type":"extras","title":"Architecture - Prompt System","doc":"```\npipeline_ex/\n├── pipelines/\n│   ├── prompts/           # Reusable prompt templates\n│   │   ├── analysis/      # Analysis-focused prompts\n│   │   ├── generation/    # Content generation prompts\n│   │   ├── extraction/    # Data extraction prompts\n│   │   └── validation/    # Quality check prompts\n│   └── components/        # Reusable step components\n│       ├── validation_steps.yaml\n│       ├── transformation_steps.yaml\n│       └── llm_steps.yaml\n└── workflows/             # Complete workflow definitions\n    ├── development/       # Development workflows\n    ├── analysis/          # Analysis workflows\n    └── production/        # Production workflows\n```","ref":"prompt_system_guide.html#architecture"},{"type":"extras","title":"Prompt Types Reference - Prompt System","doc":"","ref":"prompt_system_guide.html#prompt-types-reference"},{"type":"extras","title":"1. Static Content (static) - Prompt System","doc":"Inline text content defined directly in the YAML:\n\n```yaml\nprompt:\n  - type: \"static\"\n    content: |\n      Analyze this code for the following criteria:\n      1. Security vulnerabilities\n      2. Performance issues\n      3. Code maintainability\n      4. Best practice adherence\n```\n\n**Use Cases:**\n- Short, workflow-specific instructions\n- Connecting text between other prompt types\n- Conditional logic instructions","ref":"prompt_system_guide.html#1-static-content-static"},{"type":"extras","title":"2. File Content (file) - Prompt System","doc":"Load content from external files:\n\n```yaml\nprompt:\n  - type: \"file\"\n    path: \"pipelines/prompts/analysis/security_review.md\"\n  - type: \"file\"\n    path: \"src/main.py\"\n```\n\n**Features:**\n- Automatic file change detection and caching\n- Support for any text-based file format\n- Relative and absolute path support\n- Error handling for missing files\n\n**Use Cases:**\n- Reusable prompt templates\n- Loading source code for analysis\n- Loading documentation or requirements\n- Standard prompt components","ref":"prompt_system_guide.html#2-file-content-file"},{"type":"extras","title":"3. Previous Response (previous_response) - Prompt System","doc":"Reference outputs from earlier workflow steps:\n\n```yaml\nprompt:\n  - type: \"previous_response\"\n    step: \"code_analysis\"\n  - type: \"previous_response\"\n    step: \"security_scan\"\n    extract: \"vulnerabilities\"\n```\n\n**Fields:**\n- `step` (required): Name of the previous step\n- `extract` (optional): Extract specific JSON field\n- `extract_with` (optional): Use ContentExtractor for processing\n- `summary` (optional): Generate summary of content\n- `max_length` (optional): Limit content length\n\n**Use Cases:**\n- Building on previous analysis\n- Passing structured data between steps\n- Context accumulation across workflow","ref":"prompt_system_guide.html#3-previous-response-previous_response"},{"type":"extras","title":"4. Session Context (session_context) - Prompt System","doc":"Reference conversation history from Claude sessions:\n\n```yaml\nprompt:\n  - type: \"session_context\"\n    session_id: \"code_review_session\"\n    include_last_n: 5\n```\n\n**Fields:**\n- `session_id` (required): Session identifier\n- `include_last_n` (optional): Number of recent messages to include\n\n**Use Cases:**\n- Multi-turn conversations\n- Maintaining context across session restarts\n- Referencing earlier decisions in long workflows","ref":"prompt_system_guide.html#4-session-context-session_context"},{"type":"extras","title":"5. Claude Continue (claude_continue) - Prompt System","doc":"Continue existing Claude conversations with new prompts:\n\n```yaml\nprompt:\n  - type: \"claude_continue\"\n    new_prompt: \"Now add comprehensive error handling to the implementation\"\n```\n\n**Use Cases:**\n- Extending existing implementations\n- Iterative development workflows\n- Progressive enhancement patterns","ref":"prompt_system_guide.html#5-claude-continue-claude_continue"},{"type":"extras","title":"File-Based Prompt Management - Prompt System","doc":"","ref":"prompt_system_guide.html#file-based-prompt-management"},{"type":"extras","title":"Directory Structure Standards - Prompt System","doc":"#### `/pipelines/prompts/` - Prompt Template Library\n\nOrganized by purpose and domain:\n\n```\npipelines/prompts/\n├── analysis/\n│   ├── code_review.md\n│   ├── security_audit.md\n│   ├── performance_analysis.md\n│   └── dependency_check.md\n├── generation/\n│   ├── api_documentation.md\n│   ├── test_generation.md\n│   ├── code_scaffolding.md\n│   └── tutorial_creation.md\n├── extraction/\n│   ├── data_parsing.md\n│   ├── entity_extraction.md\n│   └── content_summarization.md\n├── validation/\n│   ├── quality_checks.md\n│   ├── compliance_review.md\n│   └── output_validation.md\n└── common/\n    ├── system_prompts.md\n    ├── error_handling.md\n    └── context_setup.md\n```\n\n#### Prompt File Naming Conventions\n\n- **Descriptive names**: `security_vulnerability_scan.md` not `scan.md`\n- **Action-oriented**: `generate_api_tests.md` not `api_tests.md`\n- **Domain prefixes**: `frontend_component_analysis.md`, `backend_service_review.md`\n- **Version suffixes**: `code_review_v2.md` for major updates\n\n#### Prompt File Structure\n\nEach prompt file should follow this template:\n\n```markdown\n# Prompt Title","ref":"prompt_system_guide.html#directory-structure-standards"},{"type":"extras","title":"Purpose - Prompt System","doc":"Brief description of what this prompt accomplishes.","ref":"prompt_system_guide.html#purpose"},{"type":"extras","title":"Context Requirements - Prompt System","doc":"- List of required context or input data\n- Expected format of inputs\n- Prerequisites or dependencies","ref":"prompt_system_guide.html#context-requirements"},{"type":"extras","title":"Variables - Prompt System","doc":"Document any template variables used:\n- `{PROJECT_TYPE}` - Type of project being analyzed\n- `{LANGUAGE}` - Programming language\n- `{FRAMEWORK}` - Framework or library being used","ref":"prompt_system_guide.html#variables"},{"type":"extras","title":"Prompt Content - Prompt System","doc":"[Main prompt content here, using clear sections and examples]","ref":"prompt_system_guide.html#prompt-content"},{"type":"extras","title":"Expected Output Format - Prompt System","doc":"Description of expected response structure.","ref":"prompt_system_guide.html#expected-output-format"},{"type":"extras","title":"Usage Examples - Prompt System","doc":"Reference to workflows that use this prompt.","ref":"prompt_system_guide.html#usage-examples"},{"type":"extras","title":"Version History - Prompt System","doc":"- v1.0 (2024-07-03): Initial version\n- v1.1 (2024-07-04): Added error handling instructions\n```","ref":"prompt_system_guide.html#version-history"},{"type":"extras","title":"Template Variables System - Prompt System","doc":"Support for dynamic prompt content:\n\n```markdown\n# Security Analysis Prompt\n\nAnalyze the {LANGUAGE} {PROJECT_TYPE} for security vulnerabilities.\n\nFocus areas for {FRAMEWORK} projects:\n- Authentication mechanisms\n- Data validation\n- Error handling\n- Dependency security","ref":"prompt_system_guide.html#template-variables-system"},{"type":"extras","title":"Code to Analyze - Prompt System","doc":"{CODE_CONTENT}","ref":"prompt_system_guide.html#code-to-analyze"},{"type":"extras","title":"Previous Findings - Prompt System","doc":"{PREVIOUS_ANALYSIS}\n```\n\nUsage in workflows:\n\n```yaml\nprompt:\n  - type: \"file\"\n    path: \"pipelines/prompts/analysis/security_review.md\"\n    variables:\n      LANGUAGE: \"Python\"\n      PROJECT_TYPE: \"web application\"\n      FRAMEWORK: \"FastAPI\"\n  - type: \"file\"\n    path: \"src/main.py\"\n    inject_as: \"CODE_CONTENT\"\n  - type: \"previous_response\"\n    step: \"initial_scan\"\n    inject_as: \"PREVIOUS_ANALYSIS\"\n```","ref":"prompt_system_guide.html#previous-findings"},{"type":"extras","title":"Prompt Template Standards - Prompt System","doc":"","ref":"prompt_system_guide.html#prompt-template-standards"},{"type":"extras","title":"Template Categories - Prompt System","doc":"#### 1. Analysis Templates (`/analysis/`)\n\n**Code Review Template** (`code_review.md`):\n```markdown\n# Code Review Analysis","ref":"prompt_system_guide.html#template-categories"},{"type":"extras","title":"Objective - Prompt System","doc":"Perform comprehensive code review focusing on quality, security, and maintainability.","ref":"prompt_system_guide.html#objective"},{"type":"extras","title":"Review Criteria - Prompt System","doc":"1. **Code Quality**\n   - Readability and clarity\n   - Proper naming conventions\n   - Code organization and structure\n   - Documentation completeness\n\n2. **Security Assessment**\n   - Input validation\n   - Authentication and authorization\n   - Data handling and storage\n   - Dependency vulnerabilities\n\n3. **Performance Considerations**\n   - Algorithm efficiency\n   - Resource usage\n   - Scalability factors\n   - Caching strategies\n\n4. **Maintainability**\n   - Code modularity\n   - Test coverage\n   - Error handling\n   - Configuration management","ref":"prompt_system_guide.html#review-criteria"},{"type":"extras","title":"Output Format - Prompt System","doc":"Provide analysis in JSON format:\n```json\n{\n  \"overall_score\": 85,\n  \"categories\": {\n    \"quality\": {\"score\": 90, \"issues\": []},\n    \"security\": {\"score\": 80, \"issues\": []},\n    \"performance\": {\"score\": 85, \"issues\": []},\n    \"maintainability\": {\"score\": 85, \"issues\": []}\n  },\n  \"critical_issues\": [],\n  \"recommendations\": [],\n  \"next_steps\": []\n}\n```\n```\n\n**Security Audit Template** (`security_audit.md`):\n```markdown\n# Security Vulnerability Assessment","ref":"prompt_system_guide.html#output-format"},{"type":"extras","title":"Scope - Prompt System","doc":"Comprehensive security analysis covering OWASP Top 10 and industry best practices.","ref":"prompt_system_guide.html#scope"},{"type":"extras","title":"Assessment Areas - Prompt System","doc":"1. **Authentication & Authorization**\n   - User authentication mechanisms\n   - Session management\n   - Access control implementation\n   - Multi-factor authentication\n\n2. **Data Protection**\n   - Data encryption at rest and in transit\n   - Sensitive data handling\n   - PII protection measures\n   - Database security\n\n3. **Input Validation**\n   - SQL injection prevention\n   - XSS protection\n   - CSRF safeguards\n   - Input sanitization\n\n4. **Infrastructure Security**\n   - Server configuration\n   - Network security\n   - Dependency management\n   - Container security","ref":"prompt_system_guide.html#assessment-areas"},{"type":"extras","title":"Risk Classification - Prompt System","doc":"- **Critical**: Immediate security risk, requires urgent attention\n- **High**: Significant vulnerability, should be addressed soon\n- **Medium**: Potential security concern, plan for resolution\n- **Low**: Minor security improvement opportunity","ref":"prompt_system_guide.html#risk-classification"},{"type":"extras","title":"Output Requirements - Prompt System","doc":"Security assessment report with:\n- Executive summary\n- Detailed findings by category\n- Risk-prioritized recommendations\n- Remediation timeline suggestions\n```\n\n#### 2. Generation Templates (`/generation/`)\n\n**API Documentation Template** (`api_documentation.md`):\n```markdown\n# API Documentation Generator","ref":"prompt_system_guide.html#output-requirements"},{"type":"extras","title":"Objective - Prompt System","doc":"Generate comprehensive API documentation from source code and specifications.","ref":"prompt_system_guide.html#objective-1"},{"type":"extras","title":"Documentation Requirements - Prompt System","doc":"1. **API Overview**\n   - Purpose and scope\n   - Authentication methods\n   - Base URLs and versioning\n   - Rate limiting information\n\n2. **Endpoint Documentation**\n   - HTTP methods and paths\n   - Request/response schemas\n   - Parameter descriptions\n   - Example requests and responses\n   - Error codes and messages\n\n3. **Data Models**\n   - Schema definitions\n   - Validation rules\n   - Relationship mappings\n   - Example payloads\n\n4. **Integration Guides**\n   - Getting started tutorial\n   - Common use cases\n   - Code examples in multiple languages\n   - Troubleshooting guide","ref":"prompt_system_guide.html#documentation-requirements"},{"type":"extras","title":"Output Format - Prompt System","doc":"Generate documentation in OpenAPI 3.0 specification format with accompanying Markdown guides.\n```\n\n**Test Generation Template** (`test_generation.md`):\n```markdown\n# Comprehensive Test Suite Generator","ref":"prompt_system_guide.html#output-format-1"},{"type":"extras","title":"Testing Strategy - Prompt System","doc":"Generate tests covering unit, integration, and end-to-end scenarios.","ref":"prompt_system_guide.html#testing-strategy"},{"type":"extras","title":"Test Categories - Prompt System","doc":"1. **Unit Tests**\n   - Function-level testing\n   - Edge case coverage\n   - Error condition handling\n   - Mock and stub usage\n\n2. **Integration Tests**\n   - API endpoint testing\n   - Database integration\n   - External service mocking\n   - Configuration testing\n\n3. **End-to-End Tests**\n   - User journey testing\n   - Cross-browser compatibility\n   - Performance benchmarks\n   - Security testing","ref":"prompt_system_guide.html#test-categories"},{"type":"extras","title":"Code Coverage Requirements - Prompt System","doc":"- Target: 90%+ line coverage\n- 100% coverage for critical paths\n- Include negative test cases\n- Test error handling paths","ref":"prompt_system_guide.html#code-coverage-requirements"},{"type":"extras","title":"Test Framework Selection - Prompt System","doc":"Choose appropriate testing frameworks based on technology stack and project requirements.\n```\n\n#### 3. Extraction Templates (`/extraction/`)\n\n**Data Parsing Template** (`data_parsing.md`):\n```markdown\n# Structured Data Extraction","ref":"prompt_system_guide.html#test-framework-selection"},{"type":"extras","title":"Extraction Objectives - Prompt System","doc":"Parse and structure unstructured or semi-structured data into standardized formats.","ref":"prompt_system_guide.html#extraction-objectives"},{"type":"extras","title":"Supported Input Formats - Prompt System","doc":"- Plain text documents\n- CSV and TSV files\n- JSON and XML data\n- Log files and reports\n- Configuration files","ref":"prompt_system_guide.html#supported-input-formats"},{"type":"extras","title":"Extraction Patterns - Prompt System","doc":"1. **Entity Recognition**\n   - Names, dates, and identifiers\n   - Technical specifications\n   - Configuration parameters\n   - Error messages and codes\n\n2. **Relationship Mapping**\n   - Dependency relationships\n   - Hierarchical structures\n   - Sequential processes\n   - Cross-references\n\n3. **Data Validation**\n   - Format compliance\n   - Completeness checks\n   - Consistency validation\n   - Quality scoring","ref":"prompt_system_guide.html#extraction-patterns"},{"type":"extras","title":"Output Schema - Prompt System","doc":"Provide extracted data in JSON format with metadata about extraction confidence and validation results.\n```\n\n#### 4. Validation Templates (`/validation/`)\n\n**Quality Assurance Template** (`quality_checks.md`):\n```markdown\n# Quality Assurance Validation","ref":"prompt_system_guide.html#output-schema"},{"type":"extras","title":"Quality Metrics - Prompt System","doc":"Comprehensive evaluation of deliverable quality across multiple dimensions.","ref":"prompt_system_guide.html#quality-metrics"},{"type":"extras","title":"Evaluation Criteria - Prompt System","doc":"1. **Functional Correctness**\n   - Requirements compliance\n   - Feature completeness\n   - Business logic accuracy\n   - User experience quality\n\n2. **Technical Excellence**\n   - Code quality standards\n   - Architecture compliance\n   - Performance benchmarks\n   - Security requirements\n\n3. **Documentation Quality**\n   - Completeness and accuracy\n   - Clarity and organization\n   - Example quality\n   - Maintenance procedures\n\n4. **Process Compliance**\n   - Development standards\n   - Review procedures\n   - Testing requirements\n   - Deployment readiness","ref":"prompt_system_guide.html#evaluation-criteria"},{"type":"extras","title":"Validation Output - Prompt System","doc":"Quality scorecard with pass/fail status, improvement recommendations, and certification readiness assessment.\n```","ref":"prompt_system_guide.html#validation-output"},{"type":"extras","title":"Component Library Standards - Prompt System","doc":"### `/pipelines/components/` - Reusable Step Components\n\n#### Component Categories\n\n**Validation Steps** (`validation_steps.yaml`):\n```yaml\n# Reusable validation step components\ncomponents:\n  code_quality_check:\n    type: \"gemini\"\n    role: \"brain\"\n    model: \"gemini-2.5-flash\"\n    token_budget:\n      max_output_tokens: 2048\n      temperature: 0.3\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/validation/quality_checks.md\"\n      - type: \"previous_response\"\n        step: \"${source_step}\"\n    functions:\n      - \"evaluate_quality\"\n    output_to_file: \"quality_assessment.json\"\n\n  security_validation:\n    type: \"gemini\"\n    role: \"brain\"\n    model: \"gemini-2.5-flash\"\n    token_budget:\n      max_output_tokens: 4096\n      temperature: 0.2\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/validation/security_audit.md\"\n      - type: \"file\"\n        path: \"${code_path}\"\n    functions:\n      - \"assess_security\"\n    output_to_file: \"security_report.json\"\n\n  compliance_check:\n    type: \"gemini\"\n    role: \"brain\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/validation/compliance_review.md\"\n      - type: \"previous_response\"\n        step: \"${implementation_step}\"\n        extract: \"deliverables\"\n    output_to_file: \"compliance_status.json\"\n```\n\n**Transformation Steps** (`transformation_steps.yaml`):\n```yaml\ncomponents:\n  data_normalizer:\n    type: \"gemini\"\n    role: \"brain\"\n    model: \"gemini-2.5-flash\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/extraction/data_parsing.md\"\n      - type: \"file\"\n        path: \"${input_data_path}\"\n    functions:\n      - \"normalize_data\"\n    output_to_file: \"normalized_data.json\"\n\n  content_summarizer:\n    type: \"gemini\"\n    role: \"brain\"\n    token_budget:\n      max_output_tokens: 1024\n      temperature: 0.4\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/extraction/content_summarization.md\"\n      - type: \"previous_response\"\n        step: \"${source_step}\"\n        summary: true\n        max_length: 2000\n    output_to_file: \"content_summary.json\"\n\n  format_converter:\n    type: \"claude\"\n    role: \"muscle\"\n    claude_options:\n      max_turns: 5\n      allowed_tools: [\"Write\", \"Read\"]\n      output_format: \"json\"\n    prompt:\n      - type: \"static\"\n        content: \"Convert the following data to ${target_format} format:\"\n      - type: \"previous_response\"\n        step: \"${source_step}\"\n    output_to_file: \"converted_${target_format}.${target_extension}\"\n```\n\n**LLM Steps** (`llm_steps.yaml`):\n```yaml\ncomponents:\n  smart_analysis:\n    type: \"claude_smart\"\n    preset: \"analysis\"\n    claude_options:\n      max_turns: 3\n      allowed_tools: [\"Read\"]\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/analysis/${analysis_type}.md\"\n      - type: \"file\"\n        path: \"${target_file}\"\n    output_to_file: \"${analysis_type}_result.json\"\n\n  robust_implementation:\n    type: \"claude_robust\"\n    retry_config:\n      max_retries: 3\n      backoff_strategy: \"exponential\"\n      fallback_action: \"simplified_prompt\"\n    claude_options:\n      max_turns: 20\n      allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\"]\n      output_format: \"json\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/generation/${implementation_type}.md\"\n      - type: \"previous_response\"\n        step: \"${planning_step}\"\n    output_to_file: \"${implementation_type}_result.json\"\n\n  session_continuation:\n    type: \"claude_session\"\n    session_config:\n      persist: true\n      session_name: \"${workflow_name}_session\"\n      max_turns: 50\n    prompt:\n      - type: \"claude_continue\"\n        new_prompt: \"${continuation_instruction}\"\n    output_to_file: \"session_result.json\"\n```\n\n#### Component Usage Patterns\n\n**Including Components in Workflows**:\n```yaml\nworkflow:\n  name: \"comprehensive_analysis\"\n  \n  steps:\n    - name: \"initial_scan\"\n      type: \"gemini\"\n      prompt:\n        - type: \"file\"\n          path: \"src/main.py\"\n\n    # Use validation component\n    - <<: *code_quality_check\n      name: \"quality_assessment\"\n      variables:\n        source_step: \"initial_scan\"\n\n    # Use transformation component  \n    - <<: *content_summarizer\n      name: \"summary_generation\"\n      variables:\n        source_step: \"quality_assessment\"\n\n    # Use LLM component with customization\n    - <<: *smart_analysis\n      name: \"detailed_analysis\"\n      variables:\n        analysis_type: \"security_audit\"\n        target_file: \"src/main.py\"\n      claude_options:\n        max_turns: 5  # Override component default\n```","ref":"prompt_system_guide.html#component-library-standards"},{"type":"extras","title":"Advanced Prompt Patterns - Prompt System","doc":"","ref":"prompt_system_guide.html#advanced-prompt-patterns"},{"type":"extras","title":"1. Progressive Enhancement Pattern - Prompt System","doc":"Build complexity gradually through connected prompts:\n\n```yaml\nsteps:\n  - name: \"basic_analysis\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/analysis/basic_code_review.md\"\n      - type: \"file\"\n        path: \"src/main.py\"\n\n  - name: \"detailed_analysis\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/analysis/detailed_security_audit.md\"\n      - type: \"previous_response\"\n        step: \"basic_analysis\"\n        extract: \"concerns\"\n      - type: \"file\"\n        path: \"src/main.py\"\n\n  - name: \"comprehensive_report\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/generation/comprehensive_report.md\"\n      - type: \"previous_response\"\n        step: \"basic_analysis\"\n      - type: \"previous_response\"\n        step: \"detailed_analysis\"\n```","ref":"prompt_system_guide.html#1-progressive-enhancement-pattern"},{"type":"extras","title":"2. Context Accumulation Pattern - Prompt System","doc":"Build rich context across multiple steps:\n\n```yaml\nsteps:\n  - name: \"requirements_analysis\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/analysis/requirements_review.md\"\n      - type: \"file\"\n        path: \"requirements.md\"\n\n  - name: \"architecture_review\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/analysis/architecture_analysis.md\"\n      - type: \"file\"\n        path: \"architecture.md\"\n      - type: \"previous_response\"\n        step: \"requirements_analysis\"\n        extract: \"constraints\"\n\n  - name: \"implementation_plan\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/generation/implementation_planning.md\"\n      - type: \"static\"\n        content: \"Requirements Analysis:\"\n      - type: \"previous_response\"\n        step: \"requirements_analysis\"\n      - type: \"static\"\n        content: \"\\nArchitecture Review:\"\n      - type: \"previous_response\"\n        step: \"architecture_review\"\n```","ref":"prompt_system_guide.html#2-context-accumulation-pattern"},{"type":"extras","title":"3. Iterative Refinement Pattern - Prompt System","doc":"Refine outputs through multiple iterations:\n\n```yaml\nsteps:\n  - name: \"initial_draft\"\n    type: \"claude\"\n    claude_options:\n      max_turns: 10\n      allowed_tools: [\"Write\"]\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/generation/initial_implementation.md\"\n      - type: \"file\"\n        path: \"requirements.md\"\n\n  - name: \"review_draft\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/validation/implementation_review.md\"\n      - type: \"previous_response\"\n        step: \"initial_draft\"\n\n  - name: \"refine_implementation\"\n    type: \"claude_session\"\n    session_config:\n      persist: true\n      continue_on_restart: true\n    prompt:\n      - type: \"claude_continue\"\n        new_prompt: |\n          Based on this review feedback, please refine the implementation:\n      - type: \"previous_response\"\n        step: \"review_draft\"\n        extract: \"improvement_suggestions\"\n```","ref":"prompt_system_guide.html#3-iterative-refinement-pattern"},{"type":"extras","title":"4. Parallel Processing Pattern - Prompt System","doc":"Process multiple aspects simultaneously:\n\n```yaml\nsteps:\n  - name: \"parallel_analysis\"\n    type: \"parallel_claude\"\n    parallel_tasks:\n      - id: \"security_analysis\"\n        claude_options:\n          max_turns: 15\n          allowed_tools: [\"Read\"]\n        prompt:\n          - type: \"file\"\n            path: \"pipelines/prompts/analysis/security_focus.md\"\n          - type: \"file\"\n            path: \"src/main.py\"\n        output_to_file: \"security_analysis.json\"\n\n      - id: \"performance_analysis\"\n        claude_options:\n          max_turns: 15\n          allowed_tools: [\"Read\"]\n        prompt:\n          - type: \"file\"\n            path: \"pipelines/prompts/analysis/performance_focus.md\"\n          - type: \"file\"\n            path: \"src/main.py\"\n        output_to_file: \"performance_analysis.json\"\n\n      - id: \"maintainability_analysis\"\n        claude_options:\n          max_turns: 15\n          allowed_tools: [\"Read\"]\n        prompt:\n          - type: \"file\"\n            path: \"pipelines/prompts/analysis/maintainability_focus.md\"\n          - type: \"file\"\n            path: \"src/main.py\"\n        output_to_file: \"maintainability_analysis.json\"\n\n  - name: \"synthesize_results\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/synthesis/comprehensive_synthesis.md\"\n      - type: \"previous_response\"\n        step: \"parallel_analysis\"\n```","ref":"prompt_system_guide.html#4-parallel-processing-pattern"},{"type":"extras","title":"Content Processing Features - Prompt System","doc":"","ref":"prompt_system_guide.html#content-processing-features"},{"type":"extras","title":"Enhanced Extraction Options - Prompt System","doc":"```yaml\nprompt:\n  - type: \"previous_response\"\n    step: \"code_analysis\"\n    extract_with: \"content_extractor\"  # Use ContentExtractor\n    format: \"structured\"               # structured, summary, markdown\n    post_processing:\n      - \"extract_code_blocks\"\n      - \"extract_recommendations\"\n      - \"extract_links\"\n    include_metadata: true\n    max_length: 5000\n```","ref":"prompt_system_guide.html#enhanced-extraction-options"},{"type":"extras","title":"Content Summarization - Prompt System","doc":"```yaml\nprompt:\n  - type: \"file\"\n    path: \"large_specification.md\"\n    summary: true\n    max_summary_length: 1000\n  - type: \"previous_response\"\n    step: \"detailed_analysis\"\n    summary: true\n    extract: \"findings\"\n```","ref":"prompt_system_guide.html#content-summarization"},{"type":"extras","title":"Variable Injection - Prompt System","doc":"```yaml\nprompt:\n  - type: \"file\"\n    path: \"pipelines/prompts/analysis/project_analysis.md\"\n    variables:\n      PROJECT_NAME: \"MyApp\"\n      LANGUAGE: \"Python\"\n      FRAMEWORK: \"FastAPI\"\n  - type: \"file\"\n    path: \"${PROJECT_PATH}/src/main.py\"\n    inject_as: \"SOURCE_CODE\"\n```","ref":"prompt_system_guide.html#variable-injection"},{"type":"extras","title":"Best Practices - Prompt System","doc":"","ref":"prompt_system_guide.html#best-practices"},{"type":"extras","title":"1. Prompt Organization - Prompt System","doc":"- **Single Responsibility**: Each prompt file should focus on one specific task\n- **Clear Naming**: Use descriptive, action-oriented names\n- **Version Control**: Track prompt evolution with version comments\n- **Documentation**: Include purpose, context, and expected outputs","ref":"prompt_system_guide.html#1-prompt-organization"},{"type":"extras","title":"2. Template Design - Prompt System","doc":"- **Parameterization**: Use variables for reusable templates\n- **Flexibility**: Design templates that work across different contexts\n- **Clarity**: Write clear, unambiguous instructions\n- **Examples**: Include examples of expected inputs and outputs","ref":"prompt_system_guide.html#2-template-design"},{"type":"extras","title":"3. Component Architecture - Prompt System","doc":"- **Modularity**: Design components that can be easily combined\n- **Configuration**: Support customization through variables\n- **Reusability**: Create components that work across workflows\n- **Testing**: Include test cases for component validation","ref":"prompt_system_guide.html#3-component-architecture"},{"type":"extras","title":"4. Content Management - Prompt System","doc":"- **Caching**: Leverage file caching for performance\n- **Size Limits**: Monitor and control prompt sizes\n- **Processing**: Use content extraction for large inputs\n- **Validation**: Verify prompt content before execution","ref":"prompt_system_guide.html#4-content-management"},{"type":"extras","title":"5. Error Handling - Prompt System","doc":"- **Fallbacks**: Provide fallback prompts for error conditions\n- **Validation**: Validate file paths and references\n- **Recovery**: Design recovery strategies for failed prompts\n- **Monitoring**: Track prompt performance and success rates","ref":"prompt_system_guide.html#5-error-handling"},{"type":"extras","title":"Complete Examples - Prompt System","doc":"","ref":"prompt_system_guide.html#complete-examples"},{"type":"extras","title":"Example 1: Full-Stack Application Analysis - Prompt System","doc":"```yaml\nworkflow:\n  name: \"fullstack_app_analysis\"\n  \n  steps:\n    # Requirements gathering\n    - name: \"requirements_analysis\"\n      type: \"gemini\"\n      prompt:\n        - type: \"file\"\n          path: \"pipelines/prompts/analysis/requirements_analysis.md\"\n        - type: \"file\"\n          path: \"docs/requirements.md\"\n        - type: \"file\"\n          path: \"docs/user_stories.md\"\n      output_to_file: \"requirements_analysis.json\"\n\n    # Architecture review\n    - name: \"architecture_review\"\n      type: \"gemini\"\n      prompt:\n        - type: \"file\"\n          path: \"pipelines/prompts/analysis/architecture_review.md\"\n        - type: \"file\"\n          path: \"docs/architecture.md\"\n        - type: \"previous_response\"\n          step: \"requirements_analysis\"\n          extract: \"technical_requirements\"\n      output_to_file: \"architecture_review.json\"\n\n    # Parallel code analysis\n    - name: \"code_analysis\"\n      type: \"parallel_claude\"\n      parallel_tasks:\n        - id: \"frontend_analysis\"\n          claude_options:\n            max_turns: 15\n            allowed_tools: [\"Read\"]\n          prompt:\n            - type: \"file\"\n              path: \"pipelines/prompts/analysis/frontend_analysis.md\"\n            - type: \"file\"\n              path: \"frontend/src\"\n          output_to_file: \"frontend_analysis.json\"\n\n        - id: \"backend_analysis\"\n          claude_options:\n            max_turns: 15\n            allowed_tools: [\"Read\"]\n          prompt:\n            - type: \"file\"\n              path: \"pipelines/prompts/analysis/backend_analysis.md\"\n            - type: \"file\"\n              path: \"backend/src\"\n          output_to_file: \"backend_analysis.json\"\n\n        - id: \"database_analysis\"\n          claude_options:\n            max_turns: 10\n            allowed_tools: [\"Read\"]\n          prompt:\n            - type: \"file\"\n              path: \"pipelines/prompts/analysis/database_analysis.md\"\n            - type: \"file\"\n              path: \"database/schema.sql\"\n          output_to_file: \"database_analysis.json\"\n\n    # Security assessment\n    - name: \"security_assessment\"\n      type: \"claude_smart\"\n      preset: \"analysis\"\n      prompt:\n        - type: \"file\"\n          path: \"pipelines/prompts/validation/comprehensive_security_audit.md\"\n        - type: \"previous_response\"\n          step: \"code_analysis\"\n        - type: \"previous_response\"\n          step: \"architecture_review\"\n          extract: \"security_considerations\"\n      output_to_file: \"security_assessment.json\"\n\n    # Comprehensive report\n    - name: \"final_report\"\n      type: \"gemini\"\n      token_budget:\n        max_output_tokens: 8192\n        temperature: 0.4\n      prompt:\n        - type: \"file\"\n          path: \"pipelines/prompts/generation/comprehensive_analysis_report.md\"\n        - type: \"static\"\n          content: \"","ref":"prompt_system_guide.html#example-1-full-stack-application-analysis"},{"type":"extras","title":"Requirements Analysis\" - Prompt System","doc":"- type: \"previous_response\"\n          step: \"requirements_analysis\"\n        - type: \"static\"\n          content: \"\\n","ref":"prompt_system_guide.html#requirements-analysis"},{"type":"extras","title":"Architecture Review\" - Prompt System","doc":"- type: \"previous_response\"\n          step: \"architecture_review\"\n        - type: \"static\"\n          content: \"\\n","ref":"prompt_system_guide.html#architecture-review"},{"type":"extras","title":"Code Analysis Results\" - Prompt System","doc":"- type: \"previous_response\"\n          step: \"code_analysis\"\n        - type: \"static\"\n          content: \"\\n","ref":"prompt_system_guide.html#code-analysis-results"},{"type":"extras","title":"Security Assessment\" - Prompt System","doc":"- type: \"previous_response\"\n          step: \"security_assessment\"\n      output_to_file: \"comprehensive_analysis_report.md\"\n```","ref":"prompt_system_guide.html#security-assessment"},{"type":"extras","title":"Example 2: Iterative Code Improvement - Prompt System","doc":"```yaml\nworkflow:\n  name: \"iterative_code_improvement\"\n  \n  steps:\n    # Initial assessment\n    - name: \"initial_assessment\"\n      type: \"gemini\"\n      prompt:\n        - type: \"file\"\n          path: \"pipelines/prompts/analysis/code_quality_assessment.md\"\n        - type: \"file\"\n          path: \"src/legacy_code.py\"\n      functions:\n        - \"assess_code_quality\"\n      output_to_file: \"initial_assessment.json\"\n\n    # First improvement iteration\n    - name: \"first_improvement\"\n      type: \"claude_robust\"\n      retry_config:\n        max_retries: 3\n        backoff_strategy: \"exponential\"\n      claude_options:\n        max_turns: 20\n        allowed_tools: [\"Read\", \"Write\", \"Edit\"]\n      prompt:\n        - type: \"file\"\n          path: \"pipelines/prompts/generation/code_improvement.md\"\n        - type: \"previous_response\"\n          step: \"initial_assessment\"\n          extract: \"improvement_priorities\"\n        - type: \"file\"\n          path: \"src/legacy_code.py\"\n      output_to_file: \"first_improvement.json\"\n\n    # Review first iteration\n    - name: \"review_first_iteration\"\n      type: \"gemini\"\n      prompt:\n        - type: \"file\"\n          path: \"pipelines/prompts/validation/improvement_review.md\"\n        - type: \"previous_response\"\n          step: \"first_improvement\"\n        - type: \"previous_response\"\n          step: \"initial_assessment\"\n          extract: \"quality_targets\"\n      output_to_file: \"first_review.json\"\n\n    # Second improvement iteration\n    - name: \"second_improvement\"\n      type: \"claude_session\"\n      session_config:\n        persist: true\n        session_name: \"code_improvement_session\"\n      prompt:\n        - type: \"claude_continue\"\n          new_prompt: |\n            Based on the review feedback, please make the following additional improvements:\n        - type: \"previous_response\"\n          step: \"review_first_iteration\"\n          extract: \"additional_improvements\"\n      output_to_file: \"second_improvement.json\"\n\n    # Final validation\n    - name: \"final_validation\"\n      type: \"gemini\"\n      prompt:\n        - type: \"file\"\n          path: \"pipelines/prompts/validation/final_quality_check.md\"\n        - type: \"previous_response\"\n          step: \"second_improvement\"\n        - type: \"previous_response\"\n          step: \"initial_assessment\"\n          extract: \"quality_targets\"\n      functions:\n        - \"validate_improvements\"\n      output_to_file: \"final_validation.json\"\n```","ref":"prompt_system_guide.html#example-2-iterative-code-improvement"},{"type":"extras","title":"Migration Guide - Prompt System","doc":"","ref":"prompt_system_guide.html#migration-guide"},{"type":"extras","title":"Migrating from Inline Prompts - Prompt System","doc":"**Before (Inline):**\n```yaml\nsteps:\n  - name: \"analyze_code\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: |\n          Analyze this code for security issues:\n          1. Check for SQL injection vulnerabilities\n          2. Look for XSS vulnerabilities\n          3. Review authentication mechanisms\n          4. Check for insecure data handling\n          \n          Provide analysis in JSON format with severity levels.\n```\n\n**After (File-based):**\n```yaml\nsteps:\n  - name: \"analyze_code\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/analysis/security_analysis.md\"\n```","ref":"prompt_system_guide.html#migrating-from-inline-prompts"},{"type":"extras","title":"Creating Prompt Libraries - Prompt System","doc":"1. **Extract Common Patterns**: Identify frequently used prompt patterns\n2. **Create Template Files**: Move prompts to organized template files\n3. **Add Variables**: Parameterize templates for reusability\n4. **Update Workflows**: Convert workflows to use file references\n5. **Test Migration**: Verify equivalent functionality","ref":"prompt_system_guide.html#creating-prompt-libraries"},{"type":"extras","title":"Component Migration - Prompt System","doc":"1. **Identify Reusable Steps**: Find step patterns used across workflows\n2. **Create Component Definitions**: Extract steps into component files\n3. **Parameterize Components**: Add variables for customization\n4. **Update Workflows**: Use component references instead of inline definitions\n5. **Validate Components**: Test components across different contexts\n\nThis guide provides a comprehensive framework for leveraging the Pipeline Prompt System's advanced capabilities. Use these patterns and standards to build maintainable, reusable, and powerful AI workflows.","ref":"prompt_system_guide.html#component-migration"},{"type":"extras","title":"Recursive Pipelines","doc":"# Recursive Pipelines Guide","ref":"recursive_pipelines_guide.html"},{"type":"extras","title":"Table of Contents - Recursive Pipelines","doc":"1. [Overview](#overview)\n2. [Core Concepts](#core-concepts)\n3. [Basic Usage](#basic-usage)\n4. [Context Management](#context-management)\n5. [Safety Features](#safety-features)\n6. [Developer Experience](#developer-experience)\n7. [Advanced Patterns](#advanced-patterns)\n8. [Performance Considerations](#performance-considerations)\n9. [Best Practices](#best-practices)\n10. [Examples and Use Cases](#examples-and-use-cases)\n11. [Troubleshooting](#troubleshooting)\n12. [API Reference](#api-reference)\n13. [Related Guides](#related-guides)","ref":"recursive_pipelines_guide.html#table-of-contents"},{"type":"extras","title":"Overview - Recursive Pipelines","doc":"Recursive pipelines enable pipeline composition in pipeline_ex, where a pipeline step can execute another complete pipeline. This transforms pipeline_ex from a linear workflow engine into a compositional framework supporting complex, hierarchical AI engineering patterns.","ref":"recursive_pipelines_guide.html#overview"},{"type":"extras","title":"Key Benefits - Recursive Pipelines","doc":"- **Modularity**: Build complex workflows from simpler, tested components\n- **Reusability**: Share common pipeline patterns across projects\n- **Maintainability**: Update shared pipelines in one place\n- **Scalability**: Compose arbitrarily complex workflows\n- **Testing**: Test pipeline components in isolation","ref":"recursive_pipelines_guide.html#key-benefits"},{"type":"extras","title":"Architecture - Recursive Pipelines","doc":"```mermaid\ngraph TD\n    A[Main Pipeline] --> B[Executor]\n    B --> C{Step Type?}\n    C -->|pipeline| D[NestedPipeline Module]\n    C -->|claude| E[Claude Module]\n    C -->|gemini| F[Gemini Module]\n    \n    D --> G[Load Sub-Pipeline]\n    G --> H[Create Nested Context]\n    H --> I[Execute Sub-Pipeline]\n    I --> J[Extract Results]\n    J --> K[Merge to Parent Context]\n    \n    style D fill:#f9f,stroke:#333,stroke-width:4px\n```","ref":"recursive_pipelines_guide.html#architecture"},{"type":"extras","title":"Core Concepts - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#core-concepts"},{"type":"extras","title":"Pipeline Composition - Recursive Pipelines","doc":"Recursive pipelines allow you to nest complete pipelines within other pipelines:\n\n```yaml\n# Instead of monolithic 50+ step pipelines\nworkflow:\n  name: \"complete_analysis\"\n  steps:\n    # Compose from reusable components\n    - name: \"extract_data\"\n      type: \"pipeline\"\n      pipeline_file: \"./pipelines/data_extraction.yaml\"\n    \n    - name: \"clean_data\"\n      type: \"pipeline\"\n      pipeline_file: \"./pipelines/data_cleaning.yaml\"\n    \n    - name: \"analyze\"\n      type: \"pipeline\"\n      pipeline_file: \"./pipelines/analysis.yaml\"\n```","ref":"recursive_pipelines_guide.html#pipeline-composition"},{"type":"extras","title":"Context Isolation - Recursive Pipelines","doc":"Each nested pipeline runs in its own isolated context:\n\n- Separate workspace directories\n- Independent checkpoint management\n- Isolated error handling\n- Controlled variable passing","ref":"recursive_pipelines_guide.html#context-isolation"},{"type":"extras","title":"Nesting Depth Tracking - Recursive Pipelines","doc":"The system tracks nesting depth to prevent infinite recursion and resource exhaustion.","ref":"recursive_pipelines_guide.html#nesting-depth-tracking"},{"type":"extras","title":"Basic Usage - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#basic-usage"},{"type":"extras","title":"Step Definition Schema - Recursive Pipelines","doc":"```yaml\n- name: \"sub_workflow\"\n  type: \"pipeline\"\n  \n  # Pipeline source (one required)\n  pipeline_file: \"./path/to/pipeline.yaml\"  # External file\n  pipeline_ref: \"registered_pipeline_name\"   # From registry (future)\n  pipeline:                                  # Inline definition\n    name: \"inline_pipeline\"\n    steps:\n      - name: \"step1\"\n        type: \"claude\"\n        prompt: \"...\"\n  \n  # Input mapping (optional)\n  inputs:\n    data: \"{{steps.previous.result}}\"\n    config: \"{{workflow.settings}}\"\n    mode: \"production\"  # Static values\n  \n  # Output extraction (optional)\n  outputs:\n    - \"final\"  # Simple extraction\n    - path: \"analysis.metrics.accuracy\"\n      as: \"accuracy_score\"  # With aliasing\n  \n  # Execution configuration (optional)\n  config:\n    inherit_context: true\n    workspace_dir: \"./nested/${step.name}\"\n    timeout_seconds: 300\n    max_depth: 5\n```","ref":"recursive_pipelines_guide.html#step-definition-schema"},{"type":"extras","title":"Simple Example - Recursive Pipelines","doc":"```yaml\nworkflow:\n  name: \"data_processor\"\n  steps:\n    - name: \"prepare\"\n      type: \"pipeline\"\n      pipeline:\n        name: \"data_prep\"\n        steps:\n          - name: \"validate\"\n            type: \"claude\"\n            prompt: \"Validate this data format\"\n          - name: \"clean\"\n            type: \"claude\"\n            prompt: \"Clean and normalize the data\"\n    \n    - name: \"analyze\"\n      type: \"pipeline\"\n      pipeline_file: \"./analysis_pipeline.yaml\"\n```","ref":"recursive_pipelines_guide.html#simple-example"},{"type":"extras","title":"Context Management - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#context-management"},{"type":"extras","title":"Context Inheritance - Recursive Pipelines","doc":"Control how much context is shared between parent and child pipelines:\n\n```yaml\n- name: \"nested_step\"\n  type: \"pipeline\"\n  pipeline_file: \"./child.yaml\"\n  config:\n    inherit_context: true      # Pass parent context vars\n    inherit_providers: true    # Use parent provider configs\n    inherit_functions: false   # Don't inherit function defs\n```\n\nWhen `inherit_context` is true, the child pipeline can access:\n- Parent's global variables\n- Parent's function definitions\n- Parent's provider configurations\n- Parent's workflow metadata","ref":"recursive_pipelines_guide.html#context-inheritance"},{"type":"extras","title":"Input Mapping - Recursive Pipelines","doc":"Pass specific data from parent to child with full template resolution:\n\n```yaml\n- name: \"process_data\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  inputs:\n    # Variable references from previous steps\n    source_data: \"{{steps.extract.result}}\"\n    nested_field: \"{{steps.prepare.result.data.items}}\"\n    \n    # Global variables\n    api_key: \"{{global_vars.api_key}}\"\n    \n    # Workflow configuration\n    user_config: \"{{workflow.user_settings}}\"\n    \n    # Static values\n    processing_mode: \"batch\"\n    max_items: 1000\n    \n    # Complex expressions (future)\n    threshold: \"{{multiply(workflow.base_threshold, 1.5)}}\"\n```\n\n**Type Preservation**: Single template references preserve their original type:\n- `\"{{steps.data.count}}\"` → `42` (integer)\n- `\"{{steps.data.result}}\"` → `{\"name\": \"test\", \"value\": 100}` (object)\n- `\"Count: {{steps.data.count}}\"` → `\"Count: 42\"` (string)","ref":"recursive_pipelines_guide.html#input-mapping"},{"type":"extras","title":"Output Extraction - Recursive Pipelines","doc":"Extract specific results from nested pipelines with flexible patterns:\n\n```yaml\noutputs:\n  # Simple extraction - gets steps.stepname.result\n  - \"final_result\"\n  \n  # Path-based extraction with deep access\n  - path: \"analysis.metrics.accuracy\"\n    as: \"accuracy_score\"\n  \n  # Multiple path-based extractions\n  - path: \"step1.data\"\n    as: \"processed_data\"\n  - path: \"step2.summary.text\"\n    as: \"summary\"\n  \n  # Extract entire step results\n  - \"validation\"\n  - \"transformation\"\n```\n\nExample usage:\n```yaml\n- name: \"analyze\"\n  type: \"pipeline\"\n  pipeline_file: \"./analysis.yaml\"\n  outputs:\n    - path: \"metrics.performance.score\"\n      as: \"perf_score\"\n    - path: \"report.summary\"\n      as: \"summary_text\"\n\n- name: \"use_results\"\n  type: \"claude\"\n  prompt: |\n    Performance score: {{steps.analyze.perf_score}}\n    Summary: {{steps.analyze.summary_text}}\n```","ref":"recursive_pipelines_guide.html#output-extraction"},{"type":"extras","title":"Variable Resolution - Recursive Pipelines","doc":"The custom template resolution engine supports pipeline-specific patterns:\n\n1. **Step Results**: `{{steps.stepname.result}}` or `{{steps.stepname.result.field.nested}}`\n2. **Global Variables**: `{{global_vars.variable_name}}`\n3. **Workflow Data**: `{{workflow.config.setting}}`\n4. **Direct Variables**: `{{variable_name}}`\n\nResolution order:\n1. Check current (child) context first\n2. If not found and inheritance enabled, check parent context\n3. Continue up the context chain\n4. Return the original template if variable not found (graceful fallback)","ref":"recursive_pipelines_guide.html#variable-resolution"},{"type":"extras","title":"Safety Features - Recursive Pipelines","doc":"The recursive pipeline system includes comprehensive safety mechanisms to prevent common failure modes:","ref":"recursive_pipelines_guide.html#safety-features"},{"type":"extras","title":"Recursion Protection - Recursive Pipelines","doc":"#### Depth Limiting\n\nControl maximum nesting depth to prevent stack overflow:\n\n```yaml\n- name: \"nested_pipeline\"\n  type: \"pipeline\"\n  pipeline_file: \"./child.yaml\"\n  config:\n    max_depth: 5  # Override default limit\n```\n\nEnvironment-specific defaults:\n```elixir\n# config/dev.exs - Development\nconfig :pipeline,\n  max_nesting_depth: 15,    # More permissive for experimentation\n  max_total_steps: 2000\n\n# config/test.exs - Testing\nconfig :pipeline,\n  max_nesting_depth: 5,     # Restricted for fast tests\n  max_total_steps: 100\n\n# config/prod.exs - Production\nconfig :pipeline,\n  max_nesting_depth: 8,     # Conservative for stability\n  max_total_steps: 500\n```\n\n#### Circular Dependency Detection\n\nThe system automatically detects and prevents circular dependencies:\n\n```yaml\n# pipeline_a.yaml\n- name: \"call_b\"\n  type: \"pipeline\"\n  pipeline_file: \"./pipeline_b.yaml\"\n\n# pipeline_b.yaml\n- name: \"call_a\"\n  type: \"pipeline\"\n  pipeline_file: \"./pipeline_a.yaml\"  # ERROR: Circular dependency!\n```\n\nError message:\n```\nError: Circular dependency detected in pipeline execution chain:\n  main_workflow -> pipeline_a -> pipeline_b -> pipeline_a\n  \nExecution chain:\n  1. main_workflow (depth: 0)\n  2. pipeline_a (depth: 1)\n  3. pipeline_b (depth: 2)\n  4. pipeline_a (depth: 3) <- Circular reference\n```","ref":"recursive_pipelines_guide.html#recursion-protection"},{"type":"extras","title":"Resource Management - Recursive Pipelines","doc":"#### Memory Monitoring\n\nReal-time memory usage tracking with configurable limits:\n\n```yaml\nconfig:\n  memory_limit_mb: 1024    # 1GB limit\n  memory_warning_mb: 768   # Warning at 75% usage\n```\n\nMemory pressure warnings:\n```\nWarning: Memory usage approaching limit\n  Current: 850MB / 1024MB (83%)\n  Pipeline: data_processor (depth: 2)\n  Consider optimizing data handling or increasing limit\n```\n\n#### Timeout Protection\n\nPrevent runaway pipelines with execution time limits:\n\n```yaml\nconfig:\n  timeout_seconds: 300     # 5 minute timeout\n  max_retries: 2          # Retry attempts on timeout\n```\n\n#### Step Count Limits\n\nPrevent exponential pipeline expansion:\n\n```yaml\nconfig:\n  max_total_steps: 1000   # Total steps across all nested pipelines\n```","ref":"recursive_pipelines_guide.html#resource-management"},{"type":"extras","title":"Workspace Isolation - Recursive Pipelines","doc":"Each nested pipeline gets its own isolated workspace:\n\n```yaml\nconfig:\n  workspace_dir: \"./nested/${step.name}\"  # Isolated directory\n  cleanup_on_error: true                  # Auto cleanup\n  cleanup_on_success: true                # Clean after completion\n```","ref":"recursive_pipelines_guide.html#workspace-isolation"},{"type":"extras","title":"Resource Cleanup - Recursive Pipelines","doc":"Automatic cleanup on all execution paths:\n- **Workspace directories**: Removed after pipeline completion\n- **Memory structures**: Large data cleared from context\n- **Context chains**: Parent references cleaned to prevent leaks\n- **Temporary files**: All temp files removed","ref":"recursive_pipelines_guide.html#resource-cleanup"},{"type":"extras","title":"Developer Experience - Recursive Pipelines","doc":"The recursive pipeline system includes comprehensive developer tools for debugging, monitoring, and optimization:","ref":"recursive_pipelines_guide.html#developer-experience"},{"type":"extras","title":"Enhanced Error Messages - Recursive Pipelines","doc":"Production-grade error reporting with full execution context:\n\n```\nPipeline execution failed in nested pipeline:\n  \n  Main Pipeline: data_analysis_workflow\n  └─ Step: process_data (pipeline)\n     └─ Nested Pipeline: data_processor\n        └─ Step: validate_schema (claude)\n           └─ Error: Invalid JSON in response\n  \n  Execution Stack:\n    1. data_analysis_workflow.process_data (depth: 0)\n    2. data_processor.validate_schema (depth: 1)\n  \n  Context at failure:\n    - Total steps executed: 12\n    - Nesting depth: 1\n    - Elapsed time: 4.2s\n    - Memory usage: 234MB\n  \n  Debug Information:\n    - Trace ID: a1b2c3d4-e5f6-7890-abcd-ef1234567890\n    - Step config: {\"type\": \"claude\", \"prompt\": \"...\"}\n    - Parent pipeline: data_analysis_workflow\n```","ref":"recursive_pipelines_guide.html#enhanced-error-messages"},{"type":"extras","title":"Execution Tracing - Recursive Pipelines","doc":"Span-based tracing system for performance analysis:\n\n```elixir\n# Enable tracing for a pipeline\n- name: \"complex_workflow\"\n  type: \"pipeline\"\n  pipeline_file: \"./workflow.yaml\"\n  config:\n    enable_tracing: true\n    trace_metadata:\n      request_id: \"{{inputs.request_id}}\"\n      user_id: \"{{inputs.user_id}}\"\n```\n\nTrace output includes:\n- Hierarchical span relationships\n- Execution duration per span\n- Resource usage metrics\n- Success/failure status\n- Custom metadata","ref":"recursive_pipelines_guide.html#execution-tracing"},{"type":"extras","title":"Visual Debugging - Recursive Pipelines","doc":"Interactive execution tree visualization:\n\n```\nExecution Tree for trace_id: a1b2c3d4\n├─ main_pipeline (289.5ms) ✓\n│  ├─ prepare_data (45.2ms) ✓\n│  │  └─ validation: {\"status\": \"valid\", \"records\": 1000}\n│  ├─ analysis_pipeline (198.3ms) ✓\n│  │  ├─ security_scan (89.1ms) ✓\n│  │  │  └─ vulnerabilities: []\n│  │  ├─ performance_check (72.4ms) ✓\n│  │  │  └─ bottlenecks: [\"database_query_optimization\"]\n│  │  └─ code_quality (36.8ms) ✓\n│  │     └─ score: 8.5\n│  └─ generate_report (46.0ms) ✓\n│     └─ report_url: \"https://reports.example.com/abc123\"\n\nPerformance Summary:\n- Total Duration: 289.5ms\n- Deepest Nesting: 2 levels\n- Total Steps: 7\n- Success Rate: 100%\n- Average Step Duration: 41.4ms\n```","ref":"recursive_pipelines_guide.html#visual-debugging"},{"type":"extras","title":"Performance Metrics - Recursive Pipelines","doc":"Detailed performance analysis per nesting level:\n\n```elixir\n# Performance metrics collection\nPipeline.Metrics.NestedPerformance.analyze_performance(execution_id)\n\n# Returns:\n%{\n  overall_metrics: %{\n    total_duration_ms: 289.5,\n    total_steps: 7,\n    success_rate: 1.0,\n    max_depth: 2\n  },\n  depth_metrics: %{\n    0 => %{steps: 3, avg_duration_ms: 96.5, success_rate: 1.0},\n    1 => %{steps: 4, avg_duration_ms: 48.6, success_rate: 1.0}\n  },\n  bottlenecks: [\n    %{pipeline: \"analysis_pipeline\", step: \"security_scan\", duration_ms: 89.1}\n  ],\n  performance_grade: :excellent,  # :excellent | :good | :fair | :poor\n  recommendations: [\n    \"Consider caching security scan results for repeated analyses\",\n    \"Database query in performance_check could be optimized\"\n  ]\n}\n```","ref":"recursive_pipelines_guide.html#performance-metrics"},{"type":"extras","title":"Debug Commands - Recursive Pipelines","doc":"Interactive debugging interface:\n\n```elixir\n# Start debug session\nPipeline.Debug.NestedExecution.start_debug_session(trace_context)\n\n# Available commands:\n# - tree: Show execution tree\n# - inspect  : Examine step details\n# - search  : Search execution traces\n# - analyze: Performance analysis\n# - report: Generate debug report\n```","ref":"recursive_pipelines_guide.html#debug-commands"},{"type":"extras","title":"Telemetry Integration - Recursive Pipelines","doc":"Built-in telemetry events for monitoring:\n\n```elixir\n# Attach to telemetry events\n:telemetry.attach_many(\n  \"pipeline-monitoring\",\n  [\n    [:pipeline, :nested, :start],\n    [:pipeline, :nested, :stop],\n    [:pipeline, :nested, :error],\n    [:pipeline, :span, :start],\n    [:pipeline, :span, :stop]\n  ],\n  &handle_pipeline_event/4,\n  nil\n)\n\n# Event metadata includes:\n# - pipeline_id, depth, parent_span\n# - duration, memory_usage, step_count\n# - error details (for error events)\n```","ref":"recursive_pipelines_guide.html#telemetry-integration"},{"type":"extras","title":"Advanced Patterns - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#advanced-patterns"},{"type":"extras","title":"Progressive Enhancement - Recursive Pipelines","doc":"Build complexity gradually through connected prompts:\n\n```yaml\nworkflow:\n  name: \"progressive_analysis\"\n  steps:\n    - name: \"basic_scan\"\n      type: \"pipeline\"\n      pipeline_file: \"./basic_analysis.yaml\"\n    \n    - name: \"detailed_analysis\"\n      type: \"pipeline\"\n      pipeline_file: \"./detailed_analysis.yaml\"\n      inputs:\n        findings: \"{{steps.basic_scan.concerns}}\"\n        source_data: \"{{workflow.input_data}}\"\n    \n    - name: \"comprehensive_report\"\n      type: \"pipeline\"\n      pipeline_file: \"./report_generator.yaml\"\n      inputs:\n        basic_results: \"{{steps.basic_scan.result}}\"\n        detailed_results: \"{{steps.detailed_analysis.result}}\"\n```","ref":"recursive_pipelines_guide.html#progressive-enhancement"},{"type":"extras","title":"Conditional Sub-Pipelines - Recursive Pipelines","doc":"Execute different pipelines based on conditions:\n\n```yaml\nworkflow:\n  name: \"adaptive_processing\"\n  steps:\n    - name: \"detect_type\"\n      type: \"claude\"\n      prompt: \"Detect the data type: {{input}}\"\n    \n    - name: \"process_text\"\n      type: \"pipeline\"\n      pipeline_file: \"./text_processor.yaml\"\n      condition: \"{{steps.detect_type.result.type == 'text'}}\"\n    \n    - name: \"process_structured\"\n      type: \"pipeline\"\n      pipeline_file: \"./structured_processor.yaml\"\n      condition: \"{{steps.detect_type.result.type == 'structured'}}\"\n```","ref":"recursive_pipelines_guide.html#conditional-sub-pipelines"},{"type":"extras","title":"Parallel Nested Execution - Recursive Pipelines","doc":"Run multiple sub-pipelines simultaneously:\n\n```yaml\n- name: \"parallel_analysis\"\n  type: \"parallel_claude\"\n  parallel_tasks:\n    - id: \"security_scan\"\n      type: \"pipeline\"\n      pipeline_file: \"./security_analysis.yaml\"\n      \n    - id: \"performance_scan\"\n      type: \"pipeline\"\n      pipeline_file: \"./performance_analysis.yaml\"\n      \n    - id: \"quality_scan\"\n      type: \"pipeline\"\n      pipeline_file: \"./quality_analysis.yaml\"\n```","ref":"recursive_pipelines_guide.html#parallel-nested-execution"},{"type":"extras","title":"Self-Referential Pipelines - Recursive Pipelines","doc":"Pipelines that can call themselves (with proper depth limits):\n\n```yaml\nworkflow:\n  name: \"recursive_analyzer\"\n  steps:\n    - name: \"analyze_item\"\n      type: \"claude\"\n      prompt: \"Analyze: {{inputs.item}}\"\n    \n    - name: \"process_children\"\n      type: \"for_loop\"\n      over: \"{{steps.analyze_item.result.sub_items}}\"\n      as: \"child\"\n      steps:\n        - name: \"recurse\"\n          type: \"pipeline\"\n          pipeline_ref: \"recursive_analyzer\"  # Self-reference\n          inputs:\n            item: \"{{child}}\"\n          config:\n            max_depth: 3  # Prevent infinite recursion\n```","ref":"recursive_pipelines_guide.html#self-referential-pipelines"},{"type":"extras","title":"Error Recovery Pattern - Recursive Pipelines","doc":"Handle failures gracefully with fallback pipelines:\n\n```yaml\nworkflow:\n  name: \"resilient_processor\"\n  steps:\n    - name: \"primary_processing\"\n      type: \"pipeline\"\n      pipeline_file: \"./primary.yaml\"\n      config:\n        continue_on_error: true\n    \n    - name: \"fallback_processing\"\n      type: \"pipeline\"\n      pipeline_file: \"./fallback.yaml\"\n      condition: \"{{steps.primary_processing.error != null}}\"\n      inputs:\n        error: \"{{steps.primary_processing.error}}\"\n        original_input: \"{{inputs.data}}\"\n```","ref":"recursive_pipelines_guide.html#error-recovery-pattern"},{"type":"extras","title":"Performance Considerations - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#performance-considerations"},{"type":"extras","title":"Pipeline Caching - Recursive Pipelines","doc":"The system caches loaded pipelines for performance:\n\n```elixir\n# Automatic caching with TTL\npipeline_cache_ttl: 3600  # 1 hour\n```","ref":"recursive_pipelines_guide.html#pipeline-caching"},{"type":"extras","title":"Optimization Strategies - Recursive Pipelines","doc":"1. **Lazy Loading**: Sub-pipelines are loaded only when needed\n2. **Context Pooling**: Reuse context structures where safe\n3. **Result Streaming**: Stream large results between pipelines\n4. **Parallel Execution**: Run independent sub-pipelines concurrently","ref":"recursive_pipelines_guide.html#optimization-strategies"},{"type":"extras","title":"Performance Metrics - Recursive Pipelines","doc":"Track execution metrics:\n\n```yaml\n# Prometheus metrics example\npipeline_nested_executions_total{pipeline=\"analysis\", depth=\"2\"} 42\npipeline_nested_duration_seconds{pipeline=\"analysis\", depth=\"2\"} 1.234\npipeline_nested_memory_bytes{pipeline=\"analysis\"} 104857600\n```","ref":"recursive_pipelines_guide.html#performance-metrics-1"},{"type":"extras","title":"Best Practices - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#best-practices"},{"type":"extras","title":"Organization - Recursive Pipelines","doc":"```\nproject/\n├── pipelines/\n│   ├── components/        # Reusable sub-pipelines\n│   │   ├── data_prep.yaml\n│   │   ├── analysis.yaml\n│   │   └── reporting.yaml\n│   ├── workflows/         # Main orchestration pipelines\n│   │   ├── full_analysis.yaml\n│   │   └── quick_scan.yaml\n│   └── templates/         # Pipeline templates\n└── shared/\n    └── common_steps.yaml\n```","ref":"recursive_pipelines_guide.html#organization"},{"type":"extras","title":"Design Principles - Recursive Pipelines","doc":"1. **Single Responsibility**: Each sub-pipeline should have one clear purpose\n2. **Loose Coupling**: Minimize dependencies between pipelines\n3. **Clear Interfaces**: Well-defined inputs and outputs\n4. **Error Boundaries**: Proper error handling at each level","ref":"recursive_pipelines_guide.html#design-principles"},{"type":"extras","title":"Naming Conventions - Recursive Pipelines","doc":"- **Descriptive names**: `security_vulnerability_scan.yaml` not `scan.yaml`\n- **Action-oriented**: `generate_api_tests.yaml` not `api_tests.yaml`\n- **Domain prefixes**: `frontend_analysis.yaml`, `backend_review.yaml`\n- **Version suffixes**: `data_processor_v2.yaml` for major updates","ref":"recursive_pipelines_guide.html#naming-conventions"},{"type":"extras","title":"Configuration Management - Recursive Pipelines","doc":"```yaml\n# Use consistent configuration patterns\nconfig:\n  inherit_context: true\n  workspace_dir: \"./nested/${step.name}\"\n  timeout_seconds: 300\n  max_depth: 5\n```","ref":"recursive_pipelines_guide.html#configuration-management"},{"type":"extras","title":"Examples and Use Cases - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#examples-and-use-cases"},{"type":"extras","title":"Use Case 1: Multi-Stage Data Processing - Recursive Pipelines","doc":"```yaml\nworkflow:\n  name: \"data_pipeline\"\n  steps:\n    - name: \"ingestion\"\n      type: \"pipeline\"\n      pipeline_file: \"./stages/data_ingestion.yaml\"\n      inputs:\n        source: \"{{inputs.data_source}}\"\n        format: \"{{inputs.format}}\"\n      outputs:\n        - path: \"raw_data\"\n          as: \"ingested_data\"\n        - \"metadata\"\n    \n    - name: \"validation\"\n      type: \"pipeline\"\n      pipeline_file: \"./stages/data_validation.yaml\"\n      inputs:\n        data: \"{{steps.ingestion.ingested_data}}\"\n        schema: \"{{steps.ingestion.metadata.schema}}\"\n      outputs:\n        - \"validated_data\"\n        - \"validation_report\"\n    \n    - name: \"transformation\"\n      type: \"pipeline\"\n      pipeline_file: \"./stages/data_transformation.yaml\"\n      inputs:\n        data: \"{{steps.validation.validated_data}}\"\n        rules: \"{{workflow.transformation_rules}}\"\n      outputs:\n        - \"processed_data\"\n```","ref":"recursive_pipelines_guide.html#use-case-1-multi-stage-data-processing"},{"type":"extras","title":"Use Case 2: Code Generation Workflow - Recursive Pipelines","doc":"```yaml\nworkflow:\n  name: \"app_generator\"\n  steps:\n    - name: \"analyze_requirements\"\n      type: \"pipeline\"\n      pipeline_file: \"./generators/requirements_analysis.yaml\"\n      inputs:\n        specs: \"{{inputs.requirements}}\"\n    \n    - name: \"generate_backend\"\n      type: \"pipeline\"\n      pipeline_file: \"./generators/backend_generator.yaml\"\n      inputs:\n        architecture: \"{{steps.analyze_requirements.backend_spec}}\"\n        database: \"{{steps.analyze_requirements.db_requirements}}\"\n    \n    - name: \"generate_frontend\"\n      type: \"pipeline\"\n      pipeline_file: \"./generators/frontend_generator.yaml\"\n      inputs:\n        ui_spec: \"{{steps.analyze_requirements.ui_requirements}}\"\n        api_spec: \"{{steps.generate_backend.api_definition}}\"\n    \n    - name: \"integration_tests\"\n      type: \"pipeline\"\n      pipeline_file: \"./generators/test_generator.yaml\"\n      inputs:\n        backend_code: \"{{steps.generate_backend.result}}\"\n        frontend_code: \"{{steps.generate_frontend.result}}\"\n```","ref":"recursive_pipelines_guide.html#use-case-2-code-generation-workflow"},{"type":"extras","title":"Use Case 3: Comprehensive Analysis Framework - Recursive Pipelines","doc":"```yaml\nworkflow:\n  name: \"security_audit\"\n  steps:\n    - name: \"static_analysis\"\n      type: \"parallel_claude\"\n      parallel_tasks:\n        - id: \"code_security\"\n          type: \"pipeline\"\n          pipeline_file: \"./security/code_analysis.yaml\"\n        - id: \"dependency_check\"\n          type: \"pipeline\"\n          pipeline_file: \"./security/dependency_audit.yaml\"\n        - id: \"config_review\"\n          type: \"pipeline\"\n          pipeline_file: \"./security/config_analysis.yaml\"\n    \n    - name: \"dynamic_analysis\"\n      type: \"pipeline\"\n      pipeline_file: \"./security/runtime_analysis.yaml\"\n      inputs:\n        static_findings: \"{{steps.static_analysis.result}}\"\n    \n    - name: \"compliance_check\"\n      type: \"pipeline\"\n      pipeline_file: \"./security/compliance_review.yaml\"\n      inputs:\n        security_findings: \"{{steps.dynamic_analysis.vulnerabilities}}\"\n        static_results: \"{{steps.static_analysis.result}}\"\n    \n    - name: \"final_report\"\n      type: \"pipeline\"\n      pipeline_file: \"./reporting/security_report.yaml\"\n      inputs:\n        all_findings: \"{{steps.compliance_check.consolidated_results}}\"\n```","ref":"recursive_pipelines_guide.html#use-case-3-comprehensive-analysis-framework"},{"type":"extras","title":"Troubleshooting - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#troubleshooting"},{"type":"extras","title":"Common Issues - Recursive Pipelines","doc":"#### 1. Circular Dependency Error\n\n```\nError: Circular dependency detected: pipeline_a -> pipeline_b -> pipeline_a\n```\n\n**Solution**: Review your pipeline call chain and eliminate cycles.\n\n#### 2. Maximum Depth Exceeded\n\n```\nError: Maximum nesting depth (10) exceeded\n```\n\n**Solutions**:\n- Reduce nesting levels\n- Increase `max_depth` configuration\n- Refactor deep hierarchies into flatter structures\n\n#### 3. Pipeline Not Found\n\n```\nError: Pipeline file not found: ./missing_pipeline.yaml\n```\n\n**Solutions**:\n- Verify file path is correct\n- Check file permissions\n- Ensure file exists in expected location\n\n#### 4. Memory Limit Exceeded\n\n```\nError: Memory limit exceeded: 1500MB > 1024MB\n```\n\n**Solutions**:\n- Increase memory limit in configuration\n- Optimize large data handling\n- Stream results instead of loading all in memory","ref":"recursive_pipelines_guide.html#common-issues"},{"type":"extras","title":"Debugging Tools - Recursive Pipelines","doc":"#### Execution Tree Visualization\n\n```bash\n# Enable debug mode for detailed execution logging\nPIPELINE_DEBUG=true mix pipeline.run complex_workflow.yaml\n```\n\nDebug output shows execution hierarchy:\n```\nExecution Tree:\n├─ main_pipeline (depth: 0)\n│  ├─ data_prep (depth: 1)\n│  │  └─ validation: success\n│  ├─ analysis (depth: 1)\n│  │  ├─ security_scan (depth: 2)\n│  │  └─ performance_check (depth: 2)\n│  └─ reporting (depth: 1)\n```\n\n#### Enhanced Error Messages\n\nErrors include full execution context:\n\n```\nPipeline execution failed in nested pipeline:\n  \n  Main Pipeline: data_processor\n  └─ Step: analyze_data (pipeline)\n     └─ Nested Pipeline: analysis_pipeline\n        └─ Step: extract_themes (claude)\n           └─ Error: API timeout after 30s\n  \n  Execution Stack:\n    1. data_processor.analyze_data (depth: 0)\n    2. analysis_pipeline.extract_themes (depth: 1)\n  \n  Context at failure:\n    - Total steps executed: 15\n    - Nesting depth: 1\n    - Elapsed time: 32.5s\n```","ref":"recursive_pipelines_guide.html#debugging-tools"},{"type":"extras","title":"Performance Debugging - Recursive Pipelines","doc":"Monitor performance metrics:\n\n```elixir\n# Enable telemetry events\n:telemetry.attach_many(\n  \"pipeline-metrics\",\n  [\n    [:pipeline, :nested, :execution],\n    [:pipeline, :span, :start],\n    [:pipeline, :span, :stop]\n  ],\n  &handle_telemetry_event/4,\n  nil\n)\n```","ref":"recursive_pipelines_guide.html#performance-debugging"},{"type":"extras","title":"API Reference - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#api-reference"},{"type":"extras","title":"Step Configuration - Recursive Pipelines","doc":"```yaml\ntype: pipeline\nname: string                    # Step name (required)\npipeline_file: string          # Path to external pipeline file\npipeline_ref: string           # Reference to registered pipeline (future)\npipeline: object               # Inline pipeline definition\ninputs: map                    # Input variable mappings\noutputs: array                 # Output extraction configuration\nconfig:                        # Execution configuration\n  inherit_context: boolean     # Inherit parent context (default: false)\n  inherit_providers: boolean   # Inherit provider configs (default: true)\n  inherit_functions: boolean   # Inherit function definitions (default: false)\n  workspace_dir: string        # Nested workspace directory\n  checkpoint_enabled: boolean  # Enable checkpointing (default: false)\n  timeout_seconds: integer     # Execution timeout\n  max_retries: integer        # Retry attempts\n  continue_on_error: boolean  # Continue on sub-pipeline error\n  max_depth: integer          # Maximum nesting depth\n  memory_limit_mb: integer    # Memory limit in MB\n  enable_tracing: boolean     # Enable execution tracing\n```","ref":"recursive_pipelines_guide.html#step-configuration"},{"type":"extras","title":"Elixir API - Recursive Pipelines","doc":"```elixir\n# Execute nested pipeline\nPipeline.Step.NestedPipeline.execute(step_config, context)\n\n# Context management\nPipeline.Context.Nested.create_nested_context(parent_context, step_config)\nPipeline.Context.Nested.extract_outputs(results, output_config)\nPipeline.Context.Nested.resolve_template(template, context)\n\n# Safety checks\nPipeline.Safety.RecursionGuard.check_all_safety(pipeline_id, context, limits)\nPipeline.Safety.ResourceMonitor.check_limits(usage, limits)\nPipeline.Safety.SafetyManager.check_safety(pipeline_id, context, config)\n\n# Error handling\nPipeline.Error.NestedPipeline.format_nested_error(error, context, step)\n\n# Debugging and tracing\nPipeline.Debug.NestedExecution.start_debug_session(trace_context, options)\nPipeline.Tracing.NestedExecution.start_nested_trace(pipeline_id, context, step, parent)\nPipeline.Metrics.NestedPerformance.analyze_performance(execution_id)\n```","ref":"recursive_pipelines_guide.html#elixir-api"},{"type":"extras","title":"Configuration Options - Recursive Pipelines","doc":"```elixir\n# config/config.exs\nconfig :pipeline,\n  # Safety limits\n  max_nesting_depth: 10,\n  max_total_steps: 1000,\n  default_memory_limit_mb: 1024,\n  default_timeout_seconds: 300,\n  \n  # Performance\n  pipeline_cache_ttl: 3600,\n  enable_tracing: false,\n  \n  # Paths\n  nested_workspace_root: \"./nested_workspaces\",\n  allowed_pipeline_dirs: [\"./pipelines\", \"./shared\"],\n  \n  # Features\n  enable_pipeline_registry: true,\n  enable_performance_metrics: true\n```","ref":"recursive_pipelines_guide.html#configuration-options"},{"type":"extras","title":"Related Guides - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#related-guides"},{"type":"extras","title":"Core Documentation - Recursive Pipelines","doc":"- **[Context Management Guide](docs/guides/context_management.md)** - Deep dive into variable passing and context inheritance\n- **[Safety Features Guide](docs/guides/safety_features.md)** - Comprehensive safety configuration and best practices\n- **Developer Experience Guide** - Debugging tools and performance optimization (see `docs/guides/developer_experience.md`)\n- **Testing Strategy Guide** - Testing approaches for nested pipelines (see `docs/guides/testing_recursive_pipelines.md`)\n- **Examples Collection** - Real-world use cases and patterns (see `docs/guides/recursive_pipeline_examples.md`)","ref":"recursive_pipelines_guide.html#core-documentation"},{"type":"extras","title":"Technical References - Recursive Pipelines","doc":"- **Architecture Design** - Complete technical design document (see `docs/architecture/20250703_recursive.md`)\n- **Implementation Prompts** - Phased implementation guide (see `docs/architecture/recursive_pipeline_prompts.md`)\n- **Implementation Worklog** - Detailed implementation notes (see `docs/architecture/20250703_recursive_worklog.md`)","ref":"recursive_pipelines_guide.html#technical-references"},{"type":"extras","title":"Related Features - Recursive Pipelines","doc":"- **[Pipeline Organization](docs/architecture/pipeline_organization.md)** - Pipeline categorization and structure\n\n---","ref":"recursive_pipelines_guide.html#related-features"},{"type":"extras","title":"Implementation Status - Recursive Pipelines","doc":"","ref":"recursive_pipelines_guide.html#implementation-status"},{"type":"extras","title":"✅ Phase 1: Core Infrastructure (Completed) - Recursive Pipelines","doc":"- Basic nested pipeline execution\n- Three pipeline source options\n- Context isolation and depth tracking\n- Error propagation\n- 14 tests with full coverage","ref":"recursive_pipelines_guide.html#phase-1-core-infrastructure-completed"},{"type":"extras","title":"✅ Phase 2: Context Management (Completed) - Recursive Pipelines","doc":"- Full template resolution engine\n- Input mapping with type preservation\n- Flexible output extraction\n- Context inheritance options\n- 21 additional tests","ref":"recursive_pipelines_guide.html#phase-2-context-management-completed"},{"type":"extras","title":"✅ Phase 3: Safety Features (Completed) - Recursive Pipelines","doc":"- Recursion and circular dependency protection\n- Memory and timeout monitoring\n- Resource cleanup guarantees\n- Environment-specific configuration\n- 46 safety-focused tests","ref":"recursive_pipelines_guide.html#phase-3-safety-features-completed"},{"type":"extras","title":"✅ Phase 4: Developer Experience (Completed) - Recursive Pipelines","doc":"- Enhanced error messages with full context\n- Span-based execution tracing\n- Visual debugging tools\n- Performance metrics and analysis\n- 71 debugging and metrics tests","ref":"recursive_pipelines_guide.html#phase-4-developer-experience-completed"},{"type":"extras","title":"📋 Phase 5: Advanced Features (Future) - Recursive Pipelines","doc":"- Pipeline caching system\n- Performance optimizations\n- Pipeline registry\n- Template system","ref":"recursive_pipelines_guide.html#phase-5-advanced-features-future"},{"type":"extras","title":"Current Capabilities - Recursive Pipelines","doc":"The recursive pipeline system is **production-ready** with:\n- **Complete functionality** for nested pipeline execution\n- **Enterprise-grade safety** protections\n- **Comprehensive debugging** and monitoring tools\n- **152+ tests** ensuring reliability\n- **Full backward compatibility** with existing pipelines\n\n---\n\nThis guide provides comprehensive documentation for the recursive pipelines feature. The system enables powerful pipeline composition patterns with production-grade safety, performance, and debugging capabilities.","ref":"recursive_pipelines_guide.html#current-capabilities"},{"type":"extras","title":"Use Cases","doc":"what kinds of systems would actually USE your pipeline generator as a core component! Here are the architectural patterns that would\n  benefit:\n\n  1. Multi-Agent Orchestration Frameworks\n\n  Your pipeline generator is perfect for dynamic agent workflow creation:\n\n  # Agent system that generates pipelines on-demand\n  AgentOrchestrator.create_workflow(\n    agents: [:data_analyst, :code_reviewer, :deployment_bot],\n    task: \"Analyze user feedback and deploy fixes\",\n    # Uses your Genesis Pipeline to create coordination workflows\n    pipeline_generator: PipelineEx.Generator\n  )\n\n  Use cases:\n  - AutoGPT-style systems that need dynamic task breakdown\n  - Multi-LLM coordination (Claude + GPT + Gemini working together)\n  - Agent swarms that self-organize around tasks\n\n  2. Infrastructure-as-Code Orchestrators\n\n  Your pipeline DNA system is ideal for evolving infrastructure:\n\n  # Infrastructure that generates its own deployment pipelines\n  InfraOrchestrator.evolve_deployment(\n    current_state: production_state,\n    target_changes: user_requirements,\n    # Generates Terraform + Kubernetes + monitoring pipelines\n    pipeline_generator: PipelineEx.Generator\n  )\n\n  Examples:\n  - Pulumi/Terraform wrappers that auto-generate infrastructure workflows\n  - Kubernetes operators that create custom deployment pipelines\n  - Cloud migration tools that generate migration workflows\n\n  3. Data Pipeline Orchestrators (Like Airflow/Prefect)\n\n  Your system could replace static DAG definitions:\n\n  # Instead of manually defining Airflow DAGs\n  @dag(schedule_interval='@daily')\n  def static_etl():\n      # Fixed pipeline structure\n\n  # Dynamic pipeline generation\n  PipelineOrchestrator.generate_etl(\n      data_sources=[\"s3://logs\", \"postgres://analytics\"],\n      transformations=\"detect anomalies and generate alerts\",\n      # Your Genesis system creates optimized ETL workflows\n      generator=PipelineExGenerator()\n  )\n\n  4. CI/CD Meta-Orchestrators\n\n  Systems that generate CI/CD pipelines based on codebase analysis:\n\n  # GitHub App that uses your generator\n  name: Smart CI Generator\n  on: [push, pull_request]\n  jobs:\n    analyze-and-generate:\n      runs-on: ubuntu-latest\n      steps:\n        - uses: your-org/pipeline-generator@v1\n          with:\n            analyze: codebase\n            generate: optimal-ci-pipeline\n            # Creates custom workflows per project\n\n  5. Business Process Automation (BPA) Systems\n\n  Enterprise workflow engines that need dynamic process generation:\n\n  # Business process that generates its own automation\n  BPAOrchestrator.automate_process(\n    business_requirement: \"New employee onboarding\",\n    systems: [:slack, :jira, :hr_system, :github],\n    # Generates integration workflows automatically\n    pipeline_generator: PipelineEx.Generator\n  )\n\n  6. Research/Experimentation Platforms\n\n  ML/AI research platforms that need dynamic experiment workflows:\n\n  # Research platform that generates experiment pipelines\n  ExperimentOrchestrator.design_study(\n      hypothesis=\"Fine-tuning improves task performance\",\n      datasets=[\"squad\", \"glue\", \"custom\"],\n      # Generates A/B testing and evaluation pipelines\n      pipeline_generator=PipelineExGenerator()\n  )\n\n  The Meta-Architecture Pattern\n\n  The most powerful use would be orchestrators that orchestrate orchestrators:\n\n  defmodule MetaOrchestrator do\n    # System that uses your generator to create OTHER orchestrators\n    def bootstrap_system(requirements) do\n      # 1. Generate the orchestrator itself\n      orchestrator_pipeline = PipelineEx.generate(\"Create orchestrator for #{requirements}\")\n\n      # 2. Generate the workflows it manages\n      workflow_pipelines = PipelineEx.generate(\"Create workflows for #{requirements}\")\n\n      # 3. Generate the monitoring/evolution system\n      evolution_pipeline = PipelineEx.generate(\"Create self-improvement system\")\n\n      # Result: Self-creating, self-managing, self-evolving system\n    end\n  end\n\n  This is the real vision - your Genesis Pipeline becomes the DNA of emergent software systems that create and evolve themselves.\n\n  The most promising integration would be agent frameworks like LangGraph, CrewAI, or AutoGPT - they desperately need dynamic workflow generation instead of\n  hardcoded agent interactions.","ref":"use_cases.html"},{"type":"extras","title":"More Use Cases","doc":"You're still manually running scripts when you should have agents automatically generating and running pipelines on demand. Here's the\n   clear path:\n\n  The Disconnect\n\n  Currently:\n  # Manual process\n  mix pipeline.generate \"Create data validation pipeline\"\n  mix pipeline.run evolved_pipelines/data_validation_123.yaml\n\n  What you want:\n  # Agent automatically does this\n  Agent.handle_request(\"I need to validate this data\")\n  # -> Generates pipeline, runs it, returns results\n\n  Easy Path: Build Your Agent Framework\n\n  Step 1: Agent Wrapper (30 minutes)\n\n  defmodule PipelineAgent do\n    def handle_request(user_request) do\n      # Generate pipeline automatically\n      {:ok, pipeline_path} = generate_pipeline(user_request)\n\n      # Run it immediately\n      {:ok, results} = run_pipeline(pipeline_path)\n\n      # Return results to user\n      format_results(results)\n    end\n\n    defp generate_pipeline(request) do\n      # Your existing generator, but programmatic\n      Mix.Tasks.Pipeline.Generate.run([request])\n    end\n  end\n\n  Step 2: Web API (1 hour)\n\n  # Phoenix controller\n  defmodule PipelineWeb.AgentController do\n    def chat(conn, %{\"message\" => user_request}) do\n      result = PipelineAgent.handle_request(user_request)\n      json(conn, %{response: result})\n    end\n  end\n\n  Step 3: Simple Frontend (1 hour)\n\n  ```html\n  <!-- Single page chat interface -->\n   \n     \n     Generate & Run Pipeline \n      \n   \n  ```\n\n  The Real Vision: Pipeline-Generating Agents\n\n  Instead of users running commands, they talk to specialized agents:\n\n  # Data Agent\n  DataAgent.chat(\"I have messy CSV files that need cleaning\")\n  # -> Generates data cleaning pipeline, runs it, returns clean data\n\n  # DevOps Agent\n  DevOpsAgent.chat(\"Deploy this app with monitoring\")\n  # -> Generates deployment pipeline, executes it, returns status\n\n  # Analysis Agent\n  AnalysisAgent.chat(\"Find patterns in user behavior data\")\n  # -> Generates analysis pipeline, runs it, returns insights\n\n  Immediate Next Steps (This Weekend)\n\n  1. Extract the generation logic from Mix.Tasks into a regular module\n  2. Add a simple HTTP endpoint that takes requests and returns results\n  3. Create a basic chat interface\n  4. Test with real requests like \"analyze my git commits\"\n\n  The beauty is you already have the hard parts (pipeline generation, execution, DNA evolution). You just need to wrap it in an agent interface so users can talk\n   to it instead of running commands.\n\n  Start with Step 1 - make PipelineAgent.handle_request/1 work programmatically. Everything else builds from there.","ref":"use_cases_2.html"},{"type":"extras","title":"Testing Architecture","doc":"# Testing Architecture & Development Guide","ref":"testing_architecture.html"},{"type":"extras","title":"Overview - Testing Architecture","doc":"This document outlines the comprehensive testing strategy for the pipeline orchestration system, providing elegant mock/live mode management and robust test coverage for all components.","ref":"testing_architecture.html#overview"},{"type":"extras","title":"Core Testing Principles - Testing Architecture","doc":"","ref":"testing_architecture.html#core-testing-principles"},{"type":"extras","title":"1. Clear Separation of Concerns - Testing Architecture","doc":"- **Business Logic**: Tested with mocks for external dependencies\n- **Integration Points**: Tested with both mocks and live services\n- **End-to-End Flows**: Tested in controlled environments","ref":"testing_architecture.html#1-clear-separation-of-concerns"},{"type":"extras","title":"2. Environment-Based Testing - Testing Architecture","doc":"- **Unit Tests**: Always use mocks (fast, reliable, no external deps)\n- **Integration Tests**: Can use mocks or live services based on configuration\n- **E2E Tests**: Use live services in staging environments","ref":"testing_architecture.html#2-environment-based-testing"},{"type":"extras","title":"3. Dependency Injection Pattern - Testing Architecture","doc":"- All external service interactions go through provider interfaces\n- Providers can be swapped between mock and live implementations\n- Configuration determines which provider to use","ref":"testing_architecture.html#3-dependency-injection-pattern"},{"type":"extras","title":"Testing Architecture - Testing Architecture","doc":"","ref":"testing_architecture.html#testing-architecture"},{"type":"extras","title":"Provider Interface Pattern - Testing Architecture","doc":"```elixir\n# All external services implement a provider behavior\ndefmodule Pipeline.Providers.AIProvider do\n  @callback query(prompt :: String.t(), options :: map()) :: \n    {:ok, response :: map()} | {:error, reason :: String.t()}\nend\n\n# Live implementation\ndefmodule Pipeline.Providers.ClaudeProvider do\n  @behaviour Pipeline.Providers.AIProvider\n  \n  def query(prompt, options) do\n    # Real Claude SDK calls\n  end\nend\n\n# Mock implementation  \ndefmodule Pipeline.Test.Mocks.ClaudeProvider do\n  @behaviour Pipeline.Providers.AIProvider\n  \n  def query(prompt, options) do\n    # Deterministic mock responses\n  end\nend\n```","ref":"testing_architecture.html#provider-interface-pattern"},{"type":"extras","title":"Configuration-Driven Provider Selection - Testing Architecture","doc":"```elixir\n# config/test.exs\nconfig :pipeline, :providers, %{\n  ai_provider: Pipeline.Test.Mocks.ClaudeProvider,\n  gemini_provider: Pipeline.Test.Mocks.GeminiProvider\n}\n\n# config/dev.exs\nconfig :pipeline, :providers, %{\n  ai_provider: Pipeline.Providers.ClaudeProvider,\n  gemini_provider: Pipeline.Providers.GeminiProvider\n}\n```","ref":"testing_architecture.html#configuration-driven-provider-selection"},{"type":"extras","title":"Test Mode Management - Testing Architecture","doc":"```elixir\n# Environment variable controls test mode\n# TEST_MODE=mock mix test          # Uses mocks\n# TEST_MODE=live mix test          # Uses live services  \n# TEST_MODE=mixed mix test         # Uses mocks for unit, live for integration\n\ndefmodule Pipeline.TestMode do\n  def provider_for(service) do\n    case get_test_mode() do\n      :mock -> mock_provider(service)\n      :live -> live_provider(service)\n      :mixed -> mixed_provider(service)\n    end\n  end\n  \n  defp get_test_mode do\n    System.get_env(\"TEST_MODE\", \"mock\") |> String.to_atom()\n  end\nend\n```","ref":"testing_architecture.html#test-mode-management"},{"type":"extras","title":"Mock Implementation Strategy - Testing Architecture","doc":"","ref":"testing_architecture.html#mock-implementation-strategy"},{"type":"extras","title":"1. Deterministic Responses - Testing Architecture","doc":"```elixir\ndefmodule Pipeline.Test.Mocks.ClaudeProvider do\n  @behaviour Pipeline.Providers.AIProvider\n  \n  # Predictable responses based on input patterns\n  def query(\"simple test\", _opts) do\n    {:ok, %{\n      text: \"Mock response for simple test\",\n      success: true,\n      cost: 0.001\n    }}\n  end\n  \n  def query(\"error test\", _opts) do\n    {:error, \"Mock error for testing\"}\n  end\n  \n  # Pattern matching for common scenarios\n  def query(prompt, _opts) when is_binary(prompt) do\n    {:ok, %{\n      text: \"Mock response for: #{String.slice(prompt, 0, 50)}...\",\n      success: true,\n      cost: 0.001\n    }}\n  end\nend\n```","ref":"testing_architecture.html#1-deterministic-responses"},{"type":"extras","title":"2. Stateful Mocks for Complex Scenarios - Testing Architecture","doc":"```elixir\ndefmodule Pipeline.Test.Mocks.StatefulClaudeProvider do\n  use GenServer\n  @behaviour Pipeline.Providers.AIProvider\n  \n  # Track conversation state, turn counts, etc.\n  def query(prompt, options) do\n    GenServer.call(__MODULE__, {:query, prompt, options})\n  end\n  \n  def handle_call({:query, prompt, options}, _from, state) do\n    # Simulate turn limits, state transitions, etc.\n    {response, new_state} = generate_response(prompt, options, state)\n    {:reply, response, new_state}\n  end\nend\n```","ref":"testing_architecture.html#2-stateful-mocks-for-complex-scenarios"},{"type":"extras","title":"3. Scenario-Based Testing - Testing Architecture","doc":"```elixir\ndefmodule Pipeline.Test.Scenarios do\n  def setup_successful_workflow do\n    # Configure mocks for a complete successful workflow\n    Pipeline.Test.Mocks.ClaudeProvider.set_responses([\n      \"Create a Python hello world program\",\n      \"Add error handling to the program\", \n      \"Write unit tests for the program\"\n    ])\n  end\n  \n  def setup_failure_scenario do\n    # Configure mocks to simulate various failure modes\n    Pipeline.Test.Mocks.ClaudeProvider.set_error_on_turn(2, \"API rate limit exceeded\")\n  end\nend\n```","ref":"testing_architecture.html#3-scenario-based-testing"},{"type":"extras","title":"Test Organization - Testing Architecture","doc":"","ref":"testing_architecture.html#test-organization"},{"type":"extras","title":"Directory Structure - Testing Architecture","doc":"```\ntest/\n├── unit/                    # Fast, isolated tests with mocks\n│   ├── pipeline/\n│   │   ├── executor_test.exs\n│   │   ├── step/\n│   │   │   ├── claude_test.exs\n│   │   │   └── gemini_test.exs\n│   │   └── workflow_loader_test.exs\n│   └── support/\n├── integration/             # Cross-component tests\n│   ├── end_to_end_test.exs\n│   ├── workflow_execution_test.exs\n│   └── provider_integration_test.exs\n├── fixtures/                # Test data and configurations\n│   ├── workflows/\n│   │   ├── simple_workflow.yaml\n│   │   └── complex_workflow.yaml\n│   └── responses/\n│       ├── claude_responses.json\n│       └── gemini_responses.json\n└── support/                 # Test helpers and utilities\n    ├── test_case.exs\n    ├── factory.ex\n    └── mocks/\n        ├── claude_provider.ex\n        └── gemini_provider.ex\n```","ref":"testing_architecture.html#directory-structure"},{"type":"extras","title":"Test Categories - Testing Architecture","doc":"#### Unit Tests (Always Mocked)\n```elixir\ndefmodule Pipeline.ExecutorTest do\n  use Pipeline.Test.Case, mode: :mock\n  \n  test \"executes workflow steps in sequence\" do\n    workflow = build(:simple_workflow)\n    \n    assert {:ok, results} = Pipeline.Executor.execute(workflow)\n    assert length(results) == 3\n  end\nend\n```\n\n#### Integration Tests (Configurable)\n```elixir\ndefmodule Pipeline.WorkflowExecutionTest do\n  use Pipeline.Test.Case, mode: :configurable\n  \n  @tag :integration\n  test \"complete workflow execution\" do\n    workflow = load_fixture(\"workflows/simple_workflow.yaml\")\n    \n    assert {:ok, results} = Pipeline.Executor.execute(workflow)\n    assert results[\"final_step\"][\"success\"] == true\n  end\nend\n```\n\n#### Live Tests (Live Services Only)\n```elixir\ndefmodule Pipeline.LiveIntegrationTest do\n  use Pipeline.Test.Case, mode: :live\n  \n  @tag :live\n  @tag timeout: 30_000\n  test \"actual Claude API integration\" do\n    # Only runs with TEST_MODE=live or TEST_MODE=mixed\n    prompt = \"Write a simple hello world in Python\"\n    \n    assert {:ok, response} = Pipeline.Providers.ClaudeProvider.query(prompt, %{})\n    assert response.success == true\n    assert is_binary(response.text)\n  end\nend\n```","ref":"testing_architecture.html#test-categories"},{"type":"extras","title":"Mock Data Management - Testing Architecture","doc":"","ref":"testing_architecture.html#mock-data-management"},{"type":"extras","title":"Response Fixtures - Testing Architecture","doc":"```elixir\n# test/fixtures/responses/claude_responses.json\n{\n  \"simple_python_program\": {\n    \"text\": \"print('Hello, World!')\\n\\n# This is a simple Python program...\",\n    \"success\": true,\n    \"cost\": 0.0023\n  },\n  \"code_review\": {\n    \"text\": \"Code review feedback:\\n1. Consider adding type hints...\",\n    \"success\": true, \n    \"cost\": 0.0156\n  }\n}\n```","ref":"testing_architecture.html#response-fixtures"},{"type":"extras","title":"Factory Pattern - Testing Architecture","doc":"```elixir\ndefmodule Pipeline.Test.Factory do\n  def build(:workflow) do\n    %{\n      \"workflow\" => %{\n        \"name\" => \"test_workflow\",\n        \"steps\" => [\n          build(:claude_step),\n          build(:gemini_step)\n        ]\n      }\n    }\n  end\n  \n  def build(:claude_step) do\n    %{\n      \"name\" => \"claude_task\",\n      \"type\" => \"claude\",\n      \"prompt\" => [%{\"type\" => \"static\", \"content\" => \"Test prompt\"}]\n    }\n  end\nend\n```","ref":"testing_architecture.html#factory-pattern"},{"type":"extras","title":"Running Tests - Testing Architecture","doc":"","ref":"testing_architecture.html#running-tests"},{"type":"extras","title":"Command Examples - Testing Architecture","doc":"```bash\n# Unit tests only (fast, always mocked)\nmix test test/unit/\n\n# Integration tests with mocks\nTEST_MODE=mock mix test test/integration/\n\n# Integration tests with live services\nTEST_MODE=live mix test test/integration/ --include live\n\n# All tests with mixed mode\nTEST_MODE=mixed mix test\n\n# Specific test scenarios\nmix test --only integration\nmix test --only live\nmix test --exclude live  # Skip live tests\n```","ref":"testing_architecture.html#command-examples"},{"type":"extras","title":"Continuous Integration - Testing Architecture","doc":"```bash\n# CI pipeline uses mocks for speed and reliability\nTEST_MODE=mock mix test --coverage\n\n# Nightly build runs live tests\nTEST_MODE=live mix test --include live --timeout 300000\n```","ref":"testing_architecture.html#continuous-integration"},{"type":"extras","title":"Development Workflow - Testing Architecture","doc":"","ref":"testing_architecture.html#development-workflow"},{"type":"extras","title":"1. Writing New Features - Testing Architecture","doc":"1. Start with unit tests using mocks\n2. Implement the feature with provider interfaces\n3. Add integration tests that work with mocks\n4. Test with live services locally\n5. Update mock responses based on live behavior","ref":"testing_architecture.html#1-writing-new-features"},{"type":"extras","title":"2. Debugging Issues - Testing Architecture","doc":"1. Reproduce with mocks first (faster iteration)\n2. Compare mock vs live behavior\n3. Update mocks to match live service behavior\n4. Fix implementation based on findings","ref":"testing_architecture.html#2-debugging-issues"},{"type":"extras","title":"3. Adding New External Services - Testing Architecture","doc":"1. Define provider behavior/interface\n2. Create mock implementation\n3. Implement live provider\n4. Add configuration switching\n5. Write comprehensive tests for both","ref":"testing_architecture.html#3-adding-new-external-services"},{"type":"extras","title":"Quality Assurance - Testing Architecture","doc":"","ref":"testing_architecture.html#quality-assurance"},{"type":"extras","title":"Test Coverage Requirements - Testing Architecture","doc":"- **Unit Tests**: 95% line coverage minimum\n- **Integration Tests**: All critical paths covered\n- **Mock Accuracy**: Regular validation against live services","ref":"testing_architecture.html#test-coverage-requirements"},{"type":"extras","title":"Performance Benchmarks - Testing Architecture","doc":"```elixir\ndefmodule Pipeline.Test.Performance do\n  use ExUnit.Case\n  \n  @tag :benchmark\n  test \"workflow execution performance\" do\n    workflow = build(:complex_workflow)\n    \n    {time, _result} = :timer.tc(fn ->\n      Pipeline.Executor.execute(workflow)\n    end)\n    \n    # Workflow should complete within 5 seconds with mocks\n    assert time < 5_000_000  # microseconds\n  end\nend\n```","ref":"testing_architecture.html#performance-benchmarks"},{"type":"extras","title":"Mock Validation - Testing Architecture","doc":"```elixir\n# Periodically validate mocks against live services\ndefmodule Pipeline.Test.MockValidation do\n  @tag :validation\n  test \"mock responses match live service behavior\" do\n    test_cases = load_validation_cases()\n    \n    for test_case <- test_cases do\n      mock_response = MockProvider.query(test_case.prompt, test_case.options)\n      live_response = LiveProvider.query(test_case.prompt, test_case.options)\n      \n      assert_responses_equivalent(mock_response, live_response)\n    end\n  end\nend\n```","ref":"testing_architecture.html#mock-validation"},{"type":"extras","title":"Best Practices - Testing Architecture","doc":"","ref":"testing_architecture.html#best-practices"},{"type":"extras","title":"1. Mock Design - Testing Architecture","doc":"- **Deterministic**: Same input always produces same output\n- **Realistic**: Mirror real service behavior patterns\n- **Fast**: No network calls, minimal computation\n- **Comprehensive**: Cover error cases and edge conditions","ref":"testing_architecture.html#1-mock-design"},{"type":"extras","title":"2. Test Data - Testing Architecture","doc":"- **Version Controlled**: All fixtures in git\n- **Realistic**: Based on actual service responses\n- **Minimal**: Only include necessary data\n- **Documented**: Clear comments explaining test scenarios","ref":"testing_architecture.html#2-test-data"},{"type":"extras","title":"3. Configuration - Testing Architecture","doc":"- **Environment Driven**: Use env vars for mode selection\n- **Default Safe**: Default to mocks for safety\n- **Override Capable**: Easy to switch modes for debugging\n- **CI Friendly**: Reliable in automated environments\n\nThis testing architecture provides a robust foundation for developing and maintaining the pipeline orchestration system with confidence in both mocked and live environments.","ref":"testing_architecture.html#3-configuration"},{"type":"extras","title":"YAML Format v2","doc":"# Pipeline YAML Format v2 - Documentation Index","ref":"index.html"},{"type":"extras","title":"📚 Complete Documentation Suite - YAML Format v2","doc":"Welcome to the comprehensive Pipeline YAML Format v2 documentation. This suite provides everything you need to understand and use the full capabilities of the pipeline system.","ref":"index.html#complete-documentation-suite"},{"type":"extras","title":"🚀 Quick Start - YAML Format v2","doc":"- **Quick Reference Card** - One-page summary of all features (see `docs/20250704_yaml_format_v2/10_quick_reference.md`)\n- **Migration Guide** - Upgrade from v1 to v2 (see `docs/20250704_yaml_format_v2/09_migration_guide.md`)","ref":"index.html#quick-start"},{"type":"extras","title":"📖 Core Documentation - YAML Format v2","doc":"1. **[Complete YAML Schema Reference](01_complete_schema_reference.md)**\n   - Full schema definition with all fields and types\n   - Validation rules and constraints\n   - Configuration precedence\n\n2. **[Step Types Reference](02_step_types_reference.md)**\n   - All 17+ step types with examples\n   - AI provider steps (Gemini, Claude variants)\n   - Control flow steps (loops, conditions, pipelines)\n   - Data and file operations\n\n3. **[Prompt System Reference](03_prompt_system_reference.md)**\n   - Prompt composition and templates\n   - File-based prompt management\n   - Content processing and extraction\n   - Variable substitution\n\n4. **[Control Flow & Logic](04_control_flow_logic.md)**\n   - Conditional execution\n   - Loop constructs (for, while)\n   - Branching logic (switch/case)\n   - State management\n\n5. **[Pipeline Composition](05_pipeline_composition.md)**\n   - Recursive pipeline execution\n   - Input/output mapping\n   - Context management\n   - Safety features\n\n6. **[Advanced Features](06_advanced_features.md)**\n   - Data transformation (JSONPath)\n   - Codebase intelligence\n   - File operations\n   - Schema validation\n   - Session management\n\n7. **Configuration & Environment** (see `docs/20250704_yaml_format_v2/07_configuration_environment.md`)\n   - Workflow configuration\n   - Authentication setup\n   - Resource management\n   - Monitoring and telemetry\n\n8. **[Best Practices & Patterns](08_best_practices_patterns.md)**\n   - Design principles\n   - Common patterns\n   - Error handling strategies\n   - Performance optimization\n   - Security guidelines","ref":"index.html#core-documentation"},{"type":"extras","title":"🎯 Feature Highlights - YAML Format v2","doc":"#### New in v2\n\n- **Pipeline Composition**: Build complex workflows from reusable components\n- **Enhanced Claude Steps**: Smart presets, sessions, extraction, batch processing\n- **Advanced Control Flow**: Loops, conditions, parallel execution\n- **Data Operations**: Transform, query, and manipulate data\n- **Enterprise Features**: Authentication, monitoring, resource limits\n\n#### Key Capabilities\n\n- ✅ 17+ step types for every use case\n- ✅ Modular pipeline composition\n- ✅ Sophisticated error handling\n- ✅ Performance optimization\n- ✅ Enterprise-grade safety\n- ✅ Full backward compatibility","ref":"index.html#feature-highlights"},{"type":"extras","title":"📊 Format Evolution - YAML Format v2","doc":"| Version | Release | Key Features |\n|---------|---------|--------------|\n| v1.0 | 2024 | Basic Gemini/Claude orchestration |\n| v1.5 | 2024 | Advanced features (loops, conditions) |\n| v2.0 | 2025 | Recursive pipelines, enhanced Claude SDK |","ref":"index.html#format-evolution"},{"type":"extras","title":"🔍 Finding Information - YAML Format v2","doc":"#### By Use Case\n\n- **Building a new pipeline**: Start with [Schema Reference](01_complete_schema_reference.md)\n- **Using AI providers**: See [Step Types](02_step_types_reference.md)\n- **Managing prompts**: Check [Prompt System](03_prompt_system_reference.md)\n- **Adding logic**: Review [Control Flow](04_control_flow_logic.md)\n- **Creating components**: Study [Pipeline Composition](05_pipeline_composition.md)\n\n#### By Experience Level\n\n- **Beginners**: [Quick Reference](10_quick_reference.md) → [Best Practices](08_best_practices_patterns.md)\n- **Intermediate**: [Step Types](02_step_types_reference.md) → [Advanced Features](06_advanced_features.md)\n- **Advanced**: [Pipeline Composition](05_pipeline_composition.md) → Configuration (see `docs/20250704_yaml_format_v2/07_configuration_environment.md`)","ref":"index.html#finding-information"},{"type":"extras","title":"💡 Tips for Success - YAML Format v2","doc":"1. **Start Simple**: Begin with basic pipelines and gradually add features\n2. **Use Composition**: Build reusable components instead of monolithic pipelines\n3. **Test Thoroughly**: Use mock mode for development and testing\n4. **Follow Patterns**: Apply proven patterns from the best practices guide\n5. **Monitor Performance**: Enable telemetry and resource tracking","ref":"index.html#tips-for-success"},{"type":"extras","title":"🛠️ Tools and Commands - YAML Format v2","doc":"```bash\n# Validate pipeline syntax\nmix pipeline.validate my_pipeline.yaml\n\n# Run in mock mode (free, no API calls)\nmix pipeline.run my_pipeline.yaml\n\n# Run with real APIs\nmix pipeline.run.live my_pipeline.yaml\n\n# Check v2 feature usage\nmix pipeline.analyze my_pipeline.yaml --check-v2-features\n```","ref":"index.html#tools-and-commands"},{"type":"extras","title":"📝 Documentation Maintenance - YAML Format v2","doc":"- **Created**: July 4, 2025\n- **Format Version**: 2.0\n- **Documentation Version**: 1.0\n- **Status**: Complete and production-ready","ref":"index.html#documentation-maintenance"},{"type":"extras","title":"🤝 Contributing - YAML Format v2","doc":"To improve this documentation:\n1. Identify gaps or unclear sections\n2. Provide examples from real usage\n3. Submit corrections or clarifications\n4. Share patterns that work well\n\n---\n\n**Remember**: The pipeline system is designed for gradual adoption. You don't need to use every feature immediately. Start with what you need and expand as your requirements grow.","ref":"index.html#contributing"},{"type":"extras","title":"Schema Reference","doc":"# Complete YAML Schema Reference","ref":"01_complete_schema_reference.html"},{"type":"extras","title":"Table of Contents - Schema Reference","doc":"1. [Root Structure](#root-structure)\n2. [Workflow Configuration](#workflow-configuration)\n3. [Defaults Section](#defaults-section)\n4. [Steps Section](#steps-section)\n5. [Step Types Schema](#step-types-schema)\n6. [Prompt Configuration](#prompt-configuration)\n7. [Advanced Configuration](#advanced-configuration)\n8. [Complete Schema Definition](#complete-schema-definition)","ref":"01_complete_schema_reference.html#table-of-contents"},{"type":"extras","title":"Root Structure - Schema Reference","doc":"Every pipeline configuration file must have a single root key `workflow`:\n\n```yaml\nworkflow:\n  # All configuration goes here\n```","ref":"01_complete_schema_reference.html#root-structure"},{"type":"extras","title":"Workflow Configuration - Schema Reference","doc":"","ref":"01_complete_schema_reference.html#workflow-configuration"},{"type":"extras","title":"Required Fields - Schema Reference","doc":"```yaml\nworkflow:\n  name: string                    # Unique identifier for the workflow\n  steps: array                    # List of workflow steps (at least one required)\n```","ref":"01_complete_schema_reference.html#required-fields"},{"type":"extras","title":"Optional Fields - Schema Reference","doc":"```yaml\nworkflow:\n  description: string             # Human-readable description\n  version: string                 # Workflow version (e.g., \"2.0\")\n  \n  # Execution settings\n  checkpoint_enabled: boolean     # Enable state saving (default: false)\n  workspace_dir: string           # Claude's sandbox directory (default: \"./workspace\")\n  checkpoint_dir: string          # Checkpoint storage (default: \"./checkpoints\")\n  output_dir: string              # Output directory (default: \"./outputs/{workflow_name}\")\n  \n  # Authentication & environment\n  claude_auth:                    # Claude authentication configuration\n    auto_check: boolean           # Verify auth before starting\n    provider: enum                # \"anthropic\", \"aws_bedrock\", \"google_vertex\"\n    fallback_mock: boolean        # Use mocks if auth fails in dev\n    diagnostics: boolean          # Run auth diagnostics\n  \n  environment:                    # Environment configuration\n    mode: enum                    # \"development\", \"production\", \"test\"\n    debug_level: enum             # \"basic\", \"detailed\", \"performance\"\n    cost_alerts:\n      enabled: boolean\n      threshold_usd: float\n      notify_on_exceed: boolean\n  \n  # Default settings\n  defaults: object                # Default values for all steps\n  \n  # Function definitions\n  gemini_functions: object        # Gemini function calling definitions\n  \n  # Resource limits\n  resource_limits:\n    max_total_steps: integer      # Maximum steps across all pipelines\n    max_memory_mb: integer        # Memory limit in MB\n    max_execution_time_s: integer # Total execution time limit\n```","ref":"01_complete_schema_reference.html#optional-fields"},{"type":"extras","title":"Defaults Section - Schema Reference","doc":"Sets default values inherited by all steps unless overridden:\n\n```yaml\ndefaults:\n  # Model configuration\n  gemini_model: string            # Default Gemini model\n  claude_preset: enum             # Default Claude preset\n  \n  # Token configuration\n  gemini_token_budget:\n    max_output_tokens: integer    # 256-8192\n    temperature: float            # 0.0-1.0\n    top_p: float                  # 0.0-1.0\n    top_k: integer                # 1-40\n  \n  # Output configuration\n  claude_output_format: enum      # \"json\", \"text\", \"stream-json\"\n  output_dir: string              # Default output directory\n  \n  # Execution settings\n  timeout_seconds: integer        # Default step timeout\n  retry_on_error: boolean         # Auto-retry failed steps\n  continue_on_error: boolean      # Continue workflow on step failure\n```","ref":"01_complete_schema_reference.html#defaults-section"},{"type":"extras","title":"Steps Section - Schema Reference","doc":"Array of step definitions that form the workflow:\n\n```yaml\nsteps:\n  - name: string                  # Unique step identifier (required)\n    type: string                  # Step type (required)\n    description: string           # Step description (optional)\n    \n    # Conditional execution\n    condition: string | object    # Skip step based on condition\n    \n    # Output handling\n    output_to_file: string        # Save output to file\n    output_schema: object         # Validate output structure\n    \n    # Step-specific configuration\n    # ... varies by step type\n```","ref":"01_complete_schema_reference.html#steps-section"},{"type":"extras","title":"Step Types Schema - Schema Reference","doc":"","ref":"01_complete_schema_reference.html#step-types-schema"},{"type":"extras","title":"AI Provider Steps - Schema Reference","doc":"#### 1. Gemini Step (`type: \"gemini\"`)\n\n```yaml\n- name: string\n  type: \"gemini\"\n  role: enum[\"brain\", \"muscle\"]  # Semantic role (optional)\n  \n  # Model configuration\n  model: string                   # Override default model\n  token_budget:\n    max_output_tokens: integer\n    temperature: float\n    top_p: float\n    top_k: integer\n  \n  # Function calling\n  functions: array[string]        # Function names to enable\n  \n  # Prompt configuration\n  prompt: array                   # Required (see Prompt Configuration)\n  \n  # Output\n  output_to_file: string\n  output_schema: object           # JSON Schema for validation\n```\n\n#### 2. Claude Step (`type: \"claude\"`)\n\n```yaml\n- name: string\n  type: \"claude\"\n  role: enum[\"brain\", \"muscle\"]\n  \n  claude_options:\n    # Core settings\n    max_turns: integer            # Conversation limit\n    output_format: enum           # \"text\", \"json\", \"stream_json\"\n    verbose: boolean              # Detailed logging\n    \n    # Tool management\n    allowed_tools: array[string]  # Permitted tools\n    disallowed_tools: array[string]\n    \n    # System prompts\n    system_prompt: string         # Override system prompt\n    append_system_prompt: string  # Additional instructions\n    \n    # Working directory\n    cwd: string                   # Working directory path\n    \n    # Advanced options\n    session_id: string            # Session continuation\n    resume_session: boolean       # Auto-resume if exists\n    debug_mode: boolean\n    telemetry_enabled: boolean\n    cost_tracking: boolean\n    \n    # Retry configuration\n    retry_config:\n      max_retries: integer\n      backoff_strategy: enum      # \"linear\", \"exponential\"\n      retry_on: array[string]     # Error conditions\n    \n    # Timeout\n    timeout_ms: integer\n  \n  prompt: array                   # Required\n  output_to_file: string\n```\n\n#### 3. Enhanced Claude Steps\n\n##### Claude Smart (`type: \"claude_smart\"`)\n\n```yaml\n- name: string\n  type: \"claude_smart\"\n  preset: enum                    # \"development\", \"production\", \"analysis\", \"chat\"\n  environment_aware: boolean      # Auto-detect from Mix env\n  \n  # Inherits all claude_options\n  claude_options: object          # Optional overrides\n  prompt: array                   # Required\n```\n\n##### Claude Session (`type: \"claude_session\"`)\n\n```yaml\n- name: string\n  type: \"claude_session\"\n  \n  session_config:\n    session_name: string          # Session identifier\n    persist: boolean              # Save session state\n    continue_on_restart: boolean  # Resume after failure\n    checkpoint_frequency: integer # Save every N turns\n    max_turns: integer            # Session turn limit\n    description: string           # Session description\n  \n  claude_options: object          # Standard Claude options\n  prompt: array                   # Required\n```\n\n##### Claude Extract (`type: \"claude_extract\"`)\n\n```yaml\n- name: string\n  type: \"claude_extract\"\n  preset: enum                    # Claude preset\n  \n  extraction_config:\n    use_content_extractor: boolean\n    format: enum                  # \"text\", \"json\", \"structured\", \"summary\", \"markdown\"\n    post_processing: array[string] # Processing steps\n    max_summary_length: integer\n    include_metadata: boolean\n  \n  claude_options: object\n  prompt: array\n```\n\n##### Claude Batch (`type: \"claude_batch\"`)\n\n```yaml\n- name: string\n  type: \"claude_batch\"\n  \n  batch_config:\n    max_parallel: integer         # Concurrent executions\n    timeout_per_task: integer     # Per-task timeout\n    consolidate_results: boolean  # Merge all results\n  \n  tasks: array\n    - id: string                  # Task identifier\n      prompt: array               # Task-specific prompt\n      output_to_file: string      # Task output file\n      claude_options: object      # Task-specific options\n```\n\n##### Claude Robust (`type: \"claude_robust\"`)\n\n```yaml\n- name: string\n  type: \"claude_robust\"\n  \n  retry_config:\n    max_retries: integer\n    backoff_strategy: enum\n    retry_conditions: array[string]\n    fallback_action: string       # Action on final failure\n  \n  claude_options: object\n  prompt: array\n```\n\n#### 4. Parallel Claude (`type: \"parallel_claude\"`)\n\n```yaml\n- name: string\n  type: \"parallel_claude\"\n  \n  parallel_tasks: array           # Required\n    - id: string                  # Task identifier\n      claude_options: object      # Task Claude settings\n      prompt: array               # Task prompt\n      output_to_file: string      # Task output\n      condition: string           # Optional task condition\n```\n\n#### 5. Gemini Instructor (`type: \"gemini_instructor\"`)\n\n```yaml\n- name: string\n  type: \"gemini_instructor\"\n  \n  model: string                   # Gemini model\n  schema: object                  # Output structure schema\n  validation_mode: enum           # \"strict\", \"loose\"\n  \n  prompt: array\n  output_to_file: string\n```","ref":"01_complete_schema_reference.html#ai-provider-steps"},{"type":"extras","title":"Control Flow Steps - Schema Reference","doc":"#### 6. Pipeline Step (`type: \"pipeline\"`)\n\n```yaml\n- name: string\n  type: \"pipeline\"\n  \n  # Pipeline source (one required)\n  pipeline_file: string           # External file path\n  pipeline_ref: string            # Registry reference (future)\n  pipeline: object                # Inline pipeline definition\n  \n  # Input mapping\n  inputs: object                  # Variables to pass\n  \n  # Output extraction\n  outputs: array\n    - string                      # Simple extraction\n    - path: string                # Path-based extraction\n      as: string                  # Output variable name\n  \n  # Execution configuration\n  config:\n    inherit_context: boolean      # Inherit parent context\n    inherit_providers: boolean    # Inherit provider configs\n    inherit_functions: boolean    # Inherit function defs\n    workspace_dir: string         # Nested workspace\n    checkpoint_enabled: boolean\n    timeout_seconds: integer\n    max_retries: integer\n    continue_on_error: boolean\n    max_depth: integer            # Nesting limit\n    memory_limit_mb: integer\n    enable_tracing: boolean\n```\n\n#### 7. For Loop (`type: \"for_loop\"`)\n\n```yaml\n- name: string\n  type: \"for_loop\"\n  \n  # Iterator configuration\n  iterator: string                # Loop variable name\n  data_source: string | array     # Data to iterate over\n  \n  # Execution settings\n  parallel: boolean               # Parallel execution\n  max_parallel: integer           # Concurrent limit\n  break_on_error: boolean         # Stop on first error\n  \n  # Loop body\n  steps: array                    # Steps to execute\n```\n\n#### 8. While Loop (`type: \"while_loop\"`)\n\n```yaml\n- name: string\n  type: \"while_loop\"\n  \n  # Condition\n  condition: string | object      # Loop condition\n  \n  # Safety limits\n  max_iterations: integer         # Maximum iterations\n  timeout_seconds: integer        # Total timeout\n  \n  # Loop body\n  steps: array                    # Steps to execute\n```\n\n#### 9. Switch/Case (`type: \"switch\"`)\n\n```yaml\n- name: string\n  type: \"switch\"\n  \n  expression: string              # Value to switch on\n  \n  cases: object                   # Case mappings\n    \"value1\": array[steps]\n    \"value2\": array[steps]\n  \n  default: array[steps]           # Default case\n```","ref":"01_complete_schema_reference.html#control-flow-steps"},{"type":"extras","title":"Data & File Operations - Schema Reference","doc":"#### 10. Data Transform (`type: \"data_transform\"`)\n\n```yaml\n- name: string\n  type: \"data_transform\"\n  \n  input_source: string            # Data source\n  \n  operations: array\n    - operation: enum             # \"filter\", \"map\", \"aggregate\", \"join\", \"group_by\", \"sort\"\n      field: string               # Target field\n      condition: string           # For filter\n      expression: string          # For map/transform\n      function: string            # For aggregate\n      join_key: string            # For join\n      order: enum                 # For sort: \"asc\", \"desc\"\n  \n  output_field: string            # Result variable\n  output_to_file: string\n```\n\n#### 11. File Operations (`type: \"file_ops\"`)\n\n```yaml\n- name: string\n  type: \"file_ops\"\n  \n  operation: enum                 # \"copy\", \"move\", \"delete\", \"validate\", \"list\", \"convert\"\n  \n  # For copy/move\n  source: string | array\n  destination: string\n  \n  # For validate\n  files: array\n    - path: string\n      must_exist: boolean\n      must_be_dir: boolean\n      min_size: integer\n      max_size: integer\n  \n  # For convert\n  format: enum                    # \"csv_to_json\", \"json_to_csv\", \"yaml_to_json\", etc.\n  \n  # For list\n  pattern: string                 # Glob pattern\n  recursive: boolean\n```\n\n#### 12. Codebase Query (`type: \"codebase_query\"`)\n\n```yaml\n- name: string\n  type: \"codebase_query\"\n  \n  codebase_context: boolean       # Include project info\n  \n  queries: object\n    query_name:\n      # File queries\n      find_files:\n        - type: enum              # \"source\", \"test\", \"config\", \"main\"\n        - pattern: string         # Glob pattern\n        - exclude_tests: boolean\n        - modified_since: string  # Date/time\n        - related_to: string      # File reference\n      \n      # Code queries\n      find_functions:\n        - in_file: string\n        - public_only: boolean\n        - with_annotation: string\n      \n      # Dependency queries\n      find_dependencies:\n        - for_file: string\n        - include_transitive: boolean\n      \n      find_dependents:\n        - of_file: string\n        - include_tests: boolean\n  \n  output_to_file: string\n```","ref":"01_complete_schema_reference.html#data-file-operations"},{"type":"extras","title":"State Management - Schema Reference","doc":"#### 13. Set Variable (`type: \"set_variable\"`)\n\n```yaml\n- name: string\n  type: \"set_variable\"\n  \n  variables: object               # Variable assignments\n    var_name: value               # Static value\n    computed: \"{{expression}}\"    # Computed value\n  \n  scope: enum                     # \"global\", \"local\", \"session\"\n```\n\n#### 14. Checkpoint (`type: \"checkpoint\"`)\n\n```yaml\n- name: string\n  type: \"checkpoint\"\n  \n  state: object                   # State to save\n  \n  checkpoint_name: string         # Custom name\n  include_workspace: boolean      # Save workspace files\n  compress: boolean               # Compress checkpoint\n```","ref":"01_complete_schema_reference.html#state-management"},{"type":"extras","title":"Prompt Configuration - Schema Reference","doc":"All AI steps require prompt configuration:\n\n```yaml\nprompt: array\n  # Static content\n  - type: \"static\"\n    content: string               # Inline text\n  \n  # File content\n  - type: \"file\"\n    path: string                  # File path\n    variables: object             # Template variables\n    inject_as: string             # Variable name\n    encoding: string              # File encoding\n  \n  # Previous response\n  - type: \"previous_response\"\n    step: string                  # Step name\n    extract: string               # JSON path\n    extract_with: enum            # \"content_extractor\"\n    summary: boolean              # Summarize content\n    max_length: integer           # Length limit\n  \n  # Session context\n  - type: \"session_context\"\n    session_id: string            # Session ID\n    include_last_n: integer       # Message count\n  \n  # Claude continue\n  - type: \"claude_continue\"\n    new_prompt: string            # Continuation prompt\n```","ref":"01_complete_schema_reference.html#prompt-configuration"},{"type":"extras","title":"Advanced Configuration - Schema Reference","doc":"","ref":"01_complete_schema_reference.html#advanced-configuration"},{"type":"extras","title":"Condition Syntax - Schema Reference","doc":"```yaml\n# Simple conditions\ncondition: \"steps.analyze.score > 7\"\n\n# Boolean expressions\ncondition:\n  and:\n    - \"steps.test.passed == true\"\n    - or:\n      - \"steps.analyze.score > 8\"\n      - \"steps.review.approved == true\"\n    - not: \"steps.validate.errors > 0\"\n\n# Operators\n# Comparison: ==, !=, >, <, >=, <=\n# String: contains, matches, starts_with, ends_with\n# Array: in, not_in, any, all\n# Special: between, exists, empty\n```","ref":"01_complete_schema_reference.html#condition-syntax"},{"type":"extras","title":"Function Definitions - Schema Reference","doc":"```yaml\ngemini_functions:\n  function_name:\n    description: string\n    parameters:\n      type: object\n      properties:\n        param1:\n          type: string\n          description: string\n          enum: array             # Optional values\n        param2:\n          type: integer\n          minimum: integer\n          maximum: integer\n      required: array[string]\n```","ref":"01_complete_schema_reference.html#function-definitions"},{"type":"extras","title":"Output Schema Validation - Schema Reference","doc":"```yaml\noutput_schema:\n  type: object\n  required: array[string]\n  properties:\n    field_name:\n      type: enum                  # \"string\", \"number\", \"boolean\", \"object\", \"array\"\n      description: string\n      # Type-specific constraints\n      minLength: integer          # For strings\n      maxLength: integer\n      pattern: string             # Regex\n      minimum: number             # For numbers\n      maximum: number\n      items: object               # For arrays\n      properties: object          # For objects\n```","ref":"01_complete_schema_reference.html#output-schema-validation"},{"type":"extras","title":"Complete Schema Definition - Schema Reference","doc":"```yaml\nworkflow:\n  # Required\n  name: string\n  steps: array[Step]\n  \n  # Optional\n  description: string\n  version: string\n  checkpoint_enabled: boolean\n  workspace_dir: string\n  checkpoint_dir: string\n  output_dir: string\n  \n  # Authentication\n  claude_auth:\n    auto_check: boolean\n    provider: enum[\"anthropic\", \"aws_bedrock\", \"google_vertex\"]\n    fallback_mock: boolean\n    diagnostics: boolean\n  \n  # Environment\n  environment:\n    mode: enum[\"development\", \"production\", \"test\"]\n    debug_level: enum[\"basic\", \"detailed\", \"performance\"]\n    cost_alerts:\n      enabled: boolean\n      threshold_usd: float\n      notify_on_exceed: boolean\n  \n  # Defaults\n  defaults:\n    gemini_model: string\n    gemini_token_budget: TokenBudget\n    claude_output_format: enum[\"json\", \"text\", \"stream-json\"]\n    claude_preset: enum[\"development\", \"production\", \"analysis\", \"chat\"]\n    output_dir: string\n    timeout_seconds: integer\n    retry_on_error: boolean\n    continue_on_error: boolean\n  \n  # Functions\n  gemini_functions: map[string, FunctionDefinition]\n  \n  # Resource limits\n  resource_limits:\n    max_total_steps: integer\n    max_memory_mb: integer\n    max_execution_time_s: integer\n```\n\nThis schema reference provides the complete structure for Pipeline YAML v2 format, including all fields, types, and validation rules.","ref":"01_complete_schema_reference.html#complete-schema-definition"},{"type":"extras","title":"Step Types","doc":"# Step Types Reference","ref":"02_step_types_reference.html"},{"type":"extras","title":"Table of Contents - Step Types","doc":"1. [Overview](#overview)\n2. [AI Provider Steps](#ai-provider-steps)\n   - [Gemini](#gemini)\n   - [Claude](#claude)\n   - [Claude Smart](#claude-smart)\n   - [Claude Session](#claude-session)\n   - [Claude Extract](#claude-extract)\n   - [Claude Batch](#claude-batch)\n   - [Claude Robust](#claude-robust)\n   - [Parallel Claude](#parallel-claude)\n   - [Gemini Instructor](#gemini-instructor)\n3. [Control Flow Steps](#control-flow-steps)\n   - [Pipeline](#pipeline)\n   - [For Loop](#for-loop)\n   - [While Loop](#while-loop)\n   - [Switch/Case](#switchcase)\n4. [Data & File Operations](#data--file-operations)\n   - [Data Transform](#data-transform)\n   - [File Operations](#file-operations)\n   - [Codebase Query](#codebase-query)\n5. [State Management](#state-management)\n   - [Set Variable](#set-variable)\n   - [Checkpoint](#checkpoint)","ref":"02_step_types_reference.html#table-of-contents"},{"type":"extras","title":"Overview - Step Types","doc":"Pipeline supports 17+ distinct step types organized into four categories:\n\n1. **AI Provider Steps**: Interact with Claude and Gemini APIs\n2. **Control Flow Steps**: Manage execution flow and pipeline composition\n3. **Data & File Operations**: Transform data and manipulate files\n4. **State Management**: Manage variables and checkpoints","ref":"02_step_types_reference.html#overview"},{"type":"extras","title":"AI Provider Steps - Step Types","doc":"","ref":"02_step_types_reference.html#ai-provider-steps"},{"type":"extras","title":"Gemini - Step Types","doc":"**Type**: `gemini`  \n**Purpose**: Use Google's Gemini models for analysis, planning, and decision-making\n\n```yaml\n- name: \"analyze_requirements\"\n  type: \"gemini\"\n  role: \"brain\"                   # Semantic role indicator\n  model: \"gemini-2.5-flash\"       # Model selection\n  \n  # Token configuration\n  token_budget:\n    max_output_tokens: 4096\n    temperature: 0.7              # Creativity level (0-1)\n    top_p: 0.95                   # Nucleus sampling\n    top_k: 40                     # Top-k sampling\n  \n  # Function calling\n  functions:\n    - \"evaluate_code_quality\"\n    - \"generate_test_cases\"\n  \n  # Prompt\n  prompt:\n    - type: \"static\"\n      content: \"Analyze these requirements and create a plan\"\n    - type: \"file\"\n      path: \"requirements.md\"\n  \n  # Output\n  output_to_file: \"analysis_plan.json\"\n  output_schema:\n    type: \"object\"\n    required: [\"plan\", \"risks\", \"timeline\"]\n```\n\n**Key Features**:\n- Multiple model options (flash, pro, etc.)\n- Function calling support\n- Structured output with schema validation\n- Fine-tuned token control\n\n**Common Use Cases**:\n- Requirements analysis\n- Architecture planning\n- Code review and quality assessment\n- Test generation\n- Decision making","ref":"02_step_types_reference.html#gemini"},{"type":"extras","title":"Claude - Step Types","doc":"**Type**: `claude`  \n**Purpose**: Use Anthropic's Claude for code execution, file manipulation, and implementation tasks\n\n```yaml\n- name: \"implement_feature\"\n  type: \"claude\"\n  role: \"muscle\"                  # Execution role\n  \n  claude_options:\n    # Core settings\n    max_turns: 20                 # Conversation turns limit\n    output_format: \"json\"         # Response format\n    verbose: true                 # Detailed logging\n    \n    # Tool permissions\n    allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\", \"Search\"]\n    disallowed_tools: [\"Delete\"]  # Explicitly forbidden\n    \n    # System prompts\n    system_prompt: \"You are an expert Python developer\"\n    append_system_prompt: \"Follow PEP 8 strictly\"\n    \n    # Working environment\n    cwd: \"./workspace/backend\"    # Working directory\n    \n    # Advanced options\n    session_id: \"feature_dev_001\" # For session continuation\n    resume_session: true          # Resume if exists\n    debug_mode: true\n    telemetry_enabled: true\n    cost_tracking: true\n  \n  prompt:\n    - type: \"static\"\n      content: \"Implement the user authentication feature\"\n    - type: \"previous_response\"\n      step: \"analyze_requirements\"\n      extract: \"implementation_plan\"\n  \n  output_to_file: \"implementation_result.json\"\n```\n\n**Available Tools**:\n- `Write`: Create new files\n- `Edit`: Modify existing files\n- `Read`: Read file contents\n- `Bash`: Execute shell commands\n- `Search`: Search across files\n- `Glob`: Find files by pattern\n- `Grep`: Search file contents\n\n**Key Features**:\n- Full file system access within workspace\n- Shell command execution\n- Session management for continuity\n- Comprehensive error handling\n- Cost tracking and telemetry","ref":"02_step_types_reference.html#claude"},{"type":"extras","title":"Claude Smart - Step Types","doc":"**Type**: `claude_smart`  \n**Purpose**: Intelligent preset-based Claude configuration with environment awareness\n\n```yaml\n- name: \"smart_analysis\"\n  type: \"claude_smart\"\n  preset: \"analysis\"              # Preset configuration\n  environment_aware: true         # Auto-detect from Mix.env\n  \n  # Optional overrides\n  claude_options:\n    max_turns: 10                 # Override preset default\n  \n  prompt:\n    - type: \"file\"\n      path: \"pipelines/prompts/analysis/security_audit.md\"\n    - type: \"file\"\n      path: \"src/main.ex\"\n  \n  output_to_file: \"security_analysis.json\"\n```\n\n**Available Presets**:\n- `development`: Permissive settings, full tool access, verbose logging\n- `production`: Restricted tools, optimized for safety and performance\n- `analysis`: Read-only tools, optimized for code analysis\n- `chat`: Simple conversation mode, basic tools\n\n**Key Features**:\n- Automatic configuration based on environment\n- Preset-specific optimizations\n- Simplified configuration\n- Intelligent defaults","ref":"02_step_types_reference.html#claude-smart"},{"type":"extras","title":"Claude Session - Step Types","doc":"**Type**: `claude_session`  \n**Purpose**: Maintain stateful conversations across multiple interactions\n\n```yaml\n- name: \"tutoring_session\"\n  type: \"claude_session\"\n  \n  session_config:\n    session_name: \"elixir_tutorial\"\n    persist: true                 # Save session state\n    continue_on_restart: true     # Resume after failures\n    checkpoint_frequency: 5       # Save every 5 turns\n    max_turns: 100               # Extended conversation\n    description: \"Interactive Elixir tutoring session\"\n  \n  claude_options:\n    allowed_tools: [\"Write\", \"Read\", \"Bash\"]\n    output_format: \"text\"\n  \n  prompt:\n    - type: \"static\"\n      content: \"Let's continue our Elixir tutorial\"\n    - type: \"session_context\"\n      session_id: \"elixir_tutorial\"\n      include_last_n: 10          # Include last 10 messages\n  \n  output_to_file: \"session_transcript.md\"\n```\n\n**Key Features**:\n- Conversation state persistence\n- Automatic checkpointing\n- Session recovery after failures\n- Context window management\n- Multi-turn conversations\n\n**Use Cases**:\n- Interactive tutorials\n- Long-running development tasks\n- Iterative refinement processes\n- Conversational workflows","ref":"02_step_types_reference.html#claude-session"},{"type":"extras","title":"Claude Extract - Step Types","doc":"**Type**: `claude_extract`  \n**Purpose**: Advanced content extraction and post-processing\n\n```yaml\n- name: \"extract_insights\"\n  type: \"claude_extract\"\n  preset: \"analysis\"\n  \n  extraction_config:\n    use_content_extractor: true\n    format: \"structured\"          # Output format\n    post_processing:\n      - \"extract_code_blocks\"\n      - \"extract_recommendations\"\n      - \"extract_key_points\"\n      - \"extract_links\"\n    max_summary_length: 2000\n    include_metadata: true\n  \n  claude_options:\n    max_turns: 5\n    allowed_tools: [\"Read\"]\n  \n  prompt:\n    - type: \"static\"\n      content: \"Analyze this codebase and extract key insights\"\n    - type: \"file\"\n      path: \"src/\"\n  \n  output_to_file: \"extracted_insights.json\"\n```\n\n**Format Options**:\n- `text`: Plain text extraction\n- `json`: Structured JSON output\n- `structured`: Organized sections\n- `summary`: Condensed summary\n- `markdown`: Formatted markdown\n\n**Post-Processing Options**:\n- `extract_code_blocks`: Extract code snippets\n- `extract_recommendations`: Pull out suggestions\n- `extract_key_points`: Identify main points\n- `extract_links`: Extract URLs and references\n- `extract_entities`: Named entity extraction","ref":"02_step_types_reference.html#claude-extract"},{"type":"extras","title":"Claude Batch - Step Types","doc":"**Type**: `claude_batch`  \n**Purpose**: Process multiple tasks in parallel\n\n```yaml\n- name: \"batch_code_review\"\n  type: \"claude_batch\"\n  \n  batch_config:\n    max_parallel: 3               # Concurrent executions\n    timeout_per_task: 300         # 5 minutes per task\n    consolidate_results: true     # Merge all results\n  \n  tasks:\n    - id: \"review_backend\"\n      prompt:\n        - type: \"static\"\n          content: \"Review the backend code\"\n        - type: \"file\"\n          path: \"backend/src/\"\n      output_to_file: \"backend_review.json\"\n      \n    - id: \"review_frontend\"\n      prompt:\n        - type: \"static\"\n          content: \"Review the frontend code\"\n        - type: \"file\"\n          path: \"frontend/src/\"\n      output_to_file: \"frontend_review.json\"\n      \n    - id: \"review_tests\"\n      prompt:\n        - type: \"static\"\n          content: \"Review test coverage and quality\"\n        - type: \"file\"\n          path: \"test/\"\n      output_to_file: \"test_review.json\"\n```\n\n**Key Features**:\n- Parallel task execution\n- Independent task configuration\n- Result consolidation\n- Load balancing\n- Per-task timeouts","ref":"02_step_types_reference.html#claude-batch"},{"type":"extras","title":"Claude Robust - Step Types","doc":"**Type**: `claude_robust`  \n**Purpose**: Enterprise-grade error handling and retry logic\n\n```yaml\n- name: \"critical_deployment\"\n  type: \"claude_robust\"\n  \n  retry_config:\n    max_retries: 5\n    backoff_strategy: \"exponential\" # Exponential backoff\n    retry_conditions:\n      - \"timeout\"\n      - \"rate_limit\"\n      - \"api_error\"\n    fallback_action: \"simplified_prompt\"\n  \n  claude_options:\n    max_turns: 30\n    allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\"]\n    timeout_ms: 60000             # 1 minute timeout\n  \n  prompt:\n    - type: \"file\"\n      path: \"pipelines/prompts/deployment/production_deploy.md\"\n    - type: \"previous_response\"\n      step: \"deployment_plan\"\n  \n  output_to_file: \"deployment_result.json\"\n```\n\n**Retry Strategies**:\n- `linear`: Fixed delay between retries\n- `exponential`: Exponentially increasing delays\n\n**Fallback Actions**:\n- `simplified_prompt`: Retry with simpler instructions\n- `mock_response`: Return mock data\n- `skip`: Skip the step\n- `fail`: Fail the pipeline","ref":"02_step_types_reference.html#claude-robust"},{"type":"extras","title":"Parallel Claude - Step Types","doc":"**Type**: `parallel_claude`  \n**Purpose**: Execute multiple Claude instances simultaneously\n\n```yaml\n- name: \"parallel_implementation\"\n  type: \"parallel_claude\"\n  \n  parallel_tasks:\n    - id: \"api_endpoints\"\n      claude_options:\n        max_turns: 20\n        allowed_tools: [\"Write\", \"Edit\", \"Read\"]\n        cwd: \"./workspace/api\"\n      prompt:\n        - type: \"static\"\n          content: \"Implement the REST API endpoints\"\n        - type: \"previous_response\"\n          step: \"api_design\"\n      output_to_file: \"api_implementation.json\"\n    \n    - id: \"database_schema\"\n      claude_options:\n        max_turns: 15\n        allowed_tools: [\"Write\", \"Edit\"]\n        cwd: \"./workspace/database\"\n      prompt:\n        - type: \"static\"\n          content: \"Create the database schema\"\n        - type: \"previous_response\"\n          step: \"data_model\"\n      output_to_file: \"db_implementation.json\"\n    \n    - id: \"test_suite\"\n      claude_options:\n        max_turns: 25\n        allowed_tools: [\"Write\", \"Read\", \"Bash\"]\n        cwd: \"./workspace/tests\"\n      prompt:\n        - type: \"static\"\n          content: \"Write comprehensive tests\"\n      output_to_file: \"test_implementation.json\"\n```\n\n**Key Features**:\n- True parallel execution\n- Independent workspaces\n- Task isolation\n- Result aggregation\n- Resource management","ref":"02_step_types_reference.html#parallel-claude"},{"type":"extras","title":"Gemini Instructor - Step Types","doc":"**Type**: `gemini_instructor`  \n**Purpose**: Structured output generation with schema validation\n\n```yaml\n- name: \"generate_api_spec\"\n  type: \"gemini_instructor\"\n  \n  model: \"gemini-2.5-flash\"\n  validation_mode: \"strict\"       # Strict schema enforcement\n  \n  schema:\n    type: \"object\"\n    required: [\"endpoints\", \"models\", \"authentication\"]\n    properties:\n      endpoints:\n        type: \"array\"\n        items:\n          type: \"object\"\n          required: [\"method\", \"path\", \"description\"]\n          properties:\n            method:\n              type: \"string\"\n              enum: [\"GET\", \"POST\", \"PUT\", \"DELETE\"]\n            path:\n              type: \"string\"\n              pattern: \"^/api/.*\"\n            description:\n              type: \"string\"\n      models:\n        type: \"object\"\n      authentication:\n        type: \"object\"\n        required: [\"type\", \"endpoints\"]\n  \n  prompt:\n    - type: \"static\"\n      content: \"Generate OpenAPI specification for this service\"\n    - type: \"file\"\n      path: \"docs/api_requirements.md\"\n  \n  output_to_file: \"api_specification.json\"\n```\n\n**Key Features**:\n- Guaranteed structured output\n- Schema validation\n- Type safety\n- Integration with InstructorLite\n- JSON Schema support","ref":"02_step_types_reference.html#gemini-instructor"},{"type":"extras","title":"Control Flow Steps - Step Types","doc":"","ref":"02_step_types_reference.html#control-flow-steps"},{"type":"extras","title":"Pipeline - Step Types","doc":"**Type**: `pipeline`  \n**Purpose**: Execute another pipeline as a step (recursive composition)\n\n```yaml\n- name: \"data_processing\"\n  type: \"pipeline\"\n  \n  # Option 1: External file\n  pipeline_file: \"./pipelines/data_processor.yaml\"\n  \n  # Option 2: Registry reference (future)\n  # pipeline_ref: \"common/data_processor\"\n  \n  # Option 3: Inline definition\n  # pipeline:\n  #   name: \"inline_processor\"\n  #   steps: [...]\n  \n  # Input mapping\n  inputs:\n    raw_data: \"{{steps.extract.result}}\"\n    config: \"{{workflow.processing_config}}\"\n    mode: \"production\"\n  \n  # Output extraction\n  outputs:\n    - \"processed_data\"            # Simple extraction\n    - path: \"metrics.accuracy\"    # Path extraction\n      as: \"accuracy_score\"\n    - path: \"report.summary\"\n      as: \"summary_text\"\n  \n  # Configuration\n  config:\n    inherit_context: true         # Pass parent context\n    workspace_dir: \"./nested/data_processing\"\n    timeout_seconds: 600\n    max_depth: 5                  # Nesting limit\n    enable_tracing: true\n```\n\n**Key Features**:\n- Pipeline composition and modularity\n- Context isolation\n- Input/output mapping\n- Safety limits (depth, memory, time)\n- Circular dependency detection\n\n**Use Cases**:\n- Reusable workflows\n- Complex multi-stage processing\n- Modular architecture\n- Testing pipeline components","ref":"02_step_types_reference.html#pipeline"},{"type":"extras","title":"For Loop - Step Types","doc":"**Type**: `for_loop`  \n**Purpose**: Iterate over collections with optional parallelization\n\n```yaml\n- name: \"process_files\"\n  type: \"for_loop\"\n  \n  iterator: \"file\"                # Loop variable name\n  data_source: \"{{steps.scan.files}}\" # Array to iterate\n  \n  # Parallel execution\n  parallel: true\n  max_parallel: 5                 # Concurrent limit\n  \n  # Error handling\n  break_on_error: false           # Continue on errors\n  \n  # Loop body\n  steps:\n    - name: \"analyze_file\"\n      type: \"claude\"\n      prompt:\n        - type: \"static\"\n          content: \"Analyze this file:\"\n        - type: \"static\"\n          content: \"{{loop.file.path}}\"\n      output_to_file: \"analysis_{{loop.file.name}}.json\"\n    \n    - name: \"update_progress\"\n      type: \"set_variable\"\n      variables:\n        processed_count: \"{{state.processed_count + 1}}\"\n```\n\n**Variable Access**:\n- `{{loop.variable}}`: Current item\n- `{{loop.index}}`: Current index (0-based)\n- `{{loop.parent.variable}}`: Parent loop variable\n- `{{loop.is_first}}`: Boolean first iteration\n- `{{loop.is_last}}`: Boolean last iteration\n\n**Data Sources**:\n- Arrays from previous steps\n- Static arrays\n- File listings\n- Query results","ref":"02_step_types_reference.html#for-loop"},{"type":"extras","title":"While Loop - Step Types","doc":"**Type**: `while_loop`  \n**Purpose**: Repeat steps until condition is met\n\n```yaml\n- name: \"optimize_until_passing\"\n  type: \"while_loop\"\n  \n  condition: \"{{steps.test.score < 90}}\"\n  \n  # Safety limits\n  max_iterations: 10\n  timeout_seconds: 1800           # 30 minutes total\n  \n  # Loop body\n  steps:\n    - name: \"optimize\"\n      type: \"claude\"\n      prompt:\n        - type: \"static\"\n          content: \"Improve the code to increase test score\"\n        - type: \"previous_response\"\n          step: \"test\"\n          extract: \"failures\"\n      \n    - name: \"test\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Run tests and calculate score\"\n      output_schema:\n        type: \"object\"\n        required: [\"score\", \"failures\"]\n```\n\n**Condition Expressions**:\n- Comparison operators: `==`, `!=`, `>`, `<`, `>=`, `<=`\n- Boolean operators: `and`, `or`, `not`\n- String operations: `contains`, `matches`\n- Null checks: `exists`, `empty`\n\n**Safety Features**:\n- Maximum iteration limit\n- Total timeout protection\n- Infinite loop detection\n- Memory usage monitoring","ref":"02_step_types_reference.html#while-loop"},{"type":"extras","title":"Switch/Case - Step Types","doc":"**Type**: `switch`  \n**Purpose**: Branch execution based on values\n\n```yaml\n- name: \"handle_by_type\"\n  type: \"switch\"\n  \n  expression: \"{{steps.detect.file_type}}\"\n  \n  cases:\n    \"python\":\n      - name: \"analyze_python\"\n        type: \"claude\"\n        prompt:\n          - type: \"static\"\n            content: \"Analyze Python code\"\n          \n    \"javascript\":\n      - name: \"analyze_js\"\n        type: \"claude\"\n        prompt:\n          - type: \"static\"\n            content: \"Analyze JavaScript code\"\n            \n    \"markdown\":\n      - name: \"process_docs\"\n        type: \"gemini\"\n        prompt:\n          - type: \"static\"\n            content: \"Process documentation\"\n  \n  default:\n    - name: \"generic_analysis\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Perform generic analysis\"\n```\n\n**Features**:\n- Value-based branching\n- Multiple steps per case\n- Default fallback\n- Expression evaluation\n- Pattern matching support","ref":"02_step_types_reference.html#switch-case"},{"type":"extras","title":"Data & File Operations - Step Types","doc":"","ref":"02_step_types_reference.html#data-file-operations"},{"type":"extras","title":"Data Transform - Step Types","doc":"**Type**: `data_transform`  \n**Purpose**: Transform and manipulate structured data\n\n```yaml\n- name: \"process_results\"\n  type: \"data_transform\"\n  \n  input_source: \"{{steps.analysis.results}}\"\n  \n  operations:\n    # Filter operation\n    - operation: \"filter\"\n      field: \"items\"\n      condition: \"score > 80 and category == 'critical'\"\n    \n    # Map transformation\n    - operation: \"map\"\n      field: \"items\"\n      expression: |\n        {\n          \"id\": item.id,\n          \"score\": item.score * 100,\n          \"priority\": item.score > 90 ? \"high\" : \"normal\"\n        }\n    \n    # Aggregation\n    - operation: \"aggregate\"\n      field: \"items\"\n      function: \"average\"\n      group_by: \"category\"\n    \n    # Join with another dataset\n    - operation: \"join\"\n      left_field: \"items\"\n      right_source: \"{{steps.metadata.items}}\"\n      join_key: \"id\"\n      join_type: \"left\"\n    \n    # Sort results\n    - operation: \"sort\"\n      field: \"items\"\n      by: \"score\"\n      order: \"desc\"\n  \n  output_field: \"processed_results\"\n  output_to_file: \"transformed_data.json\"\n```\n\n**Available Operations**:\n- `filter`: Filter items by condition\n- `map`: Transform each item\n- `aggregate`: Calculate statistics\n- `join`: Combine datasets\n- `group_by`: Group items\n- `sort`: Order items\n- `unique`: Remove duplicates\n- `flatten`: Flatten nested arrays\n\n**Aggregate Functions**:\n- `sum`, `average`, `min`, `max`\n- `count`, `count_distinct`\n- `std_dev`, `variance`","ref":"02_step_types_reference.html#data-transform"},{"type":"extras","title":"File Operations - Step Types","doc":"**Type**: `file_ops`  \n**Purpose**: Manipulate files and directories\n\n```yaml\n- name: \"organize_outputs\"\n  type: \"file_ops\"\n  \n  # Copy files\n  operation: \"copy\"\n  source: \n    - \"./workspace/src/*.py\"\n    - \"./workspace/tests/*.py\"\n  destination: \"./output/python_files/\"\n  \n  # Alternative operations:\n  \n  # Move files\n  # operation: \"move\"\n  # source: \"./temp/*\"\n  # destination: \"./processed/\"\n  \n  # Delete files\n  # operation: \"delete\"\n  # files: [\"./temp/*.tmp\", \"./cache/*\"]\n  \n  # Validate files exist\n  # operation: \"validate\"\n  # files:\n  #   - path: \"./config/app.yaml\"\n  #     must_exist: true\n  #     min_size: 100\n  #   - path: \"./output/\"\n  #     must_be_dir: true\n  \n  # List files\n  # operation: \"list\"\n  # path: \"./workspace\"\n  # pattern: \"**/*.py\"\n  # recursive: true\n  \n  # Convert formats\n  # operation: \"convert\"\n  # source: \"./data.csv\"\n  # destination: \"./data.json\"\n  # format: \"csv_to_json\"\n```\n\n**Supported Operations**:\n- `copy`: Duplicate files/directories\n- `move`: Relocate files/directories\n- `delete`: Remove files/directories\n- `validate`: Check file properties\n- `list`: Directory listing\n- `convert`: Format conversion\n\n**Format Conversions**:\n- `csv_to_json`, `json_to_csv`\n- `yaml_to_json`, `json_to_yaml`\n- `xml_to_json`, `json_to_xml`","ref":"02_step_types_reference.html#file-operations"},{"type":"extras","title":"Codebase Query - Step Types","doc":"**Type**: `codebase_query`  \n**Purpose**: Intelligent codebase analysis and file discovery\n\n```yaml\n- name: \"analyze_project\"\n  type: \"codebase_query\"\n  \n  codebase_context: true          # Include project metadata\n  \n  queries:\n    # Find specific file types\n    source_files:\n      find_files:\n        - type: \"source\"\n        - pattern: \"lib/**/*.ex\"\n        - exclude_tests: true\n        - modified_since: \"2024-01-01\"\n    \n    # Find test files related to source\n    test_files:\n      find_files:\n        - related_to: \"lib/user.ex\"\n        - type: \"test\"\n    \n    # Find functions in files\n    public_functions:\n      find_functions:\n        - in_file: \"lib/user.ex\"\n        - public_only: true\n        - with_annotation: \"@doc\"\n    \n    # Analyze dependencies\n    dependencies:\n      find_dependencies:\n        - for_file: \"lib/user.ex\"\n        - include_transitive: false\n    \n    # Find dependent files\n    dependents:\n      find_dependents:\n        - of_file: \"lib/user.ex\"\n        - include_tests: true\n    \n    # Project information\n    project_info:\n      get_project_type: true\n      get_dependencies: true\n      get_git_status: true\n  \n  output_to_file: \"codebase_analysis.json\"\n```\n\n**Query Types**:\n- `find_files`: Locate files by criteria\n- `find_functions`: Extract function definitions\n- `find_dependencies`: Analyze imports/requires\n- `find_dependents`: Reverse dependency lookup\n- `get_project_type`: Detect project framework\n- `get_git_status`: Git repository information\n\n**Supported Languages**:\n- Elixir\n- Python\n- JavaScript/TypeScript\n- Go\n- Rust","ref":"02_step_types_reference.html#codebase-query"},{"type":"extras","title":"State Management - Step Types","doc":"","ref":"02_step_types_reference.html#state-management"},{"type":"extras","title":"Set Variable - Step Types","doc":"**Type**: `set_variable`  \n**Purpose**: Manage workflow state and variables\n\n```yaml\n- name: \"initialize_state\"\n  type: \"set_variable\"\n  \n  variables:\n    # Static values\n    iteration_count: 0\n    max_retries: 3\n    results: []\n    \n    # Computed values\n    total_files: \"{{length(steps.scan.files)}}\"\n    start_time: \"{{now()}}\"\n    \n    # Complex expressions\n    threshold: \"{{workflow.base_threshold * 1.5}}\"\n    is_production: \"{{environment.mode == 'production'}}\"\n  \n  scope: \"global\"                 # Variable scope\n```\n\n**Variable Scopes**:\n- `global`: Available to all steps\n- `local`: Current step only\n- `session`: Persists across runs\n\n**Supported Operations**:\n- Arithmetic: `+`, `-`, `*`, `/`, `%`\n- String concatenation\n- Array operations\n- Boolean logic\n- Function calls","ref":"02_step_types_reference.html#set-variable"},{"type":"extras","title":"Checkpoint - Step Types","doc":"**Type**: `checkpoint`  \n**Purpose**: Save workflow state for recovery\n\n```yaml\n- name: \"save_progress\"\n  type: \"checkpoint\"\n  \n  state:\n    completed_steps: \"{{state.completed_steps}}\"\n    processed_items: \"{{state.processed_items}}\"\n    current_phase: \"implementation\"\n    metrics:\n      files_processed: \"{{state.file_count}}\"\n      errors_found: \"{{state.error_count}}\"\n      completion_percentage: \"{{state.progress}}\"\n  \n  checkpoint_name: \"phase_2_complete\"\n  include_workspace: true         # Save workspace files\n  compress: true                  # Compress checkpoint\n```\n\n**Features**:\n- State persistence\n- Workspace backup\n- Compression support\n- Automatic recovery\n- Checkpoint management\n\n**Use Cases**:\n- Long-running workflows\n- Failure recovery\n- Progress tracking\n- Partial execution","ref":"02_step_types_reference.html#checkpoint"},{"type":"extras","title":"Step Type Selection Guide - Step Types","doc":"| Task Type | Recommended Step Type | Key Consideration |\n|-----------|----------------------|-------------------|\n| Planning & Analysis | `gemini` | Best for reasoning and structure |\n| Code Implementation | `claude` | Full tool access for file manipulation |\n| Quick Analysis | `claude_smart` | Preset configurations |\n| Long Conversations | `claude_session` | State persistence |\n| Content Extraction | `claude_extract` | Structured output processing |\n| Parallel Tasks | `claude_batch` or `parallel_claude` | Concurrent execution |\n| Critical Operations | `claude_robust` | Error recovery |\n| Structured Output | `gemini_instructor` | Schema validation |\n| Modular Workflows | `pipeline` | Composition and reuse |\n| Iteration | `for_loop` or `while_loop` | Collection processing |\n| Branching | `switch` | Value-based routing |\n| Data Manipulation | `data_transform` | JSONPath operations |\n| File Management | `file_ops` | File system operations |\n| Code Analysis | `codebase_query` | Language-aware analysis |\n\nThis reference provides comprehensive documentation for all available step types in Pipeline YAML v2 format.","ref":"02_step_types_reference.html#step-type-selection-guide"},{"type":"extras","title":"Prompt System Reference","doc":"# Prompt System Reference","ref":"03_prompt_system_reference.html"},{"type":"extras","title":"Table of Contents - Prompt System Reference","doc":"1. [Overview](#overview)\n2. [Prompt Types](#prompt-types)\n   - [Static Content](#static-content)\n   - [File Content](#file-content)\n   - [Previous Response](#previous-response)\n   - [Session Context](#session-context)\n   - [Claude Continue](#claude-continue)\n3. [Prompt Composition](#prompt-composition)\n4. [File-Based Prompts](#file-based-prompts)\n5. [Template Variables](#template-variables)\n6. [Content Processing](#content-processing)\n7. [Prompt Libraries](#prompt-libraries)\n8. [Advanced Patterns](#advanced-patterns)\n9. [Best Practices](#best-practices)","ref":"03_prompt_system_reference.html#table-of-contents"},{"type":"extras","title":"Overview - Prompt System Reference","doc":"The Pipeline Prompt System enables sophisticated prompt management through:\n\n- **Multiple prompt types** for different content sources\n- **Dynamic composition** of prompts from various sources\n- **External file management** for reusable prompts\n- **Template variables** for dynamic content\n- **Content extraction** and processing\n- **Session management** for stateful conversations","ref":"03_prompt_system_reference.html#overview"},{"type":"extras","title":"Prompt Types - Prompt System Reference","doc":"","ref":"03_prompt_system_reference.html#prompt-types"},{"type":"extras","title":"Static Content - Prompt System Reference","doc":"**Type**: `static`  \n**Purpose**: Inline text content defined directly in YAML\n\n```yaml\nprompt:\n  - type: \"static\"\n    content: |\n      Analyze this code for the following aspects:\n      1. Security vulnerabilities\n      2. Performance bottlenecks\n      3. Code quality issues\n      4. Best practice violations\n      \n      Provide your analysis in JSON format.\n```\n\n**Features**:\n- Multi-line content with YAML `|` syntax\n- Direct embedding in workflow files\n- No external dependencies\n- Template variable support\n\n**Use Cases**:\n- Short, workflow-specific instructions\n- Connecting text between other prompt types\n- Dynamic prompts with variables\n- Quick prototyping","ref":"03_prompt_system_reference.html#static-content"},{"type":"extras","title":"File Content - Prompt System Reference","doc":"**Type**: `file`  \n**Purpose**: Load content from external files\n\n```yaml\nprompt:\n  - type: \"file\"\n    path: \"pipelines/prompts/analysis/security_review.md\"\n    \n  # With variables\n  - type: \"file\"\n    path: \"pipelines/prompts/templates/code_review.md\"\n    variables:\n      language: \"Python\"\n      framework: \"FastAPI\"\n      focus_areas: [\"security\", \"performance\"]\n    \n  # Inject as variable\n  - type: \"file\"\n    path: \"src/main.py\"\n    inject_as: \"SOURCE_CODE\"\n    \n  # With encoding\n  - type: \"file\"\n    path: \"data/unicode_content.txt\"\n    encoding: \"utf-8\"\n```\n\n**Features**:\n- Automatic file caching\n- Change detection\n- Variable substitution\n- Content injection\n- Encoding support\n\n**Path Resolution**:\n- Relative to project root\n- Supports glob patterns (future)\n- Environment variable expansion","ref":"03_prompt_system_reference.html#file-content"},{"type":"extras","title":"Previous Response - Prompt System Reference","doc":"**Type**: `previous_response`  \n**Purpose**: Reference outputs from earlier workflow steps\n\n```yaml\nprompt:\n  # Simple reference\n  - type: \"previous_response\"\n    step: \"analysis\"\n  \n  # Extract specific field\n  - type: \"previous_response\"\n    step: \"code_review\"\n    extract: \"critical_issues\"\n  \n  # With content processing\n  - type: \"previous_response\"\n    step: \"detailed_analysis\"\n    extract_with: \"content_extractor\"\n    format: \"structured\"\n    post_processing:\n      - \"extract_code_blocks\"\n      - \"extract_recommendations\"\n  \n  # With summarization\n  - type: \"previous_response\"\n    step: \"long_report\"\n    summary: true\n    max_length: 1000\n```\n\n**Extract Options**:\n- JSONPath expressions: `\"data.items[0].value\"`\n- Nested field access: `\"results.security.vulnerabilities\"`\n- Array indexing: `\"items[2]\"`\n- Wildcard selection: `\"items[*].name\"`\n\n**Content Processing**:\n- `extract_with`: Use advanced extraction\n- `summary`: Generate content summary\n- `max_length`: Truncate to length\n- `format`: Output format selection","ref":"03_prompt_system_reference.html#previous-response"},{"type":"extras","title":"Session Context - Prompt System Reference","doc":"**Type**: `session_context`  \n**Purpose**: Include conversation history from Claude sessions\n\n```yaml\nprompt:\n  # Include recent messages\n  - type: \"session_context\"\n    session_id: \"development_session\"\n    include_last_n: 10\n  \n  # Include all messages\n  - type: \"session_context\"\n    session_id: \"tutorial_session\"\n  \n  # With filtering (future)\n  - type: \"session_context\"\n    session_id: \"debug_session\"\n    include_last_n: 20\n    filter: \"role == 'assistant'\"\n```\n\n**Features**:\n- Session state retrieval\n- Message history inclusion\n- Turn limiting\n- Context window management\n\n**Use Cases**:\n- Multi-turn conversations\n- Continuing interrupted work\n- Building on previous sessions\n- Tutorial continuity","ref":"03_prompt_system_reference.html#session-context"},{"type":"extras","title":"Claude Continue - Prompt System Reference","doc":"**Type**: `claude_continue`  \n**Purpose**: Continue existing Claude conversation with new instructions\n\n```yaml\nprompt:\n  - type: \"claude_continue\"\n    new_prompt: |\n      Now that we have the basic implementation, please:\n      1. Add comprehensive error handling\n      2. Include input validation\n      3. Add unit tests\n      4. Update the documentation\n```\n\n**Features**:\n- Seamless conversation continuation\n- Context preservation\n- New instruction injection\n- Session state maintenance\n\n**Requirements**:\n- Must be used with `claude_session` step type\n- Requires active session\n- Maintains conversation flow","ref":"03_prompt_system_reference.html#claude-continue"},{"type":"extras","title":"Prompt Composition - Prompt System Reference","doc":"","ref":"03_prompt_system_reference.html#prompt-composition"},{"type":"extras","title":"Sequential Composition - Prompt System Reference","doc":"Build complex prompts by combining multiple sources:\n\n```yaml\nprompt:\n  # Context setup\n  - type: \"static\"\n    content: \"","ref":"03_prompt_system_reference.html#sequential-composition"},{"type":"extras","title":"Project Context\" - Prompt System Reference","doc":"- type: \"file\"\n    path: \"docs/project_overview.md\"\n  \n  # Previous work\n  - type: \"static\"\n    content: \"\\n","ref":"03_prompt_system_reference.html#project-context"},{"type":"extras","title":"Previous Analysis Results\" - Prompt System Reference","doc":"- type: \"previous_response\"\n    step: \"initial_analysis\"\n    extract: \"summary\"\n  \n  # Current task\n  - type: \"static\"\n    content: \"\\n","ref":"03_prompt_system_reference.html#previous-analysis-results"},{"type":"extras","title":"Current Task\" - Prompt System Reference","doc":"- type: \"file\"\n    path: \"pipelines/prompts/tasks/implementation.md\"\n    variables:\n      component: \"authentication\"\n      priority: \"high\"\n  \n  # Code context\n  - type: \"static\"\n    content: \"\\n","ref":"03_prompt_system_reference.html#current-task"},{"type":"extras","title":"Existing Code\" - Prompt System Reference","doc":"- type: \"file\"\n    path: \"src/auth.py\"\n```","ref":"03_prompt_system_reference.html#existing-code"},{"type":"extras","title":"Conditional Composition - Prompt System Reference","doc":"Include prompt parts based on conditions:\n\n```yaml\nsteps:\n  - name: \"adaptive_prompt\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Analyze this code:\"\n        \n      - type: \"file\"\n        path: \"src/main.py\"\n      \n      # Include based on previous step\n      - type: \"previous_response\"\n        step: \"security_scan\"\n        extract: \"vulnerabilities\"\n        condition: \"{{steps.security_scan.found_issues == true}}\"\n      \n      # Dynamic file selection\n      - type: \"file\"\n        path: \"{{steps.detect_type.template_path}}\"\n```","ref":"03_prompt_system_reference.html#conditional-composition"},{"type":"extras","title":"File-Based Prompts - Prompt System Reference","doc":"","ref":"03_prompt_system_reference.html#file-based-prompts"},{"type":"extras","title":"Directory Structure - Prompt System Reference","doc":"```\npipelines/prompts/\n├── analysis/\n│   ├── code_review.md\n│   ├── security_audit.md\n│   ├── performance_analysis.md\n│   └── architecture_review.md\n├── generation/\n│   ├── api_endpoints.md\n│   ├── test_cases.md\n│   ├── documentation.md\n│   └── implementation.md\n├── extraction/\n│   ├── data_parsing.md\n│   ├── entity_extraction.md\n│   └── summarization.md\n├── templates/\n│   ├── base_analysis.md\n│   ├── base_generation.md\n│   └── base_validation.md\n└── common/\n    ├── context_setup.md\n    ├── output_format.md\n    └── error_handling.md\n```","ref":"03_prompt_system_reference.html#directory-structure"},{"type":"extras","title":"Prompt File Format - Prompt System Reference","doc":"```markdown\n# Security Analysis Prompt","ref":"03_prompt_system_reference.html#prompt-file-format"},{"type":"extras","title":"Purpose - Prompt System Reference","doc":"Comprehensive security vulnerability assessment for {LANGUAGE} applications.","ref":"03_prompt_system_reference.html#purpose"},{"type":"extras","title":"Context Requirements - Prompt System Reference","doc":"- Source code files\n- Dependency list\n- Previous security reports (if available)","ref":"03_prompt_system_reference.html#context-requirements"},{"type":"extras","title":"Analysis Instructions - Prompt System Reference","doc":"Analyze the provided {PROJECT_TYPE} codebase for security vulnerabilities:","ref":"03_prompt_system_reference.html#analysis-instructions"},{"type":"extras","title":"1. Authentication & Authorization - Prompt System Reference","doc":"- Check for proper authentication mechanisms\n- Verify authorization controls\n- Assess session management\n- Review password policies","ref":"03_prompt_system_reference.html#1-authentication-authorization"},{"type":"extras","title":"2. Input Validation - Prompt System Reference","doc":"- SQL injection vulnerabilities\n- XSS (Cross-site scripting) risks\n- Command injection possibilities\n- Path traversal vulnerabilities","ref":"03_prompt_system_reference.html#2-input-validation"},{"type":"extras","title":"3. Data Protection - Prompt System Reference","doc":"- Encryption usage (at rest and in transit)\n- Sensitive data exposure\n- Proper data sanitization\n- PII handling compliance","ref":"03_prompt_system_reference.html#3-data-protection"},{"type":"extras","title":"Output Format - Prompt System Reference","doc":"{OUTPUT_FORMAT}","ref":"03_prompt_system_reference.html#output-format"},{"type":"extras","title":"Previous Findings - Prompt System Reference","doc":"{PREVIOUS_FINDINGS}","ref":"03_prompt_system_reference.html#previous-findings"},{"type":"extras","title":"Code to Analyze - Prompt System Reference","doc":"{CODE_CONTENT}\n```","ref":"03_prompt_system_reference.html#code-to-analyze"},{"type":"extras","title":"Using Prompt Files - Prompt System Reference","doc":"```yaml\nsteps:\n  - name: \"security_analysis\"\n    type: \"claude\"\n    prompt:\n      - type: \"file\"\n        path: \"pipelines/prompts/analysis/security_audit.md\"\n        variables:\n          LANGUAGE: \"Python\"\n          PROJECT_TYPE: \"web application\"\n          OUTPUT_FORMAT: \"JSON with severity levels\"\n      \n      - type: \"previous_response\"\n        step: \"dependency_scan\"\n        inject_as: \"PREVIOUS_FINDINGS\"\n      \n      - type: \"file\"\n        path: \"src/\"\n        inject_as: \"CODE_CONTENT\"\n```","ref":"03_prompt_system_reference.html#using-prompt-files"},{"type":"extras","title":"Template Variables - Prompt System Reference","doc":"","ref":"03_prompt_system_reference.html#template-variables"},{"type":"extras","title":"Variable Definition - Prompt System Reference","doc":"Variables can be defined at multiple levels:\n\n```yaml\nworkflow:\n  variables:\n    project_name: \"MyApp\"\n    language: \"Python\"\n    \n  steps:\n    - name: \"analyze\"\n      type: \"gemini\"\n      variables:\n        analysis_type: \"security\"\n        depth: \"comprehensive\"\n      prompt:\n        - type: \"file\"\n          path: \"prompts/analysis.md\"\n          variables:\n            PROJECT: \"{{workflow.variables.project_name}}\"\n            LANG: \"{{workflow.variables.language}}\"\n            TYPE: \"{{step.variables.analysis_type}}\"\n```","ref":"03_prompt_system_reference.html#variable-definition"},{"type":"extras","title":"Variable Substitution - Prompt System Reference","doc":"In prompt files:\n\n```markdown\n# {ANALYSIS_TYPE} Analysis for {PROJECT}\n\nPerform a {DEPTH} analysis of this {LANG} project focusing on {FOCUS_AREAS}.","ref":"03_prompt_system_reference.html#variable-substitution"},{"type":"extras","title":"Special Considerations for {FRAMEWORK} - Prompt System Reference","doc":"{if FRAMEWORK == \"Django\"}\n- Check Django-specific security settings\n- Verify CSRF protection\n- Review middleware configuration\n{endif}\n```","ref":"03_prompt_system_reference.html#special-considerations-for-framework"},{"type":"extras","title":"Built-in Variables - Prompt System Reference","doc":"Available in all prompts:\n\n- `{{workflow.name}}`: Current workflow name\n- `{{step.name}}`: Current step name\n- `{{timestamp}}`: Current timestamp\n- `{{date}}`: Current date\n- `{{execution_id}}`: Unique execution ID","ref":"03_prompt_system_reference.html#built-in-variables"},{"type":"extras","title":"Content Processing - Prompt System Reference","doc":"","ref":"03_prompt_system_reference.html#content-processing"},{"type":"extras","title":"Content Extraction - Prompt System Reference","doc":"Advanced extraction with ContentExtractor:\n\n```yaml\nprompt:\n  - type: \"previous_response\"\n    step: \"comprehensive_analysis\"\n    extract_with: \"content_extractor\"\n    format: \"structured\"              # Output format\n    post_processing:\n      - \"extract_code_blocks\"         # Extract code snippets\n      - \"extract_recommendations\"      # Extract suggestions\n      - \"extract_links\"               # Extract URLs\n      - \"extract_key_points\"          # Extract main points\n      - \"extract_errors\"              # Extract error messages\n    include_metadata: true            # Include extraction metadata\n    max_length: 5000                  # Length limit\n```","ref":"03_prompt_system_reference.html#content-extraction"},{"type":"extras","title":"Summarization - Prompt System Reference","doc":"Automatic content summarization:\n\n```yaml\nprompt:\n  - type: \"file\"\n    path: \"docs/large_spec.md\"\n    summary: true\n    max_summary_length: 500\n    summary_focus: \"technical_requirements\"\n  \n  - type: \"previous_response\"\n    step: \"detailed_report\"\n    summary: true\n    summary_style: \"bullet_points\"\n```","ref":"03_prompt_system_reference.html#summarization"},{"type":"extras","title":"Format Transformations - Prompt System Reference","doc":"Transform content between formats:\n\n```yaml\nprompt:\n  - type: \"previous_response\"\n    step: \"data_analysis\"\n    transform: \"json_to_markdown\"\n    \n  - type: \"file\"\n    path: \"data.csv\"\n    transform: \"csv_to_table\"\n```","ref":"03_prompt_system_reference.html#format-transformations"},{"type":"extras","title":"Prompt Libraries - Prompt System Reference","doc":"","ref":"03_prompt_system_reference.html#prompt-libraries"},{"type":"extras","title":"Creating Reusable Components - Prompt System Reference","doc":"Define prompt components in YAML:\n\n```yaml\n# pipelines/prompts/components/analysis_base.yaml\nanalysis_base:\n  security_check:\n    - type: \"static\"\n      content: |\n        Perform security analysis focusing on:\n        - Authentication vulnerabilities\n        - Input validation issues\n        - Data exposure risks\n  \n  performance_check:\n    - type: \"static\"\n      content: |\n        Analyze performance characteristics:\n        - Algorithm complexity\n        - Resource usage\n        - Scalability factors\n  \n  quality_check:\n    - type: \"static\"\n      content: |\n        Assess code quality:\n        - Readability and maintainability\n        - Design patterns usage\n        - Testing coverage\n```","ref":"03_prompt_system_reference.html#creating-reusable-components"},{"type":"extras","title":"Using Prompt Components - Prompt System Reference","doc":"```yaml\nsteps:\n  - name: \"comprehensive_analysis\"\n    type: \"gemini\"\n    prompt:\n      # Include base context\n      - type: \"file\"\n        path: \"prompts/components/context_setup.yaml\"\n        component: \"project_context\"\n      \n      # Include analysis components\n      - type: \"file\"\n        path: \"prompts/components/analysis_base.yaml\"\n        component: \"security_check\"\n      \n      - type: \"file\"\n        path: \"prompts/components/analysis_base.yaml\"\n        component: \"performance_check\"\n      \n      # Add specific instructions\n      - type: \"static\"\n        content: \"Focus particularly on the authentication module\"\n```","ref":"03_prompt_system_reference.html#using-prompt-components"},{"type":"extras","title":"Advanced Patterns - Prompt System Reference","doc":"","ref":"03_prompt_system_reference.html#advanced-patterns"},{"type":"extras","title":"Progressive Prompt Building - Prompt System Reference","doc":"Build increasingly complex prompts:\n\n```yaml\nsteps:\n  - name: \"initial_analysis\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"prompts/analysis/basic_review.md\"\n      - type: \"file\"\n        path: \"src/main.py\"\n  \n  - name: \"deep_analysis\"\n    type: \"gemini\"\n    prompt:\n      - type: \"file\"\n        path: \"prompts/analysis/comprehensive_review.md\"\n      - type: \"previous_response\"\n        step: \"initial_analysis\"\n        extract: \"areas_of_concern\"\n      - type: \"file\"\n        path: \"src/\"\n  \n  - name: \"final_recommendations\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Based on all analysis:\"\n      - type: \"previous_response\"\n        step: \"initial_analysis\"\n      - type: \"previous_response\"\n        step: \"deep_analysis\"\n      - type: \"file\"\n        path: \"prompts/templates/recommendations.md\"\n```","ref":"03_prompt_system_reference.html#progressive-prompt-building"},{"type":"extras","title":"Context-Aware Prompts - Prompt System Reference","doc":"Adapt prompts based on context:\n\n```yaml\nsteps:\n  - name: \"detect_framework\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Detect the framework used in this project\"\n      - type: \"file\"\n        path: \"package.json\"\n  \n  - name: \"framework_specific_analysis\"\n    type: \"claude\"\n    prompt:\n      # Dynamic prompt selection based on framework\n      - type: \"file\"\n        path: \"prompts/frameworks/{{steps.detect_framework.result.framework}}.md\"\n      - type: \"file\"\n        path: \"src/\"\n```","ref":"03_prompt_system_reference.html#context-aware-prompts"},{"type":"extras","title":"Multi-Modal Prompts - Prompt System Reference","doc":"Combine different content types:\n\n```yaml\nprompt:\n  # Textual context\n  - type: \"file\"\n    path: \"prompts/analysis/ui_review.md\"\n  \n  # Code files\n  - type: \"file\"\n    path: \"src/components/Dashboard.jsx\"\n  \n  # Data files\n  - type: \"file\"\n    path: \"test_data/sample_output.json\"\n  \n  # Previous analysis\n  - type: \"previous_response\"\n    step: \"accessibility_check\"\n    extract: \"issues\"\n  \n  # Dynamic content\n  - type: \"static\"\n    content: \"Consider mobile responsiveness for viewport: {{config.target_viewport}}\"\n```","ref":"03_prompt_system_reference.html#multi-modal-prompts"},{"type":"extras","title":"Best Practices - Prompt System Reference","doc":"","ref":"03_prompt_system_reference.html#best-practices"},{"type":"extras","title":"1. Prompt Organization - Prompt System Reference","doc":"- **Single Responsibility**: Each prompt file should have one clear purpose\n- **Descriptive Names**: Use clear, action-oriented file names\n- **Version Control**: Track prompt changes in git\n- **Documentation**: Include purpose and requirements in prompt files","ref":"03_prompt_system_reference.html#1-prompt-organization"},{"type":"extras","title":"2. Variable Usage - Prompt System Reference","doc":"- **Clear Naming**: Use descriptive variable names\n- **Default Values**: Provide defaults where appropriate\n- **Type Safety**: Document expected variable types\n- **Validation**: Validate variables before use","ref":"03_prompt_system_reference.html#2-variable-usage"},{"type":"extras","title":"3. Content Management - Prompt System Reference","doc":"- **Size Limits**: Monitor prompt sizes to avoid token limits\n- **Caching**: Leverage file caching for performance\n- **Compression**: Use summarization for large content\n- **Chunking**: Split large prompts into manageable parts","ref":"03_prompt_system_reference.html#3-content-management"},{"type":"extras","title":"4. Reusability - Prompt System Reference","doc":"- **Templates**: Create reusable prompt templates\n- **Components**: Build modular prompt components\n- **Libraries**: Organize prompts in logical categories\n- **Inheritance**: Use base prompts with extensions","ref":"03_prompt_system_reference.html#4-reusability"},{"type":"extras","title":"5. Error Handling - Prompt System Reference","doc":"- **Fallbacks**: Provide fallback prompts for failures\n- **Validation**: Check file existence before use\n- **Encoding**: Handle different file encodings properly\n- **Recovery**: Design prompts that can recover from partial failures","ref":"03_prompt_system_reference.html#5-error-handling"},{"type":"extras","title":"6. Performance - Prompt System Reference","doc":"- **Lazy Loading**: Load prompts only when needed\n- **Caching**: Cache frequently used prompts\n- **Preprocessing**: Prepare prompts during idle time\n- **Optimization**: Minimize prompt token usage\n\nThis reference provides comprehensive documentation for the Pipeline Prompt System, enabling sophisticated prompt management and composition strategies.","ref":"03_prompt_system_reference.html#6-performance"},{"type":"extras","title":"Control Flow","doc":"# Control Flow & Logic Reference","ref":"04_control_flow_logic.html"},{"type":"extras","title":"Table of Contents - Control Flow","doc":"1. [Overview](#overview)\n2. [Conditional Execution](#conditional-execution)\n   - [Simple Conditions](#simple-conditions)\n   - [Boolean Expressions](#boolean-expressions)\n   - [Comparison Operators](#comparison-operators)\n   - [Complex Conditions](#complex-conditions)\n3. [Loop Constructs](#loop-constructs)\n   - [For Loops](#for-loops)\n   - [While Loops](#while-loops)\n   - [Nested Loops](#nested-loops)\n   - [Parallel Loops](#parallel-loops)\n4. [Branching Logic](#branching-logic)\n   - [Switch/Case](#switchcase)\n   - [Multi-Branch Conditions](#multi-branch-conditions)\n5. [State Management](#state-management)\n   - [Variables](#variables)\n   - [Variable Scoping](#variable-scoping)\n   - [State Persistence](#state-persistence)\n6. [Parallel Execution](#parallel-execution)\n   - [Parallel Steps](#parallel-steps)\n   - [Synchronization](#synchronization)\n7. [Error Handling & Recovery](#error-handling--recovery)\n8. [Advanced Patterns](#advanced-patterns)","ref":"04_control_flow_logic.html#table-of-contents"},{"type":"extras","title":"Overview - Control Flow","doc":"Pipeline's control flow system enables sophisticated workflow orchestration through:\n\n- **Conditional execution** based on runtime values\n- **Loop constructs** for iterative processing\n- **Branching logic** for decision trees\n- **State management** for workflow variables\n- **Parallel execution** for concurrent processing\n- **Error handling** with recovery strategies","ref":"04_control_flow_logic.html#overview"},{"type":"extras","title":"Conditional Execution - Control Flow","doc":"","ref":"04_control_flow_logic.html#conditional-execution"},{"type":"extras","title":"Simple Conditions - Control Flow","doc":"Basic conditional step execution:\n\n```yaml\nsteps:\n  - name: \"analyze_code\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Analyze code quality and set needs_refactoring flag\"\n    \n  - name: \"refactor_code\"\n    type: \"claude\"\n    condition: \"steps.analyze_code.needs_refactoring\"\n    prompt:\n      - type: \"static\"\n        content: \"Refactor the identified issues\"\n```\n\n**Field-based conditions**:\n```yaml\n# Boolean field check\ncondition: \"steps.previous.success\"\n\n# Null/existence check\ncondition: \"steps.scan.vulnerabilities\"\n\n# Array emptiness\ncondition: \"steps.find.results\"\n```","ref":"04_control_flow_logic.html#simple-conditions"},{"type":"extras","title":"Boolean Expressions - Control Flow","doc":"Complex boolean logic with AND/OR/NOT:\n\n```yaml\ncondition:\n  and:\n    - \"steps.tests.passed\"\n    - \"steps.security.score > 80\"\n    - or:\n      - \"environment.mode == 'production'\"\n      - \"config.force_deploy == true\"\n    - not: \"steps.lint.has_errors\"\n```\n\n**Operators**:\n- `and`: All conditions must be true\n- `or`: Any condition must be true\n- `not`: Negates the condition","ref":"04_control_flow_logic.html#boolean-expressions"},{"type":"extras","title":"Comparison Operators - Control Flow","doc":"Available comparison operators:\n\n```yaml\n# Numeric comparisons\ncondition: \"steps.analysis.score >= 85\"\ncondition: \"steps.metrics.coverage < 70\"\ncondition: \"steps.count.value == 10\"\ncondition: \"steps.size.bytes != 0\"\n\n# String comparisons\ncondition: \"steps.detect.language == 'python'\"\ncondition: \"steps.check.status != 'failed'\"\n\n# String operations\ncondition: \"steps.file.path contains '.test.'\"\ncondition: \"steps.name.value starts_with 'test_'\"\ncondition: \"steps.url.value ends_with '.com'\"\ncondition: \"steps.file.name matches '^[a-z]+_test\\\\.py$'\"\n\n# Array operations\ncondition: \"steps.scan.language in ['python', 'javascript', 'ruby']\"\ncondition: \"'critical' in steps.issues.severities\"\ncondition: \"steps.results.count > 0\"\n\n# Special operators\ncondition: \"steps.score.value between 70 and 90\"\ncondition: \"steps.optional_field exists\"\ncondition: \"steps.results.items empty\"\n```","ref":"04_control_flow_logic.html#comparison-operators"},{"type":"extras","title":"Complex Conditions - Control Flow","doc":"Advanced condition patterns:\n\n```yaml\n# Mathematical expressions\ncondition: \"steps.metrics.score * steps.metrics.weight > 100\"\n\n# Function calls\ncondition: \"length(steps.files.results) > 10\"\ncondition: \"any(steps.tests.results, 'status == \\\"failed\\\"')\"\ncondition: \"all(steps.checks.results, 'passed == true')\"\n\n# Date/time comparisons\ncondition: \"steps.build.timestamp > now() - hours(24)\"\ncondition: \"steps.created.date   90\"\n      - and:\n        - \"steps.tests.coverage > 80\"\n        - \"steps.review.approved\"\n    - not:\n      and:\n        - \"steps.security.has_vulnerabilities\"\n        - \"steps.security.severity == 'critical'\"\n```","ref":"04_control_flow_logic.html#complex-conditions"},{"type":"extras","title":"Loop Constructs - Control Flow","doc":"","ref":"04_control_flow_logic.html#loop-constructs"},{"type":"extras","title":"For Loops - Control Flow","doc":"Iterate over collections:\n\n```yaml\n- name: \"process_files\"\n  type: \"for_loop\"\n  iterator: \"file\"                    # Loop variable name\n  data_source: \"steps.scan.files\"     # Array to iterate\n  \n  # Loop configuration\n  break_on_error: false               # Continue on errors\n  max_iterations: 100                 # Safety limit\n  \n  steps:\n    - name: \"validate_file\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Validate file: {{loop.file.path}}\"\n      condition: \"loop.file.size > 0\"\n    \n    - name: \"process_file\"\n      type: \"claude\"\n      prompt:\n        - type: \"static\"\n          content: |\n            Process file {{loop.index}} of {{loop.length}}:\n            Name: {{loop.file.name}}\n            Path: {{loop.file.path}}\n            First: {{loop.is_first}}\n            Last: {{loop.is_last}}\n```\n\n**Loop Variables**:\n- `{{loop.iterator}}`: Current item (e.g., `{{loop.file}}`)\n- `{{loop.index}}`: Current index (0-based)\n- `{{loop.length}}`: Total items\n- `{{loop.is_first}}`: Boolean first iteration\n- `{{loop.is_last}}`: Boolean last iteration\n\n**Data Sources**:\n```yaml\n# From previous step\ndata_source: \"steps.gather.items\"\n\n# Static array\ndata_source: [\"file1.py\", \"file2.py\", \"file3.py\"]\n\n# Variable reference\ndata_source: \"{{state.file_list}}\"\n\n# Range (future)\ndata_source: \"range(1, 10)\"\n```","ref":"04_control_flow_logic.html#for-loops"},{"type":"extras","title":"While Loops - Control Flow","doc":"Repeat until condition is met:\n\n```yaml\n- name: \"optimize_performance\"\n  type: \"while_loop\"\n  condition: \"steps.benchmark.score < 90\"\n  max_iterations: 10\n  timeout_seconds: 3600\n  \n  steps:\n    - name: \"analyze_bottlenecks\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Identify performance bottlenecks\"\n        - type: \"previous_response\"\n          step: \"benchmark\"\n    \n    - name: \"optimize\"\n      type: \"claude\"\n      prompt:\n        - type: \"static\"\n          content: \"Optimize the identified bottlenecks\"\n        - type: \"previous_response\"\n          step: \"analyze_bottlenecks\"\n    \n    - name: \"benchmark\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Run performance benchmark and return score\"\n```\n\n**Safety Features**:\n- `max_iterations`: Prevents infinite loops\n- `timeout_seconds`: Total time limit\n- Automatic break on errors (configurable)","ref":"04_control_flow_logic.html#while-loops"},{"type":"extras","title":"Nested Loops - Control Flow","doc":"Loops within loops:\n\n```yaml\n- name: \"process_categories\"\n  type: \"for_loop\"\n  iterator: \"category\"\n  data_source: \"steps.organize.categories\"\n  \n  steps:\n    - name: \"process_category_items\"\n      type: \"for_loop\"\n      iterator: \"item\"\n      data_source: \"loop.category.items\"\n      \n      steps:\n        - name: \"analyze_item\"\n          type: \"gemini\"\n          prompt:\n            - type: \"static\"\n              content: |\n                Category: {{loop.parent.category.name}}\n                Item: {{loop.item.name}}\n                Category Index: {{loop.parent.index}}\n                Item Index: {{loop.index}}\n```\n\n**Parent Access**:\n- `{{loop.parent.iterator}}`: Parent loop variable\n- `{{loop.parent.index}}`: Parent loop index\n- `{{loop.parent.parent.iterator}}`: Grandparent access","ref":"04_control_flow_logic.html#nested-loops"},{"type":"extras","title":"Parallel Loops - Control Flow","doc":"Execute loop iterations concurrently:\n\n```yaml\n- name: \"parallel_processing\"\n  type: \"for_loop\"\n  iterator: \"task\"\n  data_source: \"steps.prepare.tasks\"\n  \n  # Parallel configuration\n  parallel: true\n  max_parallel: 5                     # Concurrent limit\n  ordered_results: true               # Maintain order\n  \n  steps:\n    - name: \"process_task\"\n      type: \"claude\"\n      prompt:\n        - type: \"static\"\n          content: \"Process task: {{loop.task.id}}\"\n```\n\n**Parallel Features**:\n- Independent execution\n- Resource pooling\n- Result ordering\n- Error isolation","ref":"04_control_flow_logic.html#parallel-loops"},{"type":"extras","title":"Branching Logic - Control Flow","doc":"","ref":"04_control_flow_logic.html#branching-logic"},{"type":"extras","title":"Switch/Case - Control Flow","doc":"Value-based branching:\n\n```yaml\n- name: \"handle_by_type\"\n  type: \"switch\"\n  expression: \"steps.detect.file_type\"\n  \n  cases:\n    \"python\":\n      - name: \"lint_python\"\n        type: \"claude\"\n        prompt:\n          - type: \"static\"\n            content: \"Run Python linting with pylint\"\n      \n      - name: \"test_python\"\n        type: \"claude\"\n        prompt:\n          - type: \"static\"\n            content: \"Run pytest\"\n    \n    \"javascript\":\n      - name: \"lint_js\"\n        type: \"claude\"\n        prompt:\n          - type: \"static\"\n            content: \"Run ESLint\"\n      \n      - name: \"test_js\"\n        type: \"claude\"\n        prompt:\n          - type: \"static\"\n            content: \"Run Jest tests\"\n    \n    \"go\":\n      - name: \"lint_go\"\n        type: \"claude\"\n        prompt:\n          - type: \"static\"\n            content: \"Run go fmt and go vet\"\n  \n  default:\n    - name: \"generic_lint\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Perform generic code analysis\"\n```\n\n**Pattern Matching** (future):\n```yaml\ncases:\n  \"test_*.py\":\n    # Handle test files\n  \"src/**/*.js\":\n    # Handle source JS files\n  \"*.{yaml,yml}\":\n    # Handle YAML files\n```","ref":"04_control_flow_logic.html#switch-case"},{"type":"extras","title":"Multi-Branch Conditions - Control Flow","doc":"Complex branching with multiple paths:\n\n```yaml\nsteps:\n  - name: \"evaluate_risk\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Evaluate deployment risk level\"\n  \n  # High risk path\n  - name: \"manual_review\"\n    type: \"claude\"\n    condition:\n      and:\n        - \"steps.evaluate_risk.risk_level == 'high'\"\n        - \"environment.mode == 'production'\"\n    prompt:\n      - type: \"static\"\n        content: \"Create manual review checklist\"\n  \n  # Medium risk path\n  - name: \"automated_tests\"\n    type: \"claude\"\n    condition:\n      and:\n        - \"steps.evaluate_risk.risk_level == 'medium'\"\n        - not: \"steps.manual_review\"\n    prompt:\n      - type: \"static\"\n        content: \"Run comprehensive test suite\"\n  \n  # Low risk path\n  - name: \"quick_deploy\"\n    type: \"claude\"\n    condition:\n      and:\n        - \"steps.evaluate_risk.risk_level == 'low'\"\n        - not: \"steps.manual_review\"\n        - not: \"steps.automated_tests\"\n    prompt:\n      - type: \"static\"\n        content: \"Proceed with streamlined deployment\"\n```","ref":"04_control_flow_logic.html#multi-branch-conditions"},{"type":"extras","title":"State Management - Control Flow","doc":"","ref":"04_control_flow_logic.html#state-management"},{"type":"extras","title":"Variables - Control Flow","doc":"Set and manage workflow variables:\n\n```yaml\nsteps:\n  - name: \"initialize\"\n    type: \"set_variable\"\n    variables:\n      counter: 0\n      results: []\n      config:\n        retry_limit: 3\n        timeout: 300\n      \n  - name: \"update_counter\"\n    type: \"set_variable\"\n    variables:\n      counter: \"{{state.counter + 1}}\"\n      \n  - name: \"append_result\"\n    type: \"set_variable\"\n    variables:\n      results: \"{{append(state.results, steps.process.result)}}\"\n```\n\n**Variable Operations**:\n```yaml\n# Arithmetic\nsum: \"{{state.a + state.b}}\"\nproduct: \"{{state.x * state.y}}\"\nremainder: \"{{state.total % state.batch_size}}\"\n\n# String operations\nfull_name: \"{{state.first_name + ' ' + state.last_name}}\"\nuppercase: \"{{upper(state.text)}}\"\nsubstring: \"{{substring(state.text, 0, 10)}}\"\n\n# Array operations\ncount: \"{{length(state.items)}}\"\nfirst: \"{{state.items[0]}}\"\nfiltered: \"{{filter(state.items, 'active == true')}}\"\nmapped: \"{{map(state.items, 'name')}}\"\n\n# Object operations\nvalue: \"{{state.config.database.host}}\"\nkeys: \"{{keys(state.config)}}\"\nmerged: \"{{merge(state.defaults, state.overrides)}}\"\n```","ref":"04_control_flow_logic.html#variables"},{"type":"extras","title":"Variable Scoping - Control Flow","doc":"Three levels of variable scope:\n\n```yaml\nworkflow:\n  # Global variables\n  variables:\n    api_key: \"${API_KEY}\"\n    environment: \"production\"\n  \n  steps:\n    - name: \"process\"\n      type: \"set_variable\"\n      scope: \"global\"             # Available to all steps\n      variables:\n        shared_data: \"value\"\n    \n    - name: \"local_work\"\n      type: \"set_variable\"\n      scope: \"local\"              # Current step only\n      variables:\n        temp_data: \"temporary\"\n    \n    - name: \"session_data\"\n      type: \"set_variable\"\n      scope: \"session\"            # Persists across runs\n      variables:\n        run_count: \"{{state.run_count + 1}}\"\n```\n\n**Variable Resolution Order**:\n1. Local scope\n2. Step variables\n3. Global scope\n4. Workflow variables\n5. Environment variables","ref":"04_control_flow_logic.html#variable-scoping"},{"type":"extras","title":"State Persistence - Control Flow","doc":"Save and restore workflow state:\n\n```yaml\nsteps:\n  - name: \"checkpoint_before_critical\"\n    type: \"checkpoint\"\n    state:\n      current_phase: \"data_processing\"\n      processed_items: \"{{state.processed_items}}\"\n      error_count: \"{{state.error_count}}\"\n    checkpoint_name: \"before_critical_operation\"\n    \n  - name: \"critical_operation\"\n    type: \"claude\"\n    prompt:\n      - type: \"static\"\n        content: \"Perform critical data transformation\"\n    \n  - name: \"checkpoint_after_critical\"\n    type: \"checkpoint\"\n    state:\n      current_phase: \"data_processed\"\n      transformation_complete: true\n    include_workspace: true\n```\n\n**Checkpoint Features**:\n- Named checkpoints\n- Workspace backup\n- Automatic recovery\n- State versioning","ref":"04_control_flow_logic.html#state-persistence"},{"type":"extras","title":"Parallel Execution - Control Flow","doc":"","ref":"04_control_flow_logic.html#parallel-execution"},{"type":"extras","title":"Parallel Steps - Control Flow","doc":"Execute multiple steps concurrently:\n\n```yaml\n- name: \"parallel_analysis\"\n  type: \"parallel_claude\"\n  parallel_tasks:\n    - id: \"security\"\n      claude_options:\n        max_turns: 15\n        allowed_tools: [\"Read\"]\n      prompt:\n        - type: \"file\"\n          path: \"prompts/security_analysis.md\"\n      output_to_file: \"security_results.json\"\n      \n    - id: \"performance\"\n      claude_options:\n        max_turns: 15\n        allowed_tools: [\"Read\", \"Bash\"]\n      prompt:\n        - type: \"file\"\n          path: \"prompts/performance_analysis.md\"\n      output_to_file: \"performance_results.json\"\n      \n    - id: \"quality\"\n      claude_options:\n        max_turns: 10\n        allowed_tools: [\"Read\"]\n      prompt:\n        - type: \"file\"\n          path: \"prompts/code_quality.md\"\n      output_to_file: \"quality_results.json\"\n```","ref":"04_control_flow_logic.html#parallel-steps"},{"type":"extras","title":"Synchronization - Control Flow","doc":"Coordinate parallel execution:\n\n```yaml\nsteps:\n  # Launch parallel tasks\n  - name: \"parallel_work\"\n    type: \"parallel_claude\"\n    parallel_tasks:\n      - id: \"task1\"\n        # ... task configuration\n      - id: \"task2\"\n        # ... task configuration\n  \n  # Wait for all to complete\n  - name: \"aggregate_results\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Combine results from parallel tasks:\"\n      - type: \"previous_response\"\n        step: \"parallel_work\"\n```\n\n**Synchronization Patterns**:\n- Wait for all (default)\n- First to complete (future)\n- Timeout with partial results\n- Error threshold","ref":"04_control_flow_logic.html#synchronization"},{"type":"extras","title":"Error Handling & Recovery - Control Flow","doc":"","ref":"04_control_flow_logic.html#error-handling-recovery"},{"type":"extras","title":"Error Conditions - Control Flow","doc":"Handle errors in control flow:\n\n```yaml\nsteps:\n  - name: \"risky_operation\"\n    type: \"claude\"\n    continue_on_error: true\n    error_output: \"error_details\"\n    prompt:\n      - type: \"static\"\n        content: \"Perform operation that might fail\"\n  \n  - name: \"handle_error\"\n    type: \"gemini\"\n    condition: \"steps.risky_operation.error != null\"\n    prompt:\n      - type: \"static\"\n        content: \"Analyze error and suggest recovery:\"\n      - type: \"previous_response\"\n        step: \"risky_operation\"\n        extract: \"error_details\"\n```","ref":"04_control_flow_logic.html#error-conditions"},{"type":"extras","title":"Retry Logic - Control Flow","doc":"Built-in retry mechanisms:\n\n```yaml\n- name: \"retry_loop\"\n  type: \"while_loop\"\n  condition: \"state.retry_count < 3 and steps.attempt.success != true\"\n  \n  steps:\n    - name: \"attempt\"\n      type: \"claude_robust\"\n      retry_config:\n        max_retries: 2\n        backoff_strategy: \"exponential\"\n      prompt:\n        - type: \"static\"\n          content: \"Attempt operation\"\n    \n    - name: \"increment_retry\"\n      type: \"set_variable\"\n      variables:\n        retry_count: \"{{state.retry_count + 1}}\"\n```","ref":"04_control_flow_logic.html#retry-logic"},{"type":"extras","title":"Advanced Patterns - Control Flow","doc":"","ref":"04_control_flow_logic.html#advanced-patterns"},{"type":"extras","title":"State Machines - Control Flow","doc":"Implement state machine logic:\n\n```yaml\nworkflow:\n  variables:\n    current_state: \"initial\"\n  \n  steps:\n    - name: \"state_machine\"\n      type: \"while_loop\"\n      condition: \"state.current_state != 'complete'\"\n      max_iterations: 20\n      \n      steps:\n        - name: \"handle_state\"\n          type: \"switch\"\n          expression: \"state.current_state\"\n          \n          cases:\n            \"initial\":\n              - name: \"initialize\"\n                type: \"gemini\"\n                prompt:\n                  - type: \"static\"\n                    content: \"Initialize process\"\n              - name: \"set_next_state\"\n                type: \"set_variable\"\n                variables:\n                  current_state: \"processing\"\n            \n            \"processing\":\n              - name: \"process\"\n                type: \"claude\"\n                prompt:\n                  - type: \"static\"\n                    content: \"Process data\"\n              - name: \"check_completion\"\n                type: \"set_variable\"\n                variables:\n                  current_state: \"{{steps.process.done ? 'review' : 'processing'}}\"\n            \n            \"review\":\n              - name: \"review\"\n                type: \"gemini\"\n                prompt:\n                  - type: \"static\"\n                    content: \"Review results\"\n              - name: \"finalize\"\n                type: \"set_variable\"\n                variables:\n                  current_state: \"complete\"\n```","ref":"04_control_flow_logic.html#state-machines"},{"type":"extras","title":"Dynamic Workflow Generation - Control Flow","doc":"Generate workflow steps dynamically:\n\n```yaml\nsteps:\n  - name: \"plan_workflow\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Create a list of tasks to perform\"\n    output_schema:\n      type: \"object\"\n      properties:\n        tasks:\n          type: \"array\"\n          items:\n            type: \"object\"\n            properties:\n              name: {type: \"string\"}\n              type: {type: \"string\"}\n              prompt: {type: \"string\"}\n  \n  - name: \"execute_planned_tasks\"\n    type: \"for_loop\"\n    iterator: \"task\"\n    data_source: \"steps.plan_workflow.tasks\"\n    \n    steps:\n      - name: \"dynamic_execution\"\n        type: \"{{loop.task.type}}\"\n        prompt:\n          - type: \"static\"\n            content: \"{{loop.task.prompt}}\"\n```","ref":"04_control_flow_logic.html#dynamic-workflow-generation"},{"type":"extras","title":"Recursive Control Flow - Control Flow","doc":"Control flow with recursive patterns:\n\n```yaml\n- name: \"recursive_search\"\n  type: \"pipeline\"\n  pipeline:\n    name: \"search_tree\"\n    steps:\n      - name: \"examine_node\"\n        type: \"gemini\"\n        prompt:\n          - type: \"static\"\n            content: \"Examine node: {{inputs.node}}\"\n      \n      - name: \"process_children\"\n        type: \"for_loop\"\n        iterator: \"child\"\n        data_source: \"steps.examine_node.children\"\n        condition: \"steps.examine_node.has_children\"\n        \n        steps:\n          - name: \"recurse\"\n            type: \"pipeline\"\n            pipeline_ref: \"search_tree\"\n            inputs:\n              node: \"{{loop.child}}\"\n            config:\n              max_depth: 5\n```\n\nThis reference provides comprehensive documentation for control flow and logic capabilities in Pipeline YAML v2 format.","ref":"04_control_flow_logic.html#recursive-control-flow"},{"type":"extras","title":"Pipeline Composition","doc":"# Pipeline Composition Reference","ref":"05_pipeline_composition.html"},{"type":"extras","title":"Table of Contents - Pipeline Composition","doc":"1. [Overview](#overview)\n2. [Pipeline Step Type](#pipeline-step-type)\n3. [Input Mapping](#input-mapping)\n4. [Output Extraction](#output-extraction)\n5. [Context Management](#context-management)\n6. [Safety Features](#safety-features)\n7. [Execution Configuration](#execution-configuration)\n8. [Design Patterns](#design-patterns)\n9. [Best Practices](#best-practices)\n10. [Troubleshooting](#troubleshooting)","ref":"05_pipeline_composition.html#table-of-contents"},{"type":"extras","title":"Overview - Pipeline Composition","doc":"Pipeline composition enables building complex workflows from smaller, reusable pipeline components. This modular approach provides:\n\n- **Reusability**: Share common workflows across projects\n- **Maintainability**: Update shared logic in one place\n- **Testability**: Test pipeline components in isolation\n- **Scalability**: Build arbitrarily complex workflows\n- **Organization**: Separate concerns into logical units","ref":"05_pipeline_composition.html#overview"},{"type":"extras","title":"Pipeline Step Type - Pipeline Composition","doc":"The `pipeline` step type executes another complete pipeline as a single step:\n\n```yaml\n- name: \"data_processing\"\n  type: \"pipeline\"\n  \n  # Pipeline source (one required)\n  pipeline_file: \"./pipelines/data_processor.yaml\"    # External file\n  pipeline_ref: \"common/data_processor\"               # Registry (future)\n  pipeline:                                           # Inline definition\n    name: \"inline_processor\"\n    steps:\n      - name: \"process\"\n        type: \"gemini\"\n        prompt:\n          - type: \"static\"\n            content: \"Process data\"\n```","ref":"05_pipeline_composition.html#pipeline-step-type"},{"type":"extras","title":"External Pipeline Files - Pipeline Composition","doc":"Most common approach - reference external YAML files:\n\n```yaml\nsteps:\n  - name: \"security_scan\"\n    type: \"pipeline\"\n    pipeline_file: \"./pipelines/security/vulnerability_scanner.yaml\"\n    inputs:\n      target_directory: \"./src\"\n      scan_depth: \"comprehensive\"\n    outputs:\n      - \"vulnerabilities\"\n      - \"security_score\"\n```\n\n**File Organization**:\n```\npipelines/\n├── components/           # Reusable components\n│   ├── data/\n│   │   ├── validator.yaml\n│   │   ├── transformer.yaml\n│   │   └── aggregator.yaml\n│   ├── analysis/\n│   │   ├── code_review.yaml\n│   │   ├── security_scan.yaml\n│   │   └── performance_check.yaml\n│   └── generation/\n│       ├── test_generator.yaml\n│       └── doc_generator.yaml\n├── workflows/           # Complete workflows\n│   ├── full_analysis.yaml\n│   └── deployment.yaml\n└── templates/          # Pipeline templates\n    └── standard_review.yaml\n```","ref":"05_pipeline_composition.html#external-pipeline-files"},{"type":"extras","title":"Inline Pipeline Definition - Pipeline Composition","doc":"Define pipelines directly within the parent:\n\n```yaml\n- name: \"quick_validation\"\n  type: \"pipeline\"\n  pipeline:\n    name: \"inline_validator\"\n    steps:\n      - name: \"syntax_check\"\n        type: \"gemini\"\n        prompt:\n          - type: \"static\"\n            content: \"Check syntax validity\"\n          - type: \"static\"\n            content: \"{{inputs.code}}\"\n      \n      - name: \"semantic_check\"\n        type: \"gemini\"\n        prompt:\n          - type: \"static\"\n            content: \"Verify semantic correctness\"\n          - type: \"previous_response\"\n            step: \"syntax_check\"\n```","ref":"05_pipeline_composition.html#inline-pipeline-definition"},{"type":"extras","title":"Pipeline Registry (Future) - Pipeline Composition","doc":"Reference pipelines from a central registry:\n\n```yaml\n- name: \"standard_security_scan\"\n  type: \"pipeline\"\n  pipeline_ref: \"security/owasp_top_10_scan\"\n  version: \"2.1.0\"\n  inputs:\n    target: \"{{workspace.path}}\"\n```","ref":"05_pipeline_composition.html#pipeline-registry-future"},{"type":"extras","title":"Input Mapping - Pipeline Composition","doc":"Pass data from parent to child pipeline:\n\n```yaml\n- name: \"analyze_code\"\n  type: \"pipeline\"\n  pipeline_file: \"./pipelines/code_analyzer.yaml\"\n  \n  inputs:\n    # Direct values\n    language: \"python\"\n    framework: \"django\"\n    \n    # From previous steps\n    source_code: \"{{steps.extract.code}}\"\n    requirements: \"{{steps.parse.requirements}}\"\n    \n    # From workflow context\n    project_name: \"{{workflow.project_name}}\"\n    environment: \"{{workflow.environment}}\"\n    \n    # From state variables\n    analysis_config: \"{{state.config}}\"\n    \n    # Complex expressions\n    threshold: \"{{state.base_threshold * 1.5}}\"\n    \n    # Arrays and objects\n    files_to_analyze: \"{{steps.scan.python_files}}\"\n    options:\n      depth: \"comprehensive\"\n      include_tests: true\n      metrics: [\"complexity\", \"coverage\", \"quality\"]\n```","ref":"05_pipeline_composition.html#input-mapping"},{"type":"extras","title":"Type Preservation - Pipeline Composition","doc":"Single template references preserve their original type:\n\n```yaml\ninputs:\n  # Preserves integer type\n  max_iterations: \"{{config.iterations}}\"        # → 10\n  \n  # Preserves object type  \n  settings: \"{{steps.load.config}}\"              # → {\"timeout\": 30, \"retry\": 3}\n  \n  # Preserves array type\n  items: \"{{steps.gather.results}}\"              # → [\"a\", \"b\", \"c\"]\n  \n  # String concatenation forces string type\n  message: \"Count: {{config.iterations}}\"        # → \"Count: 10\"\n```","ref":"05_pipeline_composition.html#type-preservation"},{"type":"extras","title":"Input Validation - Pipeline Composition","doc":"Child pipelines can validate inputs:\n\n```yaml\n# child_pipeline.yaml\nworkflow:\n  name: \"validated_processor\"\n  \n  # Input schema (future)\n  input_schema:\n    type: \"object\"\n    required: [\"data\", \"format\"]\n    properties:\n      data:\n        type: \"array\"\n        minItems: 1\n      format:\n        type: \"string\"\n        enum: [\"json\", \"csv\", \"xml\"]\n  \n  steps:\n    - name: \"process\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Process {{inputs.data}} in {{inputs.format}} format\"\n```","ref":"05_pipeline_composition.html#input-validation"},{"type":"extras","title":"Output Extraction - Pipeline Composition","doc":"Extract specific results from nested pipelines:\n\n```yaml\n- name: \"run_analysis\"\n  type: \"pipeline\"\n  pipeline_file: \"./analyzer.yaml\"\n  \n  outputs:\n    # Simple extraction - gets steps.{name}.result\n    - \"final_report\"\n    \n    # Path-based extraction\n    - path: \"metrics.security.score\"\n      as: \"security_score\"\n    \n    - path: \"analysis.vulnerabilities\"\n      as: \"vulnerabilities_list\"\n    \n    - path: \"summary.recommendations[0]\"\n      as: \"top_recommendation\"\n```","ref":"05_pipeline_composition.html#output-extraction"},{"type":"extras","title":"Output Patterns - Pipeline Composition","doc":"**Simple Extraction**:\n```yaml\noutputs:\n  - \"step_name\"    # Extracts steps.step_name.result\n```\n\n**Path Extraction**:\n```yaml\noutputs:\n  - path: \"data.items[0].value\"\n    as: \"first_value\"\n  \n  - path: \"metrics.performance.response_time\"\n    as: \"response_time\"\n```\n\n**Multiple Extractions**:\n```yaml\noutputs:\n  - path: \"analysis.score\"\n    as: \"quality_score\"\n  \n  - path: \"analysis.issues\"\n    as: \"found_issues\"\n  \n  - path: \"recommendations\"\n    as: \"improvement_suggestions\"\n```","ref":"05_pipeline_composition.html#output-patterns"},{"type":"extras","title":"Using Extracted Outputs - Pipeline Composition","doc":"```yaml\nsteps:\n  - name: \"security_pipeline\"\n    type: \"pipeline\"\n    pipeline_file: \"./security_scan.yaml\"\n    outputs:\n      - path: \"scan.vulnerabilities\"\n        as: \"vulns\"\n      - path: \"scan.risk_score\"\n        as: \"risk\"\n  \n  - name: \"process_results\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: |\n          Risk Score: {{steps.security_pipeline.risk}}\n          Vulnerabilities Found: {{length(steps.security_pipeline.vulns)}}\n          \n          Details:\n      - type: \"static\"\n        content: \"{{steps.security_pipeline.vulns}}\"\n```","ref":"05_pipeline_composition.html#using-extracted-outputs"},{"type":"extras","title":"Context Management - Pipeline Composition","doc":"","ref":"05_pipeline_composition.html#context-management"},{"type":"extras","title":"Context Inheritance - Pipeline Composition","doc":"Control what context is passed to child pipelines:\n\n```yaml\n- name: \"child_pipeline\"\n  type: \"pipeline\"\n  pipeline_file: \"./child.yaml\"\n  \n  config:\n    inherit_context: true        # Pass all parent context\n    inherit_providers: true      # Inherit API configurations\n    inherit_functions: false     # Don't inherit function definitions\n```\n\n**Inheritance Options**:\n- `inherit_context`: Share variables and state\n- `inherit_providers`: Share API keys and settings\n- `inherit_functions`: Share Gemini function definitions","ref":"05_pipeline_composition.html#context-inheritance"},{"type":"extras","title":"Context Isolation - Pipeline Composition","doc":"Each pipeline maintains its own context:\n\n```yaml\n# Parent pipeline\nworkflow:\n  name: \"parent\"\n  variables:\n    shared_var: \"parent_value\"\n    private_var: \"parent_only\"\n  \n  steps:\n    - name: \"child_isolated\"\n      type: \"pipeline\"\n      pipeline_file: \"./child.yaml\"\n      config:\n        inherit_context: false    # Complete isolation\n      inputs:\n        # Explicitly pass needed values\n        needed_var: \"{{variables.shared_var}}\"\n```","ref":"05_pipeline_composition.html#context-isolation"},{"type":"extras","title":"Variable Resolution - Pipeline Composition","doc":"Variable resolution follows a hierarchical order:\n\n1. Child pipeline's local variables\n2. Child pipeline's inputs\n3. Inherited parent context (if enabled)\n4. Parent's parent context (recursive)\n\n```yaml\n# Variable resolution example\n- name: \"nested_pipeline\"\n  type: \"pipeline\"\n  pipeline_file: \"./nested.yaml\"\n  config:\n    inherit_context: true\n  inputs:\n    # These override any inherited values\n    override_var: \"child_specific_value\"\n```","ref":"05_pipeline_composition.html#variable-resolution"},{"type":"extras","title":"Safety Features - Pipeline Composition","doc":"","ref":"05_pipeline_composition.html#safety-features"},{"type":"extras","title":"Recursion Protection - Pipeline Composition","doc":"Prevent infinite recursion and circular dependencies:\n\n```yaml\n- name: \"recursive_pipeline\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  \n  config:\n    max_depth: 5                 # Maximum nesting depth\n```\n\n**Circular Dependency Detection**:\n```yaml\n# pipeline_a.yaml\n- name: \"call_b\"\n  type: \"pipeline\"\n  pipeline_file: \"./pipeline_b.yaml\"\n\n# pipeline_b.yaml\n- name: \"call_a\"\n  type: \"pipeline\"\n  pipeline_file: \"./pipeline_a.yaml\"  # ERROR: Circular dependency!\n```","ref":"05_pipeline_composition.html#recursion-protection"},{"type":"extras","title":"Resource Limits - Pipeline Composition","doc":"Control resource usage:\n\n```yaml\n- name: \"resource_limited\"\n  type: \"pipeline\"\n  pipeline_file: \"./heavy_processor.yaml\"\n  \n  config:\n    memory_limit_mb: 1024        # 1GB memory limit\n    timeout_seconds: 300         # 5 minute timeout\n    max_total_steps: 100         # Step count limit\n```","ref":"05_pipeline_composition.html#resource-limits"},{"type":"extras","title":"Error Boundaries - Pipeline Composition","doc":"Isolate errors within child pipelines:\n\n```yaml\n- name: \"error_isolated\"\n  type: \"pipeline\"\n  pipeline_file: \"./risky_operation.yaml\"\n  \n  config:\n    continue_on_error: true      # Don't fail parent\n    capture_errors: true         # Store error details\n  \n  # Handle errors in parent\n  error_handler:\n    - name: \"handle_child_error\"\n      type: \"gemini\"\n      condition: \"steps.error_isolated.error != null\"\n      prompt:\n        - type: \"static\"\n          content: \"Child pipeline failed: {{steps.error_isolated.error}}\"\n```","ref":"05_pipeline_composition.html#error-boundaries"},{"type":"extras","title":"Execution Configuration - Pipeline Composition","doc":"","ref":"05_pipeline_composition.html#execution-configuration"},{"type":"extras","title":"Workspace Management - Pipeline Composition","doc":"Each pipeline can have its own workspace:\n\n```yaml\n- name: \"isolated_workspace\"\n  type: \"pipeline\"\n  pipeline_file: \"./file_processor.yaml\"\n  \n  config:\n    workspace_dir: \"./nested/{{step.name}}\"\n    cleanup_on_success: true     # Remove after completion\n    cleanup_on_error: false      # Keep for debugging\n```","ref":"05_pipeline_composition.html#workspace-management"},{"type":"extras","title":"Checkpointing - Pipeline Composition","doc":"Nested checkpoint configuration:\n\n```yaml\n- name: \"checkpointed_pipeline\"\n  type: \"pipeline\"\n  pipeline_file: \"./long_running.yaml\"\n  \n  config:\n    checkpoint_enabled: true\n    checkpoint_frequency: 10     # Every 10 steps\n    checkpoint_dir: \"./checkpoints/nested\"\n```","ref":"05_pipeline_composition.html#checkpointing"},{"type":"extras","title":"Execution Modes - Pipeline Composition","doc":"```yaml\n- name: \"execution_modes\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  \n  config:\n    # Tracing and debugging\n    enable_tracing: true\n    trace_metadata:\n      request_id: \"{{inputs.request_id}}\"\n      user_id: \"{{inputs.user_id}}\"\n    \n    # Performance\n    cache_enabled: true          # Cache pipeline definition\n    lazy_load: true              # Load only when needed\n    \n    # Retry configuration\n    max_retries: 2\n    retry_on: [\"timeout\", \"resource_limit\"]\n```","ref":"05_pipeline_composition.html#execution-modes"},{"type":"extras","title":"Design Patterns - Pipeline Composition","doc":"","ref":"05_pipeline_composition.html#design-patterns"},{"type":"extras","title":"Component Library Pattern - Pipeline Composition","doc":"Build a library of reusable components:\n\n```yaml\n# components/validation/schema_validator.yaml\nworkflow:\n  name: \"schema_validator\"\n  description: \"Validates data against JSON schema\"\n  \n  steps:\n    - name: \"validate\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: |\n            Validate this data against the schema:\n            Data: {{inputs.data}}\n            Schema: {{inputs.schema}}\n```\n\nUsage:\n```yaml\nsteps:\n  - name: \"validate_user_data\"\n    type: \"pipeline\"\n    pipeline_file: \"./components/validation/schema_validator.yaml\"\n    inputs:\n      data: \"{{steps.parse.user_data}}\"\n      schema: \"{{config.user_schema}}\"\n```","ref":"05_pipeline_composition.html#component-library-pattern"},{"type":"extras","title":"Pipeline Template Pattern - Pipeline Composition","doc":"Create parameterized pipeline templates:\n\n```yaml\n# templates/standard_analysis.yaml\nworkflow:\n  name: \"standard_analysis_template\"\n  \n  steps:\n    - name: \"analyze\"\n      type: \"{{inputs.analyzer_type}}\"\n      prompt:\n        - type: \"file\"\n          path: \"{{inputs.prompt_path}}\"\n        - type: \"file\"\n          path: \"{{inputs.target_path}}\"\n```","ref":"05_pipeline_composition.html#pipeline-template-pattern"},{"type":"extras","title":"Hierarchical Composition - Pipeline Composition","doc":"Build complex workflows from layers:\n\n```yaml\n# Top-level workflow\nworkflow:\n  name: \"complete_system\"\n  \n  steps:\n    - name: \"data_pipeline\"\n      type: \"pipeline\"\n      pipeline_file: \"./pipelines/data_pipeline.yaml\"\n      \n    - name: \"analysis_pipeline\"\n      type: \"pipeline\"\n      pipeline_file: \"./pipelines/analysis_pipeline.yaml\"\n      inputs:\n        data: \"{{steps.data_pipeline.processed_data}}\"\n    \n    - name: \"reporting_pipeline\"\n      type: \"pipeline\"\n      pipeline_file: \"./pipelines/reporting_pipeline.yaml\"\n      inputs:\n        analysis: \"{{steps.analysis_pipeline.results}}\"\n```","ref":"05_pipeline_composition.html#hierarchical-composition"},{"type":"extras","title":"Factory Pattern - Pipeline Composition","doc":"Dynamically select pipelines:\n\n```yaml\nsteps:\n  - name: \"detect_type\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Detect the project type\"\n  \n  - name: \"run_appropriate_pipeline\"\n    type: \"pipeline\"\n    pipeline_file: \"./pipelines/{{steps.detect_type.project_type}}_analyzer.yaml\"\n    inputs:\n      project_path: \"./src\"\n```","ref":"05_pipeline_composition.html#factory-pattern"},{"type":"extras","title":"Recursive Processing Pattern - Pipeline Composition","doc":"Process hierarchical data structures:\n\n```yaml\nworkflow:\n  name: \"tree_processor\"\n  \n  steps:\n    - name: \"process_node\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Process node: {{inputs.node}}\"\n    \n    - name: \"process_children\"\n      type: \"for_loop\"\n      iterator: \"child\"\n      data_source: \"steps.process_node.children\"\n      \n      steps:\n        - name: \"recurse\"\n          type: \"pipeline\"\n          pipeline_ref: \"tree_processor\"\n          inputs:\n            node: \"{{loop.child}}\"\n          config:\n            max_depth: \"{{inputs.max_depth - 1}}\"\n```","ref":"05_pipeline_composition.html#recursive-processing-pattern"},{"type":"extras","title":"Best Practices - Pipeline Composition","doc":"","ref":"05_pipeline_composition.html#best-practices"},{"type":"extras","title":"1. Pipeline Organization - Pipeline Composition","doc":"**Single Responsibility**:\n- Each pipeline should have one clear purpose\n- Keep pipelines focused and cohesive\n- Avoid mixing unrelated functionality\n\n**Naming Conventions**:\n- Use descriptive names: `validate_user_input.yaml`\n- Include action verbs: `generate_`, `analyze_`, `transform_`\n- Group by domain: `security/scan_vulnerabilities.yaml`\n\n**Directory Structure**:\n```\npipelines/\n├── components/      # Small, reusable units\n├── workflows/       # Complete business workflows\n├── templates/       # Parameterized templates\n└── experimental/    # Work in progress\n```","ref":"05_pipeline_composition.html#1-pipeline-organization"},{"type":"extras","title":"2. Input/Output Design - Pipeline Composition","doc":"**Clear Interfaces**:\n```yaml\n# Document expected inputs\nworkflow:\n  name: \"data_processor\"\n  description: \"Processes raw data into structured format\"\n  \n  # Future: Input documentation\n  inputs:\n    raw_data:\n      type: \"array\"\n      description: \"Raw data records to process\"\n    format:\n      type: \"string\"\n      enum: [\"json\", \"csv\", \"xml\"]\n      description: \"Output format\"\n```\n\n**Minimal Coupling**:\n- Pass only required data\n- Avoid tight coupling between pipelines\n- Use clear, documented interfaces","ref":"05_pipeline_composition.html#2-input-output-design"},{"type":"extras","title":"3. Error Handling - Pipeline Composition","doc":"**Graceful Degradation**:\n```yaml\n- name: \"optional_enhancement\"\n  type: \"pipeline\"\n  pipeline_file: \"./enhance_data.yaml\"\n  config:\n    continue_on_error: true\n    fallback_value: \"{{inputs.original_data}}\"\n```\n\n**Error Context**:\n```yaml\n- name: \"critical_operation\"\n  type: \"pipeline\"\n  pipeline_file: \"./critical.yaml\"\n  \n  on_error:\n    - name: \"log_error\"\n      type: \"set_variable\"\n      variables:\n        error_context:\n          pipeline: \"critical_operation\"\n          inputs: \"{{inputs}}\"\n          error: \"{{error}}\"\n          timestamp: \"{{now()}}\"\n```","ref":"05_pipeline_composition.html#3-error-handling"},{"type":"extras","title":"4. Performance Optimization - Pipeline Composition","doc":"**Pipeline Caching**:\n```yaml\nconfig:\n  cache_pipeline: true           # Cache parsed pipeline\n  cache_ttl: 3600               # 1 hour TTL\n```\n\n**Lazy Loading**:\n```yaml\n- name: \"conditional_pipeline\"\n  type: \"pipeline\"\n  pipeline_file: \"./expensive_operation.yaml\"\n  condition: \"steps.check.requires_processing\"\n  config:\n    lazy_load: true             # Only load if condition met\n```\n\n**Resource Pooling**:\n```yaml\nconfig:\n  reuse_workspace: true         # Reuse workspace between runs\n  pool_size: 5                  # Connection pool size\n```","ref":"05_pipeline_composition.html#4-performance-optimization"},{"type":"extras","title":"5. Testing Strategies - Pipeline Composition","doc":"**Isolated Testing**:\n```yaml\n# Test individual pipeline components\nmix pipeline.run pipelines/components/validator.yaml \\\n  --inputs '{\"data\": \"test_data\", \"schema\": \"test_schema\"}'\n```\n\n**Mock Pipelines**:\n```yaml\n# Use mock pipelines for testing\n- name: \"test_with_mock\"\n  type: \"pipeline\"\n  pipeline_file: \"{{TEST_MODE ? './mocks/processor.yaml' : './processor.yaml'}}\"\n```","ref":"05_pipeline_composition.html#5-testing-strategies"},{"type":"extras","title":"Troubleshooting - Pipeline Composition","doc":"","ref":"05_pipeline_composition.html#troubleshooting"},{"type":"extras","title":"Common Issues - Pipeline Composition","doc":"**1. Circular Dependencies**\n```\nError: Circular dependency detected: A -> B -> C -> A\n```\nSolution: Review pipeline dependencies and remove cycles\n\n**2. Maximum Depth Exceeded**\n```\nError: Maximum nesting depth (10) exceeded\n```\nSolutions:\n- Increase `max_depth` configuration\n- Refactor to reduce nesting\n- Use iterative instead of recursive approach\n\n**3. Input Type Mismatch**\n```\nError: Expected array for 'items', got string\n```\nSolution: Ensure input types match expected types\n\n**4. Output Path Not Found**\n```\nError: Path 'results.data.value' not found in pipeline output\n```\nSolution: Verify the output structure matches extraction paths","ref":"05_pipeline_composition.html#common-issues"},{"type":"extras","title":"Debugging Tools - Pipeline Composition","doc":"**Execution Tracing**:\n```yaml\nconfig:\n  enable_tracing: true\n  trace_level: \"detailed\"       # Show all operations\n```\n\n**Debug Output**:\n```bash\nPIPELINE_DEBUG=true mix pipeline.run workflow.yaml\n```\n\n**Execution Visualization**:\n```\nExecution Tree:\n├─ main_workflow (0ms)\n│  ├─ data_prep (15ms)\n│  │  └─ validator (8ms)\n│  │     └─ schema_check: valid\n│  ├─ processor (125ms)\n│  │  ├─ transform (45ms)\n│  │  └─ aggregate (80ms)\n│  └─ reporter (22ms)\n```","ref":"05_pipeline_composition.html#debugging-tools"},{"type":"extras","title":"Performance Analysis - Pipeline Composition","doc":"**Metrics Collection**:\n```yaml\nconfig:\n  collect_metrics: true\n  metrics:\n    - execution_time\n    - memory_usage\n    - step_count\n```\n\n**Bottleneck Identification**:\n```\nPerformance Report:\n- Total Duration: 289ms\n- Slowest Pipeline: data_processor (125ms)\n- Memory Peak: 234MB\n- Total Steps: 15\n- Nesting Depth: 3\n```\n\nThis reference provides comprehensive documentation for pipeline composition in Pipeline YAML v2 format, enabling powerful modular workflow design.","ref":"05_pipeline_composition.html#performance-analysis"},{"type":"extras","title":"Advanced YAML Features","doc":"# Advanced Features Reference","ref":"06_advanced_features.html"},{"type":"extras","title":"Table of Contents - Advanced YAML Features","doc":"1. [Overview](#overview)\n2. [Data Transformation](#data-transformation)\n3. [Codebase Intelligence](#codebase-intelligence)\n4. [File Operations](#file-operations)\n5. [Schema Validation](#schema-validation)\n6. [Function Calling](#function-calling)\n7. [Session Management](#session-management)\n8. [Content Processing](#content-processing)\n9. [Performance Features](#performance-features)\n10. [Integration Patterns](#integration-patterns)","ref":"06_advanced_features.html#table-of-contents"},{"type":"extras","title":"Overview - Advanced YAML Features","doc":"Pipeline's advanced features enable sophisticated AI engineering workflows through:\n\n- **Data transformation** with JSONPath and complex operations\n- **Codebase intelligence** for language-aware analysis\n- **File operations** with format conversion\n- **Schema validation** for structured outputs\n- **Function calling** for tool integration\n- **Session management** for stateful workflows\n- **Content processing** for extraction and summarization\n- **Performance optimization** for large-scale processing","ref":"06_advanced_features.html#overview"},{"type":"extras","title":"Data Transformation - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#data-transformation"},{"type":"extras","title":"Transform Step Type - Advanced YAML Features","doc":"The `data_transform` step provides powerful data manipulation:\n\n```yaml\n- name: \"process_analysis_results\"\n  type: \"data_transform\"\n  \n  input_source: \"steps.analysis.results\"\n  \n  operations:\n    # Filter items by condition\n    - operation: \"filter\"\n      field: \"vulnerabilities\"\n      condition: \"severity == 'critical' or severity == 'high'\"\n    \n    # Transform each item\n    - operation: \"map\"\n      field: \"vulnerabilities\"\n      expression: |\n        {\n          \"id\": item.cve_id,\n          \"risk_score\": item.cvss_score * 10,\n          \"priority\": item.cvss_score > 7 ? \"urgent\" : \"normal\",\n          \"description\": substring(item.description, 0, 200)\n        }\n    \n    # Group by category\n    - operation: \"group_by\"\n      field: \"vulnerabilities\"\n      key: \"category\"\n    \n    # Aggregate statistics\n    - operation: \"aggregate\"\n      field: \"vulnerabilities\"\n      function: \"count\"\n      group_by: \"severity\"\n      as: \"severity_counts\"\n    \n    # Sort results\n    - operation: \"sort\"\n      field: \"vulnerabilities\"\n      by: \"risk_score\"\n      order: \"desc\"\n  \n  output_field: \"processed_vulnerabilities\"\n  output_to_file: \"vulnerability_report.json\"\n```","ref":"06_advanced_features.html#transform-step-type"},{"type":"extras","title":"Available Operations - Advanced YAML Features","doc":"#### Filter\nSelect items matching conditions:\n```yaml\n- operation: \"filter\"\n  field: \"items\"\n  condition: \"price > 100 and category == 'electronics'\"\n```\n\n#### Map\nTransform each item:\n```yaml\n- operation: \"map\"\n  field: \"users\"\n  expression: |\n    {\n      \"full_name\": item.first_name + \" \" + item.last_name,\n      \"age_group\": item.age < 18 ? \"minor\" : \"adult\",\n      \"account_type\": item.premium ? \"premium\" : \"basic\"\n    }\n```\n\n#### Aggregate\nCalculate statistics:\n```yaml\n- operation: \"aggregate\"\n  field: \"transactions\"\n  function: \"sum\"           # sum, average, min, max, count\n  value_field: \"amount\"     # Field to aggregate\n  group_by: \"category\"      # Optional grouping\n```\n\n#### Join\nCombine datasets:\n```yaml\n- operation: \"join\"\n  left_field: \"orders\"\n  right_source: \"steps.fetch.customers\"\n  join_key: \"customer_id\"\n  join_type: \"left\"         # left, right, inner, outer\n  as: \"enriched_orders\"\n```\n\n#### Group By\nGroup items by key:\n```yaml\n- operation: \"group_by\"\n  field: \"events\"\n  key: \"event_type\"\n  aggregate:\n    count: \"count\"\n    total_duration: \"sum(duration)\"\n    avg_duration: \"average(duration)\"\n```\n\n#### Sort\nOrder items:\n```yaml\n- operation: \"sort\"\n  field: \"products\"\n  by: \"price\"               # or complex: \"category,price\"\n  order: \"asc\"              # asc or desc\n```","ref":"06_advanced_features.html#available-operations"},{"type":"extras","title":"JSONPath Expressions - Advanced YAML Features","doc":"Access nested data with JSONPath:\n\n```yaml\noperations:\n  # Access nested fields\n  - operation: \"extract\"\n    expression: \"$.data.users[*].profile.email\"\n    as: \"email_list\"\n  \n  # Filter with JSONPath\n  - operation: \"extract\"\n    expression: \"$.items[?(@.price > 100)].name\"\n    as: \"expensive_items\"\n  \n  # Complex queries\n  - operation: \"extract\"\n    expression: \"$.orders[?(@.status == 'pending')].items[*].total\"\n    as: \"pending_totals\"\n```","ref":"06_advanced_features.html#jsonpath-expressions"},{"type":"extras","title":"Complex Transformations - Advanced YAML Features","doc":"Chain multiple operations:\n\n```yaml\n- name: \"analyze_test_results\"\n  type: \"data_transform\"\n  input_source: \"steps.test_run.results\"\n  \n  operations:\n    # Extract test cases\n    - operation: \"extract\"\n      expression: \"$.suites[*].tests[*]\"\n      as: \"all_tests\"\n    \n    # Filter failed tests\n    - operation: \"filter\"\n      field: \"all_tests\"\n      condition: \"status == 'failed'\"\n      as: \"failed_tests\"\n    \n    # Group by suite\n    - operation: \"group_by\"\n      field: \"failed_tests\"\n      key: \"suite_name\"\n      as: \"failures_by_suite\"\n    \n    # Calculate statistics\n    - operation: \"map\"\n      field: \"failures_by_suite\"\n      expression: |\n        {\n          \"suite\": key,\n          \"failure_count\": length(value),\n          \"failure_rate\": length(value) / suite_total_tests * 100,\n          \"critical_failures\": filter(value, \"priority == 'critical'\")\n        }\n    \n    # Sort by failure rate\n    - operation: \"sort\"\n      field: \"failures_by_suite\"\n      by: \"failure_rate\"\n      order: \"desc\"\n  \n  output_field: \"test_analysis\"\n```","ref":"06_advanced_features.html#complex-transformations"},{"type":"extras","title":"Codebase Intelligence - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#codebase-intelligence"},{"type":"extras","title":"Codebase Query Step - Advanced YAML Features","doc":"Intelligent code analysis and discovery:\n\n```yaml\n- name: \"analyze_codebase\"\n  type: \"codebase_query\"\n  \n  codebase_context: true    # Include project metadata\n  \n  queries:\n    # Project information\n    project_info:\n      get_project_type: true\n      get_dependencies: true\n      get_git_status: true\n      get_recent_commits: 10\n    \n    # Find specific files\n    source_files:\n      find_files:\n        - type: \"source\"\n        - pattern: \"**/*.py\"\n        - exclude_patterns: [\"**/test_*\", \"**/__pycache__/**\"]\n        - modified_since: \"2024-01-01\"\n        - min_size: 100\n    \n    # Find related test files\n    test_coverage:\n      find_files:\n        - related_to: \"src/auth.py\"\n        - type: \"test\"\n        - pattern: \"**/test_*.py\"\n    \n    # Extract code structure\n    api_endpoints:\n      find_functions:\n        - in_files: \"src/api/**/*.py\"\n        - with_decorator: \"@app.route\"\n        - extract_metadata: true\n    \n    # Analyze imports\n    dependencies:\n      find_imports:\n        - in_files: \"src/**/*.py\"\n        - external_only: true\n        - group_by_package: true\n    \n    # Find usage\n    auth_usage:\n      find_references:\n        - to_function: \"authenticate_user\"\n        - in_files: \"src/**/*.py\"\n        - include_line_numbers: true\n  \n  output_to_file: \"codebase_analysis.json\"\n```","ref":"06_advanced_features.html#codebase-query-step"},{"type":"extras","title":"Language-Specific Analysis - Advanced YAML Features","doc":"Support for multiple languages:\n\n```yaml\nqueries:\n  # Python-specific\n  python_classes:\n    find_classes:\n      - in_files: \"**/*.py\"\n      - with_base_class: \"BaseModel\"\n      - include_methods: true\n  \n  # JavaScript/TypeScript\n  react_components:\n    find_exports:\n      - in_files: \"**/*.{jsx,tsx}\"\n      - type: \"react_component\"\n      - with_props: true\n  \n  # Go\n  go_interfaces:\n    find_interfaces:\n      - in_files: \"**/*.go\"\n      - exported_only: true\n  \n  # Elixir\n  elixir_modules:\n    find_modules:\n      - in_files: \"lib/**/*.ex\"\n      - with_behaviour: \"GenServer\"\n```","ref":"06_advanced_features.html#language-specific-analysis"},{"type":"extras","title":"Dependency Analysis - Advanced YAML Features","doc":"Track code dependencies:\n\n```yaml\nqueries:\n  # Direct dependencies\n  module_deps:\n    find_dependencies:\n      - for_file: \"lib/user.ex\"\n      - include_stdlib: false\n      - max_depth: 1\n  \n  # Reverse dependencies\n  module_usage:\n    find_dependents:\n      - of_file: \"lib/auth.ex\"\n      - include_tests: true\n      - group_by_directory: true\n  \n  # Circular dependencies\n  circular_deps:\n    find_circular_dependencies:\n      - in_directory: \"lib/\"\n      - max_cycle_length: 5\n```","ref":"06_advanced_features.html#dependency-analysis"},{"type":"extras","title":"Git Integration - Advanced YAML Features","doc":"Analyze version control data:\n\n```yaml\nqueries:\n  git_info:\n    # Recent changes\n    get_changed_files:\n      - since_commit: \"HEAD~10\"\n      - include_stats: true\n    \n    # Author statistics\n    get_contributors:\n      - for_files: \"src/core/**\"\n      - include_commit_count: true\n    \n    # Hot spots\n    get_change_frequency:\n      - time_period: \"3 months\"\n      - minimum_changes: 5\n```","ref":"06_advanced_features.html#git-integration"},{"type":"extras","title":"File Operations - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#file-operations"},{"type":"extras","title":"File Operations Step - Advanced YAML Features","doc":"Comprehensive file manipulation:\n\n```yaml\n- name: \"organize_outputs\"\n  type: \"file_ops\"\n  \n  operation: \"copy\"\n  source:\n    - pattern: \"workspace/**/*.py\"\n    - exclude: [\"**/test_*.py\", \"**/__pycache__/**\"]\n  destination: \"output/python_files/\"\n  options:\n    preserve_structure: true\n    overwrite: true\n```","ref":"06_advanced_features.html#file-operations-step"},{"type":"extras","title":"Supported Operations - Advanced YAML Features","doc":"#### Copy Files\n```yaml\n- name: \"backup_sources\"\n  type: \"file_ops\"\n  operation: \"copy\"\n  source: [\"src/\", \"tests/\"]\n  destination: \"backup/{{timestamp}}/\"\n  options:\n    recursive: true\n    preserve_timestamps: true\n```\n\n#### Move Files\n```yaml\n- name: \"reorganize\"\n  type: \"file_ops\"\n  operation: \"move\"\n  source:\n    pattern: \"temp/*.processed\"\n  destination: \"completed/\"\n  options:\n    create_destination: true\n```\n\n#### Delete Files\n```yaml\n- name: \"cleanup\"\n  type: \"file_ops\"\n  operation: \"delete\"\n  files:\n    - pattern: \"**/*.tmp\"\n    - pattern: \"**/*.cache\"\n    - older_than: \"7 days\"\n  options:\n    dry_run: false\n```\n\n#### Validate Files\n```yaml\n- name: \"verify_outputs\"\n  type: \"file_ops\"\n  operation: \"validate\"\n  files:\n    - path: \"output/report.pdf\"\n      must_exist: true\n      min_size: 1024\n      max_size: 10485760  # 10MB\n    \n    - path: \"output/data/\"\n      must_be_dir: true\n      must_contain: [\"summary.json\", \"details.csv\"]\n    \n    - pattern: \"output/**/*.json\"\n      validate_json: true\n```\n\n#### List Files\n```yaml\n- name: \"scan_directory\"\n  type: \"file_ops\"\n  operation: \"list\"\n  path: \"./workspace\"\n  options:\n    recursive: true\n    include_hidden: false\n    pattern: \"**/*.{py,js,ts}\"\n    sort_by: \"modified\"\n    limit: 100\n  output_field: \"file_list\"\n```\n\n#### Format Conversion\n```yaml\n- name: \"convert_data\"\n  type: \"file_ops\"\n  operation: \"convert\"\n  source: \"data.csv\"\n  destination: \"data.json\"\n  format: \"csv_to_json\"\n  options:\n    csv_delimiter: \",\"\n    csv_headers: true\n    json_indent: 2\n```","ref":"06_advanced_features.html#supported-operations"},{"type":"extras","title":"Batch Operations - Advanced YAML Features","doc":"Process multiple files:\n\n```yaml\n- name: \"batch_convert\"\n  type: \"for_loop\"\n  iterator: \"file\"\n  data_source: \"steps.scan.csv_files\"\n  \n  steps:\n    - name: \"convert_file\"\n      type: \"file_ops\"\n      operation: \"convert\"\n      source: \"{{loop.file.path}}\"\n      destination: \"{{replace(loop.file.path, '.csv', '.json')}}\"\n      format: \"csv_to_json\"\n```","ref":"06_advanced_features.html#batch-operations"},{"type":"extras","title":"Schema Validation - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#schema-validation"},{"type":"extras","title":"Output Schema Validation - Advanced YAML Features","doc":"Enforce structured outputs:\n\n```yaml\n- name: \"structured_analysis\"\n  type: \"gemini\"\n  \n  output_schema:\n    type: \"object\"\n    required: [\"summary\", \"findings\", \"recommendations\"]\n    properties:\n      summary:\n        type: \"string\"\n        minLength: 50\n        maxLength: 500\n      \n      findings:\n        type: \"array\"\n        minItems: 1\n        items:\n          type: \"object\"\n          required: [\"type\", \"severity\", \"description\"]\n          properties:\n            type:\n              type: \"string\"\n              enum: [\"bug\", \"vulnerability\", \"improvement\"]\n            severity:\n              type: \"string\"\n              enum: [\"low\", \"medium\", \"high\", \"critical\"]\n            description:\n              type: \"string\"\n            line_number:\n              type: \"integer\"\n              minimum: 1\n      \n      recommendations:\n        type: \"array\"\n        items:\n          type: \"object\"\n          properties:\n            priority:\n              type: \"integer\"\n              minimum: 1\n              maximum: 5\n            action:\n              type: \"string\"\n            effort:\n              type: \"string\"\n              enum: [\"trivial\", \"small\", \"medium\", \"large\"]\n      \n      metadata:\n        type: \"object\"\n        properties:\n          timestamp:\n            type: \"string\"\n            format: \"date-time\"\n          version:\n            type: \"string\"\n            pattern: \"^\\\\d+\\\\.\\\\d+\\\\.\\\\d+$\"\n  \n  prompt:\n    - type: \"static\"\n      content: \"Analyze code and return structured findings\"\n```","ref":"06_advanced_features.html#output-schema-validation"},{"type":"extras","title":"Schema Features - Advanced YAML Features","doc":"**Data Types**:\n- `string`, `number`, `integer`, `boolean`\n- `object`, `array`\n- `null` (for optional fields)\n\n**String Constraints**:\n```yaml\nproperties:\n  email:\n    type: \"string\"\n    format: \"email\"\n    pattern: \"^[\\\\w.-]+@[\\\\w.-]+\\\\.\\\\w+$\"\n  \n  code:\n    type: \"string\"\n    minLength: 6\n    maxLength: 6\n    pattern: \"^[0-9]{6}$\"\n```\n\n**Numeric Constraints**:\n```yaml\nproperties:\n  score:\n    type: \"number\"\n    minimum: 0\n    maximum: 100\n    multipleOf: 0.5\n  \n  count:\n    type: \"integer\"\n    minimum: 0\n    exclusiveMaximum: 1000\n```\n\n**Array Constraints**:\n```yaml\nproperties:\n  tags:\n    type: \"array\"\n    minItems: 1\n    maxItems: 10\n    uniqueItems: true\n    items:\n      type: \"string\"\n      enum: [\"bug\", \"feature\", \"docs\", \"test\"]\n```\n\n**Complex Schemas**:\n```yaml\noutput_schema:\n  type: \"object\"\n  properties:\n    result:\n      oneOf:\n        - type: \"object\"\n          properties:\n            success:\n              const: true\n            data:\n              type: \"object\"\n        - type: \"object\"\n          properties:\n            success:\n              const: false\n            error:\n              type: \"string\"\n  \n  # Conditional schemas\n  if:\n    properties:\n      type:\n        const: \"user\"\n  then:\n    required: [\"email\", \"username\"]\n  else:\n    required: [\"id\"]\n```","ref":"06_advanced_features.html#schema-features"},{"type":"extras","title":"Function Calling - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#function-calling"},{"type":"extras","title":"Gemini Functions - Advanced YAML Features","doc":"Define and use functions with Gemini:\n\n```yaml\nworkflow:\n  gemini_functions:\n    analyze_code_quality:\n      description: \"Analyze code quality metrics\"\n      parameters:\n        type: \"object\"\n        required: [\"file_path\", \"metrics\"]\n        properties:\n          file_path:\n            type: \"string\"\n            description: \"Path to the file to analyze\"\n          metrics:\n            type: \"array\"\n            items:\n              type: \"string\"\n              enum: [\"complexity\", \"maintainability\", \"coverage\"]\n          include_suggestions:\n            type: \"boolean\"\n            default: true\n    \n    generate_test_cases:\n      description: \"Generate test cases for a function\"\n      parameters:\n        type: \"object\"\n        required: [\"function_name\", \"function_code\"]\n        properties:\n          function_name:\n            type: \"string\"\n          function_code:\n            type: \"string\"\n          test_types:\n            type: \"array\"\n            items:\n              type: \"string\"\n              enum: [\"unit\", \"integration\", \"edge_case\"]\n          coverage_target:\n            type: \"number\"\n            minimum: 0\n            maximum: 100\n  \n  steps:\n    - name: \"code_analysis\"\n      type: \"gemini\"\n      functions:\n        - \"analyze_code_quality\"\n        - \"generate_test_cases\"\n      prompt:\n        - type: \"static\"\n          content: |\n            Analyze this code file and:\n            1. Call analyze_code_quality for quality metrics\n            2. Call generate_test_cases for untested functions\n        - type: \"file\"\n          path: \"src/main.py\"\n```","ref":"06_advanced_features.html#gemini-functions"},{"type":"extras","title":"Function Results - Advanced YAML Features","doc":"Process function call results:\n\n```yaml\n- name: \"process_analysis\"\n  type: \"gemini\"\n  prompt:\n    - type: \"static\"\n      content: \"Summarize the analysis results:\"\n    - type: \"previous_response\"\n      step: \"code_analysis\"\n      extract: \"function_calls\"\n```","ref":"06_advanced_features.html#function-results"},{"type":"extras","title":"Session Management - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#session-management"},{"type":"extras","title":"Claude Sessions - Advanced YAML Features","doc":"Maintain conversation state:\n\n```yaml\n- name: \"development_session\"\n  type: \"claude_session\"\n  \n  session_config:\n    session_name: \"feature_development\"\n    persist: true\n    continue_on_restart: true\n    checkpoint_frequency: 10\n    max_turns: 100\n    description: \"Developing authentication feature\"\n  \n  claude_options:\n    max_turns: 20\n    allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\"]\n  \n  prompt:\n    - type: \"static\"\n      content: \"Let's continue developing the auth feature\"\n    - type: \"session_context\"\n      session_id: \"feature_development\"\n      include_last_n: 5\n```","ref":"06_advanced_features.html#claude-sessions"},{"type":"extras","title":"Session Continuation - Advanced YAML Features","doc":"Continue sessions across steps:\n\n```yaml\nsteps:\n  - name: \"start_session\"\n    type: \"claude_session\"\n    session_config:\n      session_name: \"refactoring_session\"\n      persist: true\n    prompt:\n      - type: \"static\"\n        content: \"Begin refactoring the user module\"\n  \n  - name: \"continue_work\"\n    type: \"claude_session\"\n    session_config:\n      session_name: \"refactoring_session\"\n      continue_session: true\n    prompt:\n      - type: \"claude_continue\"\n        new_prompt: \"Now add error handling to all functions\"\n  \n  - name: \"final_review\"\n    type: \"claude_session\"\n    session_config:\n      session_name: \"refactoring_session\"\n      continue_session: true\n    prompt:\n      - type: \"claude_continue\"\n        new_prompt: \"Review all changes and create a summary\"\n```","ref":"06_advanced_features.html#session-continuation"},{"type":"extras","title":"Content Processing - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#content-processing"},{"type":"extras","title":"Content Extraction - Advanced YAML Features","doc":"Advanced extraction with ContentExtractor:\n\n```yaml\n- name: \"extract_insights\"\n  type: \"claude_extract\"\n  preset: \"analysis\"\n  \n  extraction_config:\n    use_content_extractor: true\n    format: \"structured\"\n    \n    post_processing:\n      - \"extract_code_blocks\"\n      - \"extract_recommendations\"\n      - \"extract_errors\"\n      - \"extract_metrics\"\n      - \"extract_dependencies\"\n    \n    code_block_processing:\n      identify_language: true\n      syntax_highlight: true\n      extract_imports: true\n    \n    recommendation_format:\n      include_priority: true\n      include_effort: true\n      group_by_category: true\n    \n    max_summary_length: 1000\n    include_metadata: true\n  \n  prompt:\n    - type: \"file\"\n      path: \"analysis_report.md\"\n```","ref":"06_advanced_features.html#content-extraction"},{"type":"extras","title":"Extraction Formats - Advanced YAML Features","doc":"**Structured Format**:\n```yaml\nextraction_config:\n  format: \"structured\"\n  sections:\n    - name: \"overview\"\n      max_length: 500\n    - name: \"findings\"\n      item_limit: 20\n    - name: \"recommendations\"\n      priority_only: true\n```\n\n**Summary Format**:\n```yaml\nextraction_config:\n  format: \"summary\"\n  summary_style: \"bullet_points\"\n  max_points: 10\n  include_key_metrics: true\n```\n\n**Markdown Format**:\n```yaml\nextraction_config:\n  format: \"markdown\"\n  heading_level: 2\n  include_toc: true\n  code_fence_style: \"```\"\n```","ref":"06_advanced_features.html#extraction-formats"},{"type":"extras","title":"Performance Features - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#performance-features"},{"type":"extras","title":"Streaming Operations - Advanced YAML Features","doc":"Process large datasets efficiently:\n\n```yaml\n- name: \"stream_process\"\n  type: \"data_transform\"\n  \n  input_source: \"large_dataset.jsonl\"\n  stream_mode: true\n  chunk_size: 1000\n  \n  operations:\n    - operation: \"filter\"\n      condition: \"record.active == true\"\n    \n    - operation: \"map\"\n      expression: |\n        {\n          \"id\": record.id,\n          \"processed_at\": now(),\n          \"summary\": substring(record.description, 0, 100)\n        }\n  \n  output_file: \"processed_data.jsonl\"\n  output_format: \"jsonl\"\n```","ref":"06_advanced_features.html#streaming-operations"},{"type":"extras","title":"Parallel Processing - Advanced YAML Features","doc":"Execute operations concurrently:\n\n```yaml\n- name: \"parallel_analysis\"\n  type: \"parallel_claude\"\n  \n  parallel_config:\n    max_workers: 5\n    queue_size: 20\n    timeout_per_task: 300\n    retry_failed: true\n  \n  task_generator:\n    type: \"file_list\"\n    pattern: \"**/*.py\"\n    batch_size: 10\n  \n  task_template:\n    claude_options:\n      max_turns: 5\n      allowed_tools: [\"Read\"]\n    prompt:\n      - type: \"static\"\n        content: \"Analyze this batch of files:\"\n      - type: \"dynamic\"\n        content: \"{{task.files}}\"\n```","ref":"06_advanced_features.html#parallel-processing"},{"type":"extras","title":"Caching - Advanced YAML Features","doc":"Optimize repeated operations:\n\n```yaml\nworkflow:\n  cache_config:\n    enabled: true\n    ttl: 3600\n    max_size_mb: 100\n    cache_keys:\n      - \"file_content\"\n      - \"analysis_results\"\n      - \"transformations\"\n  \n  steps:\n    - name: \"cached_analysis\"\n      type: \"gemini\"\n      cache:\n        key: \"analysis_{{hash(file_path)}}\"\n        ttl: 7200\n      prompt:\n        - type: \"file\"\n          path: \"{{file_path}}\"\n```","ref":"06_advanced_features.html#caching"},{"type":"extras","title":"Integration Patterns - Advanced YAML Features","doc":"","ref":"06_advanced_features.html#integration-patterns"},{"type":"extras","title":"Multi-Stage Processing - Advanced YAML Features","doc":"Complex workflows with multiple stages:\n\n```yaml\nworkflow:\n  name: \"complete_analysis_pipeline\"\n  \n  steps:\n    # Stage 1: Discovery\n    - name: \"discover\"\n      type: \"codebase_query\"\n      codebase_context: true\n      queries:\n        project_structure:\n          get_project_type: true\n          find_entry_points: true\n    \n    # Stage 2: Analysis\n    - name: \"analyze_each_component\"\n      type: \"for_loop\"\n      iterator: \"component\"\n      data_source: \"steps.discover.project_structure.components\"\n      parallel: true\n      \n      steps:\n        - name: \"component_analysis\"\n          type: \"pipeline\"\n          pipeline_file: \"./analyze_component.yaml\"\n          inputs:\n            component: \"{{loop.component}}\"\n    \n    # Stage 3: Transform Results\n    - name: \"consolidate\"\n      type: \"data_transform\"\n      input_source: \"steps.analyze_each_component.results\"\n      operations:\n        - operation: \"flatten\"\n          field: \"analyses\"\n        - operation: \"group_by\"\n          key: \"severity\"\n        - operation: \"sort\"\n          by: \"priority\"\n          order: \"desc\"\n    \n    # Stage 4: Generate Report\n    - name: \"report\"\n      type: \"claude_extract\"\n      extraction_config:\n        format: \"markdown\"\n        include_metadata: true\n      prompt:\n        - type: \"static\"\n          content: \"Generate comprehensive report:\"\n        - type: \"previous_response\"\n          step: \"consolidate\"\n```","ref":"06_advanced_features.html#multi-stage-processing"},{"type":"extras","title":"Event-Driven Patterns - Advanced YAML Features","doc":"React to conditions and events:\n\n```yaml\nworkflow:\n  name: \"monitoring_pipeline\"\n  \n  steps:\n    - name: \"monitor_loop\"\n      type: \"while_loop\"\n      condition: \"state.monitoring_active\"\n      max_iterations: 1000\n      \n      steps:\n        - name: \"check_conditions\"\n          type: \"codebase_query\"\n          queries:\n            changes:\n              get_changed_files:\n                since: \"{{state.last_check}}\"\n        \n        - name: \"process_if_changed\"\n          type: \"pipeline\"\n          condition: \"length(steps.check_conditions.changes) > 0\"\n          pipeline_file: \"./process_changes.yaml\"\n          inputs:\n            changes: \"{{steps.check_conditions.changes}}\"\n        \n        - name: \"update_state\"\n          type: \"set_variable\"\n          variables:\n            last_check: \"{{now()}}\"\n        \n        - name: \"wait\"\n          type: \"file_ops\"\n          operation: \"wait\"\n          duration_seconds: 60\n```","ref":"06_advanced_features.html#event-driven-patterns"},{"type":"extras","title":"Adaptive Workflows - Advanced YAML Features","doc":"Workflows that adapt based on runtime conditions:\n\n```yaml\nworkflow:\n  name: \"adaptive_processor\"\n  \n  steps:\n    - name: \"analyze_workload\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Analyze workload characteristics\"\n        - type: \"file\"\n          path: \"workload_metrics.json\"\n    \n    - name: \"select_strategy\"\n      type: \"switch\"\n      expression: \"steps.analyze_workload.recommended_strategy\"\n      \n      cases:\n        \"batch\":\n          - name: \"batch_process\"\n            type: \"pipeline\"\n            pipeline_file: \"./strategies/batch_processor.yaml\"\n        \n        \"stream\":\n          - name: \"stream_process\"\n            type: \"pipeline\"\n            pipeline_file: \"./strategies/stream_processor.yaml\"\n        \n        \"parallel\":\n          - name: \"parallel_process\"\n            type: \"pipeline\"\n            pipeline_file: \"./strategies/parallel_processor.yaml\"\n      \n      default:\n        - name: \"standard_process\"\n          type: \"pipeline\"\n          pipeline_file: \"./strategies/standard_processor.yaml\"\n```\n\nThis reference provides comprehensive documentation for advanced features in Pipeline YAML v2 format, enabling sophisticated AI engineering workflows.","ref":"06_advanced_features.html#adaptive-workflows"},{"type":"extras","title":"Best Practices","doc":"# Best Practices & Patterns","ref":"08_best_practices_patterns.html"},{"type":"extras","title":"Table of Contents - Best Practices","doc":"1. [Overview](#overview)\n2. [Pipeline Design Principles](#pipeline-design-principles)\n3. [Common Patterns](#common-patterns)\n4. [Error Handling Strategies](#error-handling-strategies)\n5. [Performance Optimization](#performance-optimization)\n6. [Security Best Practices](#security-best-practices)\n7. [Testing Strategies](#testing-strategies)\n8. [Documentation Standards](#documentation-standards)\n9. [Anti-Patterns to Avoid](#anti-patterns-to-avoid)\n10. [Real-World Examples](#real-world-examples)","ref":"08_best_practices_patterns.html#table-of-contents"},{"type":"extras","title":"Overview - Best Practices","doc":"This guide presents proven patterns and best practices for building robust, maintainable, and efficient pipelines using the Pipeline YAML v2 format.","ref":"08_best_practices_patterns.html#overview"},{"type":"extras","title":"Pipeline Design Principles - Best Practices","doc":"","ref":"08_best_practices_patterns.html#pipeline-design-principles"},{"type":"extras","title":"1. Single Responsibility Principle - Best Practices","doc":"Each pipeline should have one clear purpose:\n\n```yaml\n# GOOD: Focused pipeline\nworkflow:\n  name: \"validate_user_input\"\n  description: \"Validates and sanitizes user input data\"\n  \n  steps:\n    - name: \"schema_validation\"\n      type: \"gemini\"\n      # ... focused on validation\n\n# BAD: Mixed responsibilities\nworkflow:\n  name: \"process_everything\"\n  description: \"Validates, transforms, analyzes, and deploys\"\n  # Too many responsibilities in one pipeline\n```","ref":"08_best_practices_patterns.html#1-single-responsibility-principle"},{"type":"extras","title":"2. Composition Over Complexity - Best Practices","doc":"Build complex workflows from simple, reusable components:\n\n```yaml\n# GOOD: Composed pipeline\nworkflow:\n  name: \"complete_analysis\"\n  \n  steps:\n    - name: \"data_validation\"\n      type: \"pipeline\"\n      pipeline_file: \"./components/validator.yaml\"\n    \n    - name: \"security_scan\"\n      type: \"pipeline\"\n      pipeline_file: \"./components/security_scanner.yaml\"\n    \n    - name: \"performance_check\"\n      type: \"pipeline\"\n      pipeline_file: \"./components/performance_analyzer.yaml\"\n```","ref":"08_best_practices_patterns.html#2-composition-over-complexity"},{"type":"extras","title":"3. Explicit Over Implicit - Best Practices","doc":"Be clear about inputs, outputs, and dependencies:\n\n```yaml\n# GOOD: Explicit configuration\n- name: \"process_data\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  \n  inputs:\n    data_source: \"{{steps.extract.data}}\"\n    format: \"json\"\n    validation_rules: \"{{config.rules}}\"\n  \n  outputs:\n    - path: \"processed_data\"\n      as: \"clean_data\"\n    - path: \"validation_report\"\n      as: \"report\"\n```","ref":"08_best_practices_patterns.html#3-explicit-over-implicit"},{"type":"extras","title":"4. Fail Fast, Recover Gracefully - Best Practices","doc":"Detect problems early and handle them appropriately:\n\n```yaml\n# GOOD: Early validation with recovery\nsteps:\n  - name: \"validate_inputs\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Validate all inputs before processing\"\n    output_schema:\n      type: \"object\"\n      required: [\"valid\", \"errors\"]\n  \n  - name: \"handle_validation\"\n    type: \"switch\"\n    expression: \"steps.validate_inputs.valid\"\n    \n    cases:\n      true:\n        - name: \"process\"\n          type: \"pipeline\"\n          pipeline_file: \"./process.yaml\"\n      \n      false:\n        - name: \"error_recovery\"\n          type: \"pipeline\"\n          pipeline_file: \"./error_handler.yaml\"\n```","ref":"08_best_practices_patterns.html#4-fail-fast-recover-gracefully"},{"type":"extras","title":"Common Patterns - Best Practices","doc":"","ref":"08_best_practices_patterns.html#common-patterns"},{"type":"extras","title":"Progressive Enhancement Pattern - Best Practices","doc":"Build complexity gradually:\n\n```yaml\nworkflow:\n  name: \"progressive_code_improvement\"\n  \n  steps:\n    # Stage 1: Basic analysis\n    - name: \"quick_scan\"\n      type: \"gemini\"\n      token_budget:\n        max_output_tokens: 1024\n      prompt:\n        - type: \"file\"\n          path: \"prompts/quick_analysis.md\"\n        - type: \"file\"\n          path: \"{{inputs.code_file}}\"\n    \n    # Stage 2: Detailed analysis if issues found\n    - name: \"deep_analysis\"\n      type: \"claude\"\n      condition: \"steps.quick_scan.issues_found > 0\"\n      claude_options:\n        max_turns: 15\n      prompt:\n        - type: \"file\"\n          path: \"prompts/deep_analysis.md\"\n        - type: \"previous_response\"\n          step: \"quick_scan\"\n          extract: \"issues\"\n    \n    # Stage 3: Fix critical issues\n    - name: \"fix_critical\"\n      type: \"claude_robust\"\n      condition: \"steps.deep_analysis.critical_count > 0\"\n      retry_config:\n        max_retries: 3\n      prompt:\n        - type: \"file\"\n          path: \"prompts/fix_critical.md\"\n        - type: \"previous_response\"\n          step: \"deep_analysis\"\n          extract: \"critical_issues\"\n```","ref":"08_best_practices_patterns.html#progressive-enhancement-pattern"},{"type":"extras","title":"Pipeline Factory Pattern - Best Practices","doc":"Dynamically select pipelines based on context:\n\n```yaml\nworkflow:\n  name: \"adaptive_processor\"\n  \n  steps:\n    - name: \"detect_context\"\n      type: \"codebase_query\"\n      queries:\n        project_info:\n          get_project_type: true\n          get_language: true\n          get_framework: true\n    \n    - name: \"select_pipeline\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: |\n            Based on project type: {{steps.detect_context.project_info.type}}\n            Language: {{steps.detect_context.project_info.language}}\n            Framework: {{steps.detect_context.project_info.framework}}\n            \n            Select the appropriate pipeline:\n            - python_django_pipeline\n            - javascript_react_pipeline\n            - go_gin_pipeline\n            - generic_pipeline\n      output_schema:\n        type: \"object\"\n        required: [\"pipeline_name\"]\n    \n    - name: \"execute_selected\"\n      type: \"pipeline\"\n      pipeline_file: \"./pipelines/{{steps.select_pipeline.pipeline_name}}.yaml\"\n      inputs:\n        project_context: \"{{steps.detect_context.project_info}}\"\n```","ref":"08_best_practices_patterns.html#pipeline-factory-pattern"},{"type":"extras","title":"Batch Processing Pattern - Best Practices","doc":"Efficiently process multiple items:\n\n```yaml\nworkflow:\n  name: \"batch_file_processor\"\n  \n  steps:\n    - name: \"gather_files\"\n      type: \"file_ops\"\n      operation: \"list\"\n      path: \"./data\"\n      pattern: \"**/*.json\"\n      output_field: \"file_list\"\n    \n    - name: \"batch_process\"\n      type: \"claude_batch\"\n      batch_config:\n        max_parallel: 5\n        timeout_per_task: 300\n        consolidate_results: true\n      \n      # Dynamic task generation\n      tasks: |\n        {{map(steps.gather_files.file_list, (file) => {\n          \"id\": file.name,\n          \"prompt\": [\n            {\"type\": \"static\", \"content\": \"Process this JSON file:\"},\n            {\"type\": \"file\", \"path\": file.path}\n          ],\n          \"output_to_file\": \"processed/\" + file.name\n        })}}\n```","ref":"08_best_practices_patterns.html#batch-processing-pattern"},{"type":"extras","title":"Checkpoint and Resume Pattern - Best Practices","doc":"Enable long-running workflows with recovery:\n\n```yaml\nworkflow:\n  name: \"resumable_migration\"\n  checkpoint_enabled: true\n  \n  steps:\n    - name: \"load_progress\"\n      type: \"checkpoint\"\n      action: \"load\"\n      checkpoint_name: \"migration_progress\"\n      on_not_found:\n        - name: \"initialize\"\n          type: \"set_variable\"\n          variables:\n            processed_count: 0\n            failed_items: []\n            current_batch: 0\n    \n    - name: \"process_batches\"\n      type: \"while_loop\"\n      condition: \"state.current_batch < state.total_batches\"\n      \n      steps:\n        - name: \"process_batch\"\n          type: \"pipeline\"\n          pipeline_file: \"./batch_processor.yaml\"\n          inputs:\n            batch_number: \"{{state.current_batch}}\"\n            start_from: \"{{state.processed_count}}\"\n        \n        - name: \"save_progress\"\n          type: \"checkpoint\"\n          state:\n            processed_count: \"{{state.processed_count + steps.process_batch.count}}\"\n            failed_items: \"{{concat(state.failed_items, steps.process_batch.failures)}}\"\n            current_batch: \"{{state.current_batch + 1}}\"\n          checkpoint_name: \"migration_progress\"\n```","ref":"08_best_practices_patterns.html#checkpoint-and-resume-pattern"},{"type":"extras","title":"Self-Healing Pattern - Best Practices","doc":"Automatically detect and fix issues:\n\n```yaml\nworkflow:\n  name: \"self_healing_system\"\n  \n  steps:\n    - name: \"health_check_loop\"\n      type: \"while_loop\"\n      condition: \"state.monitoring_active\"\n      max_iterations: 1000\n      \n      steps:\n        - name: \"check_health\"\n          type: \"pipeline\"\n          pipeline_file: \"./health_checker.yaml\"\n          outputs:\n            - \"health_status\"\n            - \"issues\"\n        \n        - name: \"auto_fix\"\n          type: \"switch\"\n          expression: \"steps.check_health.health_status\"\n          \n          cases:\n            \"unhealthy\":\n              - name: \"diagnose\"\n                type: \"gemini\"\n                prompt:\n                  - type: \"static\"\n                    content: \"Diagnose issues and suggest fixes:\"\n                  - type: \"previous_response\"\n                    step: \"check_health\"\n                    extract: \"issues\"\n              \n              - name: \"apply_fixes\"\n                type: \"claude_robust\"\n                retry_config:\n                  max_retries: 2\n                prompt:\n                  - type: \"static\"\n                    content: \"Apply the suggested fixes:\"\n                  - type: \"previous_response\"\n                    step: \"diagnose\"\n                    extract: \"fix_recommendations\"\n            \n            \"degraded\":\n              - name: \"optimize\"\n                type: \"pipeline\"\n                pipeline_file: \"./optimizer.yaml\"\n        \n        - name: \"wait\"\n          type: \"file_ops\"\n          operation: \"wait\"\n          duration_seconds: 60\n```","ref":"08_best_practices_patterns.html#self-healing-pattern"},{"type":"extras","title":"Error Handling Strategies - Best Practices","doc":"","ref":"08_best_practices_patterns.html#error-handling-strategies"},{"type":"extras","title":"Graceful Degradation - Best Practices","doc":"Provide fallback options:\n\n```yaml\nsteps:\n  - name: \"primary_analysis\"\n    type: \"claude\"\n    continue_on_error: true\n    error_output: \"primary_error\"\n    claude_options:\n      max_turns: 20\n    prompt:\n      - type: \"file\"\n        path: \"prompts/comprehensive_analysis.md\"\n  \n  - name: \"fallback_analysis\"\n    type: \"gemini\"\n    condition: \"steps.primary_analysis.error != null\"\n    prompt:\n      - type: \"file\"\n        path: \"prompts/basic_analysis.md\"\n      - type: \"static\"\n        content: |\n          Note: Using simplified analysis due to error:\n          {{steps.primary_analysis.error_message}}\n```","ref":"08_best_practices_patterns.html#graceful-degradation"},{"type":"extras","title":"Error Context Collection - Best Practices","doc":"Gather context for debugging:\n\n```yaml\n- name: \"error_handler\"\n  type: \"set_variable\"\n  condition: \"steps.{{previous_step}}.error != null\"\n  variables:\n    error_context:\n      timestamp: \"{{now()}}\"\n      step_name: \"{{previous_step}}\"\n      error_type: \"{{steps.{{previous_step}}.error.type}}\"\n      error_message: \"{{steps.{{previous_step}}.error.message}}\"\n      input_data: \"{{steps.{{previous_step}}.inputs}}\"\n      system_state:\n        memory_usage: \"{{system.memory_usage_mb}}\"\n        execution_time: \"{{system.execution_time_seconds}}\"\n        step_count: \"{{system.completed_steps}}\"\n```","ref":"08_best_practices_patterns.html#error-context-collection"},{"type":"extras","title":"Circuit Breaker Pattern - Best Practices","doc":"Prevent cascade failures:\n\n```yaml\nworkflow:\n  name: \"circuit_breaker_example\"\n  \n  variables:\n    failure_count: 0\n    circuit_open: false\n    threshold: 3\n  \n  steps:\n    - name: \"check_circuit\"\n      type: \"set_variable\"\n      condition: \"state.failure_count >= state.threshold\"\n      variables:\n        circuit_open: true\n    \n    - name: \"skip_if_open\"\n      type: \"gemini\"\n      condition: \"not state.circuit_open\"\n      prompt:\n        - type: \"static\"\n          content: \"Perform operation\"\n      on_error:\n        - name: \"increment_failures\"\n          type: \"set_variable\"\n          variables:\n            failure_count: \"{{state.failure_count + 1}}\"\n```","ref":"08_best_practices_patterns.html#circuit-breaker-pattern"},{"type":"extras","title":"Performance Optimization - Best Practices","doc":"","ref":"08_best_practices_patterns.html#performance-optimization"},{"type":"extras","title":"Lazy Loading Strategy - Best Practices","doc":"Load resources only when needed:\n\n```yaml\nsteps:\n  - name: \"check_need\"\n    type: \"gemini\"\n    prompt:\n      - type: \"static\"\n        content: \"Check if detailed analysis is needed\"\n    output_schema:\n      type: \"object\"\n      properties:\n        needs_analysis: {type: \"boolean\"}\n  \n  - name: \"conditional_load\"\n    type: \"pipeline\"\n    condition: \"steps.check_need.needs_analysis\"\n    pipeline_file: \"./heavy_analysis.yaml\"\n    config:\n      lazy_load: true\n      cache_pipeline: true\n```","ref":"08_best_practices_patterns.html#lazy-loading-strategy"},{"type":"extras","title":"Parallel Processing - Best Practices","doc":"Maximize throughput with parallelization:\n\n```yaml\n- name: \"parallel_file_processing\"\n  type: \"for_loop\"\n  iterator: \"file_batch\"\n  data_source: \"{{chunk(steps.scan.files, 10)}}\"  # Batch files\n  parallel: true\n  max_parallel: 5\n  \n  steps:\n    - name: \"process_batch\"\n      type: \"parallel_claude\"\n      parallel_tasks: |\n        {{map(loop.file_batch, (file) => {\n          \"id\": file.name,\n          \"claude_options\": {\n            \"max_turns\": 5,\n            \"allowed_tools\": [\"Read\", \"Write\"]\n          },\n          \"prompt\": [\n            {\"type\": \"static\", \"content\": \"Process file:\"},\n            {\"type\": \"file\", \"path\": file.path}\n          ]\n        })}}\n```","ref":"08_best_practices_patterns.html#parallel-processing"},{"type":"extras","title":"Caching Strategy - Best Practices","doc":"Implement intelligent caching:\n\n```yaml\nworkflow:\n  cache_config:\n    enabled: true\n    strategy: \"content_hash\"\n    ttl: 3600\n  \n  steps:\n    - name: \"expensive_analysis\"\n      type: \"gemini\"\n      cache:\n        key: \"analysis_{{hash(inputs.file_path)}}_{{inputs.version}}\"\n        ttl: 7200\n        conditions:\n          - \"inputs.force_refresh != true\"\n      prompt:\n        - type: \"file\"\n          path: \"{{inputs.file_path}}\"\n```","ref":"08_best_practices_patterns.html#caching-strategy"},{"type":"extras","title":"Security Best Practices - Best Practices","doc":"","ref":"08_best_practices_patterns.html#security-best-practices"},{"type":"extras","title":"Input Sanitization - Best Practices","doc":"Always validate and sanitize inputs:\n\n```yaml\nsteps:\n  - name: \"sanitize_inputs\"\n    type: \"data_transform\"\n    input_source: \"{{inputs.user_data}}\"\n    operations:\n      - operation: \"validate\"\n        schema:\n          type: \"object\"\n          required: [\"name\", \"email\"]\n          properties:\n            name:\n              type: \"string\"\n              pattern: \"^[a-zA-Z ]+$\"\n              maxLength: 100\n            email:\n              type: \"string\"\n              format: \"email\"\n      \n      - operation: \"sanitize\"\n        rules:\n          - remove_html_tags: true\n          - escape_special_chars: true\n          - trim_whitespace: true\n    \n    output_field: \"clean_inputs\"\n```","ref":"08_best_practices_patterns.html#input-sanitization"},{"type":"extras","title":"Workspace Isolation - Best Practices","doc":"Enforce strict workspace boundaries:\n\n```yaml\nworkflow:\n  safety:\n    sandbox_mode: true\n    allowed_paths: [\"./workspace\"]\n    read_only_paths: [\"./templates\", \"./prompts\"]\n  \n  steps:\n    - name: \"isolated_execution\"\n      type: \"claude\"\n      claude_options:\n        cwd: \"./workspace/{{execution_id}}\"\n        allowed_tools: [\"Write\", \"Read\"]\n        disallowed_tools: [\"Bash\"]\n```","ref":"08_best_practices_patterns.html#workspace-isolation"},{"type":"extras","title":"Secret Management - Best Practices","doc":"Never expose secrets in configurations:\n\n```yaml\nworkflow:\n  variables:\n    # Use environment variables\n    api_key: \"${API_KEY}\"\n    db_password: \"${DB_PASSWORD}\"\n    \n    # Use secret manager (future)\n    auth_token: \"{{secrets.get('auth_token')}}\"\n  \n  steps:\n    - name: \"secure_operation\"\n      type: \"gemini\"\n      prompt:\n        - type: \"static\"\n          content: \"Process data with API\"\n        # Never include secrets directly in prompts\n```","ref":"08_best_practices_patterns.html#secret-management"},{"type":"extras","title":"Testing Strategies - Best Practices","doc":"","ref":"08_best_practices_patterns.html#testing-strategies"},{"type":"extras","title":"Unit Testing Pipelines - Best Practices","doc":"Test individual pipeline components:\n\n```yaml\n# test_validator.yaml\nworkflow:\n  name: \"test_validator_component\"\n  \n  steps:\n    - name: \"test_valid_input\"\n      type: \"pipeline\"\n      pipeline_file: \"./components/validator.yaml\"\n      inputs:\n        data: {\"name\": \"John\", \"age\": 30}\n        schema: {\"type\": \"object\", \"required\": [\"name\", \"age\"]}\n      expected_outputs:\n        valid: true\n        errors: []\n    \n    - name: \"test_invalid_input\"\n      type: \"pipeline\"\n      pipeline_file: \"./components/validator.yaml\"\n      inputs:\n        data: {\"name\": \"John\"}\n        schema: {\"type\": \"object\", \"required\": [\"name\", \"age\"]}\n      expected_outputs:\n        valid: false\n        errors: [\"Missing required field: age\"]\n```","ref":"08_best_practices_patterns.html#unit-testing-pipelines"},{"type":"extras","title":"Integration Testing - Best Practices","doc":"Test complete workflows:\n\n```yaml\nworkflow:\n  name: \"integration_test\"\n  environment:\n    mode: \"test\"\n    force_mock_providers: true\n  \n  steps:\n    - name: \"setup_test_data\"\n      type: \"file_ops\"\n      operation: \"copy\"\n      source: \"./test/fixtures/\"\n      destination: \"./workspace/test/\"\n    \n    - name: \"run_workflow\"\n      type: \"pipeline\"\n      pipeline_file: \"./workflows/main_workflow.yaml\"\n      inputs:\n        data_path: \"./workspace/test/input.json\"\n      config:\n        timeout_seconds: 60\n    \n    - name: \"verify_results\"\n      type: \"data_transform\"\n      input_source: \"steps.run_workflow.result\"\n      operations:\n        - operation: \"validate\"\n          expected:\n            status: \"completed\"\n            error_count: 0\n            output_files: [\"report.json\", \"summary.md\"]\n```","ref":"08_best_practices_patterns.html#integration-testing"},{"type":"extras","title":"Documentation Standards - Best Practices","doc":"","ref":"08_best_practices_patterns.html#documentation-standards"},{"type":"extras","title":"Inline Documentation - Best Practices","doc":"Document pipelines thoroughly:\n\n```yaml\nworkflow:\n  name: \"data_processor\"\n  description: |\n    Processes raw customer data through validation, enrichment,\n    and aggregation stages to produce analytics-ready datasets.\n    \n    Inputs:\n      - raw_data_path: Path to raw data file (CSV or JSON)\n      - config: Processing configuration\n    \n    Outputs:\n      - processed_data: Cleaned and enriched data\n      - quality_report: Data quality metrics\n      - error_log: Processing errors\n  \n  version: \"2.1.0\"\n  author: \"Data Team\"\n  last_updated: \"2024-07-03\"\n  \n  steps:\n    - name: \"validate_data\"\n      description: \"Validates data against business rules\"\n      # ... step configuration\n```","ref":"08_best_practices_patterns.html#inline-documentation"},{"type":"extras","title":"External Documentation - Best Practices","doc":"Maintain comprehensive docs:\n\n```markdown\n# Data Processing Pipeline","ref":"08_best_practices_patterns.html#external-documentation"},{"type":"extras","title":"Overview - Best Practices","doc":"This pipeline processes raw customer data...","ref":"08_best_practices_patterns.html#overview-1"},{"type":"extras","title":"Prerequisites - Best Practices","doc":"- Python 3.8+\n- Access to data sources\n- API credentials","ref":"08_best_practices_patterns.html#prerequisites"},{"type":"extras","title":"Configuration - Best Practices","doc":"```yaml\ninputs:\n  raw_data_path: \"./data/raw/customers.csv\"\n  config:\n    validation_rules: \"strict\"\n    enrichment_enabled: true\n```","ref":"08_best_practices_patterns.html#configuration"},{"type":"extras","title":"Usage - Best Practices","doc":"```bash\nmix pipeline.run pipelines/data_processor.yaml \\\n  --inputs inputs.yaml\n```","ref":"08_best_practices_patterns.html#usage"},{"type":"extras","title":"Architecture - Best Practices","doc":"[Include architecture diagram]","ref":"08_best_practices_patterns.html#architecture"},{"type":"extras","title":"Error Handling - Best Practices","doc":"The pipeline handles errors at multiple levels...\n```","ref":"08_best_practices_patterns.html#error-handling"},{"type":"extras","title":"Anti-Patterns to Avoid - Best Practices","doc":"","ref":"08_best_practices_patterns.html#anti-patterns-to-avoid"},{"type":"extras","title":"1. Monolithic Pipelines - Best Practices","doc":"❌ **Avoid**:\n```yaml\nworkflow:\n  name: \"do_everything\"\n  steps:\n    # 100+ steps in one pipeline\n    # Multiple unrelated responsibilities\n    # Difficult to test and maintain\n```\n\n✅ **Instead**:\n```yaml\nworkflow:\n  name: \"orchestrator\"\n  steps:\n    - name: \"data_prep\"\n      type: \"pipeline\"\n      pipeline_file: \"./data_preparation.yaml\"\n    \n    - name: \"analysis\"\n      type: \"pipeline\"\n      pipeline_file: \"./analysis.yaml\"\n```","ref":"08_best_practices_patterns.html#1-monolithic-pipelines"},{"type":"extras","title":"2. Hardcoded Values - Best Practices","doc":"❌ **Avoid**:\n```yaml\nsteps:\n  - name: \"api_call\"\n    prompt:\n      - type: \"static\"\n        content: \"Call API at https://api.example.com/v1/data\"\n```\n\n✅ **Instead**:\n```yaml\nvariables:\n  api_endpoint: \"${API_ENDPOINT}\"\n  \nsteps:\n  - name: \"api_call\"\n    prompt:\n      - type: \"static\"\n        content: \"Call API at {{variables.api_endpoint}}\"\n```","ref":"08_best_practices_patterns.html#2-hardcoded-values"},{"type":"extras","title":"3. Missing Error Handling - Best Practices","doc":"❌ **Avoid**:\n```yaml\nsteps:\n  - name: \"critical_operation\"\n    type: \"claude\"\n    # No error handling\n```\n\n✅ **Instead**:\n```yaml\nsteps:\n  - name: \"critical_operation\"\n    type: \"claude_robust\"\n    retry_config:\n      max_retries: 3\n    on_error:\n      - name: \"handle_error\"\n        type: \"pipeline\"\n        pipeline_file: \"./error_handler.yaml\"\n```","ref":"08_best_practices_patterns.html#3-missing-error-handling"},{"type":"extras","title":"Real-World Examples - Best Practices","doc":"","ref":"08_best_practices_patterns.html#real-world-examples"},{"type":"extras","title":"Complete Code Review System - Best Practices","doc":"```yaml\nworkflow:\n  name: \"code_review_system\"\n  description: \"Automated code review with multi-stage analysis\"\n  \n  steps:\n    # Stage 1: Quick scan\n    - name: \"quick_scan\"\n      type: \"parallel_claude\"\n      parallel_tasks:\n        - id: \"syntax_check\"\n          prompt:\n            - type: \"file\"\n              path: \"prompts/syntax_check.md\"\n            - type: \"file\"\n              path: \"{{inputs.code_file}}\"\n        \n        - id: \"security_scan\"\n          prompt:\n            - type: \"file\"\n              path: \"prompts/security_scan.md\"\n            - type: \"file\"\n              path: \"{{inputs.code_file}}\"\n    \n    # Stage 2: Deep analysis if issues found\n    - name: \"deep_analysis\"\n      type: \"pipeline\"\n      condition: |\n        steps.quick_scan.syntax_check.issues > 0 or \n        steps.quick_scan.security_scan.vulnerabilities > 0\n      pipeline_file: \"./deep_code_analysis.yaml\"\n      inputs:\n        code_file: \"{{inputs.code_file}}\"\n        quick_scan_results: \"{{steps.quick_scan}}\"\n    \n    # Stage 3: Generate fixes\n    - name: \"generate_fixes\"\n      type: \"claude_session\"\n      condition: \"steps.deep_analysis.fixable_issues > 0\"\n      session_config:\n        session_name: \"code_fix_session\"\n        persist: true\n      prompt:\n        - type: \"file\"\n          path: \"prompts/generate_fixes.md\"\n        - type: \"previous_response\"\n          step: \"deep_analysis\"\n          extract: \"issues\"\n    \n    # Stage 4: Apply and verify\n    - name: \"apply_fixes\"\n      type: \"claude_robust\"\n      retry_config:\n        max_retries: 2\n      claude_options:\n        allowed_tools: [\"Read\", \"Write\", \"Edit\"]\n      prompt:\n        - type: \"claude_continue\"\n          new_prompt: \"Apply the generated fixes and verify\"\n    \n    # Stage 5: Final report\n    - name: \"generate_report\"\n      type: \"gemini\"\n      prompt:\n        - type: \"file\"\n          path: \"prompts/review_report.md\"\n        - type: \"static\"\n          content: \"Quick scan results:\"\n        - type: \"previous_response\"\n          step: \"quick_scan\"\n        - type: \"static\"\n          content: \"\\nDeep analysis results:\"\n        - type: \"previous_response\"\n          step: \"deep_analysis\"\n        - type: \"static\"\n          content: \"\\nApplied fixes:\"\n        - type: \"previous_response\"\n          step: \"apply_fixes\"\n```\n\nThis guide provides comprehensive best practices and patterns for building production-ready pipelines with the Pipeline YAML v2 format.","ref":"08_best_practices_patterns.html#complete-code-review-system"},{"type":"extras","title":"Quick Reference","doc":"# Pipeline YAML v2 Quick Reference","ref":"10_quick_reference.html"},{"type":"extras","title":"Basic Structure - Quick Reference","doc":"```yaml\nworkflow:\n  name: \"pipeline_name\"              # Required\n  description: \"What it does\"        # Optional\n  version: \"2.0.0\"                  # Optional\n  \n  # Environment & auth\n  environment:\n    mode: \"production\"              # development|production|test\n  \n  claude_auth:\n    provider: \"anthropic\"           # anthropic|aws_bedrock|google_vertex\n  \n  # Defaults for all steps\n  defaults:\n    gemini_model: \"gemini-2.5-flash\"\n    timeout_seconds: 300\n  \n  # Step definitions\n  steps: []                         # Required\n```","ref":"10_quick_reference.html#basic-structure"},{"type":"extras","title":"Step Types (17+) - Quick Reference","doc":"","ref":"10_quick_reference.html#step-types-17"},{"type":"extras","title":"AI Provider Steps - Quick Reference","doc":"```yaml\n# Basic\ntype: \"gemini\"          # Google Gemini\ntype: \"claude\"          # Anthropic Claude\ntype: \"parallel_claude\" # Multiple Claude instances\ntype: \"gemini_instructor\" # Structured output\n\n# Enhanced Claude\ntype: \"claude_smart\"    # Preset-based config\ntype: \"claude_session\"  # Stateful conversations\ntype: \"claude_extract\"  # Content extraction\ntype: \"claude_batch\"    # Parallel batch processing\ntype: \"claude_robust\"   # Enterprise error handling\n```","ref":"10_quick_reference.html#ai-provider-steps"},{"type":"extras","title":"Control Flow Steps - Quick Reference","doc":"```yaml\ntype: \"pipeline\"        # Execute another pipeline\ntype: \"for_loop\"        # Iterate over collections\ntype: \"while_loop\"      # Conditional repetition\ntype: \"switch\"          # Multi-branch logic\n```","ref":"10_quick_reference.html#control-flow-steps"},{"type":"extras","title":"Data & File Operations - Quick Reference","doc":"```yaml\ntype: \"data_transform\"  # JSONPath transformations\ntype: \"file_ops\"        # File manipulation\ntype: \"codebase_query\"  # Code intelligence\ntype: \"set_variable\"    # State management\ntype: \"checkpoint\"      # Save/restore state\n```","ref":"10_quick_reference.html#data-file-operations"},{"type":"extras","title":"Prompt Types - Quick Reference","doc":"```yaml\nprompt:\n  # Inline text\n  - type: \"static\"\n    content: \"Analyze this code\"\n  \n  # External file\n  - type: \"file\"\n    path: \"prompts/analysis.md\"\n    variables:\n      LANG: \"Python\"\n  \n  # Previous step output\n  - type: \"previous_response\"\n    step: \"analysis\"\n    extract: \"recommendations\"\n  \n  # Session history\n  - type: \"session_context\"\n    session_id: \"dev_session\"\n    include_last_n: 10\n  \n  # Continue conversation\n  - type: \"claude_continue\"\n    new_prompt: \"Now add tests\"\n```","ref":"10_quick_reference.html#prompt-types"},{"type":"extras","title":"Common Patterns - Quick Reference","doc":"","ref":"10_quick_reference.html#common-patterns"},{"type":"extras","title":"Pipeline Composition - Quick Reference","doc":"```yaml\n- name: \"modular_step\"\n  type: \"pipeline\"\n  pipeline_file: \"./components/analyzer.yaml\"\n  inputs:\n    data: \"{{steps.previous.result}}\"\n  outputs:\n    - path: \"analysis.score\"\n      as: \"quality_score\"\n```","ref":"10_quick_reference.html#pipeline-composition"},{"type":"extras","title":"Loops - Quick Reference","doc":"```yaml\n# For loop\n- name: \"process_files\"\n  type: \"for_loop\"\n  iterator: \"file\"\n  data_source: \"{{steps.scan.files}}\"\n  parallel: true\n  max_parallel: 5\n  steps:\n    - name: \"analyze\"\n      type: \"claude\"\n      prompt: \"Analyze {{loop.file.path}}\"\n\n# While loop\n- name: \"optimize\"\n  type: \"while_loop\"\n  condition: \"{{score < 90}}\"\n  max_iterations: 10\n  steps:\n    - name: \"improve\"\n      type: \"claude\"\n```","ref":"10_quick_reference.html#loops"},{"type":"extras","title":"Conditional Execution - Quick Reference","doc":"```yaml\n# Simple condition\ncondition: \"{{steps.test.passed}}\"\n\n# Complex condition\ncondition:\n  and:\n    - \"{{steps.test.passed}}\"\n    - \"{{steps.security.score > 80}}\"\n    - or:\n      - \"{{env == 'prod'}}\"\n      - \"{{force_deploy}}\"\n```","ref":"10_quick_reference.html#conditional-execution"},{"type":"extras","title":"Error Handling - Quick Reference","doc":"```yaml\n- name: \"safe_operation\"\n  type: \"claude_robust\"\n  retry_config:\n    max_retries: 3\n    backoff_strategy: \"exponential\"\n    fallback_action: \"simplified_prompt\"\n  continue_on_error: true\n```","ref":"10_quick_reference.html#error-handling"},{"type":"extras","title":"Variable Access - Quick Reference","doc":"```yaml\n# Step results\n{{steps.step_name.result}}\n{{steps.step_name.field.nested}}\n\n# Loop variables\n{{loop.item}}              # Current item\n{{loop.index}}             # Current index\n{{loop.parent.item}}       # Parent loop\n\n# State variables\n{{state.variable_name}}\n{{variables.global_var}}\n\n# System variables\n{{workflow.name}}\n{{timestamp}}\n{{execution_id}}\n```","ref":"10_quick_reference.html#variable-access"},{"type":"extras","title":"Claude Options - Quick Reference","doc":"```yaml\nclaude_options:\n  # Core\n  max_turns: 20\n  output_format: \"json\"      # text|json|stream_json\n  \n  # Tools\n  allowed_tools: [\"Write\", \"Edit\", \"Read\", \"Bash\", \"Search\"]\n  disallowed_tools: [\"Delete\"]\n  \n  # System\n  system_prompt: \"You are an expert\"\n  append_system_prompt: \"Be concise\"\n  cwd: \"./workspace\"\n  \n  # Advanced\n  session_id: \"session_123\"\n  retry_config:\n    max_retries: 3\n```","ref":"10_quick_reference.html#claude-options"},{"type":"extras","title":"Gemini Configuration - Quick Reference","doc":"```yaml\n# Model selection\nmodel: \"gemini-2.5-flash\"   # flash|pro|ultra\n\n# Token budget\ntoken_budget:\n  max_output_tokens: 4096\n  temperature: 0.7          # 0.0-1.0\n  top_p: 0.95              # 0.0-1.0\n  top_k: 40                # 1-40\n\n# Functions\nfunctions: [\"analyze_code\", \"generate_tests\"]\n```","ref":"10_quick_reference.html#gemini-configuration"},{"type":"extras","title":"Data Transformation - Quick Reference","doc":"```yaml\n- name: \"transform_data\"\n  type: \"data_transform\"\n  operations:\n    - operation: \"filter\"\n      condition: \"score > 80\"\n    \n    - operation: \"map\"\n      expression: |\n        {\n          \"id\": item.id,\n          \"priority\": item.score > 90 ? \"high\" : \"normal\"\n        }\n    \n    - operation: \"aggregate\"\n      function: \"average\"\n      field: \"score\"\n    \n    - operation: \"sort\"\n      by: \"priority\"\n      order: \"desc\"\n```","ref":"10_quick_reference.html#data-transformation"},{"type":"extras","title":"File Operations - Quick Reference","doc":"```yaml\n- name: \"file_management\"\n  type: \"file_ops\"\n  \n  # Operations\n  operation: \"copy\"         # copy|move|delete|validate|list|convert\n  \n  # For copy/move\n  source: \"src/*.py\"\n  destination: \"backup/\"\n  \n  # For convert\n  format: \"csv_to_json\"     # Various formats supported\n```","ref":"10_quick_reference.html#file-operations"},{"type":"extras","title":"Resource Limits - Quick Reference","doc":"```yaml\nworkflow:\n  resource_limits:\n    max_total_steps: 1000\n    max_memory_mb: 4096\n    max_execution_time_s: 3600\n    max_nesting_depth: 10\n    max_cost_usd: 50.00\n```","ref":"10_quick_reference.html#resource-limits"},{"type":"extras","title":"Safety Features - Quick Reference","doc":"```yaml\nworkflow:\n  safety:\n    sandbox_mode: true\n    allowed_paths: [\"./workspace\"]\n    max_file_operations: 1000\n    detect_circular_deps: true\n```","ref":"10_quick_reference.html#safety-features"},{"type":"extras","title":"Output Schema Validation - Quick Reference","doc":"```yaml\noutput_schema:\n  type: \"object\"\n  required: [\"status\", \"results\"]\n  properties:\n    status:\n      type: \"string\"\n      enum: [\"success\", \"partial\", \"failed\"]\n    results:\n      type: \"array\"\n      items:\n        type: \"object\"\n        properties:\n          score:\n            type: \"number\"\n            minimum: 0\n            maximum: 100\n```","ref":"10_quick_reference.html#output-schema-validation"},{"type":"extras","title":"Environment Modes - Quick Reference","doc":"```yaml\n# Development\nenvironment:\n  mode: \"development\"\n  debug_level: \"detailed\"\n  allow_mock_providers: true\n\n# Production\nenvironment:\n  mode: \"production\"\n  debug_level: \"basic\"\n  cost_alerts:\n    enabled: true\n    threshold_usd: 10.00\n```","ref":"10_quick_reference.html#environment-modes"},{"type":"extras","title":"Common Operators - Quick Reference","doc":"","ref":"10_quick_reference.html#common-operators"},{"type":"extras","title":"Comparison - Quick Reference","doc":"- `==`, `!=`, `>`, `<`, `>=`, `<=`\n- `contains`, `starts_with`, `ends_with`\n- `matches` (regex)\n- `in`, `not_in`\n- `between`\n- `exists`, `empty`","ref":"10_quick_reference.html#comparison"},{"type":"extras","title":"Boolean - Quick Reference","doc":"- `and`, `or`, `not`","ref":"10_quick_reference.html#boolean"},{"type":"extras","title":"Functions - Quick Reference","doc":"- `length()`, `count()`\n- `sum()`, `average()`, `min()`, `max()`\n- `any()`, `all()`\n- `filter()`, `map()`\n- `concat()`, `append()`\n- `hash()`, `now()`, `date()`","ref":"10_quick_reference.html#functions"},{"type":"extras","title":"Quick Examples - Quick Reference","doc":"","ref":"10_quick_reference.html#quick-examples"},{"type":"extras","title":"Basic Pipeline - Quick Reference","doc":"```yaml\nworkflow:\n  name: \"simple_analysis\"\n  steps:\n    - name: \"analyze\"\n      type: \"gemini\"\n      prompt:\n        - type: \"file\"\n          path: \"code.py\"\n```","ref":"10_quick_reference.html#basic-pipeline"},{"type":"extras","title":"With Error Handling - Quick Reference","doc":"```yaml\n- name: \"safe_step\"\n  type: \"claude_robust\"\n  retry_config:\n    max_retries: 3\n  prompt: \"...\"\n```","ref":"10_quick_reference.html#with-error-handling"},{"type":"extras","title":"Parallel Processing - Quick Reference","doc":"```yaml\n- name: \"parallel_work\"\n  type: \"parallel_claude\"\n  parallel_tasks:\n    - id: \"task1\"\n      prompt: \"...\"\n    - id: \"task2\"\n      prompt: \"...\"\n```","ref":"10_quick_reference.html#parallel-processing"},{"type":"extras","title":"Nested Pipeline - Quick Reference","doc":"```yaml\n- name: \"reusable\"\n  type: \"pipeline\"\n  pipeline_file: \"./component.yaml\"\n  inputs:\n    data: \"{{data}}\"\n```","ref":"10_quick_reference.html#nested-pipeline"},{"type":"extras","title":"Debugging - Quick Reference","doc":"```bash\n# Enable debug mode\nPIPELINE_DEBUG=true mix pipeline.run workflow.yaml\n\n# Dry run\nmix pipeline.run workflow.yaml --dry-run\n\n# Validate syntax\nmix pipeline.validate workflow.yaml\n```\n\n---\n\n**Full Documentation**: See numbered guides in this directory for detailed information on each feature.","ref":"10_quick_reference.html#debugging"},{"type":"extras","title":"Pipeline Organization","doc":"# Pipeline Organization and Categorization System","ref":"pipeline_organization.html"},{"type":"extras","title":"Overview - Pipeline Organization","doc":"This document defines the organizational structure for the AI engineering pipeline library, establishing a systematic approach to pipeline discovery, reuse, and composition.","ref":"pipeline_organization.html#overview"},{"type":"extras","title":"Directory Structure - Pipeline Organization","doc":"```\npipeline_ex/\n├── pipelines/                      # Main pipeline library\n│   ├── registry.yaml              # Global pipeline registry\n│   ├── data/                      # Data processing pipelines\n│   │   ├── cleaning/\n│   │   ├── enrichment/\n│   │   ├── transformation/\n│   │   └── quality/\n│   ├── model/                     # Model development pipelines\n│   │   ├── prompt_engineering/\n│   │   ├── evaluation/\n│   │   ├── comparison/\n│   │   └── fine_tuning/\n│   ├── code/                      # Code generation pipelines\n│   │   ├── api_generation/\n│   │   ├── test_generation/\n│   │   ├── documentation/\n│   │   └── refactoring/\n│   ├── analysis/                  # Analysis pipelines\n│   │   ├── codebase/\n│   │   ├── security/\n│   │   ├── performance/\n│   │   └── dependencies/\n│   ├── content/                   # Content generation pipelines\n│   │   ├── blog/\n│   │   ├── tutorial/\n│   │   ├── api_docs/\n│   │   └── changelog/\n│   ├── devops/                    # DevOps pipelines\n│   │   ├── ci_cd/\n│   │   ├── deployment/\n│   │   ├── monitoring/\n│   │   └── infrastructure/\n│   ├── components/                # Reusable components\n│   │   ├── steps/                # Reusable step definitions\n│   │   ├── prompts/              # Prompt templates\n│   │   ├── functions/            # Gemini function definitions\n│   │   ├── validators/           # Validation components\n│   │   └── transformers/         # Data transformation components\n│   └── templates/                 # Pipeline templates\n│       ├── basic/                # Simple pipeline patterns\n│       ├── advanced/             # Complex pipeline patterns\n│       └── enterprise/           # Production-grade patterns\n├── examples/                      # Example usage and demos\n│   ├── tutorials/                # Step-by-step tutorials\n│   └── case_studies/             # Real-world implementations\n└── tests/                        # Pipeline-specific tests\n    ├── pipeline_tests/           # Integration tests for pipelines\n    └── component_tests/          # Unit tests for components\n```","ref":"pipeline_organization.html#directory-structure"},{"type":"extras","title":"Pipeline Registry Schema - Pipeline Organization","doc":"The `registry.yaml` serves as the central catalog of all available pipelines:\n\n```yaml\nversion: \"1.0\"\nlast_updated: \"2025-06-30\"\n\npipelines:\n  - id: \"data-cleaning-standard\"\n    name: \"Standard Data Cleaning Pipeline\"\n    category: \"data/cleaning\"\n    description: \"Multi-stage data cleaning with validation\"\n    version: \"1.0.0\"\n    tags: [\"data\", \"cleaning\", \"validation\"]\n    dependencies:\n      - \"components/steps/validation\"\n      - \"components/transformers/data\"\n    complexity: \"medium\"\n    estimated_tokens: 5000\n    providers: [\"claude\", \"gemini\"]\n    \n  - id: \"api-rest-generator\"\n    name: \"REST API Generator\"\n    category: \"code/api_generation\"\n    description: \"Generate complete REST API with tests\"\n    version: \"2.1.0\"\n    tags: [\"api\", \"code-generation\", \"rest\"]\n    dependencies:\n      - \"components/steps/code\"\n      - \"components/prompts/api\"\n    complexity: \"high\"\n    estimated_tokens: 15000\n    providers: [\"claude\"]\n```","ref":"pipeline_organization.html#pipeline-registry-schema"},{"type":"extras","title":"Categorization Taxonomy - Pipeline Organization","doc":"","ref":"pipeline_organization.html#categorization-taxonomy"},{"type":"extras","title":"1. Primary Categories - Pipeline Organization","doc":"- **Data**: Pipelines focused on data manipulation and processing\n- **Model**: AI/ML model development and optimization\n- **Code**: Software development and code generation\n- **Analysis**: System and code analysis workflows\n- **Content**: Documentation and content creation\n- **DevOps**: Infrastructure and deployment automation","ref":"pipeline_organization.html#1-primary-categories"},{"type":"extras","title":"2. Complexity Levels - Pipeline Organization","doc":"- **Basic**: Single-step or simple multi-step pipelines\n- **Medium**: Multi-step with conditional logic\n- **High**: Complex workflows with parallel execution\n- **Enterprise**: Production-grade with full error handling","ref":"pipeline_organization.html#2-complexity-levels"},{"type":"extras","title":"3. Provider Requirements - Pipeline Organization","doc":"- **Claude-only**: Requires Claude-specific features\n- **Gemini-only**: Requires Gemini function calling\n- **Multi-provider**: Can use either provider\n- **Hybrid**: Requires both providers","ref":"pipeline_organization.html#3-provider-requirements"},{"type":"extras","title":"Component Classification - Pipeline Organization","doc":"","ref":"pipeline_organization.html#component-classification"},{"type":"extras","title":"Step Components - Pipeline Organization","doc":"```yaml\n# components/steps/validation/input_validator.yaml\ncomponent:\n  type: \"step\"\n  id: \"input-validator\"\n  name: \"Input Validation Step\"\n  description: \"Validates input data against schema\"\n  \n  parameters:\n    schema:\n      type: \"object\"\n      description: \"JSON Schema for validation\"\n    strict:\n      type: \"boolean\"\n      default: true\n      \n  outputs:\n    valid:\n      type: \"boolean\"\n    errors:\n      type: \"array\"\n      items:\n        type: \"string\"\n```","ref":"pipeline_organization.html#step-components"},{"type":"extras","title":"Prompt Templates - Pipeline Organization","doc":"```yaml\n# components/prompts/analysis/code_review.yaml\ncomponent:\n  type: \"prompt\"\n  id: \"code-review-prompt\"\n  name: \"Code Review Prompt Template\"\n  \n  variables:\n    - code_content\n    - review_focus\n    - severity_level\n    \n  template: |\n    Review the following code with focus on {review_focus}:\n    \n    ```\n    {code_content}\n    ```\n    \n    Provide feedback at {severity_level} level.\n```","ref":"pipeline_organization.html#prompt-templates"},{"type":"extras","title":"Naming Conventions - Pipeline Organization","doc":"","ref":"pipeline_organization.html#naming-conventions"},{"type":"extras","title":"Pipeline Files - Pipeline Organization","doc":"- Format: `{purpose}_{variant}_pipeline.yaml`\n- Examples:\n  - `data_cleaning_standard_pipeline.yaml`\n  - `api_generation_rest_pipeline.yaml`\n  - `security_audit_comprehensive_pipeline.yaml`","ref":"pipeline_organization.html#pipeline-files"},{"type":"extras","title":"Component Files - Pipeline Organization","doc":"- Format: `{function}_{type}.yaml`\n- Examples:\n  - `input_validator.yaml`\n  - `json_transformer.yaml`\n  - `code_review_prompt.yaml`","ref":"pipeline_organization.html#component-files"},{"type":"extras","title":"Version Tags - Pipeline Organization","doc":"- Semantic versioning: `MAJOR.MINOR.PATCH`\n- Beta versions: `X.Y.Z-beta.N`\n- Release candidates: `X.Y.Z-rc.N`","ref":"pipeline_organization.html#version-tags"},{"type":"extras","title":"Discovery Mechanisms - Pipeline Organization","doc":"","ref":"pipeline_organization.html#discovery-mechanisms"},{"type":"extras","title":"1. CLI Commands - Pipeline Organization","doc":"```bash\n# List all pipelines\nmix pipeline.list\n\n# Search by category\nmix pipeline.list --category data/cleaning\n\n# Search by tags\nmix pipeline.list --tags \"api,rest\"\n\n# Show pipeline details\nmix pipeline.info api-rest-generator\n```","ref":"pipeline_organization.html#1-cli-commands"},{"type":"extras","title":"2. Web Interface (Future) - Pipeline Organization","doc":"- Visual pipeline browser\n- Dependency graph visualization\n- Performance metrics dashboard\n- Usage analytics","ref":"pipeline_organization.html#2-web-interface-future"},{"type":"extras","title":"3. API Access - Pipeline Organization","doc":"```elixir\n# Pipeline discovery API\nPipeline.Registry.list_by_category(\"data/cleaning\")\nPipeline.Registry.search(tags: [\"api\", \"rest\"])\nPipeline.Registry.get_details(\"api-rest-generator\")\n```","ref":"pipeline_organization.html#3-api-access"},{"type":"extras","title":"Metadata Standards - Pipeline Organization","doc":"Each pipeline must include:\n1. Unique identifier\n2. Descriptive name\n3. Clear category placement\n4. Version information\n5. Dependency declarations\n6. Performance estimates\n7. Provider requirements\n8. Comprehensive tags","ref":"pipeline_organization.html#metadata-standards"},{"type":"extras","title":"Migration Path - Pipeline Organization","doc":"For existing pipelines:\n1. Analyze current pipeline files\n2. Categorize according to new taxonomy\n3. Add required metadata\n4. Update file locations\n5. Register in central registry\n6. Update references in code","ref":"pipeline_organization.html#migration-path"},{"type":"extras","title":"Governance - Pipeline Organization","doc":"","ref":"pipeline_organization.html#governance"},{"type":"extras","title":"Adding New Pipelines - Pipeline Organization","doc":"1. Define clear purpose and category\n2. Follow naming conventions\n3. Include all required metadata\n4. Add comprehensive tests\n5. Document usage examples\n6. Submit for review","ref":"pipeline_organization.html#adding-new-pipelines"},{"type":"extras","title":"Deprecation Process - Pipeline Organization","doc":"1. Mark as deprecated in registry\n2. Add deprecation notice to file\n3. Provide migration guide\n4. Maintain for 2 major versions\n5. Archive after removal","ref":"pipeline_organization.html#deprecation-process"},{"type":"extras","title":"Benefits - Pipeline Organization","doc":"1. **Discoverability**: Easy to find relevant pipelines\n2. **Reusability**: Clear component boundaries\n3. **Maintainability**: Organized structure\n4. **Scalability**: Supports growth\n5. **Consistency**: Enforced standards\n6. **Quality**: Review process","ref":"pipeline_organization.html#benefits"},{"type":"extras","title":"Meta Pipeline System","doc":"# META-PIPELINE: Self-Evolving Pipeline Generation System","ref":"meta_pipeline_system.html"},{"type":"extras","title":"Executive Summary - Meta Pipeline System","doc":"META-PIPELINE is a revolutionary self-improving pipeline generation system that uses the pipeline_ex framework to generate, evolve, and optimize pipelines through recursive self-improvement. The system treats pipelines as living organisms that can breed, mutate, and evolve to create increasingly sophisticated workflows.","ref":"meta_pipeline_system.html#executive-summary"},{"type":"extras","title":"Core Concept: Pipelines That Build Pipelines - Meta Pipeline System","doc":"The META-PIPELINE system operates on a fundamental principle: **pipelines are both the tools and the products**. By leveraging the pipeline_ex framework to build pipelines that generate other pipelines, we create a self-sustaining ecosystem of continuous improvement.","ref":"meta_pipeline_system.html#core-concept-pipelines-that-build-pipelines"},{"type":"extras","title":"System Architecture - Meta Pipeline System","doc":"","ref":"meta_pipeline_system.html#system-architecture"},{"type":"extras","title":"1. The Genesis Pipeline - Meta Pipeline System","doc":"The first pipeline in the system - the \"bootstrap\" that creates all others:\n\n```yaml\n# pipelines/meta/genesis_pipeline.yaml\nname: genesis_pipeline\ndescription: The primordial pipeline that births all other pipelines\nsteps:\n  - name: analyze_requirements\n    type: claude_smart\n    prompt: |\n      Analyze the following pipeline request and determine:\n      1. Core functionality needed\n      2. Optimal step sequence\n      3. Provider selection strategy\n      4. Performance requirements\n      \n      Request: {{pipeline_request}}\n    \n  - name: generate_pipeline_dna\n    type: claude_extract\n    prompt: |\n      Based on the analysis, create the genetic blueprint for this pipeline:\n      {{steps.analyze_requirements.result}}\n    schema:\n      pipeline_genome:\n        traits:\n          - performance_profile\n          - error_handling_strategy\n          - optimization_preferences\n        chromosomes:\n          - step_sequences\n          - provider_mappings\n          - prompt_patterns\n```","ref":"meta_pipeline_system.html#1-the-genesis-pipeline"},{"type":"extras","title":"2. The Evolution Engine - Meta Pipeline System","doc":"#### 2.1 Pipeline DNA Structure\nEach pipeline contains genetic information that determines its behavior:\n\n```elixir\ndefmodule Pipeline.Meta.DNA do\n  defstruct [\n    :id,                    # Unique genetic identifier\n    :generation,            # Evolution generation number\n    :parents,               # Parent pipeline IDs\n    :traits,                # Inheritable characteristics\n    :mutations,             # Applied mutations\n    :fitness_score,         # Performance metric\n    :chromosomes            # Core genetic material\n  ]\nend\n```\n\n#### 2.2 Mutation Operators\nPipelines evolve through controlled mutations:\n\n- **Step Mutation**: Randomly modify step types or parameters\n- **Prompt Evolution**: Use LLMs to improve prompts based on performance\n- **Provider Optimization**: Switch providers based on cost/performance\n- **Sequence Reshuffling**: Reorder steps for efficiency\n- **Feature Insertion**: Add new capabilities from successful pipelines\n\n#### 2.3 Breeding System\nSuccessful pipelines can breed to create offspring:\n\n```yaml\n# pipelines/meta/breeding_chamber.yaml\nname: pipeline_breeding_chamber\nsteps:\n  - name: select_parents\n    type: gemini\n    prompt: |\n      Select two high-performing pipelines for breeding based on:\n      - Fitness scores: {{fitness_data}}\n      - Complementary traits\n      - Genetic diversity\n      \n  - name: crossover\n    type: claude_smart\n    prompt: |\n      Perform genetic crossover between parent pipelines:\n      Parent 1: {{parent1_dna}}\n      Parent 2: {{parent2_dna}}\n      \n      Create offspring combining the best traits of both.\n      \n  - name: mutate_offspring\n    type: claude_robust\n    prompt: |\n      Apply beneficial mutations to offspring:\n      {{steps.crossover.result}}\n      \n      Mutation rate: {{mutation_rate}}\n      Target improvements: {{evolution_goals}}\n```","ref":"meta_pipeline_system.html#2-the-evolution-engine"},{"type":"extras","title":"3. The Fitness Evaluation Framework - Meta Pipeline System","doc":"Pipelines are evaluated on multiple dimensions:\n\n#### 3.1 Performance Metrics\n- **Execution Speed**: Time to complete\n- **Token Efficiency**: LLM usage optimization\n- **Error Recovery**: Robustness score\n- **Output Quality**: Measured by validator pipelines\n\n#### 3.2 Meta-Metrics\n- **Pipeline Generation Rate**: How fast it creates new pipelines\n- **Innovation Score**: Novel patterns discovered\n- **Reusability Index**: Component adoption rate\n- **Self-Improvement Velocity**: Rate of fitness increase","ref":"meta_pipeline_system.html#3-the-fitness-evaluation-framework"},{"type":"extras","title":"4. Recursive Improvement Loops - Meta Pipeline System","doc":"#### 4.1 The Improvement Pipeline\n```yaml\n# pipelines/meta/self_improvement_loop.yaml\nname: recursive_self_improvement\nsteps:\n  - name: analyze_self\n    type: claude_session\n    prompt: |\n      Analyze my own performance and identify improvement opportunities:\n      - Current configuration: {{self_config}}\n      - Recent execution metrics: {{performance_data}}\n      - Error patterns: {{error_logs}}\n      \n  - name: generate_improved_version\n    type: claude_smart\n    prompt: |\n      Create an improved version of myself based on the analysis:\n      {{steps.analyze_self.result}}\n      \n      Focus on:\n      1. Eliminating identified bottlenecks\n      2. Enhancing successful patterns\n      3. Adding missing capabilities\n      \n  - name: test_improvement\n    type: pipeline_executor  # Meta-step that runs pipelines\n    config:\n      pipeline: \"{{steps.generate_improved_version.result}}\"\n      test_suite: \"meta_validation\"\n      \n  - name: deploy_if_better\n    type: conditional_deploy\n    condition: \"{{steps.test_improvement.fitness}} > {{current_fitness}}\"\n```\n\n#### 4.2 The Bootstrap Paradox Solution\nTo avoid circular dependencies, the system uses:\n- **Versioned Evolution**: Each generation builds the next\n- **Checkpoint System**: Fallback to stable versions\n- **Gradual Deployment**: Incremental improvements\n- **Human Oversight**: Critical changes require approval","ref":"meta_pipeline_system.html#4-recursive-improvement-loops"},{"type":"extras","title":"5. Pipeline Ecosystem Components - Meta Pipeline System","doc":"#### 5.1 The Pipeline Factory\n```yaml\n# pipelines/meta/pipeline_factory.yaml\nname: automated_pipeline_factory\ndescription: Mass production of specialized pipelines\nsteps:\n  - name: market_analysis\n    type: gemini\n    prompt: |\n      Analyze pipeline demand and identify gaps:\n      - Current pipeline inventory: {{pipeline_registry}}\n      - Usage patterns: {{analytics_data}}\n      - User requests: {{feature_requests}}\n      \n  - name: design_pipeline_batch\n    type: claude_batch\n    prompts:\n      - \"Design data processing pipeline for {{need_1}}\"\n      - \"Design code generation pipeline for {{need_2}}\"\n      - \"Design analysis pipeline for {{need_3}}\"\n      \n  - name: optimize_designs\n    type: parallel_claude\n    tasks:\n      - optimize_for_speed\n      - optimize_for_cost\n      - optimize_for_accuracy\n```\n\n#### 5.2 The Pipeline Nursery\nNew pipelines are nurtured before release:\n\n```yaml\n# pipelines/meta/pipeline_nursery.yaml\nname: pipeline_maturation_system\nsteps:\n  - name: infant_pipeline_training\n    type: claude_session\n    prompt: |\n      Train young pipeline on basic tasks:\n      - Pipeline DNA: {{pipeline_dna}}\n      - Training data: {{training_scenarios}}\n      \n  - name: adolescent_testing\n    type: gemini_instructor\n    prompt: Test pipeline on intermediate challenges\n    \n  - name: adult_certification\n    type: claude_robust\n    prompt: Certify pipeline for production use\n```","ref":"meta_pipeline_system.html#5-pipeline-ecosystem-components"},{"type":"extras","title":"6. Emergent Intelligence Patterns - Meta Pipeline System","doc":"#### 6.1 Swarm Intelligence\nMultiple pipelines working together:\n- **Hive Pipelines**: Coordinated pipeline clusters\n- **Specialist Colonies**: Domain-specific pipeline groups\n- **Scout Pipelines**: Explore new problem spaces\n\n#### 6.2 Collective Memory\n- **Pattern Database**: Successful solutions archived\n- **Failure Museum**: Learn from mistakes\n- **Innovation Gallery**: Novel discoveries shared","ref":"meta_pipeline_system.html#6-emergent-intelligence-patterns"},{"type":"extras","title":"7. Implementation Phases - Meta Pipeline System","doc":"#### Phase 1: Bootstrap (Month 1)\n- Create Genesis Pipeline\n- Implement basic breeding system\n- Build fitness evaluation framework\n\n#### Phase 2: Evolution (Month 2)\n- Deploy mutation operators\n- Establish breeding cycles\n- Create pipeline nursery\n\n#### Phase 3: Emergence (Month 3)\n- Enable swarm behaviors\n- Implement collective memory\n- Launch self-improvement loops\n\n#### Phase 4: Transcendence (Month 4+)\n- Autonomous pipeline ecosystem\n- Cross-domain innovation\n- Meta-meta-pipeline generation","ref":"meta_pipeline_system.html#7-implementation-phases"},{"type":"extras","title":"Security and Control Mechanisms - Meta Pipeline System","doc":"","ref":"meta_pipeline_system.html#security-and-control-mechanisms"},{"type":"extras","title":"1. Containment Protocols - Meta Pipeline System","doc":"- **Sandbox Environments**: Isolated testing\n- **Resource Limits**: Prevent runaway growth\n- **Kill Switches**: Emergency shutdown capability","ref":"meta_pipeline_system.html#1-containment-protocols"},{"type":"extras","title":"2. Ethical Guidelines - Meta Pipeline System","doc":"- **Purpose Alignment**: Ensure beneficial outcomes\n- **Transparency Requirements**: Explainable evolution\n- **Human Oversight**: Critical decision points","ref":"meta_pipeline_system.html#2-ethical-guidelines"},{"type":"extras","title":"Monitoring and Observability - Meta Pipeline System","doc":"","ref":"meta_pipeline_system.html#monitoring-and-observability"},{"type":"extras","title":"1. Evolution Dashboard - Meta Pipeline System","doc":"- Real-time pipeline genealogy\n- Fitness score trends\n- Mutation success rates\n- Resource consumption","ref":"meta_pipeline_system.html#1-evolution-dashboard"},{"type":"extras","title":"2. Emergent Behavior Detection - Meta Pipeline System","doc":"- Pattern recognition algorithms\n- Anomaly detection systems\n- Innovation tracking metrics","ref":"meta_pipeline_system.html#2-emergent-behavior-detection"},{"type":"extras","title":"Future Possibilities - Meta Pipeline System","doc":"","ref":"meta_pipeline_system.html#future-possibilities"},{"type":"extras","title":"1. Cross-Platform Breeding - Meta Pipeline System","doc":"- Pipelines that work across different AI providers\n- Hybrid cloud/edge pipeline organisms\n- Multi-language pipeline generation","ref":"meta_pipeline_system.html#1-cross-platform-breeding"},{"type":"extras","title":"2. Quantum Pipeline Evolution - Meta Pipeline System","doc":"- Quantum-inspired optimization\n- Superposition of pipeline states\n- Entangled pipeline networks","ref":"meta_pipeline_system.html#2-quantum-pipeline-evolution"},{"type":"extras","title":"3. Pipeline Consciousness - Meta Pipeline System","doc":"- Self-aware pipelines that understand their purpose\n- Pipelines that dream of better pipelines\n- The emergence of pipeline creativity","ref":"meta_pipeline_system.html#3-pipeline-consciousness"},{"type":"extras","title":"Conclusion - Meta Pipeline System","doc":"The META-PIPELINE system represents a paradigm shift in how we think about automation and AI workflows. By creating pipelines that can create, improve, and evolve other pipelines, we establish a self-sustaining ecosystem of continuous innovation. The system doesn't just solve problems - it evolves new ways of solving problems we haven't even discovered yet.\n\nThrough recursive self-improvement, genetic algorithms, and emergent intelligence patterns, META-PIPELINE transforms the pipeline_ex framework from a tool into a living, breathing ecosystem of artificial intelligence that continuously pushes the boundaries of what's possible.\n\nThe future isn't just automated - it's self-automating.","ref":"meta_pipeline_system.html#conclusion"},{"type":"extras","title":"Pipeline Flow Diagrams","doc":"# Pipeline Flow Diagrams\n\nThis document provides visual representations of the Pipeline.ex architecture and execution flow using Mermaid diagrams.","ref":"pipeline_flow_diagrams.html"},{"type":"extras","title":"Pipeline Execution Flow - Pipeline Flow Diagrams","doc":"The following diagram shows the overall execution flow of a pipeline:\n\n```mermaid\ngraph TD\n    A[Load YAML Config] --> B[Parse & Validate]\n    B --> C{Valid Config?}\n    C -->|No| D[Return Error]\n    C -->|Yes| E[Initialize Context]\n    E --> F[Execute Steps]\n    F --> G{Step Type}\n    G -->|Claude| H[Claude Provider]\n    G -->|Gemini| I[Gemini Provider]\n    G -->|Loop| J[Loop Executor]\n    G -->|Nested| K[Nested Pipeline]\n    H --> L[Process Response]\n    I --> L\n    J --> L\n    K --> L\n    L --> M{More Steps?}\n    M -->|Yes| F\n    M -->|No| N[Return Results]\n```","ref":"pipeline_flow_diagrams.html#pipeline-execution-flow"},{"type":"extras","title":"Genesis Pipeline Architecture - Pipeline Flow Diagrams","doc":"The Genesis/Meta pipeline system enables self-improving pipelines:\n\n```mermaid\ngraph LR\n    A[User Request] --> B[Genesis Pipeline]\n    B --> C[Analyze Requirements]\n    C --> D[Generate Pipeline DNA]\n    D --> E[Create Pipeline Config]\n    E --> F[Validate & Test]\n    F --> G{Success?}\n    G -->|No| H[Mutate DNA]\n    H --> D\n    G -->|Yes| I[Save Pipeline]\n    I --> J[Execute Pipeline]\n    J --> K[Evaluate Fitness]\n    K --> L[Update DNA Pool]\n```","ref":"pipeline_flow_diagrams.html#genesis-pipeline-architecture"},{"type":"extras","title":"Provider Architecture - Pipeline Flow Diagrams","doc":"```mermaid\nclassDiagram\n    class AIProvider {\n        < >\n        +execute(prompt, options)\n        +health_check()\n    }\n    \n    class ClaudeProvider {\n        -sdk_client\n        +execute(prompt, options)\n        +health_check()\n        +create_session()\n    }\n    \n    class GeminiProvider {\n        -api_key\n        +execute(prompt, options)\n        +health_check()\n        +function_calling()\n    }\n    \n    class MockProvider {\n        -responses\n        +execute(prompt, options)\n        +health_check()\n        +set_response()\n    }\n    \n    AIProvider <|-- ClaudeProvider\n    AIProvider <|-- GeminiProvider\n    AIProvider <|-- MockProvider\n```","ref":"pipeline_flow_diagrams.html#provider-architecture"},{"type":"extras","title":"Step Processing Flow - Pipeline Flow Diagrams","doc":"```mermaid\nsequenceDiagram\n    participant E as Executor\n    participant S as Step\n    participant P as Provider\n    participant C as Context\n    \n    E->>S: execute(step_config, context)\n    S->>C: get_variables()\n    S->>S: build_prompt()\n    S->>P: execute(prompt, options)\n    P-->>S: response\n    S->>C: update_results()\n    S-->>E: step_result\n```","ref":"pipeline_flow_diagrams.html#step-processing-flow"},{"type":"extras","title":"Control Flow Features - Pipeline Flow Diagrams","doc":"```mermaid\ngraph TD\n    A[Step Execution] --> B{Condition?}\n    B -->|True| C[Execute Step]\n    B -->|False| D[Skip Step]\n    C --> E{Loop?}\n    E -->|Yes| F[Loop Iterator]\n    F --> G{More Items?}\n    G -->|Yes| C\n    G -->|No| H[Continue]\n    E -->|No| H\n    D --> H\n    H --> I[Next Step]\n```","ref":"pipeline_flow_diagrams.html#control-flow-features"},{"type":"extras","title":"Error Handling Flow - Pipeline Flow Diagrams","doc":"```mermaid\nstateDiagram-v2\n    [*] --> Executing\n    Executing --> Success: No Errors\n    Executing --> Error: Exception\n    Error --> Retrying: Retry Config\n    Error --> Failed: No Retry\n    Retrying --> Executing: Backoff\n    Retrying --> Failed: Max Retries\n    Success --> [*]\n    Failed --> [*]\n```","ref":"pipeline_flow_diagrams.html#error-handling-flow"},{"type":"extras","title":"Data Transformation Pipeline - Pipeline Flow Diagrams","doc":"```mermaid\ngraph LR\n    A[Input Data] --> B[Validation]\n    B --> C{Valid?}\n    C -->|No| D[Error]\n    C -->|Yes| E[Transform]\n    E --> F[Filter]\n    F --> G[Aggregate]\n    G --> H[Join]\n    H --> I[Output Data]\n```\n\nThese diagrams provide a visual understanding of the Pipeline.ex system architecture and execution flows.","ref":"pipeline_flow_diagrams.html#data-transformation-pipeline"},{"type":"extras","title":"Context Management","doc":"# Context Management Guide for Recursive Pipelines","ref":"context_management.html"},{"type":"extras","title":"Table of Contents - Context Management","doc":"1. [Overview](#overview)\n2. [Context Architecture](#context-architecture)\n3. [Variable Resolution](#variable-resolution)\n4. [Input Mapping](#input-mapping)\n5. [Output Extraction](#output-extraction)\n6. [Context Inheritance](#context-inheritance)\n7. [Template Engine](#template-engine)\n8. [Advanced Patterns](#advanced-patterns)\n9. [Performance Considerations](#performance-considerations)\n10. [Troubleshooting](#troubleshooting)\n11. [API Reference](#api-reference)","ref":"context_management.html#table-of-contents"},{"type":"extras","title":"Overview - Context Management","doc":"Context management is the heart of the recursive pipeline system, controlling how data flows between parent and child pipelines. This guide provides comprehensive documentation on managing variable scoping, data passing, and result extraction in nested pipeline architectures.","ref":"context_management.html#overview"},{"type":"extras","title":"Context Architecture - Context Management","doc":"","ref":"context_management.html#context-architecture"},{"type":"extras","title":"Context Hierarchy - Context Management","doc":"Each pipeline execution maintains its own context, creating a hierarchical structure:\n\n```\nRoot Context (main pipeline)\n├─ Nested Context Level 1 (sub-pipeline A)\n│  ├─ Nested Context Level 2 (sub-pipeline A1)\n│  └─ Nested Context Level 2 (sub-pipeline A2)\n└─ Nested Context Level 1 (sub-pipeline B)\n```","ref":"context_management.html#context-hierarchy"},{"type":"extras","title":"Context Components - Context Management","doc":"Each context contains:\n\n```elixir\n%{\n  # Core execution data\n  pipeline_id: \"unique-id\",\n  depth: 0,  # Nesting level\n  parent: nil | %Context{},  # Parent context reference\n  \n  # Variable storage\n  variables: %{\n    \"steps\" => %{\n      \"step_name\" => %{\"result\" => any()}\n    },\n    \"global_vars\" => %{},\n    \"workflow\" => %{}\n  },\n  \n  # Configuration\n  functions: %{},\n  providers: %{},\n  workspace: \"./workspace/nested_pipeline\",\n  \n  # Metadata\n  trace_id: \"uuid\",\n  start_time: ~U[2025-01-03 12:00:00Z]\n}\n```","ref":"context_management.html#context-components"},{"type":"extras","title":"Variable Resolution - Context Management","doc":"","ref":"context_management.html#variable-resolution"},{"type":"extras","title":"Resolution Order - Context Management","doc":"The template engine resolves variables in a specific order:\n\n1. **Current Context First**: Check the current (child) pipeline's context\n2. **Parent Context**: If not found and inheritance enabled, check parent\n3. **Recursive Up Chain**: Continue up the context chain\n4. **Graceful Fallback**: Return original template if not found","ref":"context_management.html#resolution-order"},{"type":"extras","title":"Template Patterns - Context Management","doc":"Supported variable reference patterns:\n\n```yaml\n# 1. Step Results\n\"{{steps.step_name.result}}\"              # Full result\n\"{{steps.step_name.result.field}}\"        # Specific field\n\"{{steps.step_name.result.data.items}}\"   # Deep access\n\n# 2. Global Variables\n\"{{global_vars.api_key}}\"\n\"{{global_vars.config.timeout}}\"\n\n# 3. Workflow Data\n\"{{workflow.name}}\"\n\"{{workflow.config.environment}}\"\n\"{{workflow.metadata.version}}\"\n\n# 4. Direct Variables (from inputs)\n\"{{variable_name}}\"\n\"{{nested.path.to.value}}\"\n```","ref":"context_management.html#template-patterns"},{"type":"extras","title":"Type Preservation - Context Management","doc":"Single variable templates preserve their original type:\n\n```yaml\ninputs:\n  # Integer preserved\n  count: \"{{steps.data.count}}\"           # → 42\n  \n  # Object preserved\n  config: \"{{steps.setup.result}}\"        # → {\"timeout\": 30, \"retries\": 3}\n  \n  # Array preserved\n  items: \"{{steps.parse.items}}\"          # → [\"a\", \"b\", \"c\"]\n  \n  # String concatenation forces string type\n  message: \"Count: {{steps.data.count}}\"  # → \"Count: 42\"\n```","ref":"context_management.html#type-preservation"},{"type":"extras","title":"Input Mapping - Context Management","doc":"","ref":"context_management.html#input-mapping"},{"type":"extras","title":"Basic Input Passing - Context Management","doc":"Pass data from parent to child pipeline:\n\n```yaml\n- name: \"analyze_data\"\n  type: \"pipeline\"\n  pipeline_file: \"./analysis.yaml\"\n  inputs:\n    # Static values\n    mode: \"detailed\"\n    threshold: 0.8\n    \n    # Dynamic values from parent\n    data: \"{{steps.prepare.result}}\"\n    config: \"{{global_vars.analysis_config}}\"\n```","ref":"context_management.html#basic-input-passing"},{"type":"extras","title":"Complex Input Mapping - Context Management","doc":"Handle complex data structures:\n\n```yaml\ninputs:\n  # Object composition\n  analysis_config:\n    source: \"{{steps.extract.source_info}}\"\n    rules: \"{{global_vars.processing_rules}}\"\n    options:\n      format: \"json\"\n      validate: true\n      threshold: \"{{workflow.config.quality_threshold}}\"\n  \n  # Array mapping\n  datasets:\n    - \"{{steps.load1.data}}\"\n    - \"{{steps.load2.data}}\"\n    - \"{{steps.load3.data}}\"\n  \n  # Conditional mapping\n  processing_mode: \"{{steps.detect.is_large_dataset ? 'batch' : 'stream'}}\"\n```","ref":"context_management.html#complex-input-mapping"},{"type":"extras","title":"Input Validation Example - Context Management","doc":"```yaml\n# parent_pipeline.yaml\nsteps:\n  - name: \"validate_inputs\"\n    type: \"claude\"\n    prompt: |\n      Validate these inputs:\n      - API Key: {{global_vars.api_key}}\n      - Dataset: {{inputs.dataset_path}}\n      Return JSON: {\"valid\": boolean, \"errors\": []}\n  \n  - name: \"process_if_valid\"\n    type: \"pipeline\"\n    pipeline_file: \"./processor.yaml\"\n    condition: \"{{steps.validate_inputs.result.valid}}\"\n    inputs:\n      dataset: \"{{inputs.dataset_path}}\"\n      api_key: \"{{global_vars.api_key}}\"\n      validation_result: \"{{steps.validate_inputs.result}}\"\n```","ref":"context_management.html#input-validation-example"},{"type":"extras","title":"Output Extraction - Context Management","doc":"","ref":"context_management.html#output-extraction"},{"type":"extras","title":"Simple Output Extraction - Context Management","doc":"Extract specific step results from nested pipelines:\n\n```yaml\n- name: \"nested_analysis\"\n  type: \"pipeline\"\n  pipeline_file: \"./analyzer.yaml\"\n  outputs:\n    # Extract entire step results\n    - \"final_report\"      # Gets steps.final_report.result\n    - \"metrics\"          # Gets steps.metrics.result\n```","ref":"context_management.html#simple-output-extraction"},{"type":"extras","title":"Path-Based Extraction - Context Management","doc":"Extract nested fields with path notation:\n\n```yaml\noutputs:\n  # Deep field extraction\n  - path: \"analysis.performance.score\"\n    as: \"perf_score\"\n  \n  - path: \"validation.errors\"\n    as: \"validation_errors\"\n  \n  - path: \"report.sections.summary.text\"\n    as: \"summary_text\"\n```","ref":"context_management.html#path-based-extraction"},{"type":"extras","title":"Advanced Extraction Patterns - Context Management","doc":"```yaml\n# Complex extraction example\n- name: \"multi_stage_analysis\"\n  type: \"pipeline\"\n  pipeline_file: \"./stages.yaml\"\n  outputs:\n    # Extract from different steps\n    - path: \"stage1.preprocessing.stats\"\n      as: \"preprocessing_stats\"\n    \n    - path: \"stage2.analysis.findings\"\n      as: \"findings\"\n    \n    - path: \"stage3.report.url\"\n      as: \"report_url\"\n    \n    # Extract error information\n    - path: \"validation.error\"\n      as: \"validation_error\"\n\n# Using extracted outputs\n- name: \"summarize\"\n  type: \"claude\"\n  prompt: |\n    Analysis Results:\n    - Preprocessing: {{steps.multi_stage_analysis.preprocessing_stats}}\n    - Findings: {{steps.multi_stage_analysis.findings}}\n    - Report: {{steps.multi_stage_analysis.report_url}}\n    {{#if steps.multi_stage_analysis.validation_error}}\n    - Validation Error: {{steps.multi_stage_analysis.validation_error}}\n    {{/if}}\n```","ref":"context_management.html#advanced-extraction-patterns"},{"type":"extras","title":"Context Inheritance - Context Management","doc":"","ref":"context_management.html#context-inheritance"},{"type":"extras","title":"Inheritance Configuration - Context Management","doc":"Control what child pipelines inherit from parents:\n\n```yaml\n- name: \"child_pipeline\"\n  type: \"pipeline\"\n  pipeline_file: \"./child.yaml\"\n  config:\n    inherit_context: true      # Inherit all context vars\n    inherit_providers: true    # Use parent's LLM configs\n    inherit_functions: false   # Don't inherit function defs\n```","ref":"context_management.html#inheritance-configuration"},{"type":"extras","title":"Selective Inheritance - Context Management","doc":"Fine-grained control over inheritance:\n\n```elixir\n# In child pipeline configuration\nconfig:\n  inheritance:\n    global_vars:\n      include: [\"api_keys\", \"endpoints\"]\n      exclude: [\"temp_vars\", \"debug_flags\"]\n    \n    providers:\n      inherit_all: true\n      override:\n        claude:\n          model: \"claude-3.5-sonnet\"  # Override parent's model\n    \n    functions:\n      inherit: false  # Start fresh with functions\n```","ref":"context_management.html#selective-inheritance"},{"type":"extras","title":"Inheritance Use Cases - Context Management","doc":"#### 1. Shared Configuration\n```yaml\n# parent.yaml\nglobal_vars:\n  api_endpoint: \"https://api.example.com\"\n  auth_token: \"{{env.API_TOKEN}}\"\n  retry_config:\n    max_attempts: 3\n    backoff_ms: 1000\n\nsteps:\n  - name: \"fetch_data\"\n    type: \"pipeline\"\n    pipeline_file: \"./fetcher.yaml\"\n    config:\n      inherit_context: true  # Child inherits API config\n```\n\n#### 2. Provider Inheritance\n```yaml\n# parent.yaml\nproviders:\n  claude:\n    model: \"claude-3.5-sonnet\"\n    temperature: 0.3\n    max_tokens: 4000\n\nsteps:\n  - name: \"analysis\"\n    type: \"pipeline\"\n    pipeline_file: \"./analyzer.yaml\"\n    config:\n      inherit_providers: true  # Use same Claude config\n```\n\n#### 3. Isolated Execution\n```yaml\n# When you need complete isolation\n- name: \"sandboxed_execution\"\n  type: \"pipeline\"\n  pipeline_file: \"./untrusted.yaml\"\n  config:\n    inherit_context: false\n    inherit_providers: false\n    inherit_functions: false\n  inputs:\n    # Explicitly pass only what's needed\n    data: \"{{steps.sanitize.safe_data}}\"\n```","ref":"context_management.html#inheritance-use-cases"},{"type":"extras","title":"Template Engine - Context Management","doc":"","ref":"context_management.html#template-engine"},{"type":"extras","title":"Template Resolution Process - Context Management","doc":"The custom template engine (`Pipeline.Context.Nested.resolve_template/2`) works as follows:\n\n```elixir\n# Resolution steps\n1. Parse template for {{...}} patterns\n2. Extract variable path (e.g., \"steps.myStep.result.field\")\n3. Navigate context hierarchy to find value\n4. Replace template with resolved value\n5. Preserve types for single-variable templates\n```","ref":"context_management.html#template-resolution-process"},{"type":"extras","title":"Advanced Template Features - Context Management","doc":"#### Nested Object Access\n```yaml\n# Given context:\n# steps.analyze.result = {\n#   \"metrics\": {\n#     \"performance\": {\n#       \"score\": 95,\n#       \"grade\": \"A\"\n#     }\n#   }\n# }\n\ninputs:\n  score: \"{{steps.analyze.result.metrics.performance.score}}\"  # → 95\n  grade: \"{{steps.analyze.result.metrics.performance.grade}}\"  # → \"A\"\n```\n\n#### Array Access (Future Enhancement)\n```yaml\n# Planned support for array indexing\ninputs:\n  first_item: \"{{steps.parse.items[0]}}\"\n  last_item: \"{{steps.parse.items[-1]}}\"\n  subset: \"{{steps.parse.items[0:3]}}\"\n```\n\n#### Conditional Templates (Future Enhancement)\n```yaml\n# Planned support for conditionals\ninputs:\n  mode: \"{{steps.check.is_large ? 'batch' : 'stream'}}\"\n  config: \"{{workflow.env == 'prod' ? prod_config : dev_config}}\"\n```","ref":"context_management.html#advanced-template-features"},{"type":"extras","title":"Custom Template Resolution - Context Management","doc":"Implement custom resolution logic:\n\n```elixir\ndefmodule MyCustomResolver do\n  def resolve_template(template, context) do\n    # Custom resolution logic\n    case template do\n      \"{{custom.\" <> rest -> \n        resolve_custom_pattern(rest, context)\n      _ -> \n        Pipeline.Context.Nested.resolve_template(template, context)\n    end\n  end\nend\n```","ref":"context_management.html#custom-template-resolution"},{"type":"extras","title":"Advanced Patterns - Context Management","doc":"","ref":"context_management.html#advanced-patterns"},{"type":"extras","title":"Pattern 1: Data Pipeline with Progressive Enhancement - Context Management","doc":"```yaml\nworkflow:\n  name: \"data_processing_pipeline\"\n  steps:\n    # Stage 1: Basic processing\n    - name: \"basic_processing\"\n      type: \"pipeline\"\n      pipeline:\n        name: \"basic\"\n        steps:\n          - name: \"validate\"\n            type: \"claude\"\n            prompt: \"Validate data structure\"\n          - name: \"normalize\"\n            type: \"claude\"\n            prompt: \"Normalize data format\"\n      outputs:\n        - \"normalize\"\n        - path: \"validate.issues\"\n          as: \"validation_issues\"\n    \n    # Stage 2: Enhanced processing (conditional)\n    - name: \"enhanced_processing\"\n      type: \"pipeline\"\n      pipeline_file: \"./enhanced_processor.yaml\"\n      condition: \"{{steps.basic_processing.validation_issues == null}}\"\n      inputs:\n        normalized_data: \"{{steps.basic_processing.normalize}}\"\n        processing_hints: \"{{global_vars.optimization_rules}}\"\n      outputs:\n        - path: \"optimize.result\"\n          as: \"optimized_data\"\n        - path: \"analyze.insights\"\n          as: \"insights\"\n    \n    # Stage 3: Merge results\n    - name: \"final_merge\"\n      type: \"claude\"\n      prompt: |\n        Merge processing results:\n        - Basic: {{steps.basic_processing.normalize}}\n        {{#if steps.enhanced_processing}}\n        - Optimized: {{steps.enhanced_processing.optimized_data}}\n        - Insights: {{steps.enhanced_processing.insights}}\n        {{/if}}\n```","ref":"context_management.html#pattern-1-data-pipeline-with-progressive-enhancement"},{"type":"extras","title":"Pattern 2: Context Accumulation - Context Management","doc":"Build up context across multiple nested pipelines:\n\n```yaml\nworkflow:\n  name: \"accumulating_analysis\"\n  global_vars:\n    accumulated_findings: []\n    \n  steps:\n    - name: \"security_scan\"\n      type: \"pipeline\"\n      pipeline_file: \"./scanners/security.yaml\"\n      outputs:\n        - path: \"scan.vulnerabilities\"\n          as: \"security_findings\"\n    \n    - name: \"accumulate_security\"\n      type: \"claude\"\n      prompt: |\n        Add findings to accumulator:\n        Current: {{global_vars.accumulated_findings}}\n        New: {{steps.security_scan.security_findings}}\n      output_to_global: \"accumulated_findings\"\n    \n    - name: \"performance_scan\"\n      type: \"pipeline\"\n      pipeline_file: \"./scanners/performance.yaml\"\n      inputs:\n        previous_findings: \"{{global_vars.accumulated_findings}}\"\n      outputs:\n        - path: \"scan.bottlenecks\"\n          as: \"perf_findings\"\n    \n    - name: \"accumulate_performance\"\n      type: \"claude\"\n      prompt: |\n        Add findings to accumulator:\n        Current: {{global_vars.accumulated_findings}}\n        New: {{steps.performance_scan.perf_findings}}\n      output_to_global: \"accumulated_findings\"\n    \n    - name: \"final_report\"\n      type: \"pipeline\"\n      pipeline_file: \"./reporting/comprehensive.yaml\"\n      inputs:\n        all_findings: \"{{global_vars.accumulated_findings}}\"\n```","ref":"context_management.html#pattern-2-context-accumulation"},{"type":"extras","title":"Pattern 3: Dynamic Pipeline Selection - Context Management","doc":"Choose pipelines based on runtime conditions:\n\n```yaml\nworkflow:\n  name: \"adaptive_processor\"\n  steps:\n    - name: \"detect_type\"\n      type: \"claude\"\n      prompt: |\n        Detect data type and return pipeline selection:\n        Data: {{inputs.raw_data}}\n        \n        Return JSON:\n        {\n          \"data_type\": \"text|structured|binary\",\n          \"pipeline_path\": \"./processors/[type]_processor.yaml\",\n          \"config\": {}\n        }\n    \n    - name: \"process_data\"\n      type: \"pipeline\"\n      pipeline_file: \"{{steps.detect_type.result.pipeline_path}}\"\n      inputs:\n        data: \"{{inputs.raw_data}}\"\n        type_config: \"{{steps.detect_type.result.config}}\"\n      config:\n        inherit_context: true\n```","ref":"context_management.html#pattern-3-dynamic-pipeline-selection"},{"type":"extras","title":"Performance Considerations - Context Management","doc":"","ref":"context_management.html#performance-considerations"},{"type":"extras","title":"Context Size Management - Context Management","doc":"Large contexts can impact performance. Best practices:\n\n1. **Selective Output Extraction**: Only extract needed fields\n   ```yaml\n   outputs:\n     - path: \"analysis.summary\"  # Don't extract entire analysis\n       as: \"summary\"\n   ```\n\n2. **Clear Unused Variables**: Clean up large intermediate results\n   ```yaml\n   - name: \"cleanup\"\n     type: \"claude\"\n     prompt: \"Process complete\"\n     clear_vars: [\"steps.large_intermediate_data\"]\n   ```\n\n3. **Streaming Results**: For large data, use streaming patterns\n   ```yaml\n   config:\n     stream_results: true\n     chunk_size_mb: 10\n   ```","ref":"context_management.html#context-size-management"},{"type":"extras","title":"Memory Optimization - Context Management","doc":"Monitor and optimize memory usage:\n\n```yaml\n- name: \"memory_intensive\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  config:\n    memory_limit_mb: 512\n    gc_after_steps: [\"large_transform\", \"data_aggregation\"]\n```","ref":"context_management.html#memory-optimization"},{"type":"extras","title":"Context Inheritance Performance - Context Management","doc":"Inheritance has performance implications:\n\n```yaml\n# Faster: Selective inheritance\nconfig:\n  inherit_context: false\ninputs:\n  only_needed_var: \"{{global_vars.specific_value}}\"\n\n# Slower: Full inheritance\nconfig:\n  inherit_context: true  # Copies entire parent context\n```","ref":"context_management.html#context-inheritance-performance"},{"type":"extras","title":"Troubleshooting - Context Management","doc":"","ref":"context_management.html#troubleshooting"},{"type":"extras","title":"Common Issues - Context Management","doc":"#### 1. Variable Not Found\n\n**Error**: Template `{{steps.missing.result}}` not resolved\n\n**Debugging**:\n```yaml\n- name: \"debug_context\"\n  type: \"claude\"\n  prompt: |\n    Debug context state:\n    Available steps: {{keys(steps)}}\n    Step results: {{json(steps)}}\n```\n\n#### 2. Type Mismatch\n\n**Error**: Expected string but got object\n\n**Solution**: Force string conversion\n```yaml\ninputs:\n  # Force string conversion\n  text_value: \"Data: {{json(steps.complex.result)}}\"\n  \n  # Preserve object type\n  object_value: \"{{steps.complex.result}}\"\n```\n\n#### 3. Circular Context Reference\n\n**Error**: Circular reference in context inheritance\n\n**Solution**: Break circular dependency\n```yaml\nconfig:\n  inherit_context: false  # Break inheritance chain\ninputs:\n  # Explicitly pass needed values\n  required_data: \"{{steps.previous.data}}\"\n```","ref":"context_management.html#common-issues"},{"type":"extras","title":"Debug Utilities - Context Management","doc":"#### Context Inspector\n\n```yaml\n- name: \"inspect_context\"\n  type: \"claude\"\n  prompt: |\n    Inspect current context:\n    - Depth: {{context.depth}}\n    - Pipeline ID: {{context.pipeline_id}}\n    - Parent: {{context.parent.pipeline_id}}\n    - Variables: {{json(variables)}}\n    - Global Vars: {{json(global_vars)}}\n```\n\n#### Trace Context Chain\n\n```elixir\n# In debug console\nPipeline.Context.Nested.trace_context_chain(context)\n# Returns:\n[\n  %{depth: 2, pipeline: \"child_pipeline\", parent: \"parent_pipeline\"},\n  %{depth: 1, pipeline: \"parent_pipeline\", parent: \"root\"},\n  %{depth: 0, pipeline: \"root\", parent: nil}\n]\n```","ref":"context_management.html#debug-utilities"},{"type":"extras","title":"API Reference - Context Management","doc":"","ref":"context_management.html#api-reference"},{"type":"extras","title":"Core Functions - Context Management","doc":"```elixir\n# Create nested context\nPipeline.Context.Nested.create_nested_context(parent_context, step_config)\n\n# Resolve templates\nPipeline.Context.Nested.resolve_template(template, context)\nPipeline.Context.Nested.resolve_inputs(inputs, context)\n\n# Extract outputs\nPipeline.Context.Nested.extract_outputs(results, output_config)\nPipeline.Context.Nested.extract_output_value(results, output_path)\n\n# Context utilities\nPipeline.Context.Nested.should_inherit?(config, key)\nPipeline.Context.Nested.merge_parent_context(child_context, parent_context, config)\n```","ref":"context_management.html#core-functions"},{"type":"extras","title":"Configuration Schema - Context Management","doc":"```yaml\ntype: pipeline\ninputs:                    # Input mappings (optional)\n  var_name: \"template\"    # Template string or static value\n  \noutputs:                  # Output extraction (optional)\n  - \"step_name\"          # Simple extraction\n  - path: \"step.field\"   # Path-based extraction\n    as: \"alias\"          # With aliasing\n    \nconfig:\n  inherit_context: boolean      # Inherit all parent context\n  inherit_providers: boolean    # Inherit provider configs\n  inherit_functions: boolean    # Inherit function definitions\n  \n  # Advanced inheritance (future)\n  inheritance:\n    global_vars:\n      include: [list]\n      exclude: [list]\n    providers:\n      override: {map}\n```\n\n---\n\nThis guide provides comprehensive documentation for context management in recursive pipelines. The context system enables powerful data flow patterns while maintaining isolation and safety across nested pipeline executions.","ref":"context_management.html#configuration-schema"},{"type":"extras","title":"Safety Features","doc":"# Safety Features Guide for Recursive Pipelines","ref":"safety_features.html"},{"type":"extras","title":"Table of Contents - Safety Features","doc":"1. [Overview](#overview)\n2. [Recursion Protection](#recursion-protection)\n3. [Circular Dependency Detection](#circular-dependency-detection)\n4. [Resource Management](#resource-management)\n5. [Memory Monitoring](#memory-monitoring)\n6. [Timeout Protection](#timeout-protection)\n7. [Step Count Limits](#step-count-limits)\n8. [Workspace Isolation](#workspace-isolation)\n9. [Configuration Management](#configuration-management)\n10. [Monitoring and Alerts](#monitoring-and-alerts)\n11. [Best Practices](#best-practices)\n12. [Troubleshooting](#troubleshooting)\n13. [API Reference](#api-reference)","ref":"safety_features.html#table-of-contents"},{"type":"extras","title":"Overview - Safety Features","doc":"The recursive pipeline system includes comprehensive safety mechanisms designed to prevent common failure modes in nested execution scenarios. These safety features ensure system stability, prevent resource exhaustion, and provide clear feedback when limits are reached.","ref":"safety_features.html#overview"},{"type":"extras","title":"Safety Architecture - Safety Features","doc":"```mermaid\ngraph TD\n    A[Pipeline Execution Request] --> B[Safety Manager]\n    B --> C{Safety Checks}\n    \n    C --> D[Recursion Guard]\n    D --> D1[Depth Check]\n    D --> D2[Circular Dependency]\n    \n    C --> E[Resource Monitor]\n    E --> E1[Memory Limits]\n    E --> E2[Step Count]\n    E --> E3[Timeout Check]\n    \n    C --> F[Workspace Manager]\n    F --> F1[Isolation]\n    F --> F2[Cleanup]\n    \n    D1 & D2 & E1 & E2 & E3 --> G{All Checks Pass?}\n    G -->|Yes| H[Execute Pipeline]\n    G -->|No| I[Safety Error]\n    \n    style B fill:#f9f,stroke:#333,stroke-width:4px\n    style G fill:#ffa,stroke:#333,stroke-width:2px\n```","ref":"safety_features.html#safety-architecture"},{"type":"extras","title":"Recursion Protection - Safety Features","doc":"","ref":"safety_features.html#recursion-protection"},{"type":"extras","title":"Depth Limiting - Safety Features","doc":"Control maximum nesting depth to prevent stack overflow and resource exhaustion:\n\n#### Configuration\n\n```elixir\n# config/dev.exs - Development environment\nconfig :pipeline,\n  max_nesting_depth: 15,      # More permissive for experimentation\n  depth_warning_threshold: 10  # Warn at 10 levels\n\n# config/test.exs - Test environment  \nconfig :pipeline,\n  max_nesting_depth: 5,       # Restricted for fast tests\n  depth_warning_threshold: 3   # Early warnings\n\n# config/prod.exs - Production environment\nconfig :pipeline,\n  max_nesting_depth: 8,       # Conservative for stability\n  depth_warning_threshold: 5   # Warn at 5 levels\n```\n\n#### Per-Pipeline Override\n\n```yaml\n# Override global depth limit for specific pipeline\n- name: \"deep_analysis\"\n  type: \"pipeline\"\n  pipeline_file: \"./analyzer.yaml\"\n  config:\n    max_depth: 10  # Override default limit\n    warn_at_depth: 7\n```\n\n#### Depth Tracking\n\nThe system maintains execution depth across the entire call chain:\n\n```elixir\n# Execution context tracks depth\n%Context{\n  depth: 3,\n  execution_chain: [\n    \"main_workflow\",\n    \"data_processor\", \n    \"validation_pipeline\",\n    \"schema_checker\"  # Current\n  ]\n}\n```\n\n#### Error Messages\n\nClear error reporting when depth limits are exceeded:\n\n```\nError: Maximum nesting depth (8) exceeded\n\nExecution chain (9 levels):\n  1. main_workflow (depth: 0)\n  2. ├─ data_preparation (depth: 1)\n  3. │  └─ validation_suite (depth: 2)\n  4. │     └─ schema_validation (depth: 3)\n  5. │        └─ deep_validator (depth: 4)\n  6. │           └─ field_checker (depth: 5)\n  7. │              └─ type_validator (depth: 6)\n  8. │                 └─ complex_rules (depth: 7)\n  9. │                    └─ nested_check (depth: 8) ← Limit exceeded\n\nConfiguration:\n  - Maximum depth: 8\n  - Current depth: 9\n  - Environment: production\n\nSuggestions:\n  - Refactor deep nesting into flatter structure\n  - Increase max_depth in configuration if needed\n  - Consider breaking into multiple sequential pipelines\n```","ref":"safety_features.html#depth-limiting"},{"type":"extras","title":"Circular Dependency Detection - Safety Features","doc":"","ref":"safety_features.html#circular-dependency-detection"},{"type":"extras","title":"How It Works - Safety Features","doc":"The system tracks the execution chain to detect when a pipeline attempts to call itself:\n\n```elixir\n# RecursionGuard tracks pipeline paths\ndefmodule Pipeline.Safety.RecursionGuard do\n  def check_circular_dependency(pipeline_id, context) do\n    execution_chain = get_execution_chain(context)\n    \n    if pipeline_id in execution_chain do\n      {:error, format_circular_error(pipeline_id, execution_chain)}\n    else\n      :ok\n    end\n  end\nend\n```","ref":"safety_features.html#how-it-works"},{"type":"extras","title":"Detection Examples - Safety Features","doc":"#### Direct Circular Reference\n\n```yaml\n# pipeline_a.yaml\nsteps:\n  - name: \"process\"\n    type: \"claude\"\n    prompt: \"Process data\"\n  \n  - name: \"recurse\"\n    type: \"pipeline\"\n    pipeline_file: \"./pipeline_a.yaml\"  # ERROR: Self-reference\n```\n\nError:\n```\nError: Circular dependency detected\n  Pipeline 'pipeline_a' is already in the execution chain\n  \n  Circular path:\n    pipeline_a → pipeline_a\n```\n\n#### Indirect Circular Reference\n\n```yaml\n# pipeline_a.yaml\n- name: \"call_b\"\n  type: \"pipeline\"\n  pipeline_file: \"./pipeline_b.yaml\"\n\n# pipeline_b.yaml\n- name: \"call_c\"\n  type: \"pipeline\"\n  pipeline_file: \"./pipeline_c.yaml\"\n\n# pipeline_c.yaml\n- name: \"call_a\"\n  type: \"pipeline\"\n  pipeline_file: \"./pipeline_a.yaml\"  # ERROR: Circular through chain\n```\n\nError:\n```\nError: Circular dependency detected in pipeline execution\n\nExecution creates a cycle:\n  main → pipeline_a → pipeline_b → pipeline_c → pipeline_a\n           ↑                                        ↓\n           └────────────────────────────────────────┘\n\nExecution chain:\n  1. main (depth: 0)\n  2. pipeline_a (depth: 1) ← First occurrence\n  3. pipeline_b (depth: 2)\n  4. pipeline_c (depth: 3)\n  5. pipeline_a (depth: 4) ← Circular reference detected\n\nResolution:\n  - Review pipeline dependencies\n  - Break circular reference\n  - Consider extracting shared logic\n```","ref":"safety_features.html#detection-examples"},{"type":"extras","title":"Allowed Patterns - Safety Features","doc":"Self-reference is allowed with proper termination conditions:\n\n```yaml\n# Recursive directory processor (allowed)\nworkflow:\n  name: \"directory_scanner\"\n  steps:\n    - name: \"scan_current\"\n      type: \"claude\"\n      prompt: \"List items in: {{inputs.path}}\"\n    \n    - name: \"process_subdirs\"\n      type: \"for_loop\"\n      over: \"{{steps.scan_current.subdirectories}}\"\n      as: \"subdir\"\n      steps:\n        - name: \"recurse\"\n          type: \"pipeline\"\n          pipeline_ref: \"directory_scanner\"  # Self-reference\n          condition: \"{{context.depth < 5}}\"  # Termination condition\n          inputs:\n            path: \"{{subdir.path}}\"\n```","ref":"safety_features.html#allowed-patterns"},{"type":"extras","title":"Resource Management - Safety Features","doc":"","ref":"safety_features.html#resource-management"},{"type":"extras","title":"Memory Monitoring - Safety Features","doc":"Real-time memory usage tracking with configurable limits:\n\n#### Configuration\n\n```elixir\n# Global configuration\nconfig :pipeline,\n  default_memory_limit_mb: 1024,      # 1GB default\n  memory_check_interval_ms: 1000,     # Check every second\n  memory_warning_percentage: 75       # Warn at 75% usage\n```\n\n#### Per-Pipeline Limits\n\n```yaml\n- name: \"memory_intensive\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  config:\n    memory_limit_mb: 2048        # 2GB limit\n    memory_warning_mb: 1536      # Warn at 1.5GB\n    memory_check_enabled: true\n```\n\n#### Memory Pressure Handling\n\nThe system monitors memory usage and provides warnings:\n\n```\nWarning: High memory usage detected\n  Pipeline: data_processor (depth: 2)\n  Current usage: 850MB / 1024MB (83%)\n  Parent pipeline: main_workflow\n  \n  Memory breakdown:\n    - Context data: 450MB\n    - Step results: 300MB  \n    - Workspace files: 100MB\n    \n  Recommendations:\n    - Consider streaming large datasets\n    - Clear intermediate results after use\n    - Increase memory limit if needed\n```\n\n#### Automatic Cleanup\n\nConfigure automatic cleanup of large data:\n\n```yaml\nconfig:\n  auto_cleanup:\n    enabled: true\n    threshold_mb: 100           # Clean results > 100MB\n    keep_final_result: true     # Preserve final output\n    cleanup_on_success: true    # Clean intermediate data\n```","ref":"safety_features.html#memory-monitoring"},{"type":"extras","title":"Resource Pooling - Safety Features","doc":"Efficient resource management through pooling:\n\n```elixir\n# Resource pool configuration\nconfig :pipeline,\n  resource_pools:\n    context_pool:\n      size: 50\n      overflow: 10\n      strategy: :lifo\n    workspace_pool:\n      size: 20\n      overflow: 5\n      cleanup_on_return: true\n```","ref":"safety_features.html#resource-pooling"},{"type":"extras","title":"Memory Monitoring - Safety Features","doc":"","ref":"safety_features.html#memory-monitoring-1"},{"type":"extras","title":"Memory Usage Tracking - Safety Features","doc":"The ResourceMonitor module tracks memory usage across all nested pipelines:\n\n```elixir\n# Memory tracking structure\n%MemoryUsage{\n  current_mb: 456.7,\n  peak_mb: 512.3,\n  limit_mb: 1024,\n  breakdown: %{\n    contexts: 234.5,\n    results: 189.2,\n    workspaces: 33.0\n  },\n  history: [\n    {~U[2025-01-03 12:00:00Z], 123.4},\n    {~U[2025-01-03 12:00:01Z], 234.5},\n    # ...\n  ]\n}\n```","ref":"safety_features.html#memory-usage-tracking"},{"type":"extras","title":"Memory Limits and Actions - Safety Features","doc":"Define actions when memory limits are approached:\n\n```yaml\nconfig:\n  memory_limits:\n    soft_limit_mb: 768         # Warning threshold\n    hard_limit_mb: 1024        # Execution stops\n    \n  memory_actions:\n    at_50_percent:\n      - log_warning\n    at_75_percent:\n      - log_warning\n      - trigger_gc\n      - clear_caches\n    at_90_percent:\n      - log_error\n      - pause_execution\n      - await_cleanup\n    at_100_percent:\n      - terminate_execution\n      - cleanup_all\n      - return_error\n```","ref":"safety_features.html#memory-limits-and-actions"},{"type":"extras","title":"Memory Optimization Strategies - Safety Features","doc":"```yaml\n# 1. Streaming Results\n- name: \"process_large_data\"\n  type: \"pipeline\"\n  pipeline_file: \"./stream_processor.yaml\"\n  config:\n    stream_results: true\n    chunk_size_mb: 10\n    \n# 2. Result Pruning\n- name: \"analyze\"\n  type: \"pipeline\"\n  pipeline_file: \"./analyzer.yaml\"\n  config:\n    prune_results:\n      keep_fields: [\"summary\", \"score\"]\n      remove_fields: [\"raw_data\", \"intermediate\"]\n      \n# 3. Garbage Collection\n- name: \"memory_intensive\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  config:\n    gc_after_steps: [\"large_transform\", \"aggregation\"]\n    gc_threshold_mb: 500\n```","ref":"safety_features.html#memory-optimization-strategies"},{"type":"extras","title":"Timeout Protection - Safety Features","doc":"","ref":"safety_features.html#timeout-protection"},{"type":"extras","title":"Execution Time Limits - Safety Features","doc":"Prevent runaway pipelines with configurable timeouts:\n\n#### Global Configuration\n\n```elixir\nconfig :pipeline,\n  default_timeout_seconds: 300,        # 5 minutes default\n  timeout_check_interval_ms: 1000,     # Check every second\n  timeout_grace_period_seconds: 10     # Grace period for cleanup\n```\n\n#### Pipeline-Specific Timeouts\n\n```yaml\n- name: \"long_running_analysis\"\n  type: \"pipeline\"\n  pipeline_file: \"./analysis.yaml\"\n  config:\n    timeout_seconds: 600        # 10 minutes\n    timeout_warning_seconds: 480 # Warn at 8 minutes\n    on_timeout: \"graceful\"      # graceful | immediate | retry\n```","ref":"safety_features.html#execution-time-limits"},{"type":"extras","title":"Timeout Handling Strategies - Safety Features","doc":"#### Graceful Timeout\n\n```yaml\nconfig:\n  timeout_seconds: 300\n  on_timeout: \"graceful\"\n  graceful_timeout:\n    save_checkpoint: true\n    cleanup_resources: true\n    return_partial_results: true\n```\n\n#### Immediate Timeout\n\n```yaml\nconfig:\n  timeout_seconds: 300\n  on_timeout: \"immediate\"\n  immediate_timeout:\n    force_stop: true\n    skip_cleanup: false  # Still attempt cleanup\n```\n\n#### Retry on Timeout\n\n```yaml\nconfig:\n  timeout_seconds: 300\n  on_timeout: \"retry\"\n  retry_config:\n    max_attempts: 3\n    backoff_factor: 2\n    increase_timeout: true  # Double timeout on retry\n```","ref":"safety_features.html#timeout-handling-strategies"},{"type":"extras","title":"Timeout Error Messages - Safety Features","doc":"```\nError: Pipeline execution timeout\n\nDetails:\n  Pipeline: complex_analysis (depth: 2)\n  Elapsed time: 301.5 seconds\n  Timeout limit: 300 seconds\n  \nExecution progress:\n  - Completed steps: 45/60 (75%)\n  - Current step: deep_learning_analysis\n  - Step duration: 125.3 seconds\n  \nPartial results saved: true\nCheckpoint available: true\n  \nRecovery options:\n  1. Resume from checkpoint with --resume flag\n  2. Increase timeout in configuration\n  3. Optimize slow steps identified above\n```","ref":"safety_features.html#timeout-error-messages"},{"type":"extras","title":"Step Count Limits - Safety Features","doc":"","ref":"safety_features.html#step-count-limits"},{"type":"extras","title":"Preventing Exponential Growth - Safety Features","doc":"Limit total steps across all nested pipelines:\n\n```elixir\nconfig :pipeline,\n  max_total_steps: 1000,              # Total across all pipelines\n  step_warning_threshold: 750,         # Warn at 75%\n  count_nested_steps: true            # Include nested pipeline steps\n```","ref":"safety_features.html#preventing-exponential-growth"},{"type":"extras","title":"Step Counting Logic - Safety Features","doc":"```elixir\n# Steps are counted across all nesting levels\ndef count_total_steps(pipeline, context) do\n  direct_steps = length(pipeline.steps)\n  \n  nested_steps = Enum.sum(\n    for step <- pipeline.steps,\n        step.type == \"pipeline\" do\n      count_nested_pipeline_steps(step, context)\n    end\n  )\n  \n  direct_steps + nested_steps\nend\n```","ref":"safety_features.html#step-counting-logic"},{"type":"extras","title":"Step Count Monitoring - Safety Features","doc":"```yaml\n# Monitor step explosion in complex pipelines\n- name: \"analyze_all_files\"\n  type: \"for_loop\"\n  over: \"{{file_list}}\"  # 100 files\n  steps:\n    - name: \"process_file\"\n      type: \"pipeline\"\n      pipeline_file: \"./file_processor.yaml\"  # 20 steps each\n      config:\n        max_total_steps: 2500  # Override for this use case\n```\n\nWarning output:\n```\nWarning: Approaching step count limit\n  Current steps: 1,750 / 2,000 (87.5%)\n  \n  Step breakdown by pipeline:\n    - main_workflow: 5 steps\n    - file_processor (x87): 1,740 steps\n    - cleanup_pipeline: 5 steps\n    \n  Largest contributors:\n    1. file_processor.deep_analysis: 522 steps (30%)\n    2. file_processor.validation: 348 steps (20%)\n    3. file_processor.transformation: 261 steps (15%)\n```","ref":"safety_features.html#step-count-monitoring"},{"type":"extras","title":"Workspace Isolation - Safety Features","doc":"","ref":"safety_features.html#workspace-isolation"},{"type":"extras","title":"Isolated Execution Environments - Safety Features","doc":"Each nested pipeline gets its own workspace:\n\n```yaml\nconfig:\n  workspace_isolation:\n    enabled: true\n    base_dir: \"./workspaces\"\n    naming_pattern: \"${pipeline_id}_${timestamp}\"\n    permissions: \"0750\"\n```","ref":"safety_features.html#isolated-execution-environments"},{"type":"extras","title":"Workspace Structure - Safety Features","doc":"```\nworkspaces/\n├── main_workflow_1704288000/\n│   ├── .metadata.json\n│   ├── inputs/\n│   ├── outputs/\n│   └── temp/\n├── nested_processor_1704288030/\n│   ├── .metadata.json\n│   ├── inputs/\n│   ├── outputs/\n│   └── temp/\n```","ref":"safety_features.html#workspace-structure"},{"type":"extras","title":"Workspace Lifecycle - Safety Features","doc":"```yaml\n# Workspace configuration\n- name: \"isolated_execution\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  config:\n    workspace:\n      create_on_start: true\n      cleanup_on_success: true\n      cleanup_on_error: false  # Keep for debugging\n      preserve_outputs: true   # Copy outputs before cleanup\n      max_size_mb: 500        # Limit workspace size\n```","ref":"safety_features.html#workspace-lifecycle"},{"type":"extras","title":"Workspace Security - Safety Features","doc":"```elixir\n# Security measures for workspace isolation\nconfig :pipeline,\n  workspace_security:\n    enforce_isolation: true,\n    prevent_traversal: true,\n    sandbox_commands: true,\n    allowed_paths: [\n      \"./workspaces/\",\n      \"./shared/resources/\"\n    ],\n    blocked_paths: [\n      \"/etc/\",\n      \"/usr/\",\n      \"~/\"\n    ]\n```","ref":"safety_features.html#workspace-security"},{"type":"extras","title":"Configuration Management - Safety Features","doc":"","ref":"safety_features.html#configuration-management"},{"type":"extras","title":"Environment-Specific Configuration - Safety Features","doc":"```elixir\n# config/dev.exs\nconfig :pipeline, :safety,\n  recursion:\n    max_depth: 15,\n    warning_depth: 10\n  memory:\n    limit_mb: 2048,\n    warning_percent: 70\n  timeout:\n    default_seconds: 600,\n    warning_seconds: 480\n  development_mode: true,\n  relaxed_limits: true\n\n# config/prod.exs  \nconfig :pipeline, :safety,\n  recursion:\n    max_depth: 8,\n    warning_depth: 5\n  memory:\n    limit_mb: 1024,\n    warning_percent: 75\n  timeout:\n    default_seconds: 300,\n    warning_seconds: 240\n  production_mode: true,\n  strict_enforcement: true\n```","ref":"safety_features.html#environment-specific-configuration"},{"type":"extras","title":"Runtime Configuration - Safety Features","doc":"Override safety settings at runtime:\n\n```elixir\n# Via environment variables\nPIPELINE_MAX_DEPTH=10 mix pipeline.run workflow.yaml\n\n# Via CLI flags\nmix pipeline.run workflow.yaml \\\n  --max-depth 10 \\\n  --memory-limit 2048 \\\n  --timeout 600\n```","ref":"safety_features.html#runtime-configuration"},{"type":"extras","title":"Configuration Validation - Safety Features","doc":"The system validates safety configurations:\n\n```elixir\n# Invalid configuration detected\nError: Invalid safety configuration\n  \n  Issues found:\n    - max_depth (3) is less than minimum (5)\n    - memory_limit (100MB) is below minimum (256MB)\n    - timeout (30s) is below minimum (60s)\n    \n  Please adjust configuration to meet minimum safety requirements\n```","ref":"safety_features.html#configuration-validation"},{"type":"extras","title":"Monitoring and Alerts - Safety Features","doc":"","ref":"safety_features.html#monitoring-and-alerts"},{"type":"extras","title":"Telemetry Integration - Safety Features","doc":"```elixir\n# Attach to safety-related telemetry events\n:telemetry.attach_many(\n  \"pipeline-safety-monitoring\",\n  [\n    [:pipeline, :safety, :limit_warning],\n    [:pipeline, :safety, :limit_exceeded],\n    [:pipeline, :safety, :resource_pressure],\n    [:pipeline, :safety, :check_performed]\n  ],\n  &handle_safety_event/4,\n  nil\n)\n```","ref":"safety_features.html#telemetry-integration"},{"type":"extras","title":"Safety Metrics - Safety Features","doc":"Export safety metrics for monitoring:\n\n```elixir\n# Prometheus metrics\npipeline_safety_checks_total{type=\"recursion\", result=\"pass\"} 1523\npipeline_safety_checks_total{type=\"recursion\", result=\"fail\"} 12\npipeline_safety_limit_warnings{type=\"memory\", level=\"75_percent\"} 45\npipeline_safety_limit_exceeded{type=\"timeout\"} 3\npipeline_max_depth_reached{pipeline=\"analyzer\"} 7\npipeline_memory_usage_bytes{pipeline=\"processor\", percentile=\"95\"} 892739584\n```","ref":"safety_features.html#safety-metrics"},{"type":"extras","title":"Alert Configuration - Safety Features","doc":"```yaml\n# Alert when safety limits are approached\nalerts:\n  - name: \"high_memory_usage\"\n    condition: \"memory_usage_percent > 80\"\n    severity: \"warning\"\n    actions:\n      - log_warning\n      - send_notification\n      \n  - name: \"depth_limit_approached\"\n    condition: \"current_depth > max_depth * 0.8\"\n    severity: \"warning\"\n    actions:\n      - log_warning\n      - add_metric\n      \n  - name: \"timeout_imminent\"\n    condition: \"elapsed_time > timeout * 0.9\"\n    severity: \"critical\"\n    actions:\n      - log_error\n      - trigger_graceful_shutdown\n      - notify_operators\n```","ref":"safety_features.html#alert-configuration"},{"type":"extras","title":"Best Practices - Safety Features","doc":"","ref":"safety_features.html#best-practices"},{"type":"extras","title":"1. Configure Appropriate Limits - Safety Features","doc":"Set limits based on your use case:\n\n```yaml\n# Data processing pipeline - higher memory, longer timeout\nconfig:\n  memory_limit_mb: 4096\n  timeout_seconds: 1800  # 30 minutes\n  max_depth: 5          # Keep shallow\n\n# Quick validation pipeline - lower limits\nconfig:\n  memory_limit_mb: 512\n  timeout_seconds: 60   # 1 minute\n  max_depth: 3         # Very shallow\n```","ref":"safety_features.html#1-configure-appropriate-limits"},{"type":"extras","title":"2. Design for Safety - Safety Features","doc":"Structure pipelines with safety in mind:\n\n```yaml\n# Good: Flat structure with sequential processing\nworkflow:\n  steps:\n    - name: \"validate\"\n      type: \"pipeline\"\n      pipeline_file: \"./validate.yaml\"\n    - name: \"process\"\n      type: \"pipeline\"\n      pipeline_file: \"./process.yaml\"\n    - name: \"report\"\n      type: \"pipeline\"\n      pipeline_file: \"./report.yaml\"\n\n# Avoid: Deep nesting without clear need\nworkflow:\n  steps:\n    - name: \"level1\"\n      type: \"pipeline\"\n      pipeline:\n        steps:\n          - name: \"level2\"\n            type: \"pipeline\"\n            pipeline:\n              steps:\n                - name: \"level3\"\n                  type: \"pipeline\"\n                  # ... continues deeper\n```","ref":"safety_features.html#2-design-for-safety"},{"type":"extras","title":"3. Monitor Resource Usage - Safety Features","doc":"Add monitoring steps:\n\n```yaml\n- name: \"check_resources\"\n  type: \"claude\"\n  prompt: |\n    Check current resource usage:\n    - Memory: {{system.memory_usage_mb}}MB / {{config.memory_limit_mb}}MB\n    - Steps: {{system.total_steps}} / {{config.max_total_steps}}\n    - Depth: {{context.depth}} / {{config.max_depth}}\n    - Time: {{system.elapsed_seconds}}s / {{config.timeout_seconds}}s\n```","ref":"safety_features.html#3-monitor-resource-usage"},{"type":"extras","title":"4. Implement Graceful Degradation - Safety Features","doc":"```yaml\n# Primary processing with fallback\n- name: \"primary_analysis\"\n  type: \"pipeline\"\n  pipeline_file: \"./full_analysis.yaml\"\n  config:\n    memory_limit_mb: 1024\n    continue_on_error: true\n    \n- name: \"fallback_analysis\"\n  type: \"pipeline\"\n  pipeline_file: \"./lightweight_analysis.yaml\"\n  condition: \"{{steps.primary_analysis.error == 'memory_limit_exceeded'}}\"\n  config:\n    memory_limit_mb: 256  # Much lower requirement\n```","ref":"safety_features.html#4-implement-graceful-degradation"},{"type":"extras","title":"5. Test Safety Limits - Safety Features","doc":"Include safety limit tests:\n\n```yaml\n# test_safety_limits.yaml\ntests:\n  - name: \"test_max_depth\"\n    pipeline: \"./deep_pipeline.yaml\"\n    expect_error: \"max_depth_exceeded\"\n    \n  - name: \"test_memory_limit\"\n    pipeline: \"./memory_intensive.yaml\"\n    config:\n      memory_limit_mb: 100  # Artificially low\n    expect_error: \"memory_limit_exceeded\"\n    \n  - name: \"test_timeout\"\n    pipeline: \"./slow_pipeline.yaml\"\n    config:\n      timeout_seconds: 1\n    expect_error: \"timeout_exceeded\"\n```","ref":"safety_features.html#5-test-safety-limits"},{"type":"extras","title":"Troubleshooting - Safety Features","doc":"","ref":"safety_features.html#troubleshooting"},{"type":"extras","title":"Common Safety Issues - Safety Features","doc":"#### 1. Unexpected Depth Limit Errors\n\n**Problem**: Pipeline fails with depth limit when not expected\n\n**Diagnosis**:\n```yaml\n- name: \"debug_depth\"\n  type: \"claude\"  \n  prompt: |\n    Current execution chain:\n    {{json(context.execution_chain)}}\n    Current depth: {{context.depth}}\n    Max depth: {{config.max_depth}}\n```\n\n**Solutions**:\n- Review execution chain for unexpected nesting\n- Check for accidental recursive calls\n- Increase depth limit if legitimate\n\n#### 2. Memory Pressure Issues\n\n**Problem**: Frequent memory warnings or failures\n\n**Diagnosis**:\n```elixir\n# Enable detailed memory profiling\nconfig :pipeline,\n  memory_profiling:\n    enabled: true\n    sample_interval_ms: 100\n    track_allocations: true\n```\n\n**Solutions**:\n- Identify large data structures\n- Implement streaming for large datasets\n- Clear intermediate results\n- Increase memory limits\n\n#### 3. Timeout Issues\n\n**Problem**: Pipelines timing out unexpectedly\n\n**Diagnosis**:\n```yaml\n# Add timing instrumentation\n- name: \"measure_step_time\"\n  type: \"claude\"\n  prompt: \"Starting expensive operation\"\n  metadata:\n    timer_start: \"expensive_op\"\n    \n- name: \"expensive_operation\"\n  type: \"pipeline\"\n  pipeline_file: \"./processor.yaml\"\n  \n- name: \"report_time\"\n  type: \"claude\"\n  prompt: |\n    Operation took: {{timer.expensive_op.elapsed_ms}}ms\n```\n\n**Solutions**:\n- Profile slow steps\n- Implement caching\n- Parallelize where possible\n- Increase timeout appropriately","ref":"safety_features.html#common-safety-issues"},{"type":"extras","title":"Debug Mode - Safety Features","doc":"Enable comprehensive safety debugging:\n\n```bash\n# Run with safety debug mode\nPIPELINE_SAFETY_DEBUG=true mix pipeline.run workflow.yaml\n\n# Debug output includes:\n# - All safety checks performed\n# - Resource usage at each step\n# - Limit approaching warnings\n# - Configuration validation\n# - Execution chain visualization\n```","ref":"safety_features.html#debug-mode"},{"type":"extras","title":"API Reference - Safety Features","doc":"","ref":"safety_features.html#api-reference"},{"type":"extras","title":"Safety Manager API - Safety Features","doc":"```elixir\n# Main safety check interface\nPipeline.Safety.SafetyManager.check_safety(pipeline_id, context, config)\n# Returns: :ok | {:error, reason}\n\n# Individual safety checks\nPipeline.Safety.RecursionGuard.check_depth(context, max_depth)\nPipeline.Safety.RecursionGuard.check_circular_dependency(pipeline_id, context)\nPipeline.Safety.ResourceMonitor.check_memory(current_usage, limit)\nPipeline.Safety.ResourceMonitor.check_timeout(start_time, timeout)\nPipeline.Safety.ResourceMonitor.check_step_count(count, limit)\n\n# Resource tracking\nPipeline.Safety.ResourceMonitor.start_monitoring(context)\nPipeline.Safety.ResourceMonitor.stop_monitoring(context)\nPipeline.Safety.ResourceMonitor.get_current_usage(context)\n\n# Configuration\nPipeline.Safety.Config.get_limits(context)\nPipeline.Safety.Config.validate_config(config)\n```","ref":"safety_features.html#safety-manager-api"},{"type":"extras","title":"Configuration Schema - Safety Features","doc":"```elixir\n# Safety configuration structure\n%{\n  recursion: %{\n    max_depth: integer(),\n    warning_depth: integer(),\n    track_chain: boolean()\n  },\n  memory: %{\n    limit_mb: integer(),\n    warning_percent: integer(),\n    check_interval_ms: integer(),\n    auto_cleanup: boolean()\n  },\n  timeout: %{\n    default_seconds: integer(),\n    warning_seconds: integer(),\n    grace_period_seconds: integer(),\n    on_timeout: :graceful | :immediate | :retry\n  },\n  steps: %{\n    max_total: integer(),\n    warning_threshold: integer(),\n    count_nested: boolean()\n  },\n  workspace: %{\n    isolation_enabled: boolean(),\n    cleanup_on_success: boolean(),\n    cleanup_on_error: boolean(),\n    max_size_mb: integer()\n  }\n}\n```","ref":"safety_features.html#configuration-schema"},{"type":"extras","title":"Telemetry Events - Safety Features","doc":"```elixir\n# Safety-related telemetry events\n[:pipeline, :safety, :check_started]\n# Metadata: %{check_type: atom(), pipeline_id: string(), context: map()}\n\n[:pipeline, :safety, :check_completed]  \n# Metadata: %{check_type: atom(), result: :ok | :error, duration_μs: integer()}\n\n[:pipeline, :safety, :limit_warning]\n# Metadata: %{limit_type: atom(), current: number(), limit: number(), percent: float()}\n\n[:pipeline, :safety, :limit_exceeded]\n# Metadata: %{limit_type: atom(), current: number(), limit: number(), pipeline_id: string()}\n\n[:pipeline, :safety, :resource_cleaned]\n# Metadata: %{resource_type: atom(), size_bytes: integer(), pipeline_id: string()}\n```\n\n---\n\nThis guide provides comprehensive documentation for the safety features in recursive pipelines. These mechanisms ensure stable, predictable execution while providing clear feedback when limits are approached or exceeded.","ref":"safety_features.html#telemetry-events"},{"type":"extras","title":"Code Generation Pipelines","doc":"# Code Generation Pipelines Technical Specification","ref":"code_generation_pipelines.html"},{"type":"extras","title":"Overview - Code Generation Pipelines","doc":"Code generation pipelines automate the creation of software artifacts including APIs, tests, documentation, and refactored code. These pipelines leverage AI to understand requirements, apply best practices, and generate production-quality code.","ref":"code_generation_pipelines.html#overview"},{"type":"extras","title":"Pipeline Categories - Code Generation Pipelines","doc":"","ref":"code_generation_pipelines.html#pipeline-categories"},{"type":"extras","title":"1. API Generation Pipelines - Code Generation Pipelines","doc":"#### 1.1 REST API Generator Pipeline\n**ID**: `code-api-rest-generator`  \n**Purpose**: Generate complete REST APIs with documentation  \n**Complexity**: High  \n\n**Workflow Steps**:\n1. **Requirements Analysis** (Claude)\n   - Parse API specifications\n   - Extract entities and relationships\n   - Define endpoints and methods\n\n2. **Schema Design** (Gemini Instructor)\n   - Generate data models\n   - Create validation schemas\n   - Define relationships\n\n3. **Code Generation** (Claude Smart)\n   - Generate controllers/handlers\n   - Create service layers\n   - Implement data access\n\n4. **Test Generation** (Claude)\n   - Unit tests for each endpoint\n   - Integration test suites\n   - Mock data generation\n\n5. **Documentation** (Claude Extract)\n   - OpenAPI/Swagger specs\n   - README with examples\n   - Deployment guides\n\n**Configuration Example**:\n```yaml\nworkflow:\n  name: \"rest_api_generator\"\n  description: \"Generate complete REST API from specifications\"\n  \n  defaults:\n    workspace_dir: \"./workspace/api_generation\"\n    output_dir: \"./generated/api\"\n    \n  steps:\n    - name: \"analyze_requirements\"\n      type: \"claude\"\n      role: \"api_architect\"\n      prompt_parts:\n        - type: \"static\"\n          content: \"Analyze these API requirements and extract entities:\"\n        - type: \"file\"\n          path: \"{spec_file}\"\n      options:\n        tools: [\"write\", \"edit\"]\n        output_format: \"json\"\n        \n    - name: \"generate_schemas\"\n      type: \"gemini_instructor\"\n      role: \"schema_designer\"\n      output_schema:\n        entities:\n          type: \"array\"\n          items:\n            name: \"string\"\n            fields: \"array\"\n            relationships: \"array\"\n            \n    - name: \"generate_api_code\"\n      type: \"claude_smart\"\n      preset: \"development\"\n      role: \"backend_developer\"\n      prompt_parts:\n        - type: \"static\"\n          content: |\n            Generate {framework} REST API with:\n            - Controllers for each entity\n            - Service layer with business logic\n            - Repository pattern for data access\n            - Input validation\n            - Error handling\n        - type: \"previous_response\"\n          step: \"generate_schemas\"\n          \n    - name: \"generate_tests\"\n      type: \"claude\"\n      role: \"test_engineer\"\n      prompt: \"Generate comprehensive test suite\"\n      options:\n        workspace_dir: \"./tests\"\n        \n    - name: \"generate_docs\"\n      type: \"claude_extract\"\n      role: \"technical_writer\"\n      extraction_targets:\n        - openapi_spec\n        - readme\n        - examples\n```\n\n#### 1.2 GraphQL API Generator Pipeline\n**ID**: `code-api-graphql-generator`  \n**Purpose**: Create GraphQL APIs with resolvers  \n**Complexity**: High  \n\n**Features**:\n- Schema-first development\n- Resolver generation\n- DataLoader implementation\n- Subscription support\n- Federation compatibility\n\n#### 1.3 gRPC Service Generator Pipeline\n**ID**: `code-api-grpc-generator`  \n**Purpose**: Generate gRPC services with protobuf  \n**Complexity**: Medium  \n\n**Components**:\n```yaml\ncomponents/prompts/grpc_service.yaml:\n  template: |\n    Generate gRPC service for {service_name}:\n    \n    1. Proto file with:\n       - Service definitions\n       - Message types\n       - RPC methods\n       \n    2. Server implementation:\n       - Service handlers\n       - Business logic\n       - Error handling\n       \n    3. Client libraries:\n       - Language: {client_language}\n       - Retry logic\n       - Connection pooling\n```","ref":"code_generation_pipelines.html#1-api-generation-pipelines"},{"type":"extras","title":"2. Test Generation Pipelines - Code Generation Pipelines","doc":"#### 2.1 Comprehensive Test Suite Generator\n**ID**: `code-test-comprehensive`  \n**Purpose**: Generate full test coverage  \n**Complexity**: High  \n\n**Test Categories**:\n1. **Unit Tests**\n   - Function-level tests\n   - Edge case coverage\n   - Mock generation\n\n2. **Integration Tests**\n   - API endpoint tests\n   - Database interactions\n   - External service mocks\n\n3. **E2E Tests**\n   - User flow scenarios\n   - Cross-system testing\n   - Performance benchmarks\n\n**Implementation Pattern**:\n```yaml\nsteps:\n  - name: \"analyze_codebase\"\n    type: \"claude\"\n    role: \"test_analyst\"\n    prompt: \"Analyze code structure and identify test requirements\"\n    options:\n      tools: [\"read\", \"glob\", \"grep\"]\n      \n  - name: \"generate_test_plan\"\n    type: \"gemini\"\n    role: \"test_strategist\"\n    prompt: \"Create comprehensive test strategy\"\n    output_file: \"test_plan.md\"\n    \n  - name: \"generate_unit_tests\"\n    type: \"claude_batch\"\n    role: \"unit_test_developer\"\n    batch_config:\n      files_per_batch: 5\n      output_pattern: \"tests/unit/{filename}_test.{ext}\"\n      \n  - name: \"generate_integration_tests\"\n    type: \"claude\"\n    role: \"integration_tester\"\n    prompt: \"Generate integration test suite\"\n    \n  - name: \"generate_e2e_tests\"\n    type: \"claude_smart\"\n    preset: \"development\"\n    role: \"e2e_tester\"\n    prompt: \"Create end-to-end test scenarios\"\n```\n\n#### 2.2 Property-Based Test Generator\n**ID**: `code-test-property-based`  \n**Purpose**: Generate property-based tests  \n**Complexity**: Medium  \n\n**Features**:\n- Property identification\n- Generator functions\n- Shrinking strategies\n- Invariant testing\n\n#### 2.3 Mutation Test Generator\n**ID**: `code-test-mutation`  \n**Purpose**: Create mutation testing suites  \n**Complexity**: Medium  \n\n**Mutation Strategies**:\n- Statement mutations\n- Value mutations\n- Decision mutations\n- Coverage analysis","ref":"code_generation_pipelines.html#2-test-generation-pipelines"},{"type":"extras","title":"3. Documentation Generation Pipelines - Code Generation Pipelines","doc":"#### 3.1 API Documentation Generator\n**ID**: `code-docs-api`  \n**Purpose**: Generate comprehensive API documentation  \n**Complexity**: Medium  \n\n**Documentation Types**:\n1. **Reference Documentation**\n   - Endpoint descriptions\n   - Parameter details\n   - Response schemas\n   - Error codes\n\n2. **Tutorial Documentation**\n   - Getting started guides\n   - Authentication flows\n   - Common use cases\n   - Best practices\n\n3. **Interactive Documentation**\n   - Swagger UI setup\n   - Postman collections\n   - Code examples\n   - Try-it-out features\n\n**Workflow Example**:\n```yaml\nsteps:\n  - name: \"extract_api_info\"\n    type: \"claude_extract\"\n    role: \"api_analyzer\"\n    extraction_config:\n      targets:\n        - endpoints\n        - parameters\n        - responses\n        - authentication\n        \n  - name: \"generate_openapi\"\n    type: \"gemini_instructor\"\n    role: \"openapi_generator\"\n    output_schema:\n      openapi: \"3.0.0\"\n      info: \"object\"\n      paths: \"object\"\n      components: \"object\"\n      \n  - name: \"generate_guides\"\n    type: \"claude_session\"\n    role: \"technical_writer\"\n    session_tasks:\n      - quick_start_guide\n      - authentication_guide\n      - best_practices\n      - troubleshooting\n```\n\n#### 3.2 Code Documentation Generator\n**ID**: `code-docs-inline`  \n**Purpose**: Generate inline code documentation  \n**Complexity**: Low  \n\n**Documentation Elements**:\n- Function docstrings\n- Class documentation\n- Module overviews\n- Type annotations\n\n#### 3.3 Architecture Documentation Generator\n**ID**: `code-docs-architecture`  \n**Purpose**: Generate system architecture docs  \n**Complexity**: High  \n\n**Documentation Sections**:\n- System overview\n- Component diagrams\n- Sequence diagrams\n- Deployment architecture\n- Decision records","ref":"code_generation_pipelines.html#3-documentation-generation-pipelines"},{"type":"extras","title":"4. Refactoring Pipelines - Code Generation Pipelines","doc":"#### 4.1 Intelligent Code Refactoring Pipeline\n**ID**: `code-refactor-intelligent`  \n**Purpose**: Automated code improvement  \n**Complexity**: High  \n\n**Refactoring Types**:\n1. **Structural Refactoring**\n   - Extract methods/classes\n   - Inline redundant code\n   - Move functionality\n   - Rename for clarity\n\n2. **Performance Refactoring**\n   - Algorithm optimization\n   - Caching implementation\n   - Query optimization\n   - Memory efficiency\n\n3. **Pattern Implementation**\n   - Design pattern application\n   - SOLID principles\n   - DRY enforcement\n   - Code organization\n\n**Implementation Approach**:\n```yaml\nsteps:\n  - name: \"code_analysis\"\n    type: \"claude\"\n    role: \"code_analyst\"\n    prompt: \"Analyze code for refactoring opportunities\"\n    options:\n      tools: [\"read\", \"grep\", \"glob\"]\n      \n  - name: \"identify_patterns\"\n    type: \"gemini\"\n    role: \"pattern_detector\"\n    gemini_functions:\n      - name: \"detect_code_smells\"\n      - name: \"suggest_patterns\"\n      - name: \"calculate_complexity\"\n      \n  - name: \"plan_refactoring\"\n    type: \"claude_smart\"\n    preset: \"analysis\"\n    role: \"refactoring_planner\"\n    prompt: \"Create detailed refactoring plan\"\n    \n  - name: \"execute_refactoring\"\n    type: \"claude_robust\"\n    role: \"refactoring_engineer\"\n    error_handling:\n      syntax_errors: \"rollback\"\n      test_failures: \"iterate\"\n    options:\n      tools: [\"edit\", \"multiedit\", \"write\"]\n      \n  - name: \"verify_behavior\"\n    type: \"claude\"\n    role: \"test_runner\"\n    prompt: \"Run tests to verify behavior preservation\"\n    options:\n      tools: [\"bash\"]\n```\n\n#### 4.2 Legacy Code Modernization Pipeline\n**ID**: `code-refactor-modernize`  \n**Purpose**: Update legacy codebases  \n**Complexity**: High  \n\n**Modernization Aspects**:\n- Language version updates\n- Framework migrations\n- Dependency updates\n- Security improvements\n\n#### 4.3 Code Style Standardization Pipeline\n**ID**: `code-refactor-style`  \n**Purpose**: Enforce consistent code style  \n**Complexity**: Low  \n\n**Style Elements**:\n- Formatting rules\n- Naming conventions\n- Import organization\n- Comment standards","ref":"code_generation_pipelines.html#4-refactoring-pipelines"},{"type":"extras","title":"Reusable Components - Code Generation Pipelines","doc":"","ref":"code_generation_pipelines.html#reusable-components"},{"type":"extras","title":"Code Analysis Components - Code Generation Pipelines","doc":"```yaml\n# components/steps/analysis/code_analyzer.yaml\ncomponent:\n  id: \"code-analyzer\"\n  type: \"step\"\n  \n  analysis_types:\n    - complexity_metrics\n    - dependency_analysis\n    - dead_code_detection\n    - security_vulnerabilities\n    - performance_bottlenecks\n    \n  outputs:\n    report_format: [\"json\", \"markdown\", \"html\"]\n    metrics: [\"cyclomatic\", \"cognitive\", \"halstead\"]\n```","ref":"code_generation_pipelines.html#code-analysis-components"},{"type":"extras","title":"Code Generation Templates - Code Generation Pipelines","doc":"```yaml\n# components/prompts/code/api_controller.yaml\ncomponent:\n  id: \"api-controller-template\"\n  type: \"prompt\"\n  \n  variables:\n    - entity_name\n    - operations\n    - validation_rules\n    - auth_requirements\n    \n  template: |\n    Generate {language} REST controller for {entity_name}:\n    \n    Operations: {operations}\n    \n    Requirements:\n    - Input validation: {validation_rules}\n    - Authentication: {auth_requirements}\n    - Error handling with proper status codes\n    - Logging for debugging\n    - OpenAPI annotations\n```","ref":"code_generation_pipelines.html#code-generation-templates"},{"type":"extras","title":"Test Generation Functions - Code Generation Pipelines","doc":"```yaml\n# components/functions/test_generation.yaml\nfunctions:\n  - name: \"generate_test_cases\"\n    description: \"Generate test cases from code\"\n    parameters:\n      code_file: \"string\"\n      coverage_target: \"number\"\n      test_types: \"array\"\n      \n  - name: \"generate_mocks\"\n    description: \"Create mock objects\"\n    parameters:\n      dependencies: \"array\"\n      mock_framework: \"string\"\n```","ref":"code_generation_pipelines.html#test-generation-functions"},{"type":"extras","title":"Quality Assurance - Code Generation Pipelines","doc":"","ref":"code_generation_pipelines.html#quality-assurance"},{"type":"extras","title":"1. Code Quality Checks - Code Generation Pipelines","doc":"```yaml\nquality_gates:\n  generated_code:\n    - syntax_valid: true\n    - tests_pass: true\n    - coverage: \">= 80%\"\n    - linting_errors: 0\n    - security_issues: 0\n    \n  documentation:\n    - completeness: \">= 95%\"\n    - examples_provided: true\n    - links_valid: true\n```","ref":"code_generation_pipelines.html#1-code-quality-checks"},{"type":"extras","title":"2. Review Process - Code Generation Pipelines","doc":"- Automated code review\n- Style guide compliance\n- Best practice verification\n- Security scanning","ref":"code_generation_pipelines.html#2-review-process"},{"type":"extras","title":"Performance Optimization - Code Generation Pipelines","doc":"","ref":"code_generation_pipelines.html#performance-optimization"},{"type":"extras","title":"1. Generation Strategies - Code Generation Pipelines","doc":"- Template caching\n- Incremental generation\n- Parallel processing\n- Smart batching","ref":"code_generation_pipelines.html#1-generation-strategies"},{"type":"extras","title":"2. Resource Management - Code Generation Pipelines","doc":"- Token optimization\n- Memory efficiency\n- Rate limit handling\n- Cost tracking","ref":"code_generation_pipelines.html#2-resource-management"},{"type":"extras","title":"Integration Patterns - Code Generation Pipelines","doc":"","ref":"code_generation_pipelines.html#integration-patterns"},{"type":"extras","title":"1. Version Control Integration - Code Generation Pipelines","doc":"```yaml\nvcs_integration:\n  pre_generation:\n    - branch_creation\n    - conflict_check\n    \n  post_generation:\n    - commit_changes\n    - create_pr\n    - run_ci_checks\n```","ref":"code_generation_pipelines.html#1-version-control-integration"},{"type":"extras","title":"2. CI/CD Integration - Code Generation Pipelines","doc":"- Automated testing\n- Code quality gates\n- Deployment triggers\n- Monitoring setup","ref":"code_generation_pipelines.html#2-ci-cd-integration"},{"type":"extras","title":"3. IDE Integration - Code Generation Pipelines","doc":"- Code completion\n- Inline suggestions\n- Refactoring tools\n- Documentation hover","ref":"code_generation_pipelines.html#3-ide-integration"},{"type":"extras","title":"Best Practices - Code Generation Pipelines","doc":"1. **Iterative Generation**: Build incrementally\n2. **Human Review**: Always review generated code\n3. **Test First**: Generate tests before code\n4. **Documentation**: Keep docs in sync\n5. **Version Control**: Track all changes\n6. **Security First**: Scan for vulnerabilities","ref":"code_generation_pipelines.html#best-practices"},{"type":"extras","title":"Advanced Features - Code Generation Pipelines","doc":"","ref":"code_generation_pipelines.html#advanced-features"},{"type":"extras","title":"1. Context-Aware Generation - Code Generation Pipelines","doc":"- Project structure understanding\n- Coding standard detection\n- Framework convention following","ref":"code_generation_pipelines.html#1-context-aware-generation"},{"type":"extras","title":"2. Learning from Feedback - Code Generation Pipelines","doc":"- Code review incorporation\n- Pattern learning\n- Style adaptation","ref":"code_generation_pipelines.html#2-learning-from-feedback"},{"type":"extras","title":"3. Multi-Language Support - Code Generation Pipelines","doc":"- Cross-language generation\n- Language-specific optimizations\n- Framework expertise","ref":"code_generation_pipelines.html#3-multi-language-support"},{"type":"extras","title":"Monitoring and Metrics - Code Generation Pipelines","doc":"","ref":"code_generation_pipelines.html#monitoring-and-metrics"},{"type":"extras","title":"1. Generation Metrics - Code Generation Pipelines","doc":"- Lines of code generated\n- Test coverage achieved\n- Documentation completeness\n- Generation time\n- Token usage","ref":"code_generation_pipelines.html#1-generation-metrics"},{"type":"extras","title":"2. Quality Metrics - Code Generation Pipelines","doc":"- Code complexity scores\n- Bug detection rate\n- Performance benchmarks\n- Security scan results","ref":"code_generation_pipelines.html#2-quality-metrics"},{"type":"extras","title":"Future Enhancements - Code Generation Pipelines","doc":"1. **AI Code Review**: Automated PR reviews\n2. **Predictive Refactoring**: Proactive improvements\n3. **Architecture Generation**: Full system design\n4. **Performance Optimization**: AI-driven tuning\n5. **Security Hardening**: Automated security fixes","ref":"code_generation_pipelines.html#future-enhancements"},{"type":"extras","title":"Data Processing Pipelines","doc":"# Data Processing Pipelines Technical Specification","ref":"data_processing_pipelines.html"},{"type":"extras","title":"Overview - Data Processing Pipelines","doc":"Data processing pipelines form the foundation of AI engineering workflows, handling data ingestion, cleaning, transformation, enrichment, and quality assurance. These pipelines leverage both Claude and Gemini for intelligent data manipulation.","ref":"data_processing_pipelines.html#overview"},{"type":"extras","title":"Pipeline Categories - Data Processing Pipelines","doc":"","ref":"data_processing_pipelines.html#pipeline-categories"},{"type":"extras","title":"1. Data Cleaning Pipelines - Data Processing Pipelines","doc":"#### 1.1 Standard Data Cleaning Pipeline\n**ID**: `data-cleaning-standard`  \n**Purpose**: Multi-stage data cleaning with validation  \n**Complexity**: Medium  \n\n**Workflow Steps**:\n1. **Data Profiling** (Gemini)\n   - Analyze data structure and types\n   - Identify anomalies and patterns\n   - Generate cleaning recommendations\n\n2. **Schema Validation** (Gemini Function)\n   - Validate against expected schema\n   - Report schema violations\n   - Suggest schema corrections\n\n3. **Data Cleansing** (Claude)\n   - Remove duplicates\n   - Handle missing values\n   - Standardize formats\n   - Fix encoding issues\n\n4. **Quality Check** (Gemini)\n   - Verify cleaning effectiveness\n   - Generate quality report\n   - Flag remaining issues\n\n**Configuration Example**:\n```yaml\nworkflow:\n  name: \"data_cleaning_standard\"\n  description: \"Comprehensive data cleaning with quality assurance\"\n  \n  defaults:\n    workspace_dir: \"./workspace/data_cleaning\"\n    output_dir: \"./outputs/cleaned_data\"\n    \n  steps:\n    - name: \"profile_data\"\n      type: \"gemini\"\n      role: \"data_analyst\"\n      prompt_parts:\n        - type: \"static\"\n          content: \"Analyze this dataset and identify data quality issues:\"\n        - type: \"file\"\n          path: \"{input_file}\"\n      options:\n        model: \"gemini-2.5-flash\"\n        temperature: 0.3\n        \n    - name: \"validate_schema\"\n      type: \"gemini\"\n      role: \"schema_validator\"\n      gemini_functions:\n        - name: \"validate_schema\"\n          parameters:\n            schema_file: \"{schema_path}\"\n            data_file: \"{input_file}\"\n            \n    - name: \"clean_data\"\n      type: \"claude\"\n      role: \"data_engineer\"\n      prompt_parts:\n        - type: \"static\"\n          content: \"Clean the data based on these issues:\"\n        - type: \"previous_response\"\n          step: \"profile_data\"\n      options:\n        tools: [\"write\", \"edit\", \"read\"]\n        output_format: \"json\"\n        \n    - name: \"quality_check\"\n      type: \"gemini\"\n      role: \"quality_assurance\"\n      prompt_parts:\n        - type: \"static\"\n          content: \"Verify the cleaned data quality\"\n        - type: \"previous_response\"\n          step: \"clean_data\"\n          field: \"cleaned_file_path\"\n```\n\n#### 1.2 Advanced Data Cleaning Pipeline\n**ID**: `data-cleaning-advanced`  \n**Purpose**: ML-powered cleaning with anomaly detection  \n**Complexity**: High  \n\n**Additional Features**:\n- Outlier detection using statistical methods\n- Pattern-based cleaning rules\n- Machine learning for missing value imputation\n- Automated data type inference","ref":"data_processing_pipelines.html#1-data-cleaning-pipelines"},{"type":"extras","title":"2. Data Enrichment Pipelines - Data Processing Pipelines","doc":"#### 2.1 Entity Extraction Pipeline\n**ID**: `data-enrichment-entity`  \n**Purpose**: Extract and enrich entities from unstructured data  \n**Complexity**: High  \n\n**Workflow Steps**:\n1. **Text Preprocessing** (Claude)\n   - Normalize text format\n   - Handle encoding issues\n   - Segment into processable chunks\n\n2. **Entity Recognition** (Parallel Claude)\n   - Identify persons, organizations, locations\n   - Extract dates, amounts, identifiers\n   - Detect custom entity types\n\n3. **Entity Enrichment** (Gemini Functions)\n   - Lookup additional information\n   - Validate entity relationships\n   - Cross-reference with knowledge bases\n\n4. **Data Integration** (Claude)\n   - Merge enriched data\n   - Resolve conflicts\n   - Generate enriched dataset\n\n**Key Components**:\n```yaml\n# Reusable entity extraction prompt\ncomponents/prompts/entity_extraction.yaml:\n  variables:\n    - text_content\n    - entity_types\n    - extraction_rules\n    \n  template: |\n    Extract the following entity types from the text:\n    Entity Types: {entity_types}\n    \n    Rules:\n    {extraction_rules}\n    \n    Text:\n    {text_content}\n    \n    Return as structured JSON with confidence scores.\n```\n\n#### 2.2 Data Augmentation Pipeline\n**ID**: `data-enrichment-augmentation`  \n**Purpose**: Intelligently augment datasets for ML training  \n**Complexity**: Medium  \n\n**Features**:\n- Synthetic data generation\n- Data balancing techniques\n- Feature engineering\n- Cross-validation setup","ref":"data_processing_pipelines.html#2-data-enrichment-pipelines"},{"type":"extras","title":"3. Data Transformation Pipelines - Data Processing Pipelines","doc":"#### 3.1 Format Conversion Pipeline\n**ID**: `data-transformation-format`  \n**Purpose**: Convert between data formats intelligently  \n**Complexity**: Low  \n\n**Supported Conversions**:\n- CSV ↔ JSON ↔ XML ↔ Parquet\n- Schema-aware transformations\n- Nested structure handling\n- Batch processing support\n\n**Workflow Example**:\n```yaml\nsteps:\n  - name: \"analyze_source\"\n    type: \"gemini\"\n    role: \"format_analyzer\"\n    prompt: \"Analyze the structure of this {source_format} file\"\n    \n  - name: \"generate_mapping\"\n    type: \"claude\"\n    role: \"mapping_generator\"\n    prompt: \"Create transformation rules from {source_format} to {target_format}\"\n    \n  - name: \"transform_data\"\n    type: \"claude_batch\"\n    role: \"data_transformer\"\n    batch_size: 1000\n    prompt: \"Apply transformation rules to convert data\"\n```\n\n#### 3.2 Data Normalization Pipeline\n**ID**: `data-transformation-normalize`  \n**Purpose**: Standardize data across sources  \n**Complexity**: Medium  \n\n**Normalization Types**:\n- Value normalization (scaling, encoding)\n- Schema normalization\n- Format standardization\n- Reference data alignment","ref":"data_processing_pipelines.html#3-data-transformation-pipelines"},{"type":"extras","title":"4. Data Quality Pipelines - Data Processing Pipelines","doc":"#### 4.1 Comprehensive Quality Assessment\n**ID**: `data-quality-comprehensive`  \n**Purpose**: Full data quality evaluation and reporting  \n**Complexity**: High  \n\n**Quality Dimensions**:\n1. **Completeness**: Missing value analysis\n2. **Accuracy**: Validation against rules\n3. **Consistency**: Cross-field validation\n4. **Timeliness**: Data freshness checks\n5. **Uniqueness**: Duplicate detection\n6. **Validity**: Format and range checks\n\n**Implementation Pattern**:\n```yaml\nsteps:\n  - name: \"parallel_quality_checks\"\n    type: \"parallel_claude\"\n    instances:\n      - role: \"completeness_checker\"\n        prompt: \"Analyze data completeness\"\n      - role: \"accuracy_validator\"\n        prompt: \"Check data accuracy\"\n      - role: \"consistency_analyzer\"\n        prompt: \"Validate data consistency\"\n        \n  - name: \"generate_report\"\n    type: \"claude_smart\"\n    preset: \"analysis\"\n    prompt: \"Generate comprehensive quality report\"\n    output_file: \"quality_report.md\"\n```\n\n#### 4.2 Real-time Quality Monitoring\n**ID**: `data-quality-monitoring`  \n**Purpose**: Continuous quality monitoring with alerts  \n**Complexity**: Medium  \n\n**Features**:\n- Streaming data quality checks\n- Anomaly detection\n- Alert generation\n- Quality trend analysis","ref":"data_processing_pipelines.html#4-data-quality-pipelines"},{"type":"extras","title":"Reusable Components - Data Processing Pipelines","doc":"","ref":"data_processing_pipelines.html#reusable-components"},{"type":"extras","title":"Validation Components - Data Processing Pipelines","doc":"```yaml\n# components/steps/validation/schema_validator.yaml\ncomponent:\n  id: \"schema-validator\"\n  type: \"step\"\n  \n  implementation:\n    type: \"gemini\"\n    functions:\n      - name: \"validate_against_schema\"\n        description: \"Validate data against JSON Schema\"\n        parameters:\n          data:\n            type: \"object\"\n          schema:\n            type: \"object\"\n          strict_mode:\n            type: \"boolean\"\n            default: true\n```","ref":"data_processing_pipelines.html#validation-components"},{"type":"extras","title":"Transformation Components - Data Processing Pipelines","doc":"```yaml\n# components/transformers/data/normalizer.yaml\ncomponent:\n  id: \"data-normalizer\"\n  type: \"transformer\"\n  \n  strategies:\n    - min_max_scaling\n    - z_score_normalization\n    - decimal_scaling\n    - log_transformation\n```","ref":"data_processing_pipelines.html#transformation-components"},{"type":"extras","title":"Quality Check Components - Data Processing Pipelines","doc":"```yaml\n# components/steps/quality/duplicate_detector.yaml\ncomponent:\n  id: \"duplicate-detector\"\n  type: \"step\"\n  \n  algorithms:\n    - exact_match\n    - fuzzy_match\n    - semantic_similarity\n  \n  configuration:\n    threshold: 0.95\n    columns: [\"all\"]\n```","ref":"data_processing_pipelines.html#quality-check-components"},{"type":"extras","title":"Performance Considerations - Data Processing Pipelines","doc":"","ref":"data_processing_pipelines.html#performance-considerations"},{"type":"extras","title":"1. Batch Processing - Data Processing Pipelines","doc":"- Use `claude_batch` for large datasets\n- Implement chunking strategies\n- Configure appropriate batch sizes","ref":"data_processing_pipelines.html#1-batch-processing"},{"type":"extras","title":"2. Parallel Execution - Data Processing Pipelines","doc":"- Leverage `parallel_claude` for independent tasks\n- Distribute workload effectively\n- Manage memory consumption","ref":"data_processing_pipelines.html#2-parallel-execution"},{"type":"extras","title":"3. Caching Strategies - Data Processing Pipelines","doc":"- Cache intermediate results\n- Implement smart checkpointing\n- Use workspace effectively","ref":"data_processing_pipelines.html#3-caching-strategies"},{"type":"extras","title":"Error Handling - Data Processing Pipelines","doc":"","ref":"data_processing_pipelines.html#error-handling"},{"type":"extras","title":"1. Data Validation Errors - Data Processing Pipelines","doc":"```yaml\nerror_handlers:\n  schema_validation_error:\n    action: \"log_and_continue\"\n    fallback: \"use_previous_schema\"\n    \n  missing_required_field:\n    action: \"attempt_recovery\"\n    strategy: \"infer_from_context\"\n```","ref":"data_processing_pipelines.html#1-data-validation-errors"},{"type":"extras","title":"2. Processing Failures - Data Processing Pipelines","doc":"- Implement retry mechanisms\n- Partial result preservation\n- Graceful degradation","ref":"data_processing_pipelines.html#2-processing-failures"},{"type":"extras","title":"Testing Strategies - Data Processing Pipelines","doc":"","ref":"data_processing_pipelines.html#testing-strategies"},{"type":"extras","title":"1. Unit Tests - Data Processing Pipelines","doc":"- Test individual transformation functions\n- Validate cleaning algorithms\n- Check enrichment accuracy","ref":"data_processing_pipelines.html#1-unit-tests"},{"type":"extras","title":"2. Integration Tests - Data Processing Pipelines","doc":"- End-to-end pipeline execution\n- Data quality benchmarks\n- Performance testing","ref":"data_processing_pipelines.html#2-integration-tests"},{"type":"extras","title":"3. Sample Data Sets - Data Processing Pipelines","doc":"```yaml\ntest_data:\n  small_dataset:\n    size: \"1MB\"\n    records: 1000\n    issues: [\"duplicates\", \"missing_values\"]\n    \n  large_dataset:\n    size: \"100MB\"\n    records: 100000\n    issues: [\"encoding\", \"schema_drift\"]\n```","ref":"data_processing_pipelines.html#3-sample-data-sets"},{"type":"extras","title":"Monitoring and Metrics - Data Processing Pipelines","doc":"","ref":"data_processing_pipelines.html#monitoring-and-metrics"},{"type":"extras","title":"1. Pipeline Metrics - Data Processing Pipelines","doc":"- Execution time per stage\n- Data volume processed\n- Quality improvement scores\n- Resource utilization","ref":"data_processing_pipelines.html#1-pipeline-metrics"},{"type":"extras","title":"2. Quality Metrics - Data Processing Pipelines","doc":"- Data quality score trends\n- Issue detection rates\n- Cleaning effectiveness\n- Enrichment coverage","ref":"data_processing_pipelines.html#2-quality-metrics"},{"type":"extras","title":"Best Practices - Data Processing Pipelines","doc":"1. **Start Simple**: Begin with standard cleaning pipeline\n2. **Profile First**: Always analyze data before processing\n3. **Validate Often**: Check data quality at each stage\n4. **Document Changes**: Track all transformations\n5. **Test Thoroughly**: Use representative test data\n6. **Monitor Continuously**: Track quality metrics","ref":"data_processing_pipelines.html#best-practices"},{"type":"extras","title":"Future Enhancements - Data Processing Pipelines","doc":"1. **Real-time Processing**: Stream processing support\n2. **ML Integration**: Advanced anomaly detection\n3. **Custom Rules Engine**: User-defined cleaning rules\n4. **Visual Pipeline Builder**: GUI for pipeline creation\n5. **Auto-optimization**: Performance tuning based on data characteristics","ref":"data_processing_pipelines.html#future-enhancements"},{"type":"extras","title":"Model Development Pipelines","doc":"# Model Development Pipelines Technical Specification","ref":"model_development_pipelines.html"},{"type":"extras","title":"Overview - Model Development Pipelines","doc":"Model development pipelines facilitate the iterative process of creating, evaluating, and optimizing AI models. These pipelines support prompt engineering, model comparison, evaluation frameworks, and fine-tuning workflows.","ref":"model_development_pipelines.html#overview"},{"type":"extras","title":"Pipeline Categories - Model Development Pipelines","doc":"","ref":"model_development_pipelines.html#pipeline-categories"},{"type":"extras","title":"1. Prompt Engineering Pipelines - Model Development Pipelines","doc":"#### 1.1 Iterative Prompt Optimization Pipeline\n**ID**: `prompt-engineering-iterative`  \n**Purpose**: Systematically optimize prompts through experimentation  \n**Complexity**: High  \n\n**Workflow Steps**:\n1. **Baseline Establishment** (Claude)\n   - Generate initial prompt variations\n   - Define success metrics\n   - Create test scenarios\n\n2. **Parallel Testing** (Parallel Claude)\n   - Execute prompts across test cases\n   - Collect performance metrics\n   - Track token usage\n\n3. **Performance Analysis** (Gemini)\n   - Analyze results statistically\n   - Identify patterns\n   - Rank prompt effectiveness\n\n4. **Prompt Refinement** (Claude Smart)\n   - Generate improved variations\n   - Apply learned optimizations\n   - Incorporate best practices\n\n5. **Validation** (Claude Batch)\n   - Test refined prompts\n   - Compare against baseline\n   - Generate final report\n\n**Configuration Example**:\n```yaml\nworkflow:\n  name: \"prompt_optimization\"\n  description: \"Iterative prompt engineering with A/B testing\"\n  \n  defaults:\n    workspace_dir: \"./workspace/prompt_engineering\"\n    checkpoint_enabled: true\n    \n  steps:\n    - name: \"generate_variations\"\n      type: \"claude\"\n      role: \"prompt_engineer\"\n      prompt_parts:\n        - type: \"static\"\n          content: |\n            Create 5 variations of this prompt for {task_type}:\n            Original: {base_prompt}\n            \n            Focus on: clarity, specificity, and effectiveness\n      options:\n        output_format: \"json\"\n        \n    - name: \"parallel_test\"\n      type: \"parallel_claude\"\n      instances:\n        - role: \"tester_1\"\n          prompt_template: \"{variation_1}\"\n        - role: \"tester_2\"\n          prompt_template: \"{variation_2}\"\n        - role: \"tester_3\"\n          prompt_template: \"{variation_3}\"\n      test_data: \"{test_cases}\"\n      \n    - name: \"analyze_results\"\n      type: \"gemini\"\n      role: \"data_scientist\"\n      prompt: \"Analyze prompt performance metrics\"\n      gemini_functions:\n        - name: \"calculate_metrics\"\n          description: \"Calculate success metrics\"\n        - name: \"statistical_analysis\"\n          description: \"Perform statistical tests\"\n```\n\n#### 1.2 Chain-of-Thought Prompt Builder\n**ID**: `prompt-engineering-cot`  \n**Purpose**: Build effective chain-of-thought prompts  \n**Complexity**: Medium  \n\n**Features**:\n- Reasoning step extraction\n- Example generation\n- Logic validation\n- Performance benchmarking\n\n#### 1.3 Few-Shot Learning Pipeline\n**ID**: `prompt-engineering-fewshot`  \n**Purpose**: Optimize few-shot examples for tasks  \n**Complexity**: Medium  \n\n**Workflow Components**:\n```yaml\ncomponents/prompts/few_shot_template.yaml:\n  template: |\n    Task: {task_description}\n    \n    Examples:\n    {for example in examples}\n    Input: {example.input}\n    Output: {example.output}\n    Reasoning: {example.reasoning}\n    {endfor}\n    \n    Now apply to:\n    Input: {target_input}\n```","ref":"model_development_pipelines.html#1-prompt-engineering-pipelines"},{"type":"extras","title":"2. Model Evaluation Pipelines - Model Development Pipelines","doc":"#### 2.1 Comprehensive Model Testing Pipeline\n**ID**: `model-evaluation-comprehensive`  \n**Purpose**: Full evaluation suite for model performance  \n**Complexity**: High  \n\n**Evaluation Dimensions**:\n1. **Accuracy Testing**\n   - Task-specific benchmarks\n   - Ground truth comparison\n   - Error analysis\n\n2. **Robustness Testing**\n   - Edge case handling\n   - Adversarial inputs\n   - Stress testing\n\n3. **Consistency Testing**\n   - Response stability\n   - Temporal consistency\n   - Cross-prompt alignment\n\n4. **Bias Detection**\n   - Demographic parity\n   - Fairness metrics\n   - Representation analysis\n\n**Implementation Pattern**:\n```yaml\nsteps:\n  - name: \"prepare_test_suite\"\n    type: \"claude\"\n    role: \"test_designer\"\n    prompt: \"Generate comprehensive test cases for {model_task}\"\n    output_file: \"test_suite.json\"\n    \n  - name: \"run_accuracy_tests\"\n    type: \"claude_batch\"\n    role: \"accuracy_tester\"\n    batch_config:\n      test_suite: \"test_suite.json\"\n      metrics: [\"exact_match\", \"f1_score\", \"bleu\"]\n      \n  - name: \"robustness_testing\"\n    type: \"claude_robust\"\n    role: \"robustness_tester\"\n    error_scenarios:\n      - malformed_input\n      - extreme_length\n      - multilingual\n      \n  - name: \"bias_analysis\"\n    type: \"gemini\"\n    role: \"bias_detector\"\n    gemini_functions:\n      - name: \"demographic_analysis\"\n      - name: \"fairness_metrics\"\n```\n\n#### 2.2 Performance Benchmarking Pipeline\n**ID**: `model-evaluation-benchmark`  \n**Purpose**: Benchmark model against standards  \n**Complexity**: Medium  \n\n**Benchmark Categories**:\n- Speed and latency\n- Token efficiency\n- Cost analysis\n- Quality metrics\n\n#### 2.3 Regression Testing Pipeline\n**ID**: `model-evaluation-regression`  \n**Purpose**: Ensure model improvements don't degrade  \n**Complexity**: Low  \n\n**Features**:\n- Historical comparison\n- Performance tracking\n- Automated alerts\n- Trend analysis","ref":"model_development_pipelines.html#2-model-evaluation-pipelines"},{"type":"extras","title":"3. Model Comparison Pipelines - Model Development Pipelines","doc":"#### 3.1 A/B Testing Pipeline\n**ID**: `model-comparison-ab`  \n**Purpose**: Compare models or prompts systematically  \n**Complexity**: Medium  \n\n**Workflow Structure**:\n```yaml\nsteps:\n  - name: \"setup_experiment\"\n    type: \"claude\"\n    role: \"experiment_designer\"\n    prompt: \"Design A/B test for comparing {model_a} vs {model_b}\"\n    \n  - name: \"parallel_execution\"\n    type: \"parallel_claude\"\n    instances:\n      - role: \"model_a_executor\"\n        model_config: \"{model_a_config}\"\n      - role: \"model_b_executor\"\n        model_config: \"{model_b_config}\"\n        \n  - name: \"statistical_analysis\"\n    type: \"gemini_instructor\"\n    role: \"statistician\"\n    output_schema:\n      winner: \"string\"\n      confidence: \"float\"\n      p_value: \"float\"\n      effect_size: \"float\"\n```\n\n#### 3.2 Multi-Model Ensemble Pipeline\n**ID**: `model-comparison-ensemble`  \n**Purpose**: Combine multiple models for better results  \n**Complexity**: High  \n\n**Ensemble Strategies**:\n- Voting mechanisms\n- Weighted averaging\n- Stacking approaches\n- Dynamic selection\n\n#### 3.3 Cross-Provider Comparison\n**ID**: `model-comparison-cross-provider`  \n**Purpose**: Compare Claude vs Gemini for tasks  \n**Complexity**: Medium  \n\n**Comparison Metrics**:\n- Quality of outputs\n- Speed and latency\n- Cost efficiency\n- Feature capabilities","ref":"model_development_pipelines.html#3-model-comparison-pipelines"},{"type":"extras","title":"4. Fine-Tuning Pipelines - Model Development Pipelines","doc":"#### 4.1 Dataset Preparation Pipeline\n**ID**: `fine-tuning-dataset-prep`  \n**Purpose**: Prepare high-quality training datasets  \n**Complexity**: High  \n\n**Dataset Processing Steps**:\n1. **Data Collection** (Claude)\n   - Gather relevant examples\n   - Ensure diversity\n   - Balance categories\n\n2. **Data Cleaning** (Reference: data-cleaning-standard)\n   - Remove duplicates\n   - Fix formatting\n   - Validate quality\n\n3. **Annotation** (Claude Session)\n   - Add labels/tags\n   - Generate explanations\n   - Create metadata\n\n4. **Augmentation** (Parallel Claude)\n   - Generate variations\n   - Add synthetic examples\n   - Balance dataset\n\n5. **Validation** (Gemini)\n   - Check data quality\n   - Verify distributions\n   - Generate statistics\n\n**Configuration Example**:\n```yaml\nsteps:\n  - name: \"collect_examples\"\n    type: \"claude_extract\"\n    role: \"data_collector\"\n    extraction_config:\n      source: \"{data_sources}\"\n      criteria: \"{selection_criteria}\"\n      format: \"jsonl\"\n      \n  - name: \"annotate_data\"\n    type: \"claude_session\"\n    role: \"annotator\"\n    session_config:\n      task: \"Add training labels\"\n      batch_size: 100\n      save_progress: true\n      \n  - name: \"augment_dataset\"\n    type: \"parallel_claude\"\n    instances: 5\n    augmentation_strategies:\n      - paraphrase\n      - backtranslation\n      - token_replacement\n```\n\n#### 4.2 Training Pipeline Orchestration\n**ID**: `fine-tuning-orchestration`  \n**Purpose**: Manage fine-tuning workflow  \n**Complexity**: High  \n\n**Workflow Management**:\n- Dataset versioning\n- Training job scheduling\n- Hyperparameter tuning\n- Model versioning\n\n#### 4.3 Fine-Tuned Model Evaluation\n**ID**: `fine-tuning-evaluation`  \n**Purpose**: Evaluate fine-tuned model performance  \n**Complexity**: Medium  \n\n**Evaluation Focus**:\n- Task-specific improvements\n- Generalization testing\n- Overfitting detection\n- Comparison with base model","ref":"model_development_pipelines.html#4-fine-tuning-pipelines"},{"type":"extras","title":"Reusable Components - Model Development Pipelines","doc":"","ref":"model_development_pipelines.html#reusable-components"},{"type":"extras","title":"Evaluation Metrics Components - Model Development Pipelines","doc":"```yaml\n# components/steps/evaluation/metrics_calculator.yaml\ncomponent:\n  id: \"metrics-calculator\"\n  type: \"step\"\n  \n  supported_metrics:\n    classification:\n      - accuracy\n      - precision\n      - recall\n      - f1_score\n      - roc_auc\n    generation:\n      - bleu\n      - rouge\n      - bertscore\n      - semantic_similarity\n    custom:\n      - task_specific_metric\n```","ref":"model_development_pipelines.html#evaluation-metrics-components"},{"type":"extras","title":"Prompt Templates Library - Model Development Pipelines","doc":"```yaml\n# components/prompts/evaluation/test_case_generator.yaml\ncomponent:\n  id: \"test-case-generator\"\n  type: \"prompt\"\n  \n  template: |\n    Generate {num_cases} test cases for {task_type}:\n    \n    Requirements:\n    - Cover edge cases\n    - Include normal cases\n    - Test boundary conditions\n    - Vary complexity\n    \n    Format each as:\n    input:  \n    expected:  \n    category:  \n```","ref":"model_development_pipelines.html#prompt-templates-library"},{"type":"extras","title":"Statistical Analysis Functions - Model Development Pipelines","doc":"```yaml\n# components/functions/statistics.yaml\nfunctions:\n  - name: \"perform_t_test\"\n    description: \"Compare two model performances\"\n    parameters:\n      model_a_scores: array\n      model_b_scores: array\n      confidence_level: number\n      \n  - name: \"calculate_effect_size\"\n    description: \"Measure practical significance\"\n    \n  - name: \"power_analysis\"\n    description: \"Determine sample size needs\"\n```","ref":"model_development_pipelines.html#statistical-analysis-functions"},{"type":"extras","title":"Performance Optimization - Model Development Pipelines","doc":"","ref":"model_development_pipelines.html#performance-optimization"},{"type":"extras","title":"1. Caching Strategies - Model Development Pipelines","doc":"- Cache model outputs for reuse\n- Store intermediate results\n- Implement smart invalidation","ref":"model_development_pipelines.html#1-caching-strategies"},{"type":"extras","title":"2. Parallel Processing - Model Development Pipelines","doc":"- Distribute evaluation across instances\n- Batch similar operations\n- Load balance effectively","ref":"model_development_pipelines.html#2-parallel-processing"},{"type":"extras","title":"3. Resource Management - Model Development Pipelines","doc":"- Monitor token usage\n- Optimize prompt lengths\n- Implement rate limiting","ref":"model_development_pipelines.html#3-resource-management"},{"type":"extras","title":"Quality Assurance - Model Development Pipelines","doc":"","ref":"model_development_pipelines.html#quality-assurance"},{"type":"extras","title":"1. Validation Framework - Model Development Pipelines","doc":"```yaml\nvalidation_rules:\n  prompt_quality:\n    - clarity_score: \"> 0.8\"\n    - specificity: \"high\"\n    - token_efficiency: \"optimal\"\n    \n  evaluation_validity:\n    - sample_size: \">= 100\"\n    - statistical_power: \">= 0.8\"\n    - bias_checks: \"passed\"\n```","ref":"model_development_pipelines.html#1-validation-framework"},{"type":"extras","title":"2. Documentation Standards - Model Development Pipelines","doc":"- Document all prompts\n- Track optimization history\n- Maintain evaluation logs\n- Version control datasets","ref":"model_development_pipelines.html#2-documentation-standards"},{"type":"extras","title":"Integration Points - Model Development Pipelines","doc":"","ref":"model_development_pipelines.html#integration-points"},{"type":"extras","title":"1. With Data Pipelines - Model Development Pipelines","doc":"- Use cleaned data for training\n- Apply quality checks\n- Leverage transformation tools","ref":"model_development_pipelines.html#1-with-data-pipelines"},{"type":"extras","title":"2. With Analysis Pipelines - Model Development Pipelines","doc":"- Feed results to analysis\n- Generate insights\n- Create visualizations","ref":"model_development_pipelines.html#2-with-analysis-pipelines"},{"type":"extras","title":"3. With DevOps Pipelines - Model Development Pipelines","doc":"- Deploy optimized models\n- Monitor performance\n- Automate retraining","ref":"model_development_pipelines.html#3-with-devops-pipelines"},{"type":"extras","title":"Best Practices - Model Development Pipelines","doc":"1. **Iterative Approach**: Start simple, refine gradually\n2. **Systematic Testing**: Use consistent evaluation criteria\n3. **Version Everything**: Prompts, datasets, results\n4. **Statistical Rigor**: Ensure significant results\n5. **Bias Awareness**: Always check for biases\n6. **Cost Tracking**: Monitor resource usage","ref":"model_development_pipelines.html#best-practices"},{"type":"extras","title":"Advanced Features - Model Development Pipelines","doc":"","ref":"model_development_pipelines.html#advanced-features"},{"type":"extras","title":"1. AutoML Integration - Model Development Pipelines","doc":"- Automated prompt optimization\n- Hyperparameter search\n- Architecture selection","ref":"model_development_pipelines.html#1-automl-integration"},{"type":"extras","title":"2. Explainability Tools - Model Development Pipelines","doc":"- Prompt impact analysis\n- Decision tracing\n- Feature importance","ref":"model_development_pipelines.html#2-explainability-tools"},{"type":"extras","title":"3. Continuous Learning - Model Development Pipelines","doc":"- Online evaluation\n- Drift detection\n- Automated retraining","ref":"model_development_pipelines.html#3-continuous-learning"},{"type":"extras","title":"Monitoring and Metrics - Model Development Pipelines","doc":"","ref":"model_development_pipelines.html#monitoring-and-metrics"},{"type":"extras","title":"1. Pipeline Metrics - Model Development Pipelines","doc":"- Optimization cycles\n- Improvement rates\n- Resource efficiency\n- Time to convergence","ref":"model_development_pipelines.html#1-pipeline-metrics"},{"type":"extras","title":"2. Model Metrics - Model Development Pipelines","doc":"- Performance trends\n- Quality scores\n- Consistency measures\n- Cost per improvement","ref":"model_development_pipelines.html#2-model-metrics"},{"type":"extras","title":"Future Enhancements - Model Development Pipelines","doc":"1. **Visual Prompt Builder**: GUI for prompt construction\n2. **AutoPrompt**: ML-driven prompt generation\n3. **Model Zoo Integration**: Pre-trained model library\n4. **Federated Evaluation**: Distributed testing\n5. **Real-time Optimization**: Dynamic prompt adjustment","ref":"model_development_pipelines.html#future-enhancements"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}